# PhonespeakApi.AccountApi

All URIs are relative to *http://api-dev.phonespeak.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**accountCallUsage**](AccountApi.md#accountCallUsage) | **GET** /client/Account/{id}/CallUsage | List of Call Usage
[**accountCreate**](AccountApi.md#accountCreate) | **POST** /client/Account | Create a single account
[**accountCreateBillingContact**](AccountApi.md#accountCreateBillingContact) | **POST** /client/Account/{id}/BillingContact | Create a single billing contact
[**accountCreateCreditCard**](AccountApi.md#accountCreateCreditCard) | **POST** /client/Account/{id}/CreditCard | Create credit card
[**accountCreateInvoice**](AccountApi.md#accountCreateInvoice) | **POST** /client/Account/{id}/Invoice | Create invoice
[**accountCreateSession**](AccountApi.md#accountCreateSession) | **POST** /client/Account/Session | 
[**accountDelete**](AccountApi.md#accountDelete) | **DELETE** /client/Account/{id} | Delete a single account
[**accountDeleteBillingContact**](AccountApi.md#accountDeleteBillingContact) | **DELETE** /client/Account/{id}/BillingContact/{contactId} | Delete billing contact
[**accountDeleteCreditCard**](AccountApi.md#accountDeleteCreditCard) | **DELETE** /client/Account/{id}/CreditCard/{creditCardId} | Delete credit card
[**accountDeleteMusicOnHold**](AccountApi.md#accountDeleteMusicOnHold) | **DELETE** /client/Account/{id}/MusicOnHold/{mohId} | Delete MusicOnHold
[**accountDisableInternationalCall**](AccountApi.md#accountDisableInternationalCall) | **DELETE** /client/Account/{id}/InternationalCall | Disable international call
[**accountEnableInternationalCall**](AccountApi.md#accountEnableInternationalCall) | **POST** /client/Account/{id}/InternationalCall | Enable international call
[**accountGet**](AccountApi.md#accountGet) | **GET** /client/Account/{id} | Retrieve a single account
[**accountGetAvailableUserExtension**](AccountApi.md#accountGetAvailableUserExtension) | **GET** /client/Account/{id}/Extension/Available | Update business hour
[**accountGetBillingContact**](AccountApi.md#accountGetBillingContact) | **GET** /client/Account/{id}/BillingContact/{contactId} | Retrieve billing contact details
[**accountGetCreditCard**](AccountApi.md#accountGetCreditCard) | **GET** /client/Account/{id}/CreditCard/{creditCardId} | Get credit card details
[**accountGetInvoice**](AccountApi.md#accountGetInvoice) | **GET** /client/Account/{id}/Invoice/{invoiceId} | Get invoice
[**accountGetPhoneNumber**](AccountApi.md#accountGetPhoneNumber) | **GET** /client/Account/{id}/PhoneNumber | Get Account&#39;s Phone Number
[**accountGetPhoneNumberList**](AccountApi.md#accountGetPhoneNumberList) | **GET** /client/Account/{id}/PhoneNumberList | Get Account&#39;s Phone Number (Manage Number)
[**accountIsCreditCardExist**](AccountApi.md#accountIsCreditCardExist) | **GET** /client/Account/{id}/CreditCard/Exist | Is Credit card exist
[**accountListAccountPhoneNumber**](AccountApi.md#accountListAccountPhoneNumber) | **GET** /client/Account/{id}/AccountPhoneNumber | List Phone Number
[**accountListAllowedCountryCode**](AccountApi.md#accountListAllowedCountryCode) | **GET** /client/Account/{id}/CallCountryCode | Get list of allowed country code
[**accountListCreditCards**](AccountApi.md#accountListCreditCards) | **GET** /client/Account/{id}/CreditCard | Get list of credit card
[**accountListE911Addresses**](AccountApi.md#accountListE911Addresses) | **GET** /client/Account/{id}/E911Address | Retrieve list of E911 address
[**accountListInvoices**](AccountApi.md#accountListInvoices) | **GET** /client/Account/{id}/Invoice | Get list of invoices.
[**accountListMusicOnHold**](AccountApi.md#accountListMusicOnHold) | **GET** /client/Account/{id}/MusicOnHold | Get list of MusicOnHolds
[**accountListRateDeck**](AccountApi.md#accountListRateDeck) | **GET** /client/Account/{id}/RateDeck | 
[**accountTopupCallCredit**](AccountApi.md#accountTopupCallCredit) | **PUT** /client/Account/{id}/CallCredit | Topup Call Credit
[**accountUpdate**](AccountApi.md#accountUpdate) | **PUT** /client/Account/{id} | Update account
[**accountUpdateAllowedCountryCode**](AccountApi.md#accountUpdateAllowedCountryCode) | **PUT** /client/Account/{id}/CallCountryCode | Add allowed country code
[**accountUpdateBillingContact**](AccountApi.md#accountUpdateBillingContact) | **PUT** /client/Account/{id}/BillingContact/{contactId} | Update billing contact
[**accountUpdateCallRecording**](AccountApi.md#accountUpdateCallRecording) | **PUT** /client/Account/{id}/CallRecording | Update Call Recording
[**accountUpdateCompanyAddress**](AccountApi.md#accountUpdateCompanyAddress) | **PUT** /client/Account/{id}/CompanyAddress | Update company address
[**accountUpdateCreditCard**](AccountApi.md#accountUpdateCreditCard) | **PUT** /client/Account/{id}/CreditCard | Update credit card
[**accountUpdateE911Address**](AccountApi.md#accountUpdateE911Address) | **PUT** /client/Account/{id}/E911Address | Update E911 address
[**accountUpdateInvoice**](AccountApi.md#accountUpdateInvoice) | **PUT** /client/Account/{id}/Invoice/{invoiceId} | Update invoice
[**accountUpdateSelectedMusicOnHold**](AccountApi.md#accountUpdateSelectedMusicOnHold) | **PUT** /client/Account/{id}/MusicOnHold/{mohId} | Set MusicOnHold
[**accountUpdateSubscriptionTrial**](AccountApi.md#accountUpdateSubscriptionTrial) | **PUT** /client/Account/{id}/Subscription/Trial | 
[**accountUpdateTimezone**](AccountApi.md#accountUpdateTimezone) | **PUT** /client/Account/{id}/Timezone | Update timezone
[**accountUploadMusicOnHold**](AccountApi.md#accountUploadMusicOnHold) | **POST** /client/Account/{id}/MusicOnHold | Upload MusicOnHold
[**accountVerifyCreditCard**](AccountApi.md#accountVerifyCreditCard) | **GET** /client/Account/CreditCard/Verify | Create credit card
[**accountVerifyInternationalCall**](AccountApi.md#accountVerifyInternationalCall) | **PUT** /client/Account/{id}/InternationalCall | Verify international call


<a name="accountCallUsage"></a>
# **accountCallUsage**
> Object accountCallUsage(id, startDate, endDate, opts)

List of Call Usage

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | account id

var startDate = new Date("2013-10-20T19:20:30+01:00"); // Date | start date

var endDate = new Date("2013-10-20T19:20:30+01:00"); // Date | end date

var opts = { 
  'type': 56, // Number | call type
  'size': 56, // Number | page size
  'pageNum': 56 // Number | page number
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountCallUsage(id, startDate, endDate, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| account id | 
 **startDate** | **Date**| start date | 
 **endDate** | **Date**| end date | 
 **type** | **Number**| call type | [optional] 
 **size** | **Number**| page size | [optional] 
 **pageNum** | **Number**| page number | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountCreate"></a>
# **accountCreate**
> Object accountCreate(signupInfo)

Create a single account

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var signupInfo = new PhonespeakApi.SignupInfo(); // SignupInfo | Account Signup info


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountCreate(signupInfo, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **signupInfo** | [**SignupInfo**](SignupInfo.md)| Account Signup info | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="accountCreateBillingContact"></a>
# **accountCreateBillingContact**
> Object accountCreateBillingContact(id, billingContact)

Create a single billing contact

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var billingContact = new PhonespeakApi.BillingContact(); // BillingContact | Billing contact's details


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountCreateBillingContact(id, billingContact, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **billingContact** | [**BillingContact**](BillingContact.md)| Billing contact&#39;s details | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="accountCreateCreditCard"></a>
# **accountCreateCreditCard**
> Object accountCreateCreditCard(id, creditCard)

Create credit card

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var creditCard = new PhonespeakApi.CreditCard(); // CreditCard | New credit card details


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountCreateCreditCard(id, creditCard, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **creditCard** | [**CreditCard**](CreditCard.md)| New credit card details | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="accountCreateInvoice"></a>
# **accountCreateInvoice**
> Object accountCreateInvoice(id, stripeBillingInvoice)

Create invoice

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var stripeBillingInvoice = new PhonespeakApi.Invoice(); // Invoice | Invoice details


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountCreateInvoice(id, stripeBillingInvoice, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **stripeBillingInvoice** | [**Invoice**](Invoice.md)| Invoice details | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="accountCreateSession"></a>
# **accountCreateSession**
> Object accountCreateSession(signupInfo)



### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var signupInfo = new PhonespeakApi.SignupInfo(); // SignupInfo | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountCreateSession(signupInfo, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **signupInfo** | [**SignupInfo**](SignupInfo.md)|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="accountDelete"></a>
# **accountDelete**
> Object accountDelete(id)

Delete a single account

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id to delete


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountDelete(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id to delete | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountDeleteBillingContact"></a>
# **accountDeleteBillingContact**
> Object accountDeleteBillingContact(id, contactId)

Delete billing contact

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var contactId = "contactId_example"; // String | Billing Contact id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountDeleteBillingContact(id, contactId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **contactId** | **String**| Billing Contact id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountDeleteCreditCard"></a>
# **accountDeleteCreditCard**
> Object accountDeleteCreditCard(id, creditCardId)

Delete credit card

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var creditCardId = "creditCardId_example"; // String | Credit card id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountDeleteCreditCard(id, creditCardId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **creditCardId** | **String**| Credit card id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountDeleteMusicOnHold"></a>
# **accountDeleteMusicOnHold**
> Object accountDeleteMusicOnHold(id, mohId)

Delete MusicOnHold

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var mohId = "mohId_example"; // String | MusicOnHold id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountDeleteMusicOnHold(id, mohId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **mohId** | **String**| MusicOnHold id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountDisableInternationalCall"></a>
# **accountDisableInternationalCall**
> Object accountDisableInternationalCall(id)

Disable international call

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountDisableInternationalCall(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountEnableInternationalCall"></a>
# **accountEnableInternationalCall**
> Object accountEnableInternationalCall(id)

Enable international call

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountEnableInternationalCall(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountGet"></a>
# **accountGet**
> Object accountGet(id)

Retrieve a single account

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountGet(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountGetAvailableUserExtension"></a>
# **accountGetAvailableUserExtension**
> Object accountGetAvailableUserExtension(id)

Update business hour

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Teammate id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountGetAvailableUserExtension(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Teammate id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountGetBillingContact"></a>
# **accountGetBillingContact**
> Object accountGetBillingContact(id, contactId)

Retrieve billing contact details

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var contactId = "contactId_example"; // String | Billing Contact id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountGetBillingContact(id, contactId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **contactId** | **String**| Billing Contact id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountGetCreditCard"></a>
# **accountGetCreditCard**
> Object accountGetCreditCard(id, creditCardId)

Get credit card details

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var creditCardId = "creditCardId_example"; // String | Credit card id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountGetCreditCard(id, creditCardId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **creditCardId** | **String**| Credit card id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountGetInvoice"></a>
# **accountGetInvoice**
> Object accountGetInvoice(id, invoiceId)

Get invoice

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var invoiceId = "invoiceId_example"; // String | Invoice id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountGetInvoice(id, invoiceId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **invoiceId** | **String**| Invoice id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountGetPhoneNumber"></a>
# **accountGetPhoneNumber**
> Object accountGetPhoneNumber(id)

Get Account&#39;s Phone Number

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountGetPhoneNumber(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountGetPhoneNumberList"></a>
# **accountGetPhoneNumberList**
> Object accountGetPhoneNumberList(id)

Get Account&#39;s Phone Number (Manage Number)

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountGetPhoneNumberList(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountIsCreditCardExist"></a>
# **accountIsCreditCardExist**
> Object accountIsCreditCardExist(id)

Is Credit card exist

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountIsCreditCardExist(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountListAccountPhoneNumber"></a>
# **accountListAccountPhoneNumber**
> Object accountListAccountPhoneNumber(id)

List Phone Number

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountListAccountPhoneNumber(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountListAllowedCountryCode"></a>
# **accountListAllowedCountryCode**
> Object accountListAllowedCountryCode(id)

Get list of allowed country code

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountListAllowedCountryCode(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountListCreditCards"></a>
# **accountListCreditCards**
> Object accountListCreditCards(id)

Get list of credit card

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountListCreditCards(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountListE911Addresses"></a>
# **accountListE911Addresses**
> Object accountListE911Addresses(id, opts)

Retrieve list of E911 address

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var opts = { 
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56 // Number | Page number to retrieve (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountListE911Addresses(id, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountListInvoices"></a>
# **accountListInvoices**
> Object accountListInvoices(id, opts)

Get list of invoices.

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var opts = { 
  'size': 56, // Number | The size of the invoice list (optional)
  'startAfter': "startAfter_example" // String | the value start after the list (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountListInvoices(id, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **size** | **Number**| The size of the invoice list (optional) | [optional] 
 **startAfter** | **String**| the value start after the list (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountListMusicOnHold"></a>
# **accountListMusicOnHold**
> Object accountListMusicOnHold(id)

Get list of MusicOnHolds

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountListMusicOnHold(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountListRateDeck"></a>
# **accountListRateDeck**
> Object accountListRateDeck(id)



### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountListRateDeck(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountTopupCallCredit"></a>
# **accountTopupCallCredit**
> Object accountTopupCallCredit(id, amount)

Topup Call Credit

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | account id

var amount = 1.2; // Number | amount


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountTopupCallCredit(id, amount, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| account id | 
 **amount** | **Number**| amount | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountUpdate"></a>
# **accountUpdate**
> Object accountUpdate(id, account)

Update account

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var account = new PhonespeakApi.Account(); // Account | New account details


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountUpdate(id, account, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **account** | [**Account**](Account.md)| New account details | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="accountUpdateAllowedCountryCode"></a>
# **accountUpdateAllowedCountryCode**
> Object accountUpdateAllowedCountryCode(id, countryCode)

Add allowed country code

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var countryCode = [new PhonespeakApi.[String]()]; // [String] | Country Code details


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountUpdateAllowedCountryCode(id, countryCode, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **countryCode** | **[String]**| Country Code details | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="accountUpdateBillingContact"></a>
# **accountUpdateBillingContact**
> Object accountUpdateBillingContact(id, contactId, billingContact)

Update billing contact

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var contactId = "contactId_example"; // String | Billing Contact id

var billingContact = new PhonespeakApi.BillingContact(); // BillingContact | New billing contact details


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountUpdateBillingContact(id, contactId, billingContact, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **contactId** | **String**| Billing Contact id | 
 **billingContact** | [**BillingContact**](BillingContact.md)| New billing contact details | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="accountUpdateCallRecording"></a>
# **accountUpdateCallRecording**
> Object accountUpdateCallRecording(id, callRecordingSetting)

Update Call Recording

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var callRecordingSetting = true; // Boolean | call Recording Setting


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountUpdateCallRecording(id, callRecordingSetting, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **callRecordingSetting** | **Boolean**| call Recording Setting | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountUpdateCompanyAddress"></a>
# **accountUpdateCompanyAddress**
> Object accountUpdateCompanyAddress(id, companyAddress)

Update company address

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var companyAddress = new PhonespeakApi.Address(); // Address | New company address


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountUpdateCompanyAddress(id, companyAddress, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **companyAddress** | [**Address**](Address.md)| New company address | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="accountUpdateCreditCard"></a>
# **accountUpdateCreditCard**
> Object accountUpdateCreditCard(id, creditCard)

Update credit card

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var creditCard = new PhonespeakApi.CreditCard(); // CreditCard | Credit card object


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountUpdateCreditCard(id, creditCard, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **creditCard** | [**CreditCard**](CreditCard.md)| Credit card object | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="accountUpdateE911Address"></a>
# **accountUpdateE911Address**
> Object accountUpdateE911Address(id, e911)

Update E911 address

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var e911 = new PhonespeakApi.E911Address(); // E911Address | New E911 info


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountUpdateE911Address(id, e911, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **e911** | [**E911Address**](E911Address.md)| New E911 info | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="accountUpdateInvoice"></a>
# **accountUpdateInvoice**
> Object accountUpdateInvoice(id, invoiceId, stripeBillingInvoice)

Update invoice

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var invoiceId = "invoiceId_example"; // String | Invoice Id

var stripeBillingInvoice = new PhonespeakApi.Invoice(); // Invoice | New invoice details


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountUpdateInvoice(id, invoiceId, stripeBillingInvoice, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **invoiceId** | **String**| Invoice Id | 
 **stripeBillingInvoice** | [**Invoice**](Invoice.md)| New invoice details | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="accountUpdateSelectedMusicOnHold"></a>
# **accountUpdateSelectedMusicOnHold**
> Object accountUpdateSelectedMusicOnHold(id, mohId)

Set MusicOnHold

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var mohId = "mohId_example"; // String | MusicOnHold id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountUpdateSelectedMusicOnHold(id, mohId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **mohId** | **String**| MusicOnHold id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountUpdateSubscriptionTrial"></a>
# **accountUpdateSubscriptionTrial**
> Object accountUpdateSubscriptionTrial(id)



### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountUpdateSubscriptionTrial(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountUpdateTimezone"></a>
# **accountUpdateTimezone**
> Object accountUpdateTimezone(id, timezone)

Update timezone

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var timezone = "timezone_example"; // String | New timezone


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountUpdateTimezone(id, timezone, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **timezone** | **String**| New timezone | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="accountUploadMusicOnHold"></a>
# **accountUploadMusicOnHold**
> Object accountUploadMusicOnHold(id, uploadMusicOnHold)

Upload MusicOnHold

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var uploadMusicOnHold = "/path/to/file.txt"; // File | Upload music on hold file


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountUploadMusicOnHold(id, uploadMusicOnHold, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **uploadMusicOnHold** | **File**| Upload music on hold file | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json, application/xml

<a name="accountVerifyCreditCard"></a>
# **accountVerifyCreditCard**
> Object accountVerifyCreditCard(opts)

Create credit card

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var opts = { 
  'creditCardCreditCardId': "creditCardCreditCardId_example", // String | Credit Card Id
  'creditCardName': "creditCardName_example", // String | Credit Card Name
  'creditCardNumber': "creditCardNumber_example", // String | Credit Card Number
  'creditCardLast4Digits': "creditCardLast4Digits_example", // String | Credit Card last 4 digits
  'creditCardCvc': "creditCardCvc_example", // String | Credit Card Cvc
  'creditCardExpirationMonth': 789, // Number | Credit Card Expired Month
  'creditCardExpirationYear': 789, // Number | Credit Card Expired Year
  'creditCardAddressZip': "creditCardAddressZip_example", // String | Credit Card's address zip
  'creditCardIsDefault': true, // Boolean | Default credit card
  'creditCardBillingAddressName': "creditCardBillingAddressName_example", // String | Customer's mobile number for billing purpose
  'creditCardBillingAddressMobile': "creditCardBillingAddressMobile_example", // String | Customer's mobile number for billing purpose
  'creditCardBillingAddressLine1': "creditCardBillingAddressLine1_example", // String | Address line 1
  'creditCardBillingAddressLine2': "creditCardBillingAddressLine2_example", // String | Address line 2
  'creditCardBillingAddressCity': "creditCardBillingAddressCity_example", // String | City
  'creditCardBillingAddressState': "creditCardBillingAddressState_example", // String | State
  'creditCardBillingAddressPostalCode': "creditCardBillingAddressPostalCode_example", // String | Postal code
  'creditCardBillingAddressCountry': "creditCardBillingAddressCountry_example" // String | Country
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountVerifyCreditCard(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **creditCardCreditCardId** | **String**| Credit Card Id | [optional] 
 **creditCardName** | **String**| Credit Card Name | [optional] 
 **creditCardNumber** | **String**| Credit Card Number | [optional] 
 **creditCardLast4Digits** | **String**| Credit Card last 4 digits | [optional] 
 **creditCardCvc** | **String**| Credit Card Cvc | [optional] 
 **creditCardExpirationMonth** | **Number**| Credit Card Expired Month | [optional] 
 **creditCardExpirationYear** | **Number**| Credit Card Expired Year | [optional] 
 **creditCardAddressZip** | **String**| Credit Card&#39;s address zip | [optional] 
 **creditCardIsDefault** | **Boolean**| Default credit card | [optional] 
 **creditCardBillingAddressName** | **String**| Customer&#39;s mobile number for billing purpose | [optional] 
 **creditCardBillingAddressMobile** | **String**| Customer&#39;s mobile number for billing purpose | [optional] 
 **creditCardBillingAddressLine1** | **String**| Address line 1 | [optional] 
 **creditCardBillingAddressLine2** | **String**| Address line 2 | [optional] 
 **creditCardBillingAddressCity** | **String**| City | [optional] 
 **creditCardBillingAddressState** | **String**| State | [optional] 
 **creditCardBillingAddressPostalCode** | **String**| Postal code | [optional] 
 **creditCardBillingAddressCountry** | **String**| Country | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="accountVerifyInternationalCall"></a>
# **accountVerifyInternationalCall**
> Object accountVerifyInternationalCall(id, firstAmount, secondAmount)

Verify international call

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.AccountApi();

var id = "id_example"; // String | Account id

var firstAmount = 1.2; // Number | First amount for verify charges

var secondAmount = 1.2; // Number | Second amount for verify charges


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.accountVerifyInternationalCall(id, firstAmount, secondAmount, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **firstAmount** | **Number**| First amount for verify charges | 
 **secondAmount** | **Number**| Second amount for verify charges | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

