# PhonespeakApi.AuthenticationApi

All URIs are relative to *http://api-dev.phonespeak.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getBearerAuthToken**](AuthenticationApi.md#getBearerAuthToken) | **POST** /token | Authenticates provided credentials and returns an access token


<a name="getBearerAuthToken"></a>
# **getBearerAuthToken**
> InlineResponse200 getBearerAuthToken(platform, grantType, opts)

Authenticates provided credentials and returns an access token

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');

var apiInstance = new PhonespeakApi.AuthenticationApi();

var platform = "1"; // String | Platform (0 - csr, 1 - account, 2 - desktop, 3 - mobile, 4 - impersonate)

var grantType = "password"; // String | authorization grant type. (password/refresh_token)

var opts = { 
  'username': "username_example", // String | Valid PhoneSpeak username
  'password': "password_example", // String | Valid PhoneSpeak password
  'refreshToken': "refreshToken_example", // String | Valid refresh token
  'type': "type_example" // String | Login type (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getBearerAuthToken(platform, grantType, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **platform** | **String**| Platform (0 - csr, 1 - account, 2 - desktop, 3 - mobile, 4 - impersonate) | [default to 1]
 **grantType** | **String**| authorization grant type. (password/refresh_token) | [default to password]
 **username** | **String**| Valid PhoneSpeak username | [optional] 
 **password** | **String**| Valid PhoneSpeak password | [optional] 
 **refreshToken** | **String**| Valid refresh token | [optional] 
 **type** | **String**| Login type (optional) | [optional] 

### Return type

[**InlineResponse200**](InlineResponse200.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json

