# PhonespeakApi.CdrApi

All URIs are relative to *http://api-dev.phonespeak.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**cdrCallLogExport**](CdrApi.md#cdrCallLogExport) | **POST** /client/Cdr/{accountId}/CallLogExport | Call Log
[**cdrCreate**](CdrApi.md#cdrCreate) | **POST** /client/Cdr | Create a single cdr
[**cdrCreateCallRecording**](CdrApi.md#cdrCreateCallRecording) | **POST** /client/Cdr/{ownerId}CallRecording/{participant}/Participant | Create Call Recording
[**cdrDelete**](CdrApi.md#cdrDelete) | **DELETE** /client/Cdr/{id} | Delete a single cdr
[**cdrDeleteCallLog**](CdrApi.md#cdrDeleteCallLog) | **DELETE** /client/Cdr/{cdrId}/CallLog | Call Log
[**cdrDeleteCallRecording**](CdrApi.md#cdrDeleteCallRecording) | **DELETE** /client/Cdr/{id}/CallRecording | Delete Call Recording
[**cdrDeleteCallSession**](CdrApi.md#cdrDeleteCallSession) | **DELETE** /client/Cdr/{accountId}/CallSession | Delete Call Session
[**cdrDeleteRecentCall**](CdrApi.md#cdrDeleteRecentCall) | **DELETE** /client/Cdr/{id}/RecentCalls/{teammateId} | Delete recent call
[**cdrGet**](CdrApi.md#cdrGet) | **GET** /client/Cdr/{id} | Retrieve a single cdr
[**cdrGetCallRecording**](CdrApi.md#cdrGetCallRecording) | **GET** /client/Cdr/{ownerId}/CallRecording/{id} | Get Call Recording
[**cdrList**](CdrApi.md#cdrList) | **GET** /client/Cdr/{accountId}/List | List all cdrs by account, team mate or team
[**cdrListCallLog**](CdrApi.md#cdrListCallLog) | **POST** /client/Cdr/{accountId}/CallLog | Call Log
[**cdrListCallRecording**](CdrApi.md#cdrListCallRecording) | **GET** /client/Cdr/{ownerId}/CallRecording | List Call Recording
[**cdrListCallSession**](CdrApi.md#cdrListCallSession) | **GET** /client/Cdr/{accountId}/CallSession | List Call Session
[**cdrListRecentActivity**](CdrApi.md#cdrListRecentActivity) | **GET** /client/Cdr/{id}/RecentActivity/{participant} | Get all recent call
[**cdrListRecentCalls**](CdrApi.md#cdrListRecentCalls) | **GET** /client/Cdr/{id}/RecentCalls | Get all recent call
[**cdrListRecentCalls_0**](CdrApi.md#cdrListRecentCalls_0) | **POST** /client/Cdr/{id}/RecentCalls/dummyendpoint | Get all recent call
[**cdrListTeamRecentCall**](CdrApi.md#cdrListTeamRecentCall) | **GET** /client/Cdr/{id}/TeamRecentCalls | Get all team recent call
[**cdrUnreadRecentCallCount**](CdrApi.md#cdrUnreadRecentCallCount) | **GET** /client/Cdr/{id}/RecentCalls/UnreadCount | Total Unread Recent
[**cdrUpdateCallRecording**](CdrApi.md#cdrUpdateCallRecording) | **PUT** /client/Cdr/{id}/CallRecording | Update Call Recording
[**cdrUpdateExtensionStatus**](CdrApi.md#cdrUpdateExtensionStatus) | **POST** /client/Cdr/Extension | Portsip update extension status
[**cdrUpdateRecentCallsRead**](CdrApi.md#cdrUpdateRecentCallsRead) | **PUT** /client/Cdr/{id}/RecentCalls/Read | Update recent call read
[**cdrUpdateTeamRecentCallReadStatus**](CdrApi.md#cdrUpdateTeamRecentCallReadStatus) | **PUT** /client/Cdr/{id}/TeamRecentCalls/{ownerId}/Read | Get all team recent call


<a name="cdrCallLogExport"></a>
# **cdrCallLogExport**
> Object cdrCallLogExport(numberList, accountId, startDate, endDate, opts)

Call Log

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var numberList = [new PhonespeakApi.[String]()]; // [String] | number list

var accountId = "accountId_example"; // String | account id

var startDate = new Date("2013-10-20T19:20:30+01:00"); // Date | start date

var endDate = new Date("2013-10-20T19:20:30+01:00"); // Date | end date

var opts = { 
  'type': 56, // Number | call type
  'size': 56, // Number | page size
  'pageNum': 56 // Number | page number
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrCallLogExport(numberList, accountId, startDate, endDate, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **numberList** | **[String]**| number list | 
 **accountId** | **String**| account id | 
 **startDate** | **Date**| start date | 
 **endDate** | **Date**| end date | 
 **type** | **Number**| call type | [optional] 
 **size** | **Number**| page size | [optional] 
 **pageNum** | **Number**| page number | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="cdrCreate"></a>
# **cdrCreate**
> Object cdrCreate(cdr)

Create a single cdr

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var cdr = new PhonespeakApi.Cdr(); // Cdr | The cdr object to create


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrCreate(cdr, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cdr** | [**Cdr**](Cdr.md)| The cdr object to create | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="cdrCreateCallRecording"></a>
# **cdrCreateCallRecording**
> Object cdrCreateCallRecording(ownerId, participant, uploadCallRecording, opts)

Create Call Recording

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var ownerId = "ownerId_example"; // String | Owner Id

var participant = "participant_example"; // String | Participant

var uploadCallRecording = "/path/to/file.txt"; // File | Upload call recording file

var opts = { 
  'type': 56 // Number | Type
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrCreateCallRecording(ownerId, participant, uploadCallRecording, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ownerId** | **String**| Owner Id | 
 **participant** | **String**| Participant | 
 **uploadCallRecording** | **File**| Upload call recording file | 
 **type** | **Number**| Type | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json, application/xml

<a name="cdrDelete"></a>
# **cdrDelete**
> Object cdrDelete(id)

Delete a single cdr

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var id = "id_example"; // String | Cdr id to delete


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrDelete(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Cdr id to delete | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cdrDeleteCallLog"></a>
# **cdrDeleteCallLog**
> Object cdrDeleteCallLog(cdrId)

Call Log

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var cdrId = "cdrId_example"; // String | cdr id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrDeleteCallLog(cdrId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cdrId** | **String**| cdr id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cdrDeleteCallRecording"></a>
# **cdrDeleteCallRecording**
> Object cdrDeleteCallRecording(id)

Delete Call Recording

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var id = "id_example"; // String | Call Recording Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrDeleteCallRecording(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Call Recording Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cdrDeleteCallSession"></a>
# **cdrDeleteCallSession**
> Object cdrDeleteCallSession(accountId, sessionId)

Delete Call Session

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var accountId = "accountId_example"; // String | Account Id

var sessionId = 56; // Number | Call session Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrDeleteCallSession(accountId, sessionId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**| Account Id | 
 **sessionId** | **Number**| Call session Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cdrDeleteRecentCall"></a>
# **cdrDeleteRecentCall**
> Object cdrDeleteRecentCall(id, teammateId)

Delete recent call

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var id = "id_example"; // String | cdr id

var teammateId = "teammateId_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrDeleteRecentCall(id, teammateId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| cdr id | 
 **teammateId** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cdrGet"></a>
# **cdrGet**
> Object cdrGet(id)

Retrieve a single cdr

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var id = "id_example"; // String | Unique identifier of the cdr


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrGet(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Unique identifier of the cdr | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cdrGetCallRecording"></a>
# **cdrGetCallRecording**
> Object cdrGetCallRecording(ownerId, id)

Get Call Recording

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var ownerId = "ownerId_example"; // String | Call Recording Id

var id = "id_example"; // String | Call Recording Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrGetCallRecording(ownerId, id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ownerId** | **String**| Call Recording Id | 
 **id** | **String**| Call Recording Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cdrList"></a>
# **cdrList**
> Object cdrList(accountId, opts)

List all cdrs by account, team mate or team

Test Remarks

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var accountId = "accountId_example"; // String | accountId to retrieve cdr list

var opts = { 
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56, // Number | Page number to retrieve (optional)
  'fromDate': new Date("2013-10-20T19:20:30+01:00") // Date | Get all record greater than this date (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrList(accountId, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**| accountId to retrieve cdr list | 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 
 **fromDate** | **Date**| Get all record greater than this date (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cdrListCallLog"></a>
# **cdrListCallLog**
> Object cdrListCallLog(numberList, accountId, startDate, endDate, opts)

Call Log

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var numberList = [new PhonespeakApi.[String]()]; // [String] | number list

var accountId = "accountId_example"; // String | account id

var startDate = new Date("2013-10-20T19:20:30+01:00"); // Date | start date

var endDate = new Date("2013-10-20T19:20:30+01:00"); // Date | end date

var opts = { 
  'type': 56, // Number | call type
  'size': 56, // Number | page size
  'pageNum': 56, // Number | page number
  'fromDate': new Date("2013-10-20T19:20:30+01:00") // Date | Get all record greater than this date (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrListCallLog(numberList, accountId, startDate, endDate, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **numberList** | **[String]**| number list | 
 **accountId** | **String**| account id | 
 **startDate** | **Date**| start date | 
 **endDate** | **Date**| end date | 
 **type** | **Number**| call type | [optional] 
 **size** | **Number**| page size | [optional] 
 **pageNum** | **Number**| page number | [optional] 
 **fromDate** | **Date**| Get all record greater than this date (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="cdrListCallRecording"></a>
# **cdrListCallRecording**
> Object cdrListCallRecording(ownerId, opts)

List Call Recording

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var ownerId = "ownerId_example"; // String | Call Recording Id

var opts = { 
  'type': 56, // Number | 
  'size': 56, // Number | 
  'pageNum': 56 // Number | 
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrListCallRecording(ownerId, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ownerId** | **String**| Call Recording Id | 
 **type** | **Number**|  | [optional] 
 **size** | **Number**|  | [optional] 
 **pageNum** | **Number**|  | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cdrListCallSession"></a>
# **cdrListCallSession**
> Object cdrListCallSession(accountId, opts)

List Call Session

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var accountId = "accountId_example"; // String | Account Id

var opts = { 
  'size': 56, // Number | size
  'pageNum': 56 // Number | page number
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrListCallSession(accountId, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**| Account Id | 
 **size** | **Number**| size | [optional] 
 **pageNum** | **Number**| page number | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cdrListRecentActivity"></a>
# **cdrListRecentActivity**
> Object cdrListRecentActivity(id, participant, opts)

Get all recent call

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var id = "id_example"; // String | teammate id

var participant = "participant_example"; // String | participant id

var opts = { 
  'type': 56, // Number | type of call
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56, // Number | Page number to retrieve (optional)
  'fromDate': new Date("2013-10-20T19:20:30+01:00") // Date | Get all record greater than this date (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrListRecentActivity(id, participant, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| teammate id | 
 **participant** | **String**| participant id | 
 **type** | **Number**| type of call | [optional] 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 
 **fromDate** | **Date**| Get all record greater than this date (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cdrListRecentCalls"></a>
# **cdrListRecentCalls**
> Object cdrListRecentCalls(id, opts)

Get all recent call

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var id = "id_example"; // String | teammate id

var opts = { 
  'type': 56, // Number | type of call
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56, // Number | Page number to retrieve (optional)
  'fromDate': new Date("2013-10-20T19:20:30+01:00") // Date | Get all record greater than this date (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrListRecentCalls(id, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| teammate id | 
 **type** | **Number**| type of call | [optional] 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 
 **fromDate** | **Date**| Get all record greater than this date (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cdrListRecentCalls_0"></a>
# **cdrListRecentCalls_0**
> Object cdrListRecentCalls_0(id, callLog, opts)

Get all recent call

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var id = "id_example"; // String | teammate id

var callLog = new PhonespeakApi.CallLog(); // CallLog | Calllog Model

var opts = { 
  'type': 56, // Number | type of call
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56, // Number | Page number to retrieve (optional)
  'fromDate': new Date("2013-10-20T19:20:30+01:00") // Date | Get all record greater than this date (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrListRecentCalls_0(id, callLog, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| teammate id | 
 **callLog** | [**CallLog**](CallLog.md)| Calllog Model | 
 **type** | **Number**| type of call | [optional] 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 
 **fromDate** | **Date**| Get all record greater than this date (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="cdrListTeamRecentCall"></a>
# **cdrListTeamRecentCall**
> Object cdrListTeamRecentCall(id, opts)

Get all team recent call

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var id = "id_example"; // String | team id

var opts = { 
  'status': 56, // Number | type of call
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56, // Number | Page number to retrieve (optional)
  'fromDate': new Date("2013-10-20T19:20:30+01:00") // Date | Get all record greater than this date (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrListTeamRecentCall(id, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| team id | 
 **status** | **Number**| type of call | [optional] 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 
 **fromDate** | **Date**| Get all record greater than this date (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cdrUnreadRecentCallCount"></a>
# **cdrUnreadRecentCallCount**
> Object cdrUnreadRecentCallCount(id)

Total Unread Recent

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var id = "id_example"; // String | cdr id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrUnreadRecentCallCount(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| cdr id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cdrUpdateCallRecording"></a>
# **cdrUpdateCallRecording**
> Object cdrUpdateCallRecording(id, callRecording)

Update Call Recording

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var id = "id_example"; // String | Call Recording Id

var callRecording = new PhonespeakApi.CallRecording(); // CallRecording | Call Recording


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrUpdateCallRecording(id, callRecording, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Call Recording Id | 
 **callRecording** | [**CallRecording**](CallRecording.md)| Call Recording | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="cdrUpdateExtensionStatus"></a>
# **cdrUpdateExtensionStatus**
> Object cdrUpdateExtensionStatus(pbxCallStatus)

Portsip update extension status

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var pbxCallStatus = new PhonespeakApi.PbxCallStatus(); // PbxCallStatus | The cdr object to create


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrUpdateExtensionStatus(pbxCallStatus, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **pbxCallStatus** | [**PbxCallStatus**](PbxCallStatus.md)| The cdr object to create | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="cdrUpdateRecentCallsRead"></a>
# **cdrUpdateRecentCallsRead**
> Object cdrUpdateRecentCallsRead(id, opts)

Update recent call read

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var id = "id_example"; // String | teammate id

var opts = { 
  'status': 56 // Number | type of call
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrUpdateRecentCallsRead(id, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| teammate id | 
 **status** | **Number**| type of call | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cdrUpdateTeamRecentCallReadStatus"></a>
# **cdrUpdateTeamRecentCallReadStatus**
> Object cdrUpdateTeamRecentCallReadStatus(id, ownerId)

Get all team recent call

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CdrApi();

var id = "id_example"; // String | team id

var ownerId = "ownerId_example"; // String | owner id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cdrUpdateTeamRecentCallReadStatus(id, ownerId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| team id | 
 **ownerId** | **String**| owner id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

