# PhonespeakApi.ChatApi

All URIs are relative to *http://api-dev.phonespeak.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**chatArchiveConversation**](ChatApi.md#chatArchiveConversation) | **PUT** /client/Chat/Archive/{id} | Archive conversation
[**chatCreateConversation**](ChatApi.md#chatCreateConversation) | **POST** /client/Chat/Conversation | Create conversation
[**chatCreateMessage**](ChatApi.md#chatCreateMessage) | **POST** /client/Chat/Message | Send Message
[**chatDeleteConversation**](ChatApi.md#chatDeleteConversation) | **DELETE** /client/Chat/Conversation/{conversationId} | Delete Conversation
[**chatDeleteMessage**](ChatApi.md#chatDeleteMessage) | **DELETE** /client/Chat/Message/{messageId} | Delete Message
[**chatGetConversation**](ChatApi.md#chatGetConversation) | **GET** /client/Chat/Conversation/{conversationId} | Get Conversation
[**chatGetExistingConversation**](ChatApi.md#chatGetExistingConversation) | **POST** /client/Chat/ExistingConversation | Get Existing Conversation
[**chatGetUnreadConversationCount**](ChatApi.md#chatGetUnreadConversationCount) | **GET** /client/Chat/UnreadConversationCount/{teammateId} | Get Unread Conversation Count
[**chatListConversation**](ChatApi.md#chatListConversation) | **GET** /client/Chat/Conversation | List the conversation
[**chatPinConversation**](ChatApi.md#chatPinConversation) | **PUT** /client/Chat/Pin/{id} | Pin conversation
[**chatSendSMS**](ChatApi.md#chatSendSMS) | **POST** /client/Chat/{id}/sms | Testing
[**chatUnArchiveConversation**](ChatApi.md#chatUnArchiveConversation) | **PUT** /client/Chat/UnArchive/{id} | UnArchive conversation
[**chatUnpinConversation**](ChatApi.md#chatUnpinConversation) | **PUT** /client/Chat/Unpin/{id} | Unpin conversation
[**chatUpdateAllMessagesToRead**](ChatApi.md#chatUpdateAllMessagesToRead) | **PUT** /client/Chat/UpdateAllMessagesToRead/{teammateId} | Update all conversation&#39;s messages to read
[**chatUpdateGroupImage**](ChatApi.md#chatUpdateGroupImage) | **PUT** /client/Chat/GroupImage/{conversationId} | Update Group Image
[**chatUpdateGroupName**](ChatApi.md#chatUpdateGroupName) | **PUT** /client/Chat/GroupName/{conversationId} | Update Group Name


<a name="chatArchiveConversation"></a>
# **chatArchiveConversation**
> Object chatArchiveConversation(conversationId, id)

Archive conversation

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var conversationId = "conversationId_example"; // String | The conversation id

var id = "id_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatArchiveConversation(conversationId, id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **conversationId** | **String**| The conversation id | 
 **id** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="chatCreateConversation"></a>
# **chatCreateConversation**
> Object chatCreateConversation(info)

Create conversation

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var info = new PhonespeakApi.CreateConversation(); // CreateConversation | Create conversation info


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatCreateConversation(info, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **info** | [**CreateConversation**](CreateConversation.md)| Create conversation info | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="chatCreateMessage"></a>
# **chatCreateMessage**
> Object chatCreateMessage(msg)

Send Message

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var msg = new PhonespeakApi.Message(); // Message | Send message detail


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatCreateMessage(msg, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **msg** | [**Message**](Message.md)| Send message detail | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="chatDeleteConversation"></a>
# **chatDeleteConversation**
> Object chatDeleteConversation(conversationId)

Delete Conversation

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var conversationId = "conversationId_example"; // String | The conversation id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatDeleteConversation(conversationId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **conversationId** | **String**| The conversation id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="chatDeleteMessage"></a>
# **chatDeleteMessage**
> Object chatDeleteMessage(messageId)

Delete Message

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var messageId = "messageId_example"; // String | The message id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatDeleteMessage(messageId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **messageId** | **String**| The message id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="chatGetConversation"></a>
# **chatGetConversation**
> Object chatGetConversation(conversationId, opts)

Get Conversation

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var conversationId = "conversationId_example"; // String | The conversation id

var opts = { 
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56, // Number | Page number to retrieve (optional)
  'fromDate': new Date("2013-10-20T19:20:30+01:00") // Date | 
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatGetConversation(conversationId, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **conversationId** | **String**| The conversation id | 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 
 **fromDate** | **Date**|  | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="chatGetExistingConversation"></a>
# **chatGetExistingConversation**
> Object chatGetExistingConversation(info)

Get Existing Conversation

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var info = new PhonespeakApi.CreateConversation(); // CreateConversation | Get existing conversation info


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatGetExistingConversation(info, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **info** | [**CreateConversation**](CreateConversation.md)| Get existing conversation info | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="chatGetUnreadConversationCount"></a>
# **chatGetUnreadConversationCount**
> Object chatGetUnreadConversationCount(teammateId, opts)

Get Unread Conversation Count

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var teammateId = "teammateId_example"; // String | The teammate id

var opts = { 
  'teamId': "teamId_example" // String | The team id (Optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatGetUnreadConversationCount(teammateId, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **teammateId** | **String**| The teammate id | 
 **teamId** | **String**| The team id (Optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="chatListConversation"></a>
# **chatListConversation**
> Object chatListConversation(ownerId, opts)

List the conversation

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var ownerId = "ownerId_example"; // String | The sender of the chat message

var opts = { 
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56 // Number | Page number to retrieve (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatListConversation(ownerId, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ownerId** | **String**| The sender of the chat message | 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="chatPinConversation"></a>
# **chatPinConversation**
> Object chatPinConversation(conversationId, id)

Pin conversation

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var conversationId = "conversationId_example"; // String | The conversation id

var id = "id_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatPinConversation(conversationId, id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **conversationId** | **String**| The conversation id | 
 **id** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="chatSendSMS"></a>
# **chatSendSMS**
> Object chatSendSMS(id)

Testing

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var id = "id_example"; // String | Unique identifier of the cdr


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatSendSMS(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Unique identifier of the cdr | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="chatUnArchiveConversation"></a>
# **chatUnArchiveConversation**
> Object chatUnArchiveConversation(conversationId, id)

UnArchive conversation

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var conversationId = "conversationId_example"; // String | The conversation id

var id = "id_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatUnArchiveConversation(conversationId, id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **conversationId** | **String**| The conversation id | 
 **id** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="chatUnpinConversation"></a>
# **chatUnpinConversation**
> Object chatUnpinConversation(conversationId, id)

Unpin conversation

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var conversationId = "conversationId_example"; // String | The conversation id

var id = "id_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatUnpinConversation(conversationId, id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **conversationId** | **String**| The conversation id | 
 **id** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="chatUpdateAllMessagesToRead"></a>
# **chatUpdateAllMessagesToRead**
> Object chatUpdateAllMessagesToRead(teammateId, groupId)

Update all conversation&#39;s messages to read

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var teammateId = "teammateId_example"; // String | The teammate id

var groupId = "groupId_example"; // String | The group id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatUpdateAllMessagesToRead(teammateId, groupId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **teammateId** | **String**| The teammate id | 
 **groupId** | **String**| The group id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="chatUpdateGroupImage"></a>
# **chatUpdateGroupImage**
> Object chatUpdateGroupImage(conversationId, groupImage)

Update Group Image

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var conversationId = "conversationId_example"; // String | The conversation id

var groupImage = new PhonespeakApi.ProfileImage(); // ProfileImage | Group Image


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatUpdateGroupImage(conversationId, groupImage, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **conversationId** | **String**| The conversation id | 
 **groupImage** | [**ProfileImage**](ProfileImage.md)| Group Image | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="chatUpdateGroupName"></a>
# **chatUpdateGroupName**
> Object chatUpdateGroupName(conversationId, groupName)

Update Group Name

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.ChatApi();

var conversationId = "conversationId_example"; // String | The conversation id

var groupName = "groupName_example"; // String | Group Name


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.chatUpdateGroupName(conversationId, groupName, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **conversationId** | **String**| The conversation id | 
 **groupName** | **String**| Group Name | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

