# PhonespeakApi.CloudSoftPhoneApi

All URIs are relative to *http://api-dev.phonespeak.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**cloudSoftPhoneFetchMessage**](CloudSoftPhoneApi.md#cloudSoftPhoneFetchMessage) | **POST** /CloudSoftPhone/Message/Fetch | List all contacts
[**cloudSoftPhoneListContacts**](CloudSoftPhoneApi.md#cloudSoftPhoneListContacts) | **GET** /CloudSoftPhone/Contact | List all contacts
[**cloudSoftPhoneLogin**](CloudSoftPhoneApi.md#cloudSoftPhoneLogin) | **GET** /CloudSoftPhone/Prov | Login
[**cloudSoftPhonePushTokenReporter**](CloudSoftPhoneApi.md#cloudSoftPhonePushTokenReporter) | **POST** /CloudSoftPhone/PushToken | List all contacts
[**cloudSoftPhoneSendMessage**](CloudSoftPhoneApi.md#cloudSoftPhoneSendMessage) | **POST** /CloudSoftPhone/Message | List all contacts


<a name="cloudSoftPhoneFetchMessage"></a>
# **cloudSoftPhoneFetchMessage**
> Object cloudSoftPhoneFetchMessage(request)

List all contacts

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CloudSoftPhoneApi();

var request = new PhonespeakApi.CspFetchMessageRequest(); // CspFetchMessageRequest | Csp fetch message request


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cloudSoftPhoneFetchMessage(request, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **request** | [**CspFetchMessageRequest**](CspFetchMessageRequest.md)| Csp fetch message request | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="cloudSoftPhoneListContacts"></a>
# **cloudSoftPhoneListContacts**
> Object cloudSoftPhoneListContacts(u, p)

List all contacts

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CloudSoftPhoneApi();

var u = "u_example"; // String | username that required to login

var p = "p_example"; // String | password


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cloudSoftPhoneListContacts(u, p, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **u** | **String**| username that required to login | 
 **p** | **String**| password | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cloudSoftPhoneLogin"></a>
# **cloudSoftPhoneLogin**
> Object cloudSoftPhoneLogin(cloudUsername, cloudPassword, cloudId)

Login

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CloudSoftPhoneApi();

var cloudUsername = "cloudUsername_example"; // String | username that required to login

var cloudPassword = "cloudPassword_example"; // String | password

var cloudId = "cloudId_example"; // String | full


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cloudSoftPhoneLogin(cloudUsername, cloudPassword, cloudId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cloudUsername** | **String**| username that required to login | 
 **cloudPassword** | **String**| password | 
 **cloudId** | **String**| full | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="cloudSoftPhonePushTokenReporter"></a>
# **cloudSoftPhonePushTokenReporter**
> Object cloudSoftPhonePushTokenReporter(cspPushToken)

List all contacts

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CloudSoftPhoneApi();

var cspPushToken = new PhonespeakApi.CspPushToken(); // CspPushToken | Push token object


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cloudSoftPhonePushTokenReporter(cspPushToken, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cspPushToken** | [**CspPushToken**](CspPushToken.md)| Push token object | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="cloudSoftPhoneSendMessage"></a>
# **cloudSoftPhoneSendMessage**
> Object cloudSoftPhoneSendMessage(message)

List all contacts

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CloudSoftPhoneApi();

var message = new PhonespeakApi.CspSendMessage(); // CspSendMessage | Send message object


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cloudSoftPhoneSendMessage(message, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **message** | [**CspSendMessage**](CspSendMessage.md)| Send message object | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

