# PhonespeakApi.CompanyNumberApi

All URIs are relative to *http://api-dev.phonespeak.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**companyNumberAddPhoneNumber**](CompanyNumberApi.md#companyNumberAddPhoneNumber) | **POST** /client/CompanyNumber/{id}/PhoneNumber | Add Phone Number for Company Number
[**companyNumberCreate**](CompanyNumberApi.md#companyNumberCreate) | **POST** /client/CompanyNumber | Create a single Company Number
[**companyNumberCreateIvr**](CompanyNumberApi.md#companyNumberCreateIvr) | **POST** /client/CompanyNumber/{id}/Ivr | Create Company Number&#39;s ivr
[**companyNumberDelete**](CompanyNumberApi.md#companyNumberDelete) | **DELETE** /client/CompanyNumber/{id} | Delete a single Company Number
[**companyNumberDeleteIvr**](CompanyNumberApi.md#companyNumberDeleteIvr) | **DELETE** /client/CompanyNumber/{id}/Ivr/{ivrNumber} | Delete Company Number&#39;s ivr
[**companyNumberDeleteIvrGreeting**](CompanyNumberApi.md#companyNumberDeleteIvrGreeting) | **DELETE** /client/CompanyNumber/{id}/Ivr/{ivrNumber}/Greeting/{greetingId} | Delete Ivr Greeting File
[**companyNumberDeletePhoneNumber**](CompanyNumberApi.md#companyNumberDeletePhoneNumber) | **DELETE** /client/CompanyNumber/{id}/PhoneNumber/{phoneNumberId} | Delete Phone Number for Company Number
[**companyNumberGet**](CompanyNumberApi.md#companyNumberGet) | **GET** /client/CompanyNumber/{id} | Retrieve a single Company Number by id
[**companyNumberIvrConvertTextToSpeech**](CompanyNumberApi.md#companyNumberIvrConvertTextToSpeech) | **POST** /client/CompanyNumber/{id}/Ivr/{ivrNumber}/Greeting/SpeechGreeting | Ivr Convert text to speech
[**companyNumberList**](CompanyNumberApi.md#companyNumberList) | **GET** /client/CompanyNumber | List all Company Numbers by account
[**companyNumberListAvailableTeammates**](CompanyNumberApi.md#companyNumberListAvailableTeammates) | **GET** /client/CompanyNumber/{id}/ListAvailableTeammates | Get Teammate list for company number
[**companyNumberListIvrGreetings**](CompanyNumberApi.md#companyNumberListIvrGreetings) | **GET** /client/CompanyNumber/{id}/Ivr/{ivrNumber}/Greeting | List Ivr Greetings for a team
[**companyNumberUpdate**](CompanyNumberApi.md#companyNumberUpdate) | **PUT** /client/CompanyNumber/{id} | Update a single Company Number by id
[**companyNumberUpdateBusinessHour**](CompanyNumberApi.md#companyNumberUpdateBusinessHour) | **PUT** /client/CompanyNumber/{id}/BusinessHour | Update Company Number Business Hour by id
[**companyNumberUpdateCallerIdPermission**](CompanyNumberApi.md#companyNumberUpdateCallerIdPermission) | **PUT** /client/CompanyNumber/{id}/CallerIdPermission | Add teammate for Company Number
[**companyNumberUpdateClosedHourHandling**](CompanyNumberApi.md#companyNumberUpdateClosedHourHandling) | **PUT** /client/CompanyNumber/{id}/ClosedHourHandling | Update Company Number Closed Hour Handling
[**companyNumberUpdateIvrKey**](CompanyNumberApi.md#companyNumberUpdateIvrKey) | **PUT** /client/CompanyNumber/{id}/Ivr/{ivrNumber}/IvrKey/{keyNumber} | Update Ivr Key
[**companyNumberUpdateIvrName**](CompanyNumberApi.md#companyNumberUpdateIvrName) | **PUT** /client/CompanyNumber/{id}/Ivr/{ivrNumber}/Name/{ivrName} | Update Company Number&#39;s ivr
[**companyNumberUpdateIvrTimeout**](CompanyNumberApi.md#companyNumberUpdateIvrTimeout) | **PUT** /client/CompanyNumber/{id}/Ivr/{ivrNumber} | Update Ivr Timeout
[**companyNumberUpdateOpenHourHandling**](CompanyNumberApi.md#companyNumberUpdateOpenHourHandling) | **PUT** /client/CompanyNumber/{id}/OpenHourHandling | Update Company Number Open Hour Handling
[**companyNumberUpdatePhoneNumber**](CompanyNumberApi.md#companyNumberUpdatePhoneNumber) | **PUT** /client/CompanyNumber/{id}/PhoneNumber/{phoneNumberId} | Add Phone Number
[**companyNumberUpdateSMSHandling**](CompanyNumberApi.md#companyNumberUpdateSMSHandling) | **PUT** /client/CompanyNumber/{id}/Sms/SMSHandling | Update SMS Handling for Company Number
[**companyNumberUpdateSelectedIvrGreeting**](CompanyNumberApi.md#companyNumberUpdateSelectedIvrGreeting) | **PUT** /client/CompanyNumber/{id}/Ivr/{ivrNumber}/Greeting/{greetingId} | Update/Set a Company Number&#39;s default Voicemail Greeting
[**companyNumberUploadIvrGreeting**](CompanyNumberApi.md#companyNumberUploadIvrGreeting) | **POST** /client/CompanyNumber/{id}/Ivr/{ivrNumber}/Greeting | Upload Ivr Greeting File


<a name="companyNumberAddPhoneNumber"></a>
# **companyNumberAddPhoneNumber**
> Object companyNumberAddPhoneNumber(id, phoneNumber)

Add Phone Number for Company Number

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | Company Number id to update

var phoneNumber = new PhonespeakApi.PhoneNumber(); // PhoneNumber | The phone number object for company number


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberAddPhoneNumber(id, phoneNumber, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Company Number id to update | 
 **phoneNumber** | [**PhoneNumber**](PhoneNumber.md)| The phone number object for company number | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="companyNumberCreate"></a>
# **companyNumberCreate**
> Object companyNumberCreate(companyNumberInfo)

Create a single Company Number

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var companyNumberInfo = new PhonespeakApi.AddCompanyNumberInfo(); // AddCompanyNumberInfo | The Company Number object to create


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberCreate(companyNumberInfo, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyNumberInfo** | [**AddCompanyNumberInfo**](AddCompanyNumberInfo.md)| The Company Number object to create | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="companyNumberCreateIvr"></a>
# **companyNumberCreateIvr**
> Object companyNumberCreateIvr(id)

Create Company Number&#39;s ivr

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | The team object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberCreateIvr(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="companyNumberDelete"></a>
# **companyNumberDelete**
> Object companyNumberDelete(id)

Delete a single Company Number

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | Company number id to delete


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberDelete(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Company number id to delete | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="companyNumberDeleteIvr"></a>
# **companyNumberDeleteIvr**
> Object companyNumberDeleteIvr(id, ivrNumber)

Delete Company Number&#39;s ivr

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | The team object to update

var ivrNumber = "ivrNumber_example"; // String | The ivr to add


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberDeleteIvr(id, ivrNumber, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team object to update | 
 **ivrNumber** | **String**| The ivr to add | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="companyNumberDeleteIvrGreeting"></a>
# **companyNumberDeleteIvrGreeting**
> Object companyNumberDeleteIvrGreeting(id, ivrNumber, greetingId)

Delete Ivr Greeting File

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | Team Id

var ivrNumber = "ivrNumber_example"; // String | Ivr Id

var greetingId = "greetingId_example"; // String | Ivr Greeting Id to delete


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberDeleteIvrGreeting(id, ivrNumber, greetingId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 
 **ivrNumber** | **String**| Ivr Id | 
 **greetingId** | **String**| Ivr Greeting Id to delete | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="companyNumberDeletePhoneNumber"></a>
# **companyNumberDeletePhoneNumber**
> Object companyNumberDeletePhoneNumber(id, phoneNumberId)

Delete Phone Number for Company Number

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | Company Number id to update

var phoneNumberId = "phoneNumberId_example"; // String | Phone number id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberDeletePhoneNumber(id, phoneNumberId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Company Number id to update | 
 **phoneNumberId** | **String**| Phone number id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="companyNumberGet"></a>
# **companyNumberGet**
> Object companyNumberGet(id)

Retrieve a single Company Number by id

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | The Company Number id to retrieve


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberGet(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The Company Number id to retrieve | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="companyNumberIvrConvertTextToSpeech"></a>
# **companyNumberIvrConvertTextToSpeech**
> Object companyNumberIvrConvertTextToSpeech(id, ivrNumber, textToSpeechInfo, textToSpeech)

Ivr Convert text to speech

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | team id

var ivrNumber = "ivrNumber_example"; // String | ivr number

var textToSpeechInfo = new PhonespeakApi.TextToSpeechInfo(); // TextToSpeechInfo | Text-to-Speech Info

var textToSpeech = "/path/to/file.txt"; // File | Type to convert Text to Speech


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberIvrConvertTextToSpeech(id, ivrNumber, textToSpeechInfo, textToSpeech, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| team id | 
 **ivrNumber** | **String**| ivr number | 
 **textToSpeechInfo** | [**TextToSpeechInfo**](TextToSpeechInfo.md)| Text-to-Speech Info | 
 **textToSpeech** | **File**| Type to convert Text to Speech | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml, multipart/form-data
 - **Accept**: application/json, application/xml

<a name="companyNumberList"></a>
# **companyNumberList**
> Object companyNumberList(opts)

List all Company Numbers by account

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var opts = { 
  'search': "search_example", // String | Search text
  'orderBy': "orderBy_example", // String | Sort by column
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56 // Number | Page number to retrieve (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberList(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **search** | **String**| Search text | [optional] 
 **orderBy** | **String**| Sort by column | [optional] 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="companyNumberListAvailableTeammates"></a>
# **companyNumberListAvailableTeammates**
> Object companyNumberListAvailableTeammates(id)

Get Teammate list for company number

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberListAvailableTeammates(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="companyNumberListIvrGreetings"></a>
# **companyNumberListIvrGreetings**
> Object companyNumberListIvrGreetings(id, ivrNumber)

List Ivr Greetings for a team

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | Team Id

var ivrNumber = "ivrNumber_example"; // String | Team Ivr Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberListIvrGreetings(id, ivrNumber, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 
 **ivrNumber** | **String**| Team Ivr Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="companyNumberUpdate"></a>
# **companyNumberUpdate**
> Object companyNumberUpdate(id, companyNumber)

Update a single Company Number by id

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | Company Number id to update

var companyNumber = new PhonespeakApi.CompanyNumber(); // CompanyNumber | The Company Number object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberUpdate(id, companyNumber, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Company Number id to update | 
 **companyNumber** | [**CompanyNumber**](CompanyNumber.md)| The Company Number object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="companyNumberUpdateBusinessHour"></a>
# **companyNumberUpdateBusinessHour**
> Object companyNumberUpdateBusinessHour(id, companyNumber)

Update Company Number Business Hour by id

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | Company Number id to update

var companyNumber = new PhonespeakApi.CompanyNumber(); // CompanyNumber | The Company Number object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberUpdateBusinessHour(id, companyNumber, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Company Number id to update | 
 **companyNumber** | [**CompanyNumber**](CompanyNumber.md)| The Company Number object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="companyNumberUpdateCallerIdPermission"></a>
# **companyNumberUpdateCallerIdPermission**
> Object companyNumberUpdateCallerIdPermission(id, teammateId)

Add teammate for Company Number

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | Company Number id to update

var teammateId = new PhonespeakApi.CompanyNumber(); // CompanyNumber | caller id permission teammate id list


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberUpdateCallerIdPermission(id, teammateId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Company Number id to update | 
 **teammateId** | [**CompanyNumber**](CompanyNumber.md)| caller id permission teammate id list | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="companyNumberUpdateClosedHourHandling"></a>
# **companyNumberUpdateClosedHourHandling**
> Object companyNumberUpdateClosedHourHandling(id, companyNumber)

Update Company Number Closed Hour Handling

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | Company Number id to update

var companyNumber = new PhonespeakApi.CompanyNumber(); // CompanyNumber | The Company Number object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberUpdateClosedHourHandling(id, companyNumber, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Company Number id to update | 
 **companyNumber** | [**CompanyNumber**](CompanyNumber.md)| The Company Number object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="companyNumberUpdateIvrKey"></a>
# **companyNumberUpdateIvrKey**
> Object companyNumberUpdateIvrKey(id, ivrNumber, keyNumber, ivrKey)

Update Ivr Key

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | company number id

var ivrNumber = "ivrNumber_example"; // String | ivr number

var keyNumber = 56; // Number | key number

var ivrKey = new PhonespeakApi.IvrKey(); // IvrKey | ivr key object


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberUpdateIvrKey(id, ivrNumber, keyNumber, ivrKey, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| company number id | 
 **ivrNumber** | **String**| ivr number | 
 **keyNumber** | **Number**| key number | 
 **ivrKey** | [**IvrKey**](IvrKey.md)| ivr key object | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="companyNumberUpdateIvrName"></a>
# **companyNumberUpdateIvrName**
> Object companyNumberUpdateIvrName(id, ivrNumber, ivrName)

Update Company Number&#39;s ivr

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | The team object to update

var ivrNumber = "ivrNumber_example"; // String | ivr number

var ivrName = "ivrName_example"; // String | ivr name


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberUpdateIvrName(id, ivrNumber, ivrName, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team object to update | 
 **ivrNumber** | **String**| ivr number | 
 **ivrName** | **String**| ivr name | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="companyNumberUpdateIvrTimeout"></a>
# **companyNumberUpdateIvrTimeout**
> Object companyNumberUpdateIvrTimeout(id, ivrNumber, timeOut)

Update Ivr Timeout

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | company number id

var ivrNumber = "ivrNumber_example"; // String | ivr number

var timeOut = new PhonespeakApi.IvrTimeOut(); // IvrTimeOut | timeout action


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberUpdateIvrTimeout(id, ivrNumber, timeOut, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| company number id | 
 **ivrNumber** | **String**| ivr number | 
 **timeOut** | [**IvrTimeOut**](IvrTimeOut.md)| timeout action | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="companyNumberUpdateOpenHourHandling"></a>
# **companyNumberUpdateOpenHourHandling**
> Object companyNumberUpdateOpenHourHandling(id, companyNumber)

Update Company Number Open Hour Handling

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | Company Number id to update

var companyNumber = new PhonespeakApi.CompanyNumber(); // CompanyNumber | The Company Number object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberUpdateOpenHourHandling(id, companyNumber, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Company Number id to update | 
 **companyNumber** | [**CompanyNumber**](CompanyNumber.md)| The Company Number object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="companyNumberUpdatePhoneNumber"></a>
# **companyNumberUpdatePhoneNumber**
> Object companyNumberUpdatePhoneNumber(id, phoneNumberId, phoneNumber)

Add Phone Number

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | Company Number id

var phoneNumberId = "phoneNumberId_example"; // String | Phone number Id

var phoneNumber = new PhonespeakApi.PhoneNumber(); // PhoneNumber | Phone number details


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberUpdatePhoneNumber(id, phoneNumberId, phoneNumber, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Company Number id | 
 **phoneNumberId** | **String**| Phone number Id | 
 **phoneNumber** | [**PhoneNumber**](PhoneNumber.md)| Phone number details | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="companyNumberUpdateSMSHandling"></a>
# **companyNumberUpdateSMSHandling**
> Object companyNumberUpdateSMSHandling(id, info)

Update SMS Handling for Company Number

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | Company Number Id

var info = new PhonespeakApi.SMSHandling(); // SMSHandling | SMS handling info


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberUpdateSMSHandling(id, info, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Company Number Id | 
 **info** | [**SMSHandling**](SMSHandling.md)| SMS handling info | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="companyNumberUpdateSelectedIvrGreeting"></a>
# **companyNumberUpdateSelectedIvrGreeting**
> Object companyNumberUpdateSelectedIvrGreeting(id, ivrNumber, greetingId)

Update/Set a Company Number&#39;s default Voicemail Greeting

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | Team Id

var ivrNumber = "ivrNumber_example"; // String | Ivr Id

var greetingId = "greetingId_example"; // String | Greeting Id to set as default


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberUpdateSelectedIvrGreeting(id, ivrNumber, greetingId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 
 **ivrNumber** | **String**| Ivr Id | 
 **greetingId** | **String**| Greeting Id to set as default | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="companyNumberUploadIvrGreeting"></a>
# **companyNumberUploadIvrGreeting**
> Object companyNumberUploadIvrGreeting(id, ivrNumber, uploadIvrGreeting)

Upload Ivr Greeting File

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CompanyNumberApi();

var id = "id_example"; // String | Team Id

var ivrNumber = "ivrNumber_example"; // String | Ivr Id

var uploadIvrGreeting = "/path/to/file.txt"; // File | Upload voicemail greeting file


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.companyNumberUploadIvrGreeting(id, ivrNumber, uploadIvrGreeting, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 
 **ivrNumber** | **String**| Ivr Id | 
 **uploadIvrGreeting** | **File**| Upload voicemail greeting file | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json, application/xml

