# PhonespeakApi.CsrApi

All URIs are relative to *http://api-dev.phonespeak.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**csrAddNumber**](CsrApi.md#csrAddNumber) | **PUT** /client/Csr/Number/{id} | Add Phone Number
[**csrApplyInvoiceCoupon**](CsrApi.md#csrApplyInvoiceCoupon) | **POST** /client/Csr/Account/{id}/InvoiceCoupon | Apply Invoice Coupon
[**csrApplySubscriptionCoupon**](CsrApi.md#csrApplySubscriptionCoupon) | **POST** /client/Csr/Account/{id}/SubscriptionCoupon | Apply Subscription Coupon
[**csrCallLogExport**](CsrApi.md#csrCallLogExport) | **GET** /client/Csr/CallLog/Export | Export Call Log
[**csrCheckLnp**](CsrApi.md#csrCheckLnp) | **POST** /client/Csr/Account/Portin/CheckLnp | Check Lnp
[**csrCompleteOrder**](CsrApi.md#csrCompleteOrder) | **PUT** /client/Csr/Order/{orderId}/Complete | Complete Order
[**csrCreate**](CsrApi.md#csrCreate) | **POST** /client/Csr/Representative | Create a single Csr user
[**csrCreateAccount**](CsrApi.md#csrCreateAccount) | **POST** /client/Csr/Account | Create a single account
[**csrCreateLnp**](CsrApi.md#csrCreateLnp) | **POST** /client/Csr/Account/{accountId}/Portin | Create Lnp
[**csrCreateProduct**](CsrApi.md#csrCreateProduct) | **POST** /client/Csr/Product | Create Product
[**csrDelete**](CsrApi.md#csrDelete) | **DELETE** /client/Csr/Representative/{id} | Delete a single Csr user
[**csrDeleteLnp**](CsrApi.md#csrDeleteLnp) | **DELETE** /client/Csr/Account/{accountId}/Portin/{orderId} | Delete Lnp
[**csrDeleteTeammate**](CsrApi.md#csrDeleteTeammate) | **DELETE** /client/Csr/Account/{id}/Teammate/{teammateId} | Delete a single teammate
[**csrForgotPassword**](CsrApi.md#csrForgotPassword) | **POST** /client/Csr/ForgotPassword | Csr Forgot password
[**csrGet**](CsrApi.md#csrGet) | **GET** /client/Csr/Representative/{id} | Retrieve a single Csr user
[**csrGetAccount**](CsrApi.md#csrGetAccount) | **GET** /client/Csr/Account/{id} | Retrieve a single account
[**csrGetCallLog**](CsrApi.md#csrGetCallLog) | **GET** /client/Csr/CallLog/{id} | List all call log
[**csrGetLnp**](CsrApi.md#csrGetLnp) | **GET** /client/Csr/Account/{accountId}/Portin/{orderId} | Get Lnp
[**csrGetOrder**](CsrApi.md#csrGetOrder) | **GET** /client/Csr/Order/{orderId} | Get Order
[**csrGetUncoveredRate**](CsrApi.md#csrGetUncoveredRate) | **GET** /client/Csr/RateDeck/UncoveredRate | Get current Uncovered Rate
[**csrGiveCredit**](CsrApi.md#csrGiveCredit) | **POST** /client/Csr/Account/{id}/Credit | Give Credit
[**csrImportRateDeck**](CsrApi.md#csrImportRateDeck) | **POST** /client/Csr/RateDeck/Import | Import Rate Deck
[**csrList**](CsrApi.md#csrList) | **GET** /client/Csr/Representative | Retrieve list of Csr users
[**csrListAccountCompanyNumber**](CsrApi.md#csrListAccountCompanyNumber) | **GET** /client/Csr/Account/{id}/CompanyNumber | List all Company Numbers by account
[**csrListAccountPhoneNumber**](CsrApi.md#csrListAccountPhoneNumber) | **GET** /client/Csr/Account/{id}/PhoneNumber | List Phone Number
[**csrListAccountTeammate**](CsrApi.md#csrListAccountTeammate) | **GET** /client/Csr/Account/{id}/Teammate | Get all teammates by account
[**csrListAccounts**](CsrApi.md#csrListAccounts) | **GET** /client/Csr/Account | Retrieve list of all accounts
[**csrListCallLog**](CsrApi.md#csrListCallLog) | **GET** /client/Csr/CallLog | List all call log
[**csrListCharge**](CsrApi.md#csrListCharge) | **GET** /client/Csr/Account/{id}/Charge | List Charge
[**csrListLnp**](CsrApi.md#csrListLnp) | **POST** /client/Csr/Account/Portin/ListLnp | List Lnp
[**csrListOrder**](CsrApi.md#csrListOrder) | **GET** /client/Csr/Order/List | List Order
[**csrListPhysicalPhoneByOrderId**](CsrApi.md#csrListPhysicalPhoneByOrderId) | **GET** /client/Csr/Account/{id}/PhysicalPhone/{orderId} | List Physical Phone by orderId
[**csrLogin**](CsrApi.md#csrLogin) | **POST** /client/Csr/Login | Login
[**csrManualCharge**](CsrApi.md#csrManualCharge) | **POST** /client/Csr/Account/{id}/Charge | Manual Charge
[**csrMoveNumber**](CsrApi.md#csrMoveNumber) | **PUT** /client/Csr/Number/{id}/Move | Move Number
[**csrRefund**](CsrApi.md#csrRefund) | **GET** /client/Csr/Account/{accountId}/Refund/{chargeId} | Create Refund
[**csrUpdate**](CsrApi.md#csrUpdate) | **PUT** /client/Csr/Representative/{id} | Update a single Csr user
[**csrUpdateAccountDetails**](CsrApi.md#csrUpdateAccountDetails) | **PUT** /client/Csr/Account/{id} | Update account
[**csrUpdateAccountPackage**](CsrApi.md#csrUpdateAccountPackage) | **PUT** /client/Csr/Account/{id}/Package | Update account package
[**csrUpdateAccountSetting**](CsrApi.md#csrUpdateAccountSetting) | **PUT** /client/Csr/Account/{id}/Setting | Update Setting
[**csrUpdateAccountStatus**](CsrApi.md#csrUpdateAccountStatus) | **PUT** /client/Csr/Account/{id}/Status | Update Account Status
[**csrUpdateCsrPassword**](CsrApi.md#csrUpdateCsrPassword) | **PUT** /client/Csr/Representative/{id}/Password | Update a single Csr User Password
[**csrUpdateMacAddress**](CsrApi.md#csrUpdateMacAddress) | **PUT** /client/Csr/Account/{id}/PhysicalPhone | Update Physical Phone Mac Address
[**csrUpdateReferenceId**](CsrApi.md#csrUpdateReferenceId) | **PUT** /client/Csr/Order/{orderId}/Reference/{referenceId} | Update Reference Id
[**csrUpdateShippingAddress**](CsrApi.md#csrUpdateShippingAddress) | **PUT** /client/Csr/Order/{orderId}/Address | Update Shipping Address
[**csrUpdateTollFreeRateDeck**](CsrApi.md#csrUpdateTollFreeRateDeck) | **PUT** /client/Csr/RateDeck/TollFree | Update TollFree RateDeck
[**csrUpdateTrackingLink**](CsrApi.md#csrUpdateTrackingLink) | **POST** /client/Csr/Order/{orderId}/Tracking | Update Tracking Link
[**csrUpdateUncoveredRateDeck**](CsrApi.md#csrUpdateUncoveredRateDeck) | **PUT** /client/Csr/RateDeck/UncoveredRate | Update Uncovered RateDeck
[**csrUploadLoas**](CsrApi.md#csrUploadLoas) | **PUT** /client/Csr/Account/{id}/Portin/{orderId}/UploadLoas | Upoad Loas
[**csrUploadProfileImage**](CsrApi.md#csrUploadProfileImage) | **POST** /client/Csr/Representative/{id}/ProfileImage | Upload profile image (format-accepted: .gif |.jpg |.jpeg |.png)


<a name="csrAddNumber"></a>
# **csrAddNumber**
> Object csrAddNumber(id, phoneNumber)

Add Phone Number

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account Id

var phoneNumber = "phoneNumber_example"; // String | Phone Numbers


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrAddNumber(id, phoneNumber, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account Id | 
 **phoneNumber** | **String**| Phone Numbers | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrApplyInvoiceCoupon"></a>
# **csrApplyInvoiceCoupon**
> Object csrApplyInvoiceCoupon(id, couponId)

Apply Invoice Coupon

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account id

var couponId = "couponId_example"; // String | Coupon Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrApplyInvoiceCoupon(id, couponId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **couponId** | **String**| Coupon Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrApplySubscriptionCoupon"></a>
# **csrApplySubscriptionCoupon**
> Object csrApplySubscriptionCoupon(id, couponId)

Apply Subscription Coupon

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account Id

var couponId = "couponId_example"; // String | Coupon Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrApplySubscriptionCoupon(id, couponId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account Id | 
 **couponId** | **String**| Coupon Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrCallLogExport"></a>
# **csrCallLogExport**
> Object csrCallLogExport(fromDate, toDate, opts)

Export Call Log

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var fromDate = new Date("2013-10-20T19:20:30+01:00"); // Date | From date

var toDate = new Date("2013-10-20T19:20:30+01:00"); // Date | To date

var opts = { 
  'companyName': "companyName_example" // String | Company Name (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrCallLogExport(fromDate, toDate, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fromDate** | **Date**| From date | 
 **toDate** | **Date**| To date | 
 **companyName** | **String**| Company Name (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrCheckLnp"></a>
# **csrCheckLnp**
> Object csrCheckLnp(numbers)

Check Lnp

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var numbers = [new PhonespeakApi.[String]()]; // [String] | Number List


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrCheckLnp(numbers, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **numbers** | **[String]**| Number List | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="csrCompleteOrder"></a>
# **csrCompleteOrder**
> Object csrCompleteOrder(orderId)

Complete Order

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var orderId = "orderId_example"; // String | The order id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrCompleteOrder(orderId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **orderId** | **String**| The order id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrCreate"></a>
# **csrCreate**
> Object csrCreate(csrUser)

Create a single Csr user

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var csrUser = new PhonespeakApi.CsrUser(); // CsrUser | The Csr user object to create


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrCreate(csrUser, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **csrUser** | [**CsrUser**](CsrUser.md)| The Csr user object to create | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="csrCreateAccount"></a>
# **csrCreateAccount**
> Object csrCreateAccount(signUpInfo)

Create a single account

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var signUpInfo = new PhonespeakApi.SignupInfo(); // SignupInfo | Account Sign Up info


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrCreateAccount(signUpInfo, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **signUpInfo** | [**SignupInfo**](SignupInfo.md)| Account Sign Up info | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="csrCreateLnp"></a>
# **csrCreateLnp**
> Object csrCreateLnp(bandwidthPortin, accountId)

Create Lnp

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var bandwidthPortin = new PhonespeakApi.BandwidthPortin(); // BandwidthPortin | Bandwidth Portin Object

var accountId = "accountId_example"; // String | Account Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrCreateLnp(bandwidthPortin, accountId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bandwidthPortin** | [**BandwidthPortin**](BandwidthPortin.md)| Bandwidth Portin Object | 
 **accountId** | **String**| Account Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="csrCreateProduct"></a>
# **csrCreateProduct**
> Object csrCreateProduct(product)

Create Product

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var product = new PhonespeakApi.Product(); // Product | The Product Detail


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrCreateProduct(product, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **product** | [**Product**](Product.md)| The Product Detail | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="csrDelete"></a>
# **csrDelete**
> Object csrDelete(id)

Delete a single Csr user

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | The Csr user id to delete


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrDelete(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The Csr user id to delete | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrDeleteLnp"></a>
# **csrDeleteLnp**
> Object csrDeleteLnp(orderId, accountId)

Delete Lnp

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var orderId = "orderId_example"; // String | Order Id

var accountId = "accountId_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrDeleteLnp(orderId, accountId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **orderId** | **String**| Order Id | 
 **accountId** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrDeleteTeammate"></a>
# **csrDeleteTeammate**
> Object csrDeleteTeammate(id, teammateId)

Delete a single teammate

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account id

var teammateId = "teammateId_example"; // String | Teammate id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrDeleteTeammate(id, teammateId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **teammateId** | **String**| Teammate id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrForgotPassword"></a>
# **csrForgotPassword**
> Object csrForgotPassword(email)

Csr Forgot password

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var email = "email_example"; // String | Email


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrForgotPassword(email, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **String**| Email | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrGet"></a>
# **csrGet**
> Object csrGet(id)

Retrieve a single Csr user

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | The Csr user id to retrieve


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrGet(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The Csr user id to retrieve | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrGetAccount"></a>
# **csrGetAccount**
> Object csrGetAccount(id)

Retrieve a single account

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrGetAccount(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrGetCallLog"></a>
# **csrGetCallLog**
> Object csrGetCallLog(id)

List all call log

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | unique cdr id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrGetCallLog(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| unique cdr id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrGetLnp"></a>
# **csrGetLnp**
> Object csrGetLnp(orderId, accountId)

Get Lnp

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var orderId = "orderId_example"; // String | Order Id

var accountId = "accountId_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrGetLnp(orderId, accountId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **orderId** | **String**| Order Id | 
 **accountId** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrGetOrder"></a>
# **csrGetOrder**
> Object csrGetOrder(orderId)

Get Order

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var orderId = "orderId_example"; // String | The order id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrGetOrder(orderId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **orderId** | **String**| The order id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrGetUncoveredRate"></a>
# **csrGetUncoveredRate**
> Object csrGetUncoveredRate()

Get current Uncovered Rate

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrGetUncoveredRate(callback);
```

### Parameters
This endpoint does not need any parameter.

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrGiveCredit"></a>
# **csrGiveCredit**
> Object csrGiveCredit(id, amount)

Give Credit

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account id

var amount = 1.2; // Number | Amount given


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrGiveCredit(id, amount, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **amount** | **Number**| Amount given | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrImportRateDeck"></a>
# **csrImportRateDeck**
> Object csrImportRateDeck(importRateDeck)

Import Rate Deck

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var importRateDeck = "/path/to/file.txt"; // File | Import rate deck file


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrImportRateDeck(importRateDeck, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **importRateDeck** | **File**| Import rate deck file | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json, application/xml

<a name="csrList"></a>
# **csrList**
> Object csrList(opts)

Retrieve list of Csr users

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var opts = { 
  'search': "search_example", // String | Search text (optional)
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56 // Number | Page number to retrieve (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrList(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **search** | **String**| Search text (optional) | [optional] 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrListAccountCompanyNumber"></a>
# **csrListAccountCompanyNumber**
> Object csrListAccountCompanyNumber(id)

List all Company Numbers by account

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrListAccountCompanyNumber(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrListAccountPhoneNumber"></a>
# **csrListAccountPhoneNumber**
> Object csrListAccountPhoneNumber(id)

List Phone Number

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrListAccountPhoneNumber(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrListAccountTeammate"></a>
# **csrListAccountTeammate**
> Object csrListAccountTeammate(id)

Get all teammates by account

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrListAccountTeammate(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrListAccounts"></a>
# **csrListAccounts**
> Object csrListAccounts(opts)

Retrieve list of all accounts

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var opts = { 
  'status': 56, // Number | Account status
  'search': "search_example", // String | Search text
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56 // Number | Page number to retrieve (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrListAccounts(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **status** | **Number**| Account status | [optional] 
 **search** | **String**| Search text | [optional] 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrListCallLog"></a>
# **csrListCallLog**
> Object csrListCallLog(fromDate, toDate, opts)

List all call log

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var fromDate = new Date("2013-10-20T19:20:30+01:00"); // Date | From date

var toDate = new Date("2013-10-20T19:20:30+01:00"); // Date | To date

var opts = { 
  'companyName': "companyName_example", // String | Company Name (optional)
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56 // Number | Page number to retrieve (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrListCallLog(fromDate, toDate, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fromDate** | **Date**| From date | 
 **toDate** | **Date**| To date | 
 **companyName** | **String**| Company Name (optional) | [optional] 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrListCharge"></a>
# **csrListCharge**
> Object csrListCharge(id)

List Charge

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrListCharge(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrListLnp"></a>
# **csrListLnp**
> Object csrListLnp(bandwidthPortinSearch)

List Lnp

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var bandwidthPortinSearch = new PhonespeakApi.BandwidthPortinSearch(); // BandwidthPortinSearch | Bandwidth Search Object


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrListLnp(bandwidthPortinSearch, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bandwidthPortinSearch** | [**BandwidthPortinSearch**](BandwidthPortinSearch.md)| Bandwidth Search Object | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="csrListOrder"></a>
# **csrListOrder**
> Object csrListOrder(opts)

List Order

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var opts = { 
  'status': 56, // Number | Order Status (Value : 2-5)(Optional)
  'orderId': "orderId_example", // String | Order Id (Optional)
  'referenceId': "referenceId_example", // String | Reference Id (Optional)
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56 // Number | Page number to retrieve (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrListOrder(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **status** | **Number**| Order Status (Value : 2-5)(Optional) | [optional] 
 **orderId** | **String**| Order Id (Optional) | [optional] 
 **referenceId** | **String**| Reference Id (Optional) | [optional] 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrListPhysicalPhoneByOrderId"></a>
# **csrListPhysicalPhoneByOrderId**
> Object csrListPhysicalPhoneByOrderId(id, orderId)

List Physical Phone by orderId

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account id

var orderId = "orderId_example"; // String | The order id/ reference id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrListPhysicalPhoneByOrderId(id, orderId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **orderId** | **String**| The order id/ reference id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrLogin"></a>
# **csrLogin**
> Object csrLogin(authentication)

Login

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var authentication = new PhonespeakApi.Authentication(); // Authentication | Authentication details


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrLogin(authentication, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **authentication** | [**Authentication**](Authentication.md)| Authentication details | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="csrManualCharge"></a>
# **csrManualCharge**
> Object csrManualCharge(id, amount)

Manual Charge

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account id

var amount = 1.2; // Number | Charge amount


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrManualCharge(id, amount, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **amount** | **Number**| Charge amount | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrMoveNumber"></a>
# **csrMoveNumber**
> Object csrMoveNumber(id, phoneNumberId, assignTo)

Move Number

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account Id

var phoneNumberId = "phoneNumberId_example"; // String | Phone Number Id

var assignTo = "assignTo_example"; // String | Assign to 's owner Id (Un-assign = \"\")


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrMoveNumber(id, phoneNumberId, assignTo, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account Id | 
 **phoneNumberId** | **String**| Phone Number Id | 
 **assignTo** | **String**| Assign to &#39;s owner Id (Un-assign &#x3D; \&quot;\&quot;) | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrRefund"></a>
# **csrRefund**
> Object csrRefund(accountId, chargeId, amount)

Create Refund

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var accountId = "accountId_example"; // String | Account Id

var chargeId = "chargeId_example"; // String | Charge Id

var amount = 1.2; // Number | Refund Amount


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrRefund(accountId, chargeId, amount, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**| Account Id | 
 **chargeId** | **String**| Charge Id | 
 **amount** | **Number**| Refund Amount | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrUpdate"></a>
# **csrUpdate**
> Object csrUpdate(id, csrUser)

Update a single Csr user

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | The  Csr user id to update

var csrUser = new PhonespeakApi.CsrUser(); // CsrUser | The Csr user object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrUpdate(id, csrUser, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The  Csr user id to update | 
 **csrUser** | [**CsrUser**](CsrUser.md)| The Csr user object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="csrUpdateAccountDetails"></a>
# **csrUpdateAccountDetails**
> Object csrUpdateAccountDetails(id, csrAccount)

Update account

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account id

var csrAccount = new PhonespeakApi.CsrAccount(); // CsrAccount | New account details


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrUpdateAccountDetails(id, csrAccount, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **csrAccount** | [**CsrAccount**](CsrAccount.md)| New account details | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="csrUpdateAccountPackage"></a>
# **csrUpdateAccountPackage**
> Object csrUpdateAccountPackage(id, packageId)

Update account package

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account Id

var packageId = "packageId_example"; // String | Package Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrUpdateAccountPackage(id, packageId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account Id | 
 **packageId** | **String**| Package Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrUpdateAccountSetting"></a>
# **csrUpdateAccountSetting**
> Object csrUpdateAccountSetting(id, setting)

Update Setting

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account id

var setting = new PhonespeakApi.AccountSetting(); // AccountSetting | Setting


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrUpdateAccountSetting(id, setting, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **setting** | [**AccountSetting**](AccountSetting.md)| Setting | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="csrUpdateAccountStatus"></a>
# **csrUpdateAccountStatus**
> Object csrUpdateAccountStatus(id, status)

Update Account Status

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | 

var status = 56; // Number | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrUpdateAccountStatus(id, status, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 
 **status** | **Number**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrUpdateCsrPassword"></a>
# **csrUpdateCsrPassword**
> Object csrUpdateCsrPassword(id, password)

Update a single Csr User Password

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | The  Csr user id to update

var password = "password_example"; // String | New password


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrUpdateCsrPassword(id, password, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The  Csr user id to update | 
 **password** | **String**| New password | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrUpdateMacAddress"></a>
# **csrUpdateMacAddress**
> Object csrUpdateMacAddress(id, deskphoneMacAddress)

Update Physical Phone Mac Address

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account id

var deskphoneMacAddress = [new PhonespeakApi.DeskphoneMacAddress()]; // [DeskphoneMacAddress] | List of desk phone


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrUpdateMacAddress(id, deskphoneMacAddress, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **deskphoneMacAddress** | [**[DeskphoneMacAddress]**](DeskphoneMacAddress.md)| List of desk phone | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="csrUpdateReferenceId"></a>
# **csrUpdateReferenceId**
> Object csrUpdateReferenceId(orderId, referenceId)

Update Reference Id

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var orderId = "orderId_example"; // String | The order id

var referenceId = "referenceId_example"; // String | The reference id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrUpdateReferenceId(orderId, referenceId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **orderId** | **String**| The order id | 
 **referenceId** | **String**| The reference id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrUpdateShippingAddress"></a>
# **csrUpdateShippingAddress**
> Object csrUpdateShippingAddress(orderId, address)

Update Shipping Address

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var orderId = "orderId_example"; // String | The order id

var address = new PhonespeakApi.Address(); // Address | Shipping Address


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrUpdateShippingAddress(orderId, address, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **orderId** | **String**| The order id | 
 **address** | [**Address**](Address.md)| Shipping Address | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="csrUpdateTollFreeRateDeck"></a>
# **csrUpdateTollFreeRateDeck**
> Object csrUpdateTollFreeRateDeck(rate)

Update TollFree RateDeck

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var rate = 1.2; // Number | New rate


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrUpdateTollFreeRateDeck(rate, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **rate** | **Number**| New rate | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrUpdateTrackingLink"></a>
# **csrUpdateTrackingLink**
> Object csrUpdateTrackingLink(orderId, info)

Update Tracking Link

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var orderId = "orderId_example"; // String | The order id

var info = new PhonespeakApi.TrackingRequest(); // TrackingRequest | The tracking info


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrUpdateTrackingLink(orderId, info, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **orderId** | **String**| The order id | 
 **info** | [**TrackingRequest**](TrackingRequest.md)| The tracking info | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="csrUpdateUncoveredRateDeck"></a>
# **csrUpdateUncoveredRateDeck**
> Object csrUpdateUncoveredRateDeck(rate)

Update Uncovered RateDeck

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var rate = 1.2; // Number | New rate


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrUpdateUncoveredRateDeck(rate, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **rate** | **Number**| New rate | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrUploadLoas"></a>
# **csrUploadLoas**
> Object csrUploadLoas(id, orderId)

Upoad Loas

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Account id

var orderId = "orderId_example"; // String | Order Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrUploadLoas(id, orderId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Account id | 
 **orderId** | **String**| Order Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="csrUploadProfileImage"></a>
# **csrUploadProfileImage**
> Object csrUploadProfileImage(id, profileImage)

Upload profile image (format-accepted: .gif |.jpg |.jpeg |.png)

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.CsrApi();

var id = "id_example"; // String | Csr user id

var profileImage = new PhonespeakApi.ProfileImage(); // ProfileImage | Profile image(base64)


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.csrUploadProfileImage(id, profileImage, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Csr user id | 
 **profileImage** | [**ProfileImage**](ProfileImage.md)| Profile image(base64) | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

