# PhonespeakApi.DeskPhoneApi

All URIs are relative to *http://api-dev.phonespeak.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deskPhoneAddToCart**](DeskPhoneApi.md#deskPhoneAddToCart) | **POST** /client/deskphone/Cart | Add to Cart
[**deskPhoneConfirmOrder**](DeskPhoneApi.md#deskPhoneConfirmOrder) | **PUT** /client/deskphone/Order/Confirm/{orderId} | Confirm Order
[**deskPhoneDeleteAllCartByOwnerId**](DeskPhoneApi.md#deskPhoneDeleteAllCartByOwnerId) | **DELETE** /client/deskphone/Cart/Owner/{ownerId} | Delete All Cart By Owner Id
[**deskPhoneDeleteCart**](DeskPhoneApi.md#deskPhoneDeleteCart) | **DELETE** /client/deskphone/Cart/{cartId} | Delete Single cart
[**deskPhoneGetCart**](DeskPhoneApi.md#deskPhoneGetCart) | **GET** /client/deskphone/Cart/{cartId} | Get Single cart
[**deskPhoneGetOrder**](DeskPhoneApi.md#deskPhoneGetOrder) | **GET** /client/deskphone/Order/{orderId} | Get Order
[**deskPhoneGetProduct**](DeskPhoneApi.md#deskPhoneGetProduct) | **GET** /client/deskphone/Product/{productId} | Get Product
[**deskPhoneListCart**](DeskPhoneApi.md#deskPhoneListCart) | **GET** /client/deskphone/Cart/{ownerId}/List | Get List of Cart by owner id
[**deskPhoneListDeskPhone**](DeskPhoneApi.md#deskPhoneListDeskPhone) | **GET** /client/deskphone/DeskPhone/List | List DeskPhone
[**deskPhoneListOrder**](DeskPhoneApi.md#deskPhoneListOrder) | **GET** /client/deskphone/Order/{ownerId}/List | List Order by OwnerId
[**deskPhoneListProduct**](DeskPhoneApi.md#deskPhoneListProduct) | **GET** /client/deskphone/Product | Get List of Product
[**deskPhoneListShippingOption**](DeskPhoneApi.md#deskPhoneListShippingOption) | **GET** /client/deskphone/ShippingOption/List | List Shipping Option
[**deskPhonePlaceOrder**](DeskPhoneApi.md#deskPhonePlaceOrder) | **POST** /client/deskphone/Order/Place | Place Order
[**deskPhoneUpdateCart**](DeskPhoneApi.md#deskPhoneUpdateCart) | **PUT** /client/deskphone/Cart/{cartId} | Update Single cart
[**deskPhoneUpdateCarts**](DeskPhoneApi.md#deskPhoneUpdateCarts) | **PUT** /client/deskphone/Cart | Update List of Cart


<a name="deskPhoneAddToCart"></a>
# **deskPhoneAddToCart**
> Object deskPhoneAddToCart(cart)

Add to Cart

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.DeskPhoneApi();

var cart = new PhonespeakApi.Cart(); // Cart | The cart detail


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deskPhoneAddToCart(cart, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cart** | [**Cart**](Cart.md)| The cart detail | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="deskPhoneConfirmOrder"></a>
# **deskPhoneConfirmOrder**
> Object deskPhoneConfirmOrder(orderId)

Confirm Order

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.DeskPhoneApi();

var orderId = "orderId_example"; // String | The order id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deskPhoneConfirmOrder(orderId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **orderId** | **String**| The order id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="deskPhoneDeleteAllCartByOwnerId"></a>
# **deskPhoneDeleteAllCartByOwnerId**
> Object deskPhoneDeleteAllCartByOwnerId(ownerId)

Delete All Cart By Owner Id

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.DeskPhoneApi();

var ownerId = "ownerId_example"; // String | The owner Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deskPhoneDeleteAllCartByOwnerId(ownerId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ownerId** | **String**| The owner Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="deskPhoneDeleteCart"></a>
# **deskPhoneDeleteCart**
> Object deskPhoneDeleteCart(cartId)

Delete Single cart

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.DeskPhoneApi();

var cartId = "cartId_example"; // String | The cart id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deskPhoneDeleteCart(cartId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cartId** | **String**| The cart id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="deskPhoneGetCart"></a>
# **deskPhoneGetCart**
> Object deskPhoneGetCart(cartId)

Get Single cart

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.DeskPhoneApi();

var cartId = "cartId_example"; // String | The cart id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deskPhoneGetCart(cartId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cartId** | **String**| The cart id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="deskPhoneGetOrder"></a>
# **deskPhoneGetOrder**
> Object deskPhoneGetOrder(orderId)

Get Order

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.DeskPhoneApi();

var orderId = "orderId_example"; // String | The order id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deskPhoneGetOrder(orderId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **orderId** | **String**| The order id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="deskPhoneGetProduct"></a>
# **deskPhoneGetProduct**
> Object deskPhoneGetProduct(productId)

Get Product

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.DeskPhoneApi();

var productId = "productId_example"; // String | The product id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deskPhoneGetProduct(productId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **productId** | **String**| The product id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="deskPhoneListCart"></a>
# **deskPhoneListCart**
> Object deskPhoneListCart(ownerId)

Get List of Cart by owner id

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.DeskPhoneApi();

var ownerId = "ownerId_example"; // String | The Owner Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deskPhoneListCart(ownerId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ownerId** | **String**| The Owner Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="deskPhoneListDeskPhone"></a>
# **deskPhoneListDeskPhone**
> Object deskPhoneListDeskPhone(accountId)

List DeskPhone

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.DeskPhoneApi();

var accountId = "accountId_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deskPhoneListDeskPhone(accountId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="deskPhoneListOrder"></a>
# **deskPhoneListOrder**
> Object deskPhoneListOrder(ownerId)

List Order by OwnerId

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.DeskPhoneApi();

var ownerId = "ownerId_example"; // String | The owner id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deskPhoneListOrder(ownerId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ownerId** | **String**| The owner id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="deskPhoneListProduct"></a>
# **deskPhoneListProduct**
> Object deskPhoneListProduct(opts)

Get List of Product

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.DeskPhoneApi();

var opts = { 
  'size': 56, // Number | The size
  'page': 56 // Number | The page
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deskPhoneListProduct(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **size** | **Number**| The size | [optional] 
 **page** | **Number**| The page | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="deskPhoneListShippingOption"></a>
# **deskPhoneListShippingOption**
> Object deskPhoneListShippingOption()

List Shipping Option

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.DeskPhoneApi();

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deskPhoneListShippingOption(callback);
```

### Parameters
This endpoint does not need any parameter.

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="deskPhonePlaceOrder"></a>
# **deskPhonePlaceOrder**
> Object deskPhonePlaceOrder(order)

Place Order

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.DeskPhoneApi();

var order = new PhonespeakApi.Order(); // Order | The order detail


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deskPhonePlaceOrder(order, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **order** | [**Order**](Order.md)| The order detail | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="deskPhoneUpdateCart"></a>
# **deskPhoneUpdateCart**
> Object deskPhoneUpdateCart(cart, cartId)

Update Single cart

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.DeskPhoneApi();

var cart = new PhonespeakApi.Cart(); // Cart | The cart object

var cartId = "cartId_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deskPhoneUpdateCart(cart, cartId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cart** | [**Cart**](Cart.md)| The cart object | 
 **cartId** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="deskPhoneUpdateCarts"></a>
# **deskPhoneUpdateCarts**
> Object deskPhoneUpdateCarts(carts)

Update List of Cart

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.DeskPhoneApi();

var carts = [new PhonespeakApi.Cart()]; // [Cart] | The list cart object


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deskPhoneUpdateCarts(carts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **carts** | [**[Cart]**](Cart.md)| The list cart object | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

