# PhonespeakApi.NoteApi

All URIs are relative to *http://api-dev.phonespeak.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**noteCreate**](NoteApi.md#noteCreate) | **POST** /client/note/Create | Create a single note
[**noteDelete**](NoteApi.md#noteDelete) | **DELETE** /client/note/{noteId} | Delete note
[**noteGet**](NoteApi.md#noteGet) | **GET** /client/note/{noteId} | Retrieve a single Note
[**noteList**](NoteApi.md#noteList) | **GET** /client/note/{ownerId}/List | List Notes
[**noteUpdate**](NoteApi.md#noteUpdate) | **PUT** /client/note/{noteId} | Update note


<a name="noteCreate"></a>
# **noteCreate**
> Object noteCreate(ownerId, content, accountId)

Create a single note

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.NoteApi();

var ownerId = "ownerId_example"; // String | The owner id (tight which record)

var content = "content_example"; // String | The content

var accountId = "accountId_example"; // String | Account Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.noteCreate(ownerId, content, accountId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ownerId** | **String**| The owner id (tight which record) | 
 **content** | **String**| The content | 
 **accountId** | **String**| Account Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="noteDelete"></a>
# **noteDelete**
> Object noteDelete(noteId, accountId)

Delete note

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.NoteApi();

var noteId = "noteId_example"; // String | The note id

var accountId = "accountId_example"; // String | The note id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.noteDelete(noteId, accountId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **noteId** | **String**| The note id | 
 **accountId** | **String**| The note id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="noteGet"></a>
# **noteGet**
> Object noteGet(noteId, accountId)

Retrieve a single Note

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.NoteApi();

var noteId = "noteId_example"; // String | The note id

var accountId = "accountId_example"; // String | Account Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.noteGet(noteId, accountId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **noteId** | **String**| The note id | 
 **accountId** | **String**| Account Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="noteList"></a>
# **noteList**
> Object noteList(ownerId, accountId, opts)

List Notes

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.NoteApi();

var ownerId = "ownerId_example"; // String | Owner Id to retrieve

var accountId = "accountId_example"; // String | Account Id

var opts = { 
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56 // Number | Page number to retrieve (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.noteList(ownerId, accountId, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ownerId** | **String**| Owner Id to retrieve | 
 **accountId** | **String**| Account Id | 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="noteUpdate"></a>
# **noteUpdate**
> Object noteUpdate(noteId, content, accountId)

Update note

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.NoteApi();

var noteId = "noteId_example"; // String | The note id

var content = "content_example"; // String | The new content

var accountId = "accountId_example"; // String | Account Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.noteUpdate(noteId, content, accountId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **noteId** | **String**| The note id | 
 **content** | **String**| The new content | 
 **accountId** | **String**| Account Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

