# PhonespeakApi.NumberApi

All URIs are relative to *http://api-dev.phonespeak.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**numberGet**](NumberApi.md#numberGet) | **POST** /client/Number/Get | Get List of Numbers
[**numberGetAreaCode**](NumberApi.md#numberGetAreaCode) | **GET** /client/Number/GetAreaCodes | Get Area Codes
[**numberGetPhoneNumDetails**](NumberApi.md#numberGetPhoneNumDetails) | **GET** /client/Number/GetPhoneNumDetails | Get Phone Number Detail
[**numberGetStates**](NumberApi.md#numberGetStates) | **GET** /client/Number/GetStates | Get available states
[**numberGetUserState**](NumberApi.md#numberGetUserState) | **GET** /client/Number/UserState | 
[**numberMoveNumber**](NumberApi.md#numberMoveNumber) | **PUT** /client/Number/{id}/Move | Move Number
[**numberReserve**](NumberApi.md#numberReserve) | **POST** /client/Number/Reserve | Reserve Number
[**numberValidateE911Address**](NumberApi.md#numberValidateE911Address) | **POST** /client/Number/E911Address | Validate the E911 address


<a name="numberGet"></a>
# **numberGet**
> Object numberGet(getModel)

Get List of Numbers

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.NumberApi();

var getModel = new PhonespeakApi.GetNumber(); // GetNumber | Get Number model


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.numberGet(getModel, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **getModel** | [**GetNumber**](GetNumber.md)| Get Number model | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="numberGetAreaCode"></a>
# **numberGetAreaCode**
> Object numberGetAreaCode(stateCode, isTollFree)

Get Area Codes

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.NumberApi();

var stateCode = "stateCode_example"; // String | State Code

var isTollFree = true; // Boolean | Toll Free


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.numberGetAreaCode(stateCode, isTollFree, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **stateCode** | **String**| State Code | 
 **isTollFree** | **Boolean**| Toll Free | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="numberGetPhoneNumDetails"></a>
# **numberGetPhoneNumDetails**
> Object numberGetPhoneNumDetails(_number)

Get Phone Number Detail

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.NumberApi();

var _number = "_number_example"; // String | Number


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.numberGetPhoneNumDetails(_number, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_number** | **String**| Number | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="numberGetStates"></a>
# **numberGetStates**
> Object numberGetStates(opts)

Get available states

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.NumberApi();

var opts = { 
  'country': "country_example" // String | 
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.numberGetStates(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **country** | **String**|  | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="numberGetUserState"></a>
# **numberGetUserState**
> Object numberGetUserState()



### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.NumberApi();

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.numberGetUserState(callback);
```

### Parameters
This endpoint does not need any parameter.

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="numberMoveNumber"></a>
# **numberMoveNumber**
> Object numberMoveNumber(id, accountId, assignTo)

Move Number

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.NumberApi();

var id = "id_example"; // String | Phone Number Id

var accountId = "accountId_example"; // String | Account Id

var assignTo = "assignTo_example"; // String | Assign to 's owner Id (Un-assign = \"\")


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.numberMoveNumber(id, accountId, assignTo, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Phone Number Id | 
 **accountId** | **String**| Account Id | 
 **assignTo** | **String**| Assign to &#39;s owner Id (Un-assign &#x3D; \&quot;\&quot;) | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="numberReserve"></a>
# **numberReserve**
> Object numberReserve(reserveModel)

Reserve Number

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.NumberApi();

var reserveModel = new PhonespeakApi.ReserveNumber(); // ReserveNumber | Reserve model


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.numberReserve(reserveModel, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **reserveModel** | [**ReserveNumber**](ReserveNumber.md)| Reserve model | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="numberValidateE911Address"></a>
# **numberValidateE911Address**
> Object numberValidateE911Address(address)

Validate the E911 address

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.NumberApi();

var address = new PhonespeakApi.E911Address(); // E911Address | E911 model


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.numberValidateE911Address(address, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **address** | [**E911Address**](E911Address.md)| E911 model | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

