# PhonespeakApi.SmsApi

All URIs are relative to *http://api-dev.phonespeak.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**smsCreateBandwidthSmsInbound**](SmsApi.md#smsCreateBandwidthSmsInbound) | **POST** /client/Sms/Bandwidth | Receive SMS from Bandwidth
[**smsCreateBandwidthSmsInboundV2**](SmsApi.md#smsCreateBandwidthSmsInboundV2) | **POST** /client/Sms/Bandwidth/v2 | Receive SMS from Bandwidth
[**smsCreateIntelliquentSmsInbound**](SmsApi.md#smsCreateIntelliquentSmsInbound) | **POST** /client/Sms/Inteliquent | Receive SMS from Inteliquent


<a name="smsCreateBandwidthSmsInbound"></a>
# **smsCreateBandwidthSmsInbound**
> Object smsCreateBandwidthSmsInbound(smsInbound)

Receive SMS from Bandwidth

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SmsApi();

var smsInbound = new PhonespeakApi.SmsInbound(); // SmsInbound | sms inbound from Bandwidth


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.smsCreateBandwidthSmsInbound(smsInbound, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **smsInbound** | [**SmsInbound**](SmsInbound.md)| sms inbound from Bandwidth | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="smsCreateBandwidthSmsInboundV2"></a>
# **smsCreateBandwidthSmsInboundV2**
> Object smsCreateBandwidthSmsInboundV2(incomingMessages)

Receive SMS from Bandwidth

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SmsApi();

var incomingMessages = [new PhonespeakApi.IncomingMessage()]; // [IncomingMessage] | sms inbound from Bandwidth


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.smsCreateBandwidthSmsInboundV2(incomingMessages, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **incomingMessages** | [**[IncomingMessage]**](IncomingMessage.md)| sms inbound from Bandwidth | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="smsCreateIntelliquentSmsInbound"></a>
# **smsCreateIntelliquentSmsInbound**
> Object smsCreateIntelliquentSmsInbound(inteliquentSmsInbound)

Receive SMS from Inteliquent

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SmsApi();

var inteliquentSmsInbound = new PhonespeakApi.InteliquentSMSInbound(); // InteliquentSMSInbound | sms inbound from Inteliquent


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.smsCreateIntelliquentSmsInbound(inteliquentSmsInbound, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **inteliquentSmsInbound** | [**InteliquentSMSInbound**](InteliquentSMSInbound.md)| sms inbound from Inteliquent | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

