# PhonespeakApi.SubscriptionApi

All URIs are relative to *http://api-dev.phonespeak.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**subscriptionCreatePackage**](SubscriptionApi.md#subscriptionCreatePackage) | **POST** /client/subscription/Package | Create Package
[**subscriptionCreateUrl**](SubscriptionApi.md#subscriptionCreateUrl) | **POST** /client/subscription/Url/Create | Create Url
[**subscriptionDelete**](SubscriptionApi.md#subscriptionDelete) | **DELETE** /client/subscription/Package/{id} | Delete a single package
[**subscriptionDeleteUrl**](SubscriptionApi.md#subscriptionDeleteUrl) | **DELETE** /client/subscription/Url/{urlId} | Delete Url
[**subscriptionGetUrl**](SubscriptionApi.md#subscriptionGetUrl) | **GET** /client/subscription/Url/{urlId} | Get Single Url
[**subscriptionListInvoiceCoupon**](SubscriptionApi.md#subscriptionListInvoiceCoupon) | **GET** /client/subscription/Coupon/Invoice | List Invoice Coupon
[**subscriptionListPackage**](SubscriptionApi.md#subscriptionListPackage) | **GET** /client/subscription/Package | List all Package
[**subscriptionListPackagePlan**](SubscriptionApi.md#subscriptionListPackagePlan) | **GET** /client/subscription/Package/Plan | List all plan
[**subscriptionListPlan**](SubscriptionApi.md#subscriptionListPlan) | **GET** /client/subscription/Plan/{packageId} | List Plan
[**subscriptionListStripeProduct**](SubscriptionApi.md#subscriptionListStripeProduct) | **GET** /client/subscription/StripeProduct/List | Get List of Stripe Product
[**subscriptionListSubscriptionCoupon**](SubscriptionApi.md#subscriptionListSubscriptionCoupon) | **GET** /client/subscription/Coupon/Subscription | List Subscription Coupon
[**subscriptionListUrl**](SubscriptionApi.md#subscriptionListUrl) | **GET** /client/subscription/Url/List | Get list of url
[**subscriptionUpdatePackage**](SubscriptionApi.md#subscriptionUpdatePackage) | **PUT** /client/subscription/Package/{id} | Update Package
[**subscriptionUpdateUrl**](SubscriptionApi.md#subscriptionUpdateUrl) | **PUT** /client/subscription/Url/{urlId} | Update Url


<a name="subscriptionCreatePackage"></a>
# **subscriptionCreatePackage**
> Object subscriptionCreatePackage(_package)

Create Package

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SubscriptionApi();

var _package = new PhonespeakApi.ModelPackage(); // ModelPackage | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.subscriptionCreatePackage(_package, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_package** | [**ModelPackage**](ModelPackage.md)|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="subscriptionCreateUrl"></a>
# **subscriptionCreateUrl**
> Object subscriptionCreateUrl(url)

Create Url

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SubscriptionApi();

var url = new PhonespeakApi.Url(); // Url | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.subscriptionCreateUrl(url, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **url** | [**Url**](Url.md)|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="subscriptionDelete"></a>
# **subscriptionDelete**
> Object subscriptionDelete(id)

Delete a single package

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SubscriptionApi();

var id = "id_example"; // String | The package id to be delete


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.subscriptionDelete(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The package id to be delete | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="subscriptionDeleteUrl"></a>
# **subscriptionDeleteUrl**
> Object subscriptionDeleteUrl(urlId)

Delete Url

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SubscriptionApi();

var urlId = "urlId_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.subscriptionDeleteUrl(urlId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **urlId** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="subscriptionGetUrl"></a>
# **subscriptionGetUrl**
> Object subscriptionGetUrl(urlId)

Get Single Url

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SubscriptionApi();

var urlId = "urlId_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.subscriptionGetUrl(urlId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **urlId** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="subscriptionListInvoiceCoupon"></a>
# **subscriptionListInvoiceCoupon**
> Object subscriptionListInvoiceCoupon()

List Invoice Coupon

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SubscriptionApi();

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.subscriptionListInvoiceCoupon(callback);
```

### Parameters
This endpoint does not need any parameter.

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="subscriptionListPackage"></a>
# **subscriptionListPackage**
> Object subscriptionListPackage(opts)

List all Package

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SubscriptionApi();

var opts = { 
  'currency': "currency_example", // String | Bill Interval: \"usd\" or \"myr\"
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56 // Number | Page number to retrieve (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.subscriptionListPackage(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **currency** | **String**| Bill Interval: \&quot;usd\&quot; or \&quot;myr\&quot; | [optional] 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="subscriptionListPackagePlan"></a>
# **subscriptionListPackagePlan**
> Object subscriptionListPackagePlan(billInterval, currency)

List all plan

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SubscriptionApi();

var billInterval = "billInterval_example"; // String | Bill Interval: \"month\" or \"year\"

var currency = "currency_example"; // String | Currency


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.subscriptionListPackagePlan(billInterval, currency, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **billInterval** | **String**| Bill Interval: \&quot;month\&quot; or \&quot;year\&quot; | 
 **currency** | **String**| Currency | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="subscriptionListPlan"></a>
# **subscriptionListPlan**
> Object subscriptionListPlan(packageId)

List Plan

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SubscriptionApi();

var packageId = "packageId_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.subscriptionListPlan(packageId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **packageId** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="subscriptionListStripeProduct"></a>
# **subscriptionListStripeProduct**
> Object subscriptionListStripeProduct()

Get List of Stripe Product

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SubscriptionApi();

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.subscriptionListStripeProduct(callback);
```

### Parameters
This endpoint does not need any parameter.

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="subscriptionListSubscriptionCoupon"></a>
# **subscriptionListSubscriptionCoupon**
> Object subscriptionListSubscriptionCoupon()

List Subscription Coupon

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SubscriptionApi();

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.subscriptionListSubscriptionCoupon(callback);
```

### Parameters
This endpoint does not need any parameter.

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="subscriptionListUrl"></a>
# **subscriptionListUrl**
> Object subscriptionListUrl(opts)

Get list of url

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SubscriptionApi();

var opts = { 
  'currency': "currency_example", // String | 
  'size': 56, // Number | 
  'pageNum': 56 // Number | 
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.subscriptionListUrl(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **currency** | **String**|  | [optional] 
 **size** | **Number**|  | [optional] 
 **pageNum** | **Number**|  | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="subscriptionUpdatePackage"></a>
# **subscriptionUpdatePackage**
> Object subscriptionUpdatePackage(id, _package)

Update Package

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SubscriptionApi();

var id = "id_example"; // String | 

var _package = new PhonespeakApi.ModelPackage(); // ModelPackage | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.subscriptionUpdatePackage(id, _package, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 
 **_package** | [**ModelPackage**](ModelPackage.md)|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="subscriptionUpdateUrl"></a>
# **subscriptionUpdateUrl**
> Object subscriptionUpdateUrl(urlId, url)

Update Url

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.SubscriptionApi();

var urlId = "urlId_example"; // String | 

var url = new PhonespeakApi.Url(); // Url | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.subscriptionUpdateUrl(urlId, url, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **urlId** | **String**|  | 
 **url** | [**Url**](Url.md)|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

