# PhonespeakApi.TeamApi

All URIs are relative to *http://api-dev.phonespeak.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**teamConvertTextToSpeech**](TeamApi.md#teamConvertTextToSpeech) | **POST** /client/Team/{id}/VoicemailGreeting/SpeechGreeting | Convert text to speech
[**teamCreate**](TeamApi.md#teamCreate) | **POST** /client/Team | Create a single team
[**teamCreateIvr**](TeamApi.md#teamCreateIvr) | **POST** /client/Team/{id}/Ivr | Create team&#39;s ivr
[**teamDelete**](TeamApi.md#teamDelete) | **DELETE** /client/Team/{id} | Delete a single team
[**teamDeleteIvr**](TeamApi.md#teamDeleteIvr) | **DELETE** /client/Team/{id}/Ivr/{ivrNumber} | Delete team&#39;s ivr
[**teamDeleteIvrGreeting**](TeamApi.md#teamDeleteIvrGreeting) | **DELETE** /client/Team/{id}/Ivr/{ivrNumber}/Greeting/{greetingId} | Delete Ivr Greeting File
[**teamDeleteMusicOnHold**](TeamApi.md#teamDeleteMusicOnHold) | **DELETE** /client/Team/{id}/MusicOnHold/{mohId} | Delete MusicOnHold file
[**teamDeleteVoicemailGreeting**](TeamApi.md#teamDeleteVoicemailGreeting) | **DELETE** /client/Team/{id}/VoicemailGreeting/{voicemailId} | Delete Voicemail Greeting File
[**teamGet**](TeamApi.md#teamGet) | **GET** /client/Team/{id} | Retrieve a single team by id
[**teamIvrConvertTextToSpeech**](TeamApi.md#teamIvrConvertTextToSpeech) | **POST** /client/Team/{id}/Ivr/{ivrNumber}/Greeting/SpeechGreeting | Ivr Convert text to speech
[**teamList**](TeamApi.md#teamList) | **GET** /client/Team | List all teams by account
[**teamListAvailableNumber**](TeamApi.md#teamListAvailableNumber) | **GET** /client/Team/{id}/AvailableNumber | List Caller Id
[**teamListAvailableTeammates**](TeamApi.md#teamListAvailableTeammates) | **GET** /client/Team/{id}/ListAvailableTeammates | Get Teammate list for team
[**teamListIvrGreetings**](TeamApi.md#teamListIvrGreetings) | **GET** /client/Team/{id}/Ivr/{ivrNumber}/Greeting | List Ivr Greetings for a team
[**teamListMusicOnHold**](TeamApi.md#teamListMusicOnHold) | **GET** /client/Team/{id}/MusicOnHold | List MusicOnHolds for team
[**teamListTeamsByTeammate**](TeamApi.md#teamListTeamsByTeammate) | **GET** /client/Team/Teammate | List all teams by teammate
[**teamListVoicemailGreetings**](TeamApi.md#teamListVoicemailGreetings) | **GET** /client/Team/{id}/VoicemailGreeting | List Voicemail Greetings for a team
[**teamTeamSummary**](TeamApi.md#teamTeamSummary) | **GET** /client/Team/{teamId}/TeamSummary | Team Summary
[**teamUpdate**](TeamApi.md#teamUpdate) | **PUT** /client/Team/{id} | Update a single team
[**teamUpdateBusinessHour**](TeamApi.md#teamUpdateBusinessHour) | **PUT** /client/Team/{id}/BusinessHour | Update team business hour
[**teamUpdateCallQueue**](TeamApi.md#teamUpdateCallQueue) | **PUT** /client/Team/{id}/CallQueue | Update team&#39;s call queue
[**teamUpdateCallRouting**](TeamApi.md#teamUpdateCallRouting) | **PUT** /client/Team/{id}/CallRouting | Update team call routing
[**teamUpdateClosedHourHandling**](TeamApi.md#teamUpdateClosedHourHandling) | **PUT** /client/Team/{id}/ClosedHourHandling | Update team close hour call handling
[**teamUpdateIvrKey**](TeamApi.md#teamUpdateIvrKey) | **PUT** /client/Team/{id}/Ivr/{ivrNumber}/IvrKey/{keyNumber} | Update Ivr Key
[**teamUpdateIvrName**](TeamApi.md#teamUpdateIvrName) | **PUT** /client/Team/{id}/Ivr/{ivrNumber}/Name/{ivrName} | Update team&#39;s ivr
[**teamUpdateIvrTimeout**](TeamApi.md#teamUpdateIvrTimeout) | **PUT** /client/Team/{id}/Ivr/{ivrNumber} | Update Ivr Timeout
[**teamUpdateMissedCallHandling**](TeamApi.md#teamUpdateMissedCallHandling) | **PUT** /client/Team/{id}/MissedCallHandling | Update team miss call handling
[**teamUpdateOpenHourHandling**](TeamApi.md#teamUpdateOpenHourHandling) | **PUT** /client/Team/{id}/OpenHourHandling | Update team open hour call handling
[**teamUpdateRingGroup**](TeamApi.md#teamUpdateRingGroup) | **PUT** /client/Team/{id}/RingGroup | Update team&#39;s ring group
[**teamUpdateSelectedIvrGreeting**](TeamApi.md#teamUpdateSelectedIvrGreeting) | **PUT** /client/Team/{id}/Ivr/{ivrNumber}/Greeting/{greetingId} | Update/Set a Team&#39;s default Voicemail Greeting
[**teamUpdateSelectedMusicOnHold**](TeamApi.md#teamUpdateSelectedMusicOnHold) | **PUT** /client/Team/{id}/MusicOnHold/{mohId} | Update/Set team&#39;s default MusicOnHold
[**teamUpdateSelectedVoicemailGreeting**](TeamApi.md#teamUpdateSelectedVoicemailGreeting) | **PUT** /client/Team/{id}/VoicemailGreeting/{voicemailId} | Update/Set a Team&#39;s default Voicemail Greeting
[**teamUpdateTeammate**](TeamApi.md#teamUpdateTeammate) | **PUT** /client/Team/{id}/Teammate | Update team&#39;s teammate list
[**teamUploadIvrGreeting**](TeamApi.md#teamUploadIvrGreeting) | **POST** /client/Team/{id}/Ivr/{ivrNumber}/Greeting | Upload Ivr Greeting File
[**teamUploadMusicOnHold**](TeamApi.md#teamUploadMusicOnHold) | **POST** /client/Team/{id}/MusicOnHold | Upload MusicOnHold File
[**teamUploadVoicemailGreeting**](TeamApi.md#teamUploadVoicemailGreeting) | **POST** /client/Team/{id}/VoicemailGreeting | Upload Voicemail Greeting File


<a name="teamConvertTextToSpeech"></a>
# **teamConvertTextToSpeech**
> Object teamConvertTextToSpeech(id, textToSpeechInfo, textToSpeech)

Convert text to speech

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | 

var textToSpeechInfo = new PhonespeakApi.TextToSpeechInfo(); // TextToSpeechInfo | Text-to-Speech Info

var textToSpeech = "/path/to/file.txt"; // File | Type to convert Text to Speech


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamConvertTextToSpeech(id, textToSpeechInfo, textToSpeech, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 
 **textToSpeechInfo** | [**TextToSpeechInfo**](TextToSpeechInfo.md)| Text-to-Speech Info | 
 **textToSpeech** | **File**| Type to convert Text to Speech | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml, multipart/form-data
 - **Accept**: application/json, application/xml

<a name="teamCreate"></a>
# **teamCreate**
> Object teamCreate(team)

Create a single team

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var team = new PhonespeakApi.Team(); // Team | The team object to create


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamCreate(team, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **team** | [**Team**](Team.md)| The team object to create | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="teamCreateIvr"></a>
# **teamCreateIvr**
> Object teamCreateIvr(id)

Create team&#39;s ivr

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | The team object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamCreateIvr(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamDelete"></a>
# **teamDelete**
> Object teamDelete(id)

Delete a single team

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | The team id to delete


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamDelete(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team id to delete | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamDeleteIvr"></a>
# **teamDeleteIvr**
> Object teamDeleteIvr(id, ivrNumber)

Delete team&#39;s ivr

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | The team object to update

var ivrNumber = "ivrNumber_example"; // String | The ivr to add


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamDeleteIvr(id, ivrNumber, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team object to update | 
 **ivrNumber** | **String**| The ivr to add | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamDeleteIvrGreeting"></a>
# **teamDeleteIvrGreeting**
> Object teamDeleteIvrGreeting(id, ivrNumber, greetingId)

Delete Ivr Greeting File

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | Team Id

var ivrNumber = "ivrNumber_example"; // String | Ivr Id

var greetingId = "greetingId_example"; // String | Ivr Greeting Id to delete


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamDeleteIvrGreeting(id, ivrNumber, greetingId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 
 **ivrNumber** | **String**| Ivr Id | 
 **greetingId** | **String**| Ivr Greeting Id to delete | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamDeleteMusicOnHold"></a>
# **teamDeleteMusicOnHold**
> Object teamDeleteMusicOnHold(id, mohId)

Delete MusicOnHold file

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | Team Id

var mohId = "mohId_example"; // String | MusicOnHold Id to delete


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamDeleteMusicOnHold(id, mohId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 
 **mohId** | **String**| MusicOnHold Id to delete | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamDeleteVoicemailGreeting"></a>
# **teamDeleteVoicemailGreeting**
> Object teamDeleteVoicemailGreeting(id, voicemailId)

Delete Voicemail Greeting File

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | Team Id

var voicemailId = "voicemailId_example"; // String | Voicemail Greeting Id to delete


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamDeleteVoicemailGreeting(id, voicemailId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 
 **voicemailId** | **String**| Voicemail Greeting Id to delete | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamGet"></a>
# **teamGet**
> Object teamGet(id)

Retrieve a single team by id

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | The team id to retrieve


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamGet(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team id to retrieve | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamIvrConvertTextToSpeech"></a>
# **teamIvrConvertTextToSpeech**
> Object teamIvrConvertTextToSpeech(id, ivrNumber, textToSpeechInfo, textToSpeech)

Ivr Convert text to speech

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | team id

var ivrNumber = "ivrNumber_example"; // String | ivr number

var textToSpeechInfo = new PhonespeakApi.TextToSpeechInfo(); // TextToSpeechInfo | Text-to-Speech Info

var textToSpeech = "/path/to/file.txt"; // File | Type to convert Text to Speech


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamIvrConvertTextToSpeech(id, ivrNumber, textToSpeechInfo, textToSpeech, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| team id | 
 **ivrNumber** | **String**| ivr number | 
 **textToSpeechInfo** | [**TextToSpeechInfo**](TextToSpeechInfo.md)| Text-to-Speech Info | 
 **textToSpeech** | **File**| Type to convert Text to Speech | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml, multipart/form-data
 - **Accept**: application/json, application/xml

<a name="teamList"></a>
# **teamList**
> Object teamList(opts)

List all teams by account

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var opts = { 
  'orderBy': "orderBy_example", // String | Sort the listing by column.
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56 // Number | Page number to retrieve (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamList(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **orderBy** | **String**| Sort the listing by column. | [optional] 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamListAvailableNumber"></a>
# **teamListAvailableNumber**
> Object teamListAvailableNumber(id)

List Caller Id

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | Teammate id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamListAvailableNumber(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Teammate id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamListAvailableTeammates"></a>
# **teamListAvailableTeammates**
> Object teamListAvailableTeammates(id)

Get Teammate list for team

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamListAvailableTeammates(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamListIvrGreetings"></a>
# **teamListIvrGreetings**
> Object teamListIvrGreetings(id, ivrNumber)

List Ivr Greetings for a team

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | Team Id

var ivrNumber = "ivrNumber_example"; // String | Team Ivr Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamListIvrGreetings(id, ivrNumber, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 
 **ivrNumber** | **String**| Team Ivr Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamListMusicOnHold"></a>
# **teamListMusicOnHold**
> Object teamListMusicOnHold(id)

List MusicOnHolds for team

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | Team Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamListMusicOnHold(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamListTeamsByTeammate"></a>
# **teamListTeamsByTeammate**
> Object teamListTeamsByTeammate(opts)

List all teams by teammate

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var opts = { 
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56 // Number | Page number to retrieve (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamListTeamsByTeammate(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamListVoicemailGreetings"></a>
# **teamListVoicemailGreetings**
> Object teamListVoicemailGreetings(id)

List Voicemail Greetings for a team

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | Team Id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamListVoicemailGreetings(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamTeamSummary"></a>
# **teamTeamSummary**
> Object teamTeamSummary(teamId, startDate, endDate)

Team Summary

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var teamId = "teamId_example"; // String | Account Id

var startDate = new Date("2013-10-20T19:20:30+01:00"); // Date | Start date

var endDate = new Date("2013-10-20T19:20:30+01:00"); // Date | End date


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamTeamSummary(teamId, startDate, endDate, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **teamId** | **String**| Account Id | 
 **startDate** | **Date**| Start date | 
 **endDate** | **Date**| End date | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamUpdate"></a>
# **teamUpdate**
> Object teamUpdate(id, team)

Update a single team

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | The team id to update

var team = new PhonespeakApi.Team(); // Team | The team object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUpdate(id, team, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team id to update | 
 **team** | [**Team**](Team.md)| The team object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="teamUpdateBusinessHour"></a>
# **teamUpdateBusinessHour**
> Object teamUpdateBusinessHour(id, team)

Update team business hour

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | The team id to update

var team = new PhonespeakApi.Team(); // Team | The team object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUpdateBusinessHour(id, team, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team id to update | 
 **team** | [**Team**](Team.md)| The team object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="teamUpdateCallQueue"></a>
# **teamUpdateCallQueue**
> Object teamUpdateCallQueue(id, team)

Update team&#39;s call queue

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | The team id to update

var team = new PhonespeakApi.Team(); // Team | The team object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUpdateCallQueue(id, team, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team id to update | 
 **team** | [**Team**](Team.md)| The team object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="teamUpdateCallRouting"></a>
# **teamUpdateCallRouting**
> Object teamUpdateCallRouting(id, team)

Update team call routing

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | The team id to update

var team = new PhonespeakApi.Team(); // Team | The team object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUpdateCallRouting(id, team, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team id to update | 
 **team** | [**Team**](Team.md)| The team object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="teamUpdateClosedHourHandling"></a>
# **teamUpdateClosedHourHandling**
> Object teamUpdateClosedHourHandling(id, team)

Update team close hour call handling

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | The team id to update

var team = new PhonespeakApi.Team(); // Team | The team object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUpdateClosedHourHandling(id, team, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team id to update | 
 **team** | [**Team**](Team.md)| The team object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="teamUpdateIvrKey"></a>
# **teamUpdateIvrKey**
> Object teamUpdateIvrKey(id, ivrNumber, keyNumber, ivrKey)

Update Ivr Key

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | team id

var ivrNumber = "ivrNumber_example"; // String | ivr number

var keyNumber = 56; // Number | key number

var ivrKey = new PhonespeakApi.IvrKey(); // IvrKey | ivr key object


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUpdateIvrKey(id, ivrNumber, keyNumber, ivrKey, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| team id | 
 **ivrNumber** | **String**| ivr number | 
 **keyNumber** | **Number**| key number | 
 **ivrKey** | [**IvrKey**](IvrKey.md)| ivr key object | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="teamUpdateIvrName"></a>
# **teamUpdateIvrName**
> Object teamUpdateIvrName(id, ivrNumber, ivrName)

Update team&#39;s ivr

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | The team object to update

var ivrNumber = "ivrNumber_example"; // String | ivr number

var ivrName = "ivrName_example"; // String | ivr name


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUpdateIvrName(id, ivrNumber, ivrName, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team object to update | 
 **ivrNumber** | **String**| ivr number | 
 **ivrName** | **String**| ivr name | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamUpdateIvrTimeout"></a>
# **teamUpdateIvrTimeout**
> Object teamUpdateIvrTimeout(id, ivrNumber, timeOut)

Update Ivr Timeout

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | team id

var ivrNumber = "ivrNumber_example"; // String | ivr number

var timeOut = new PhonespeakApi.IvrTimeOut(); // IvrTimeOut | timeout action


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUpdateIvrTimeout(id, ivrNumber, timeOut, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| team id | 
 **ivrNumber** | **String**| ivr number | 
 **timeOut** | [**IvrTimeOut**](IvrTimeOut.md)| timeout action | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="teamUpdateMissedCallHandling"></a>
# **teamUpdateMissedCallHandling**
> Object teamUpdateMissedCallHandling(id, team)

Update team miss call handling

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | The team id to update

var team = new PhonespeakApi.Team(); // Team | The team object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUpdateMissedCallHandling(id, team, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team id to update | 
 **team** | [**Team**](Team.md)| The team object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="teamUpdateOpenHourHandling"></a>
# **teamUpdateOpenHourHandling**
> Object teamUpdateOpenHourHandling(id, team)

Update team open hour call handling

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | The team id to update

var team = new PhonespeakApi.Team(); // Team | The team object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUpdateOpenHourHandling(id, team, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team id to update | 
 **team** | [**Team**](Team.md)| The team object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="teamUpdateRingGroup"></a>
# **teamUpdateRingGroup**
> Object teamUpdateRingGroup(id, team)

Update team&#39;s ring group

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | The team id to update

var team = new PhonespeakApi.Team(); // Team | The team object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUpdateRingGroup(id, team, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team id to update | 
 **team** | [**Team**](Team.md)| The team object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="teamUpdateSelectedIvrGreeting"></a>
# **teamUpdateSelectedIvrGreeting**
> Object teamUpdateSelectedIvrGreeting(id, ivrNumber, greetingId)

Update/Set a Team&#39;s default Voicemail Greeting

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | Team Id

var ivrNumber = "ivrNumber_example"; // String | Ivr Id

var greetingId = "greetingId_example"; // String | Greeting Id to set as default


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUpdateSelectedIvrGreeting(id, ivrNumber, greetingId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 
 **ivrNumber** | **String**| Ivr Id | 
 **greetingId** | **String**| Greeting Id to set as default | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamUpdateSelectedMusicOnHold"></a>
# **teamUpdateSelectedMusicOnHold**
> Object teamUpdateSelectedMusicOnHold(id, mohId)

Update/Set team&#39;s default MusicOnHold

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | Team Id

var mohId = "mohId_example"; // String | MusicOnHold Id to set as default


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUpdateSelectedMusicOnHold(id, mohId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 
 **mohId** | **String**| MusicOnHold Id to set as default | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamUpdateSelectedVoicemailGreeting"></a>
# **teamUpdateSelectedVoicemailGreeting**
> Object teamUpdateSelectedVoicemailGreeting(id, voicemailId)

Update/Set a Team&#39;s default Voicemail Greeting

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | Team Id

var voicemailId = "voicemailId_example"; // String | Voicemail Greeting Id to set as default


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUpdateSelectedVoicemailGreeting(id, voicemailId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 
 **voicemailId** | **String**| Voicemail Greeting Id to set as default | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="teamUpdateTeammate"></a>
# **teamUpdateTeammate**
> Object teamUpdateTeammate(id, teammateId)

Update team&#39;s teammate list

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | The team id to update

var teammateId = [new PhonespeakApi.[String]()]; // [String] | The team object to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUpdateTeammate(id, teammateId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The team id to update | 
 **teammateId** | **[String]**| The team object to update | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="teamUploadIvrGreeting"></a>
# **teamUploadIvrGreeting**
> Object teamUploadIvrGreeting(id, ivrNumber, uploadIvrGreeting)

Upload Ivr Greeting File

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | Team Id

var ivrNumber = "ivrNumber_example"; // String | Ivr Id

var uploadIvrGreeting = "/path/to/file.txt"; // File | Upload voicemail greeting file


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUploadIvrGreeting(id, ivrNumber, uploadIvrGreeting, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 
 **ivrNumber** | **String**| Ivr Id | 
 **uploadIvrGreeting** | **File**| Upload voicemail greeting file | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json, application/xml

<a name="teamUploadMusicOnHold"></a>
# **teamUploadMusicOnHold**
> Object teamUploadMusicOnHold(id, uploadMusicOnHold)

Upload MusicOnHold File

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | Team Id

var uploadMusicOnHold = "/path/to/file.txt"; // File | Upload music on hold file


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUploadMusicOnHold(id, uploadMusicOnHold, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 
 **uploadMusicOnHold** | **File**| Upload music on hold file | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json, application/xml

<a name="teamUploadVoicemailGreeting"></a>
# **teamUploadVoicemailGreeting**
> Object teamUploadVoicemailGreeting(id, uploadVoicemailGreeting)

Upload Voicemail Greeting File

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.TeamApi();

var id = "id_example"; // String | Team Id

var uploadVoicemailGreeting = "/path/to/file.txt"; // File | Upload voicemail greeting file


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.teamUploadVoicemailGreeting(id, uploadVoicemailGreeting, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Team Id | 
 **uploadVoicemailGreeting** | **File**| Upload voicemail greeting file | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json, application/xml

