# PhonespeakApi.Teammate

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | **String** | Teammate id | [optional] 
**accountId** | **String** | Teammate&#39;s parent account id | [optional] 
**email** | **String** | The teammate&#39;s email | [optional] 
**password** | **String** | The teammate&#39;s password | [optional] 
**sipPassword** | **String** | The teammate&#39;s portsip password | [optional] 
**conferenceId** | **String** | Conference Id | [optional] 
**firstName** | **String** | The teammate&#39;s first name | [optional] 
**lastName** | **String** | The teammate&#39;s last name | [optional] 
**fullName** | **String** | The teammate&#39;s full name | [optional] 
**title** | **String** | The teammate&#39;s title | [optional] 
**role** | **Number** | The teammate&#39;s role  1 &#x3D; Admin  2 &#x3D; Standard User | [optional] 
**voicemailGreetings** | [**[Greeting]**](Greeting.md) | The list of teammate&#39;s voicemail greetings | [optional] 
**e911Address** | [**E911Address**](E911Address.md) | The teammate&#39;s E911Address | [optional] 
**profileImage** | **String** | The teammate&#39;s profile picture url | [optional] 
**callerId** | **String** | The teammate&#39;s caller Id | [optional] 
**smsUsage** | **Number** | The teammate&#39;s total sms usage within a billing period | [optional] 
**callUsage** | **Number** | The teammate&#39;s total call usage within a billing period | [optional] 
**isFirstTime** | **Boolean** | Check if teammate is first time login to application | [optional] 
**isDeleted** | **Boolean** | Indicate teammate is delete from system | [optional] 
**isChangePassword** | **Boolean** | Check if teammate require to change password when login | [optional] 
**isEnableCallWaiting** | **Boolean** | Check if teammate enable call waiting setting | [optional] 
**_number** | **String** | Teammate&#39;s default phone number | [optional] 
**defaultCallerId** | **String** | Teammate&#39;s default caller id | [optional] 
**phoneNumbers** | [**[PhoneNumber]**](PhoneNumber.md) | Teammate&#39;s list of phone number | [optional] 
**extension** | **String** | Teammate&#39;s extension | [optional] 
**status** | **Number** | Teammate&#39;s status  1 &#x3D; Active  2 &#x3D; Pending  3 &#x3D; Suspend | [optional] 
**onlineStatus** | **Number** | Teammate&#39;s online status  1 &#x3D; Online  2 &#x3D; Away  3 &#x3D; Do not disturb  4 &#x3D; Invisible | [optional] 
**isCompany** | **Boolean** | Indicate is company or teammate. True &#x3D; company. | [optional] 
**tags** | **[String]** | Teammate&#39;s tags | [optional] 
**dndTeam** | **[String]** | Teammate&#39;s dnd team | [optional] 
**ringGroup** | [**RingGroup**](RingGroup.md) | Teammate&#39;s ring group | [optional] 
**callForwarding** | **String** | Teammate&#39;s call forwarding to which number | [optional] 
**voicemailPin** | **String** | Teammate&#39;s voicemail&#39;s pin | [optional] 
**callRecordingSetting** | **String** | Teammate&#39;s call recording settings | [optional] 
**callRecordingMessage** | **Boolean** | Teammate&#39;s call recording settings | [optional] 
**isVoicemailNotification** | **Boolean** | Teammate&#39;s receive voicemail email notification | [optional] 
**isIncludeVoicemail** | **Boolean** | The flag of innclude voicemails in email notification | [optional] 
**missedCallHandling** | [**MissedCallHandling**](MissedCallHandling.md) | Teammate&#39;s miss call routing setting | [optional] 
**businessHour** | [**BusinessHour**](BusinessHour.md) | Teammate Business Hour | [optional] 
**createdDate** | **Date** | Teammate&#39;s creation date | [optional] 
**createdBy** | **String** | Teammate&#39;s created by | [optional] 
**updatedDate** | **Date** | Teammate&#39;s updated date | [optional] 
**updatedBy** | **String** | Teammate&#39;s updated by | [optional] 
**answered** | **Number** | call answered | [optional] 
**lastUpdatedContactDate** | **Date** | Teammate&#39;s Last Updated Contact Date for CloudSoftPhone | [optional] 
**lastLogins** | [**[LastLogin]**](LastLogin.md) | Teammate Last Login Detail | [optional] 


<a name="CallRecordingSettingEnum"></a>
## Enum: CallRecordingSettingEnum


* `None` (value: `"None"`)

* `IncomingCalls` (value: `"IncomingCalls"`)

* `OutgoingCalls` (value: `"OutgoingCalls"`)

* `AllCalls` (value: `"AllCalls"`)




