# PhonespeakApi.VoicemailApi

All URIs are relative to *http://api-dev.phonespeak.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**voicemailDelete**](VoicemailApi.md#voicemailDelete) | **DELETE** /client/Voicemail/{id} | Delete a single voicemail
[**voicemailList**](VoicemailApi.md#voicemailList) | **GET** /client/Voicemail/{ownerId} | List all voicemails by owner id
[**voicemailListDummyEndPoint**](VoicemailApi.md#voicemailListDummyEndPoint) | **GET** /client/Voicemail/{ownerId}/dummyendpoint | List all voicemails by owner id
[**voicemailUnreadVoicemailCount**](VoicemailApi.md#voicemailUnreadVoicemailCount) | **GET** /client/Voicemail/{id}/UnreadCount | Total Unread Voicemail
[**voicemailUpdateAllVoicemailReadStatus**](VoicemailApi.md#voicemailUpdateAllVoicemailReadStatus) | **PUT** /client/Voicemail/{ownerId}/Read | Update all voicemail read status
[**voicemailUpdateVoicemailReadStatus**](VoicemailApi.md#voicemailUpdateVoicemailReadStatus) | **PUT** /client/Voicemail/{ownerId}/Read/{id} | Update voicemail read status
[**voicemailUpdateVoicemailUnreadStatus**](VoicemailApi.md#voicemailUpdateVoicemailUnreadStatus) | **PUT** /client/Voicemail/{ownerId}/Unread/{id} | Update voicemail unread status


<a name="voicemailDelete"></a>
# **voicemailDelete**
> Object voicemailDelete(id)

Delete a single voicemail

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.VoicemailApi();

var id = "id_example"; // String | The voicemail id to delete


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.voicemailDelete(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The voicemail id to delete | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="voicemailList"></a>
# **voicemailList**
> Object voicemailList(ownerId, opts)

List all voicemails by owner id

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.VoicemailApi();

var ownerId = "ownerId_example"; // String | 

var opts = { 
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56, // Number | Page number to retrieve (optional)
  'fromDate': new Date("2013-10-20T19:20:30+01:00") // Date | Get all record greater than this date (optional)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.voicemailList(ownerId, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ownerId** | **String**|  | 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 
 **fromDate** | **Date**| Get all record greater than this date (optional) | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="voicemailListDummyEndPoint"></a>
# **voicemailListDummyEndPoint**
> Object voicemailListDummyEndPoint(ownerId, opts)

List all voicemails by owner id

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.VoicemailApi();

var ownerId = "ownerId_example"; // String | 

var opts = { 
  'size': 56, // Number | Number of records to retrieve (optional)
  'pageNum': 56, // Number | Page number to retrieve (optional)
  'voicemailId': "voicemailId_example", // String | Voicemail Id
  'voicemailCdrId': "voicemailCdrId_example", // String | Cdr Id
  'voicemailProfileImage': "voicemailProfileImage_example", // String | Caller Profile Image. no profile image if empty
  'voicemailTranscribe': "voicemailTranscribe_example", // String | Transcript of the audio file
  'voicemailAccountId': "voicemailAccountId_example", // String | Account Id
  'voicemailParticipantType': 56, // Number | ParticipantT Type
  'voicemailParticipantId': "voicemailParticipantId_example", // String | Participant Id
  'voicemailParticipantName': "voicemailParticipantName_example", // String | Name
  'voicemailFrom': "voicemailFrom_example", // String | Voicemail created from phone number
  'voicemailCallerOwnerId': "voicemailCallerOwnerId_example", // String | Voicemail caller owner id
  'voicemailUrl': "voicemailUrl_example", // String | Voicemail recording location (amazon AWS S3 uri)
  'voicemailDuration': 56, // Number | Voicemail duration
  'voicemailReferenceId': "voicemailReferenceId_example", // String | Reference Id from portsip
  'voicemailOwnerId': "voicemailOwnerId_example", // String | Voicemail ownerId
  'voicemailIsRead': true, // Boolean | Voicemail is read?
  'voicemailRead': ["voicemailRead_example"], // [String] | Voicemail read list
  'voicemailCreatedDate': new Date("2013-10-20T19:20:30+01:00"), // Date | Voicemail created date
  'voicemailIsExtensionCall': true // Boolean | Is Extension Call
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.voicemailListDummyEndPoint(ownerId, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ownerId** | **String**|  | 
 **size** | **Number**| Number of records to retrieve (optional) | [optional] 
 **pageNum** | **Number**| Page number to retrieve (optional) | [optional] 
 **voicemailId** | **String**| Voicemail Id | [optional] 
 **voicemailCdrId** | **String**| Cdr Id | [optional] 
 **voicemailProfileImage** | **String**| Caller Profile Image. no profile image if empty | [optional] 
 **voicemailTranscribe** | **String**| Transcript of the audio file | [optional] 
 **voicemailAccountId** | **String**| Account Id | [optional] 
 **voicemailParticipantType** | **Number**| ParticipantT Type | [optional] 
 **voicemailParticipantId** | **String**| Participant Id | [optional] 
 **voicemailParticipantName** | **String**| Name | [optional] 
 **voicemailFrom** | **String**| Voicemail created from phone number | [optional] 
 **voicemailCallerOwnerId** | **String**| Voicemail caller owner id | [optional] 
 **voicemailUrl** | **String**| Voicemail recording location (amazon AWS S3 uri) | [optional] 
 **voicemailDuration** | **Number**| Voicemail duration | [optional] 
 **voicemailReferenceId** | **String**| Reference Id from portsip | [optional] 
 **voicemailOwnerId** | **String**| Voicemail ownerId | [optional] 
 **voicemailIsRead** | **Boolean**| Voicemail is read? | [optional] 
 **voicemailRead** | [**[String]**](String.md)| Voicemail read list | [optional] 
 **voicemailCreatedDate** | **Date**| Voicemail created date | [optional] 
 **voicemailIsExtensionCall** | **Boolean**| Is Extension Call | [optional] 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json, application/xml

<a name="voicemailUnreadVoicemailCount"></a>
# **voicemailUnreadVoicemailCount**
> Object voicemailUnreadVoicemailCount(id)

Total Unread Voicemail

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.VoicemailApi();

var id = "id_example"; // String | Owner id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.voicemailUnreadVoicemailCount(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Owner id | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="voicemailUpdateAllVoicemailReadStatus"></a>
# **voicemailUpdateAllVoicemailReadStatus**
> Object voicemailUpdateAllVoicemailReadStatus(ownerId)

Update all voicemail read status

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.VoicemailApi();

var ownerId = "ownerId_example"; // String | The voicemail id to delete


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.voicemailUpdateAllVoicemailReadStatus(ownerId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ownerId** | **String**| The voicemail id to delete | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="voicemailUpdateVoicemailReadStatus"></a>
# **voicemailUpdateVoicemailReadStatus**
> Object voicemailUpdateVoicemailReadStatus(ownerId, id)

Update voicemail read status

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.VoicemailApi();

var ownerId = "ownerId_example"; // String | The ownerId of the voicemails

var id = "id_example"; // String | The voicemail id to update the read status


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.voicemailUpdateVoicemailReadStatus(ownerId, id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ownerId** | **String**| The ownerId of the voicemails | 
 **id** | **String**| The voicemail id to update the read status | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

<a name="voicemailUpdateVoicemailUnreadStatus"></a>
# **voicemailUpdateVoicemailUnreadStatus**
> Object voicemailUpdateVoicemailUnreadStatus(ownerId, id)

Update voicemail unread status

### Example
```javascript
var PhonespeakApi = require('phonespeak_api');
var defaultClient = PhonespeakApi.ApiClient.instance;

// Configure API key authorization: Authorization
var Authorization = defaultClient.authentications['Authorization'];
Authorization.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//Authorization.apiKeyPrefix = 'Token';

var apiInstance = new PhonespeakApi.VoicemailApi();

var ownerId = "ownerId_example"; // String | The ownerId of the voicemails

var id = "id_example"; // String | The voicemail id to update the read status


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.voicemailUpdateVoicemailUnreadStatus(ownerId, id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ownerId** | **String**| The ownerId of the voicemails | 
 **id** | **String**| The voicemail id to update the read status | 

### Return type

**Object**

### Authorization

[Authorization](../README.md#Authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/xml

