/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Account', 'model/Address', 'model/BillingContact', 'model/CreditCard', 'model/E911Address', 'model/Invoice', 'model/SignupInfo'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/Account'), require('../model/Address'), require('../model/BillingContact'), require('../model/CreditCard'), require('../model/E911Address'), require('../model/Invoice'), require('../model/SignupInfo'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.AccountApi = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.Account, root.PhonespeakApi.Address, root.PhonespeakApi.BillingContact, root.PhonespeakApi.CreditCard, root.PhonespeakApi.E911Address, root.PhonespeakApi.Invoice, root.PhonespeakApi.SignupInfo);
  }
}(this, function(ApiClient, Account, Address, BillingContact, CreditCard, E911Address, Invoice, SignupInfo) {
  'use strict';

  /**
   * Account service.
   * @module api/AccountApi
   * @version v2
   */

  /**
   * Constructs a new AccountApi. 
   * @alias module:api/AccountApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the accountCallUsage operation.
     * @callback module:api/AccountApi~accountCallUsageCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List of Call Usage
     * @param {String} id account id
     * @param {Date} startDate start date
     * @param {Date} endDate end date
     * @param {Object} opts Optional parameters
     * @param {Number} opts.type call type
     * @param {Number} opts.size page size
     * @param {Number} opts.pageNum page number
     * @param {module:api/AccountApi~accountCallUsageCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountCallUsage = function(id, startDate, endDate, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountCallUsage");
      }

      // verify the required parameter 'startDate' is set
      if (startDate === undefined || startDate === null) {
        throw new Error("Missing the required parameter 'startDate' when calling accountCallUsage");
      }

      // verify the required parameter 'endDate' is set
      if (endDate === undefined || endDate === null) {
        throw new Error("Missing the required parameter 'endDate' when calling accountCallUsage");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'startDate': startDate,
        'endDate': endDate,
        'type': opts['type'],
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/CallUsage', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountCreate operation.
     * @callback module:api/AccountApi~accountCreateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a single account
     * @param {module:model/SignupInfo} signupInfo Account Signup info
     * @param {module:api/AccountApi~accountCreateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountCreate = function(signupInfo, callback) {
      var postBody = signupInfo;

      // verify the required parameter 'signupInfo' is set
      if (signupInfo === undefined || signupInfo === null) {
        throw new Error("Missing the required parameter 'signupInfo' when calling accountCreate");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountCreateBillingContact operation.
     * @callback module:api/AccountApi~accountCreateBillingContactCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a single billing contact
     * @param {String} id Account id
     * @param {module:model/BillingContact} billingContact Billing contact&#39;s details
     * @param {module:api/AccountApi~accountCreateBillingContactCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountCreateBillingContact = function(id, billingContact, callback) {
      var postBody = billingContact;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountCreateBillingContact");
      }

      // verify the required parameter 'billingContact' is set
      if (billingContact === undefined || billingContact === null) {
        throw new Error("Missing the required parameter 'billingContact' when calling accountCreateBillingContact");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/BillingContact', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountCreateCreditCard operation.
     * @callback module:api/AccountApi~accountCreateCreditCardCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create credit card
     * @param {String} id Account id
     * @param {module:model/CreditCard} creditCard New credit card details
     * @param {module:api/AccountApi~accountCreateCreditCardCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountCreateCreditCard = function(id, creditCard, callback) {
      var postBody = creditCard;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountCreateCreditCard");
      }

      // verify the required parameter 'creditCard' is set
      if (creditCard === undefined || creditCard === null) {
        throw new Error("Missing the required parameter 'creditCard' when calling accountCreateCreditCard");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/CreditCard', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountCreateInvoice operation.
     * @callback module:api/AccountApi~accountCreateInvoiceCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create invoice
     * @param {String} id Account id
     * @param {module:model/Invoice} stripeBillingInvoice Invoice details
     * @param {module:api/AccountApi~accountCreateInvoiceCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountCreateInvoice = function(id, stripeBillingInvoice, callback) {
      var postBody = stripeBillingInvoice;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountCreateInvoice");
      }

      // verify the required parameter 'stripeBillingInvoice' is set
      if (stripeBillingInvoice === undefined || stripeBillingInvoice === null) {
        throw new Error("Missing the required parameter 'stripeBillingInvoice' when calling accountCreateInvoice");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/Invoice', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountCreateSession operation.
     * @callback module:api/AccountApi~accountCreateSessionCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {module:model/SignupInfo} signupInfo 
     * @param {module:api/AccountApi~accountCreateSessionCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountCreateSession = function(signupInfo, callback) {
      var postBody = signupInfo;

      // verify the required parameter 'signupInfo' is set
      if (signupInfo === undefined || signupInfo === null) {
        throw new Error("Missing the required parameter 'signupInfo' when calling accountCreateSession");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/Session', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountDelete operation.
     * @callback module:api/AccountApi~accountDeleteCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete a single account
     * @param {String} id Account id to delete
     * @param {module:api/AccountApi~accountDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountDelete = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountDelete");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountDeleteBillingContact operation.
     * @callback module:api/AccountApi~accountDeleteBillingContactCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete billing contact
     * @param {String} id Account id
     * @param {String} contactId Billing Contact id
     * @param {module:api/AccountApi~accountDeleteBillingContactCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountDeleteBillingContact = function(id, contactId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountDeleteBillingContact");
      }

      // verify the required parameter 'contactId' is set
      if (contactId === undefined || contactId === null) {
        throw new Error("Missing the required parameter 'contactId' when calling accountDeleteBillingContact");
      }


      var pathParams = {
        'id': id,
        'contactId': contactId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/BillingContact/{contactId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountDeleteCreditCard operation.
     * @callback module:api/AccountApi~accountDeleteCreditCardCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete credit card
     * @param {String} id Account id
     * @param {String} creditCardId Credit card id
     * @param {module:api/AccountApi~accountDeleteCreditCardCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountDeleteCreditCard = function(id, creditCardId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountDeleteCreditCard");
      }

      // verify the required parameter 'creditCardId' is set
      if (creditCardId === undefined || creditCardId === null) {
        throw new Error("Missing the required parameter 'creditCardId' when calling accountDeleteCreditCard");
      }


      var pathParams = {
        'id': id,
        'creditCardId': creditCardId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/CreditCard/{creditCardId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountDeleteMusicOnHold operation.
     * @callback module:api/AccountApi~accountDeleteMusicOnHoldCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete MusicOnHold
     * @param {String} id Account id
     * @param {String} mohId MusicOnHold id
     * @param {module:api/AccountApi~accountDeleteMusicOnHoldCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountDeleteMusicOnHold = function(id, mohId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountDeleteMusicOnHold");
      }

      // verify the required parameter 'mohId' is set
      if (mohId === undefined || mohId === null) {
        throw new Error("Missing the required parameter 'mohId' when calling accountDeleteMusicOnHold");
      }


      var pathParams = {
        'id': id,
        'mohId': mohId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/MusicOnHold/{mohId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountDisableInternationalCall operation.
     * @callback module:api/AccountApi~accountDisableInternationalCallCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Disable international call
     * @param {String} id Account id
     * @param {module:api/AccountApi~accountDisableInternationalCallCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountDisableInternationalCall = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountDisableInternationalCall");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/InternationalCall', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountEnableInternationalCall operation.
     * @callback module:api/AccountApi~accountEnableInternationalCallCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Enable international call
     * @param {String} id Account id
     * @param {module:api/AccountApi~accountEnableInternationalCallCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountEnableInternationalCall = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountEnableInternationalCall");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/InternationalCall', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountGet operation.
     * @callback module:api/AccountApi~accountGetCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve a single account
     * @param {String} id Account id
     * @param {module:api/AccountApi~accountGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountGet = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountGet");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountGetAvailableUserExtension operation.
     * @callback module:api/AccountApi~accountGetAvailableUserExtensionCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update business hour
     * @param {String} id Teammate id
     * @param {module:api/AccountApi~accountGetAvailableUserExtensionCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountGetAvailableUserExtension = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountGetAvailableUserExtension");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/Extension/Available', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountGetBillingContact operation.
     * @callback module:api/AccountApi~accountGetBillingContactCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve billing contact details
     * @param {String} id Account id
     * @param {String} contactId Billing Contact id
     * @param {module:api/AccountApi~accountGetBillingContactCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountGetBillingContact = function(id, contactId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountGetBillingContact");
      }

      // verify the required parameter 'contactId' is set
      if (contactId === undefined || contactId === null) {
        throw new Error("Missing the required parameter 'contactId' when calling accountGetBillingContact");
      }


      var pathParams = {
        'id': id,
        'contactId': contactId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/BillingContact/{contactId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountGetCreditCard operation.
     * @callback module:api/AccountApi~accountGetCreditCardCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get credit card details
     * @param {String} id Account id
     * @param {String} creditCardId Credit card id
     * @param {module:api/AccountApi~accountGetCreditCardCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountGetCreditCard = function(id, creditCardId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountGetCreditCard");
      }

      // verify the required parameter 'creditCardId' is set
      if (creditCardId === undefined || creditCardId === null) {
        throw new Error("Missing the required parameter 'creditCardId' when calling accountGetCreditCard");
      }


      var pathParams = {
        'id': id,
        'creditCardId': creditCardId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/CreditCard/{creditCardId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountGetInvoice operation.
     * @callback module:api/AccountApi~accountGetInvoiceCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get invoice
     * @param {String} id Account id
     * @param {String} invoiceId Invoice id
     * @param {module:api/AccountApi~accountGetInvoiceCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountGetInvoice = function(id, invoiceId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountGetInvoice");
      }

      // verify the required parameter 'invoiceId' is set
      if (invoiceId === undefined || invoiceId === null) {
        throw new Error("Missing the required parameter 'invoiceId' when calling accountGetInvoice");
      }


      var pathParams = {
        'id': id,
        'invoiceId': invoiceId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/Invoice/{invoiceId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountGetPhoneNumber operation.
     * @callback module:api/AccountApi~accountGetPhoneNumberCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Account&#39;s Phone Number
     * @param {String} id Account id
     * @param {module:api/AccountApi~accountGetPhoneNumberCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountGetPhoneNumber = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountGetPhoneNumber");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/PhoneNumber', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountGetPhoneNumberList operation.
     * @callback module:api/AccountApi~accountGetPhoneNumberListCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Account&#39;s Phone Number (Manage Number)
     * @param {String} id Account id
     * @param {module:api/AccountApi~accountGetPhoneNumberListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountGetPhoneNumberList = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountGetPhoneNumberList");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/PhoneNumberList', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountIsCreditCardExist operation.
     * @callback module:api/AccountApi~accountIsCreditCardExistCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Is Credit card exist
     * @param {String} id Account id
     * @param {module:api/AccountApi~accountIsCreditCardExistCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountIsCreditCardExist = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountIsCreditCardExist");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/CreditCard/Exist', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountListAccountPhoneNumber operation.
     * @callback module:api/AccountApi~accountListAccountPhoneNumberCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Phone Number
     * @param {String} id Account id
     * @param {module:api/AccountApi~accountListAccountPhoneNumberCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountListAccountPhoneNumber = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountListAccountPhoneNumber");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/AccountPhoneNumber', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountListAllowedCountryCode operation.
     * @callback module:api/AccountApi~accountListAllowedCountryCodeCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get list of allowed country code
     * @param {String} id Account id
     * @param {module:api/AccountApi~accountListAllowedCountryCodeCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountListAllowedCountryCode = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountListAllowedCountryCode");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/CallCountryCode', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountListCreditCards operation.
     * @callback module:api/AccountApi~accountListCreditCardsCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get list of credit card
     * @param {String} id Account id
     * @param {module:api/AccountApi~accountListCreditCardsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountListCreditCards = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountListCreditCards");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/CreditCard', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountListE911Addresses operation.
     * @callback module:api/AccountApi~accountListE911AddressesCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve list of E911 address
     * @param {String} id Account id
     * @param {Object} opts Optional parameters
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {module:api/AccountApi~accountListE911AddressesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountListE911Addresses = function(id, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountListE911Addresses");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/E911Address', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountListInvoices operation.
     * @callback module:api/AccountApi~accountListInvoicesCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get list of invoices.
     * @param {String} id Account id
     * @param {Object} opts Optional parameters
     * @param {Number} opts.size The size of the invoice list (optional)
     * @param {String} opts.startAfter the value start after the list (optional)
     * @param {module:api/AccountApi~accountListInvoicesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountListInvoices = function(id, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountListInvoices");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'size': opts['size'],
        'startAfter': opts['startAfter'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/Invoice', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountListMusicOnHold operation.
     * @callback module:api/AccountApi~accountListMusicOnHoldCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get list of MusicOnHolds
     * @param {String} id Account id
     * @param {module:api/AccountApi~accountListMusicOnHoldCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountListMusicOnHold = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountListMusicOnHold");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/MusicOnHold', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountListRateDeck operation.
     * @callback module:api/AccountApi~accountListRateDeckCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {String} id 
     * @param {module:api/AccountApi~accountListRateDeckCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountListRateDeck = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountListRateDeck");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/RateDeck', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountTopupCallCredit operation.
     * @callback module:api/AccountApi~accountTopupCallCreditCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Topup Call Credit
     * @param {String} id account id
     * @param {Number} amount amount
     * @param {module:api/AccountApi~accountTopupCallCreditCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountTopupCallCredit = function(id, amount, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountTopupCallCredit");
      }

      // verify the required parameter 'amount' is set
      if (amount === undefined || amount === null) {
        throw new Error("Missing the required parameter 'amount' when calling accountTopupCallCredit");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'amount': amount,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/CallCredit', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountUpdate operation.
     * @callback module:api/AccountApi~accountUpdateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update account
     * @param {String} id Account id
     * @param {module:model/Account} account New account details
     * @param {module:api/AccountApi~accountUpdateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountUpdate = function(id, account, callback) {
      var postBody = account;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountUpdate");
      }

      // verify the required parameter 'account' is set
      if (account === undefined || account === null) {
        throw new Error("Missing the required parameter 'account' when calling accountUpdate");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountUpdateAllowedCountryCode operation.
     * @callback module:api/AccountApi~accountUpdateAllowedCountryCodeCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add allowed country code
     * @param {String} id Account id
     * @param {Array.<module:model/String>} countryCode Country Code details
     * @param {module:api/AccountApi~accountUpdateAllowedCountryCodeCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountUpdateAllowedCountryCode = function(id, countryCode, callback) {
      var postBody = countryCode;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountUpdateAllowedCountryCode");
      }

      // verify the required parameter 'countryCode' is set
      if (countryCode === undefined || countryCode === null) {
        throw new Error("Missing the required parameter 'countryCode' when calling accountUpdateAllowedCountryCode");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/CallCountryCode', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountUpdateBillingContact operation.
     * @callback module:api/AccountApi~accountUpdateBillingContactCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update billing contact
     * @param {String} id Account id
     * @param {String} contactId Billing Contact id
     * @param {module:model/BillingContact} billingContact New billing contact details
     * @param {module:api/AccountApi~accountUpdateBillingContactCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountUpdateBillingContact = function(id, contactId, billingContact, callback) {
      var postBody = billingContact;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountUpdateBillingContact");
      }

      // verify the required parameter 'contactId' is set
      if (contactId === undefined || contactId === null) {
        throw new Error("Missing the required parameter 'contactId' when calling accountUpdateBillingContact");
      }

      // verify the required parameter 'billingContact' is set
      if (billingContact === undefined || billingContact === null) {
        throw new Error("Missing the required parameter 'billingContact' when calling accountUpdateBillingContact");
      }


      var pathParams = {
        'id': id,
        'contactId': contactId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/BillingContact/{contactId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountUpdateCallRecording operation.
     * @callback module:api/AccountApi~accountUpdateCallRecordingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Call Recording
     * @param {String} id Account id
     * @param {Boolean} callRecordingSetting call Recording Setting
     * @param {module:api/AccountApi~accountUpdateCallRecordingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountUpdateCallRecording = function(id, callRecordingSetting, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountUpdateCallRecording");
      }

      // verify the required parameter 'callRecordingSetting' is set
      if (callRecordingSetting === undefined || callRecordingSetting === null) {
        throw new Error("Missing the required parameter 'callRecordingSetting' when calling accountUpdateCallRecording");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'CallRecordingSetting': callRecordingSetting,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/CallRecording', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountUpdateCompanyAddress operation.
     * @callback module:api/AccountApi~accountUpdateCompanyAddressCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update company address
     * @param {String} id Account id
     * @param {module:model/Address} companyAddress New company address
     * @param {module:api/AccountApi~accountUpdateCompanyAddressCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountUpdateCompanyAddress = function(id, companyAddress, callback) {
      var postBody = companyAddress;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountUpdateCompanyAddress");
      }

      // verify the required parameter 'companyAddress' is set
      if (companyAddress === undefined || companyAddress === null) {
        throw new Error("Missing the required parameter 'companyAddress' when calling accountUpdateCompanyAddress");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/CompanyAddress', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountUpdateCreditCard operation.
     * @callback module:api/AccountApi~accountUpdateCreditCardCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update credit card
     * @param {String} id Account id
     * @param {module:model/CreditCard} creditCard Credit card object
     * @param {module:api/AccountApi~accountUpdateCreditCardCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountUpdateCreditCard = function(id, creditCard, callback) {
      var postBody = creditCard;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountUpdateCreditCard");
      }

      // verify the required parameter 'creditCard' is set
      if (creditCard === undefined || creditCard === null) {
        throw new Error("Missing the required parameter 'creditCard' when calling accountUpdateCreditCard");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/CreditCard', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountUpdateE911Address operation.
     * @callback module:api/AccountApi~accountUpdateE911AddressCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update E911 address
     * @param {String} id Account id
     * @param {module:model/E911Address} e911 New E911 info
     * @param {module:api/AccountApi~accountUpdateE911AddressCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountUpdateE911Address = function(id, e911, callback) {
      var postBody = e911;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountUpdateE911Address");
      }

      // verify the required parameter 'e911' is set
      if (e911 === undefined || e911 === null) {
        throw new Error("Missing the required parameter 'e911' when calling accountUpdateE911Address");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/E911Address', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountUpdateInvoice operation.
     * @callback module:api/AccountApi~accountUpdateInvoiceCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update invoice
     * @param {String} id Account id
     * @param {String} invoiceId Invoice Id
     * @param {module:model/Invoice} stripeBillingInvoice New invoice details
     * @param {module:api/AccountApi~accountUpdateInvoiceCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountUpdateInvoice = function(id, invoiceId, stripeBillingInvoice, callback) {
      var postBody = stripeBillingInvoice;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountUpdateInvoice");
      }

      // verify the required parameter 'invoiceId' is set
      if (invoiceId === undefined || invoiceId === null) {
        throw new Error("Missing the required parameter 'invoiceId' when calling accountUpdateInvoice");
      }

      // verify the required parameter 'stripeBillingInvoice' is set
      if (stripeBillingInvoice === undefined || stripeBillingInvoice === null) {
        throw new Error("Missing the required parameter 'stripeBillingInvoice' when calling accountUpdateInvoice");
      }


      var pathParams = {
        'id': id,
        'invoiceId': invoiceId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/Invoice/{invoiceId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountUpdateSelectedMusicOnHold operation.
     * @callback module:api/AccountApi~accountUpdateSelectedMusicOnHoldCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Set MusicOnHold
     * @param {String} id Account id
     * @param {String} mohId MusicOnHold id
     * @param {module:api/AccountApi~accountUpdateSelectedMusicOnHoldCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountUpdateSelectedMusicOnHold = function(id, mohId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountUpdateSelectedMusicOnHold");
      }

      // verify the required parameter 'mohId' is set
      if (mohId === undefined || mohId === null) {
        throw new Error("Missing the required parameter 'mohId' when calling accountUpdateSelectedMusicOnHold");
      }


      var pathParams = {
        'id': id,
        'mohId': mohId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/MusicOnHold/{mohId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountUpdateSubscriptionTrial operation.
     * @callback module:api/AccountApi~accountUpdateSubscriptionTrialCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {String} id 
     * @param {module:api/AccountApi~accountUpdateSubscriptionTrialCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountUpdateSubscriptionTrial = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountUpdateSubscriptionTrial");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/Subscription/Trial', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountUpdateTimezone operation.
     * @callback module:api/AccountApi~accountUpdateTimezoneCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update timezone
     * @param {String} id Account id
     * @param {String} timezone New timezone
     * @param {module:api/AccountApi~accountUpdateTimezoneCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountUpdateTimezone = function(id, timezone, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountUpdateTimezone");
      }

      // verify the required parameter 'timezone' is set
      if (timezone === undefined || timezone === null) {
        throw new Error("Missing the required parameter 'timezone' when calling accountUpdateTimezone");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'timezone': timezone,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/Timezone', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountUploadMusicOnHold operation.
     * @callback module:api/AccountApi~accountUploadMusicOnHoldCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upload MusicOnHold
     * @param {String} id Account id
     * @param {File} uploadMusicOnHold Upload music on hold file
     * @param {module:api/AccountApi~accountUploadMusicOnHoldCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountUploadMusicOnHold = function(id, uploadMusicOnHold, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountUploadMusicOnHold");
      }

      // verify the required parameter 'uploadMusicOnHold' is set
      if (uploadMusicOnHold === undefined || uploadMusicOnHold === null) {
        throw new Error("Missing the required parameter 'uploadMusicOnHold' when calling accountUploadMusicOnHold");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'UploadMusicOnHold': uploadMusicOnHold
      };

      var authNames = ['Authorization'];
      var contentTypes = ['multipart/form-data'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/MusicOnHold', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountVerifyCreditCard operation.
     * @callback module:api/AccountApi~accountVerifyCreditCardCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create credit card
     * @param {Object} opts Optional parameters
     * @param {String} opts.creditCardCreditCardId Credit Card Id
     * @param {String} opts.creditCardName Credit Card Name
     * @param {String} opts.creditCardNumber Credit Card Number
     * @param {String} opts.creditCardLast4Digits Credit Card last 4 digits
     * @param {String} opts.creditCardCvc Credit Card Cvc
     * @param {Number} opts.creditCardExpirationMonth Credit Card Expired Month
     * @param {Number} opts.creditCardExpirationYear Credit Card Expired Year
     * @param {String} opts.creditCardAddressZip Credit Card&#39;s address zip
     * @param {Boolean} opts.creditCardIsDefault Default credit card
     * @param {String} opts.creditCardBillingAddressName Customer&#39;s mobile number for billing purpose
     * @param {String} opts.creditCardBillingAddressMobile Customer&#39;s mobile number for billing purpose
     * @param {String} opts.creditCardBillingAddressLine1 Address line 1
     * @param {String} opts.creditCardBillingAddressLine2 Address line 2
     * @param {String} opts.creditCardBillingAddressCity City
     * @param {String} opts.creditCardBillingAddressState State
     * @param {String} opts.creditCardBillingAddressPostalCode Postal code
     * @param {String} opts.creditCardBillingAddressCountry Country
     * @param {module:api/AccountApi~accountVerifyCreditCardCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountVerifyCreditCard = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'creditCard.creditCardId': opts['creditCardCreditCardId'],
        'creditCard.name': opts['creditCardName'],
        'creditCard.number': opts['creditCardNumber'],
        'creditCard.last4Digits': opts['creditCardLast4Digits'],
        'creditCard.cvc': opts['creditCardCvc'],
        'creditCard.expirationMonth': opts['creditCardExpirationMonth'],
        'creditCard.expirationYear': opts['creditCardExpirationYear'],
        'creditCard.addressZip': opts['creditCardAddressZip'],
        'creditCard.isDefault': opts['creditCardIsDefault'],
        'creditCard.billingAddress.name': opts['creditCardBillingAddressName'],
        'creditCard.billingAddress.mobile': opts['creditCardBillingAddressMobile'],
        'creditCard.billingAddress.line1': opts['creditCardBillingAddressLine1'],
        'creditCard.billingAddress.line2': opts['creditCardBillingAddressLine2'],
        'creditCard.billingAddress.city': opts['creditCardBillingAddressCity'],
        'creditCard.billingAddress.state': opts['creditCardBillingAddressState'],
        'creditCard.billingAddress.postalCode': opts['creditCardBillingAddressPostalCode'],
        'creditCard.billingAddress.country': opts['creditCardBillingAddressCountry'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/CreditCard/Verify', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountVerifyInternationalCall operation.
     * @callback module:api/AccountApi~accountVerifyInternationalCallCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Verify international call
     * @param {String} id Account id
     * @param {Number} firstAmount First amount for verify charges
     * @param {Number} secondAmount Second amount for verify charges
     * @param {module:api/AccountApi~accountVerifyInternationalCallCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.accountVerifyInternationalCall = function(id, firstAmount, secondAmount, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling accountVerifyInternationalCall");
      }

      // verify the required parameter 'firstAmount' is set
      if (firstAmount === undefined || firstAmount === null) {
        throw new Error("Missing the required parameter 'firstAmount' when calling accountVerifyInternationalCall");
      }

      // verify the required parameter 'secondAmount' is set
      if (secondAmount === undefined || secondAmount === null) {
        throw new Error("Missing the required parameter 'secondAmount' when calling accountVerifyInternationalCall");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'firstAmount': firstAmount,
        'secondAmount': secondAmount,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Account/{id}/InternationalCall', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
