/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CallLog', 'model/CallRecording', 'model/Cdr', 'model/PbxCallStatus'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/CallLog'), require('../model/CallRecording'), require('../model/Cdr'), require('../model/PbxCallStatus'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.CdrApi = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.CallLog, root.PhonespeakApi.CallRecording, root.PhonespeakApi.Cdr, root.PhonespeakApi.PbxCallStatus);
  }
}(this, function(ApiClient, CallLog, CallRecording, Cdr, PbxCallStatus) {
  'use strict';

  /**
   * Cdr service.
   * @module api/CdrApi
   * @version v2
   */

  /**
   * Constructs a new CdrApi. 
   * @alias module:api/CdrApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the cdrCallLogExport operation.
     * @callback module:api/CdrApi~cdrCallLogExportCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Call Log
     * @param {Array.<module:model/String>} numberList number list
     * @param {String} accountId account id
     * @param {Date} startDate start date
     * @param {Date} endDate end date
     * @param {Object} opts Optional parameters
     * @param {Number} opts.type call type
     * @param {Number} opts.size page size
     * @param {Number} opts.pageNum page number
     * @param {module:api/CdrApi~cdrCallLogExportCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrCallLogExport = function(numberList, accountId, startDate, endDate, opts, callback) {
      opts = opts || {};
      var postBody = numberList;

      // verify the required parameter 'numberList' is set
      if (numberList === undefined || numberList === null) {
        throw new Error("Missing the required parameter 'numberList' when calling cdrCallLogExport");
      }

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling cdrCallLogExport");
      }

      // verify the required parameter 'startDate' is set
      if (startDate === undefined || startDate === null) {
        throw new Error("Missing the required parameter 'startDate' when calling cdrCallLogExport");
      }

      // verify the required parameter 'endDate' is set
      if (endDate === undefined || endDate === null) {
        throw new Error("Missing the required parameter 'endDate' when calling cdrCallLogExport");
      }


      var pathParams = {
        'accountId': accountId
      };
      var queryParams = {
        'startDate': startDate,
        'endDate': endDate,
        'type': opts['type'],
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{accountId}/CallLogExport', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrCreate operation.
     * @callback module:api/CdrApi~cdrCreateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a single cdr
     * @param {module:model/Cdr} cdr The cdr object to create
     * @param {module:api/CdrApi~cdrCreateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrCreate = function(cdr, callback) {
      var postBody = cdr;

      // verify the required parameter 'cdr' is set
      if (cdr === undefined || cdr === null) {
        throw new Error("Missing the required parameter 'cdr' when calling cdrCreate");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrCreateCallRecording operation.
     * @callback module:api/CdrApi~cdrCreateCallRecordingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create Call Recording
     * @param {String} ownerId Owner Id
     * @param {String} participant Participant
     * @param {File} uploadCallRecording Upload call recording file
     * @param {Object} opts Optional parameters
     * @param {Number} opts.type Type
     * @param {module:api/CdrApi~cdrCreateCallRecordingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrCreateCallRecording = function(ownerId, participant, uploadCallRecording, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'ownerId' is set
      if (ownerId === undefined || ownerId === null) {
        throw new Error("Missing the required parameter 'ownerId' when calling cdrCreateCallRecording");
      }

      // verify the required parameter 'participant' is set
      if (participant === undefined || participant === null) {
        throw new Error("Missing the required parameter 'participant' when calling cdrCreateCallRecording");
      }

      // verify the required parameter 'uploadCallRecording' is set
      if (uploadCallRecording === undefined || uploadCallRecording === null) {
        throw new Error("Missing the required parameter 'uploadCallRecording' when calling cdrCreateCallRecording");
      }


      var pathParams = {
        'ownerId': ownerId,
        'participant': participant
      };
      var queryParams = {
        'type': opts['type'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'UploadCallRecording': uploadCallRecording
      };

      var authNames = ['Authorization'];
      var contentTypes = ['multipart/form-data'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{ownerId}CallRecording/{participant}/Participant', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrDelete operation.
     * @callback module:api/CdrApi~cdrDeleteCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete a single cdr
     * @param {String} id Cdr id to delete
     * @param {module:api/CdrApi~cdrDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrDelete = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling cdrDelete");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrDeleteCallLog operation.
     * @callback module:api/CdrApi~cdrDeleteCallLogCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Call Log
     * @param {String} cdrId cdr id
     * @param {module:api/CdrApi~cdrDeleteCallLogCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrDeleteCallLog = function(cdrId, callback) {
      var postBody = null;

      // verify the required parameter 'cdrId' is set
      if (cdrId === undefined || cdrId === null) {
        throw new Error("Missing the required parameter 'cdrId' when calling cdrDeleteCallLog");
      }


      var pathParams = {
        'cdrId': cdrId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{cdrId}/CallLog', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrDeleteCallRecording operation.
     * @callback module:api/CdrApi~cdrDeleteCallRecordingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete Call Recording
     * @param {String} id Call Recording Id
     * @param {module:api/CdrApi~cdrDeleteCallRecordingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrDeleteCallRecording = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling cdrDeleteCallRecording");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{id}/CallRecording', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrDeleteCallSession operation.
     * @callback module:api/CdrApi~cdrDeleteCallSessionCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete Call Session
     * @param {String} accountId Account Id
     * @param {Number} sessionId Call session Id
     * @param {module:api/CdrApi~cdrDeleteCallSessionCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrDeleteCallSession = function(accountId, sessionId, callback) {
      var postBody = null;

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling cdrDeleteCallSession");
      }

      // verify the required parameter 'sessionId' is set
      if (sessionId === undefined || sessionId === null) {
        throw new Error("Missing the required parameter 'sessionId' when calling cdrDeleteCallSession");
      }


      var pathParams = {
        'accountId': accountId
      };
      var queryParams = {
        'sessionId': sessionId,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{accountId}/CallSession', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrDeleteRecentCall operation.
     * @callback module:api/CdrApi~cdrDeleteRecentCallCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete recent call
     * @param {String} id cdr id
     * @param {String} teammateId 
     * @param {module:api/CdrApi~cdrDeleteRecentCallCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrDeleteRecentCall = function(id, teammateId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling cdrDeleteRecentCall");
      }

      // verify the required parameter 'teammateId' is set
      if (teammateId === undefined || teammateId === null) {
        throw new Error("Missing the required parameter 'teammateId' when calling cdrDeleteRecentCall");
      }


      var pathParams = {
        'id': id,
        'teammateId': teammateId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{id}/RecentCalls/{teammateId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrGet operation.
     * @callback module:api/CdrApi~cdrGetCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve a single cdr
     * @param {String} id Unique identifier of the cdr
     * @param {module:api/CdrApi~cdrGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrGet = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling cdrGet");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrGetCallRecording operation.
     * @callback module:api/CdrApi~cdrGetCallRecordingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Call Recording
     * @param {String} ownerId Call Recording Id
     * @param {String} id Call Recording Id
     * @param {module:api/CdrApi~cdrGetCallRecordingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrGetCallRecording = function(ownerId, id, callback) {
      var postBody = null;

      // verify the required parameter 'ownerId' is set
      if (ownerId === undefined || ownerId === null) {
        throw new Error("Missing the required parameter 'ownerId' when calling cdrGetCallRecording");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling cdrGetCallRecording");
      }


      var pathParams = {
        'ownerId': ownerId,
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{ownerId}/CallRecording/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrList operation.
     * @callback module:api/CdrApi~cdrListCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List all cdrs by account, team mate or team
     * Test Remarks
     * @param {String} accountId accountId to retrieve cdr list
     * @param {Object} opts Optional parameters
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {Date} opts.fromDate Get all record greater than this date (optional)
     * @param {module:api/CdrApi~cdrListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrList = function(accountId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling cdrList");
      }


      var pathParams = {
        'accountId': accountId
      };
      var queryParams = {
        'size': opts['size'],
        'pageNum': opts['pageNum'],
        'fromDate': opts['fromDate'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{accountId}/List', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrListCallLog operation.
     * @callback module:api/CdrApi~cdrListCallLogCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Call Log
     * @param {Array.<module:model/String>} numberList number list
     * @param {String} accountId account id
     * @param {Date} startDate start date
     * @param {Date} endDate end date
     * @param {Object} opts Optional parameters
     * @param {Number} opts.type call type
     * @param {Number} opts.size page size
     * @param {Number} opts.pageNum page number
     * @param {Date} opts.fromDate Get all record greater than this date (optional)
     * @param {module:api/CdrApi~cdrListCallLogCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrListCallLog = function(numberList, accountId, startDate, endDate, opts, callback) {
      opts = opts || {};
      var postBody = numberList;

      // verify the required parameter 'numberList' is set
      if (numberList === undefined || numberList === null) {
        throw new Error("Missing the required parameter 'numberList' when calling cdrListCallLog");
      }

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling cdrListCallLog");
      }

      // verify the required parameter 'startDate' is set
      if (startDate === undefined || startDate === null) {
        throw new Error("Missing the required parameter 'startDate' when calling cdrListCallLog");
      }

      // verify the required parameter 'endDate' is set
      if (endDate === undefined || endDate === null) {
        throw new Error("Missing the required parameter 'endDate' when calling cdrListCallLog");
      }


      var pathParams = {
        'accountId': accountId
      };
      var queryParams = {
        'startDate': startDate,
        'endDate': endDate,
        'type': opts['type'],
        'size': opts['size'],
        'pageNum': opts['pageNum'],
        'fromDate': opts['fromDate'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{accountId}/CallLog', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrListCallRecording operation.
     * @callback module:api/CdrApi~cdrListCallRecordingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Call Recording
     * @param {String} ownerId Call Recording Id
     * @param {Object} opts Optional parameters
     * @param {Number} opts.type 
     * @param {Number} opts.size 
     * @param {Number} opts.pageNum 
     * @param {module:api/CdrApi~cdrListCallRecordingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrListCallRecording = function(ownerId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'ownerId' is set
      if (ownerId === undefined || ownerId === null) {
        throw new Error("Missing the required parameter 'ownerId' when calling cdrListCallRecording");
      }


      var pathParams = {
        'ownerId': ownerId
      };
      var queryParams = {
        'type': opts['type'],
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{ownerId}/CallRecording', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrListCallSession operation.
     * @callback module:api/CdrApi~cdrListCallSessionCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Call Session
     * @param {String} accountId Account Id
     * @param {Object} opts Optional parameters
     * @param {Number} opts.size size
     * @param {Number} opts.pageNum page number
     * @param {module:api/CdrApi~cdrListCallSessionCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrListCallSession = function(accountId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling cdrListCallSession");
      }


      var pathParams = {
        'accountId': accountId
      };
      var queryParams = {
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{accountId}/CallSession', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrListRecentActivity operation.
     * @callback module:api/CdrApi~cdrListRecentActivityCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all recent call
     * @param {String} id teammate id
     * @param {String} participant participant id
     * @param {Object} opts Optional parameters
     * @param {Number} opts.type type of call
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {Date} opts.fromDate Get all record greater than this date (optional)
     * @param {module:api/CdrApi~cdrListRecentActivityCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrListRecentActivity = function(id, participant, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling cdrListRecentActivity");
      }

      // verify the required parameter 'participant' is set
      if (participant === undefined || participant === null) {
        throw new Error("Missing the required parameter 'participant' when calling cdrListRecentActivity");
      }


      var pathParams = {
        'id': id,
        'participant': participant
      };
      var queryParams = {
        'type': opts['type'],
        'size': opts['size'],
        'pageNum': opts['pageNum'],
        'fromDate': opts['fromDate'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{id}/RecentActivity/{participant}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrListRecentCalls operation.
     * @callback module:api/CdrApi~cdrListRecentCallsCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all recent call
     * @param {String} id teammate id
     * @param {Object} opts Optional parameters
     * @param {Number} opts.type type of call
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {Date} opts.fromDate Get all record greater than this date (optional)
     * @param {module:api/CdrApi~cdrListRecentCallsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrListRecentCalls = function(id, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling cdrListRecentCalls");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'type': opts['type'],
        'size': opts['size'],
        'pageNum': opts['pageNum'],
        'fromDate': opts['fromDate'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{id}/RecentCalls', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrListRecentCalls_0 operation.
     * @callback module:api/CdrApi~cdrListRecentCalls_0Callback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all recent call
     * @param {String} id teammate id
     * @param {module:model/CallLog} callLog Calllog Model
     * @param {Object} opts Optional parameters
     * @param {Number} opts.type type of call
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {Date} opts.fromDate Get all record greater than this date (optional)
     * @param {module:api/CdrApi~cdrListRecentCalls_0Callback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrListRecentCalls_0 = function(id, callLog, opts, callback) {
      opts = opts || {};
      var postBody = callLog;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling cdrListRecentCalls_0");
      }

      // verify the required parameter 'callLog' is set
      if (callLog === undefined || callLog === null) {
        throw new Error("Missing the required parameter 'callLog' when calling cdrListRecentCalls_0");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'type': opts['type'],
        'size': opts['size'],
        'pageNum': opts['pageNum'],
        'fromDate': opts['fromDate'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{id}/RecentCalls/dummyendpoint', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrListTeamRecentCall operation.
     * @callback module:api/CdrApi~cdrListTeamRecentCallCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all team recent call
     * @param {String} id team id
     * @param {Object} opts Optional parameters
     * @param {Number} opts.status type of call
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {Date} opts.fromDate Get all record greater than this date (optional)
     * @param {module:api/CdrApi~cdrListTeamRecentCallCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrListTeamRecentCall = function(id, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling cdrListTeamRecentCall");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'status': opts['status'],
        'size': opts['size'],
        'pageNum': opts['pageNum'],
        'fromDate': opts['fromDate'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{id}/TeamRecentCalls', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrUnreadRecentCallCount operation.
     * @callback module:api/CdrApi~cdrUnreadRecentCallCountCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Total Unread Recent
     * @param {String} id cdr id
     * @param {module:api/CdrApi~cdrUnreadRecentCallCountCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrUnreadRecentCallCount = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling cdrUnreadRecentCallCount");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{id}/RecentCalls/UnreadCount', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrUpdateCallRecording operation.
     * @callback module:api/CdrApi~cdrUpdateCallRecordingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Call Recording
     * @param {String} id Call Recording Id
     * @param {module:model/CallRecording} callRecording Call Recording
     * @param {module:api/CdrApi~cdrUpdateCallRecordingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrUpdateCallRecording = function(id, callRecording, callback) {
      var postBody = callRecording;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling cdrUpdateCallRecording");
      }

      // verify the required parameter 'callRecording' is set
      if (callRecording === undefined || callRecording === null) {
        throw new Error("Missing the required parameter 'callRecording' when calling cdrUpdateCallRecording");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{id}/CallRecording', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrUpdateExtensionStatus operation.
     * @callback module:api/CdrApi~cdrUpdateExtensionStatusCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Portsip update extension status
     * @param {module:model/PbxCallStatus} pbxCallStatus The cdr object to create
     * @param {module:api/CdrApi~cdrUpdateExtensionStatusCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrUpdateExtensionStatus = function(pbxCallStatus, callback) {
      var postBody = pbxCallStatus;

      // verify the required parameter 'pbxCallStatus' is set
      if (pbxCallStatus === undefined || pbxCallStatus === null) {
        throw new Error("Missing the required parameter 'pbxCallStatus' when calling cdrUpdateExtensionStatus");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/Extension', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrUpdateRecentCallsRead operation.
     * @callback module:api/CdrApi~cdrUpdateRecentCallsReadCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update recent call read
     * @param {String} id teammate id
     * @param {Object} opts Optional parameters
     * @param {Number} opts.status type of call
     * @param {module:api/CdrApi~cdrUpdateRecentCallsReadCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrUpdateRecentCallsRead = function(id, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling cdrUpdateRecentCallsRead");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'status': opts['status'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{id}/RecentCalls/Read', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cdrUpdateTeamRecentCallReadStatus operation.
     * @callback module:api/CdrApi~cdrUpdateTeamRecentCallReadStatusCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all team recent call
     * @param {String} id team id
     * @param {String} ownerId owner id
     * @param {module:api/CdrApi~cdrUpdateTeamRecentCallReadStatusCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cdrUpdateTeamRecentCallReadStatus = function(id, ownerId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling cdrUpdateTeamRecentCallReadStatus");
      }

      // verify the required parameter 'ownerId' is set
      if (ownerId === undefined || ownerId === null) {
        throw new Error("Missing the required parameter 'ownerId' when calling cdrUpdateTeamRecentCallReadStatus");
      }


      var pathParams = {
        'id': id,
        'ownerId': ownerId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Cdr/{id}/TeamRecentCalls/{ownerId}/Read', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
