/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CreateConversation', 'model/Message', 'model/ProfileImage'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/CreateConversation'), require('../model/Message'), require('../model/ProfileImage'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.ChatApi = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.CreateConversation, root.PhonespeakApi.Message, root.PhonespeakApi.ProfileImage);
  }
}(this, function(ApiClient, CreateConversation, Message, ProfileImage) {
  'use strict';

  /**
   * Chat service.
   * @module api/ChatApi
   * @version v2
   */

  /**
   * Constructs a new ChatApi. 
   * @alias module:api/ChatApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the chatArchiveConversation operation.
     * @callback module:api/ChatApi~chatArchiveConversationCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Archive conversation
     * @param {String} conversationId The conversation id
     * @param {String} id 
     * @param {module:api/ChatApi~chatArchiveConversationCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatArchiveConversation = function(conversationId, id, callback) {
      var postBody = null;

      // verify the required parameter 'conversationId' is set
      if (conversationId === undefined || conversationId === null) {
        throw new Error("Missing the required parameter 'conversationId' when calling chatArchiveConversation");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling chatArchiveConversation");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'conversationId': conversationId,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/Archive/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the chatCreateConversation operation.
     * @callback module:api/ChatApi~chatCreateConversationCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create conversation
     * @param {module:model/CreateConversation} info Create conversation info
     * @param {module:api/ChatApi~chatCreateConversationCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatCreateConversation = function(info, callback) {
      var postBody = info;

      // verify the required parameter 'info' is set
      if (info === undefined || info === null) {
        throw new Error("Missing the required parameter 'info' when calling chatCreateConversation");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/Conversation', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the chatCreateMessage operation.
     * @callback module:api/ChatApi~chatCreateMessageCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Send Message
     * @param {module:model/Message} msg Send message detail
     * @param {module:api/ChatApi~chatCreateMessageCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatCreateMessage = function(msg, callback) {
      var postBody = msg;

      // verify the required parameter 'msg' is set
      if (msg === undefined || msg === null) {
        throw new Error("Missing the required parameter 'msg' when calling chatCreateMessage");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/Message', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the chatDeleteConversation operation.
     * @callback module:api/ChatApi~chatDeleteConversationCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete Conversation
     * @param {String} conversationId The conversation id
     * @param {module:api/ChatApi~chatDeleteConversationCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatDeleteConversation = function(conversationId, callback) {
      var postBody = null;

      // verify the required parameter 'conversationId' is set
      if (conversationId === undefined || conversationId === null) {
        throw new Error("Missing the required parameter 'conversationId' when calling chatDeleteConversation");
      }


      var pathParams = {
        'conversationId': conversationId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/Conversation/{conversationId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the chatDeleteMessage operation.
     * @callback module:api/ChatApi~chatDeleteMessageCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete Message
     * @param {String} messageId The message id
     * @param {module:api/ChatApi~chatDeleteMessageCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatDeleteMessage = function(messageId, callback) {
      var postBody = null;

      // verify the required parameter 'messageId' is set
      if (messageId === undefined || messageId === null) {
        throw new Error("Missing the required parameter 'messageId' when calling chatDeleteMessage");
      }


      var pathParams = {
        'messageId': messageId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/Message/{messageId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the chatGetConversation operation.
     * @callback module:api/ChatApi~chatGetConversationCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Conversation
     * @param {String} conversationId The conversation id
     * @param {Object} opts Optional parameters
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {Date} opts.fromDate 
     * @param {module:api/ChatApi~chatGetConversationCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatGetConversation = function(conversationId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'conversationId' is set
      if (conversationId === undefined || conversationId === null) {
        throw new Error("Missing the required parameter 'conversationId' when calling chatGetConversation");
      }


      var pathParams = {
        'conversationId': conversationId
      };
      var queryParams = {
        'size': opts['size'],
        'pageNum': opts['pageNum'],
        'fromDate': opts['fromDate'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/Conversation/{conversationId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the chatGetExistingConversation operation.
     * @callback module:api/ChatApi~chatGetExistingConversationCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Existing Conversation
     * @param {module:model/CreateConversation} info Get existing conversation info
     * @param {module:api/ChatApi~chatGetExistingConversationCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatGetExistingConversation = function(info, callback) {
      var postBody = info;

      // verify the required parameter 'info' is set
      if (info === undefined || info === null) {
        throw new Error("Missing the required parameter 'info' when calling chatGetExistingConversation");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/ExistingConversation', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the chatGetUnreadConversationCount operation.
     * @callback module:api/ChatApi~chatGetUnreadConversationCountCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Unread Conversation Count
     * @param {String} teammateId The teammate id
     * @param {Object} opts Optional parameters
     * @param {String} opts.teamId The team id (Optional)
     * @param {module:api/ChatApi~chatGetUnreadConversationCountCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatGetUnreadConversationCount = function(teammateId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'teammateId' is set
      if (teammateId === undefined || teammateId === null) {
        throw new Error("Missing the required parameter 'teammateId' when calling chatGetUnreadConversationCount");
      }


      var pathParams = {
        'teammateId': teammateId
      };
      var queryParams = {
        'teamId': opts['teamId'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/UnreadConversationCount/{teammateId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the chatListConversation operation.
     * @callback module:api/ChatApi~chatListConversationCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List the conversation
     * @param {String} ownerId The sender of the chat message
     * @param {Object} opts Optional parameters
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {module:api/ChatApi~chatListConversationCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatListConversation = function(ownerId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'ownerId' is set
      if (ownerId === undefined || ownerId === null) {
        throw new Error("Missing the required parameter 'ownerId' when calling chatListConversation");
      }


      var pathParams = {
      };
      var queryParams = {
        'ownerId': ownerId,
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/Conversation', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the chatPinConversation operation.
     * @callback module:api/ChatApi~chatPinConversationCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Pin conversation
     * @param {String} conversationId The conversation id
     * @param {String} id 
     * @param {module:api/ChatApi~chatPinConversationCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatPinConversation = function(conversationId, id, callback) {
      var postBody = null;

      // verify the required parameter 'conversationId' is set
      if (conversationId === undefined || conversationId === null) {
        throw new Error("Missing the required parameter 'conversationId' when calling chatPinConversation");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling chatPinConversation");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'conversationId': conversationId,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/Pin/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the chatSendSMS operation.
     * @callback module:api/ChatApi~chatSendSMSCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Testing
     * @param {String} id Unique identifier of the cdr
     * @param {module:api/ChatApi~chatSendSMSCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatSendSMS = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling chatSendSMS");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/{id}/sms', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the chatUnArchiveConversation operation.
     * @callback module:api/ChatApi~chatUnArchiveConversationCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * UnArchive conversation
     * @param {String} conversationId The conversation id
     * @param {String} id 
     * @param {module:api/ChatApi~chatUnArchiveConversationCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatUnArchiveConversation = function(conversationId, id, callback) {
      var postBody = null;

      // verify the required parameter 'conversationId' is set
      if (conversationId === undefined || conversationId === null) {
        throw new Error("Missing the required parameter 'conversationId' when calling chatUnArchiveConversation");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling chatUnArchiveConversation");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'conversationId': conversationId,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/UnArchive/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the chatUnpinConversation operation.
     * @callback module:api/ChatApi~chatUnpinConversationCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Unpin conversation
     * @param {String} conversationId The conversation id
     * @param {String} id 
     * @param {module:api/ChatApi~chatUnpinConversationCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatUnpinConversation = function(conversationId, id, callback) {
      var postBody = null;

      // verify the required parameter 'conversationId' is set
      if (conversationId === undefined || conversationId === null) {
        throw new Error("Missing the required parameter 'conversationId' when calling chatUnpinConversation");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling chatUnpinConversation");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'conversationId': conversationId,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/Unpin/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the chatUpdateAllMessagesToRead operation.
     * @callback module:api/ChatApi~chatUpdateAllMessagesToReadCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update all conversation&#39;s messages to read
     * @param {String} teammateId The teammate id
     * @param {String} groupId The group id
     * @param {module:api/ChatApi~chatUpdateAllMessagesToReadCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatUpdateAllMessagesToRead = function(teammateId, groupId, callback) {
      var postBody = null;

      // verify the required parameter 'teammateId' is set
      if (teammateId === undefined || teammateId === null) {
        throw new Error("Missing the required parameter 'teammateId' when calling chatUpdateAllMessagesToRead");
      }

      // verify the required parameter 'groupId' is set
      if (groupId === undefined || groupId === null) {
        throw new Error("Missing the required parameter 'groupId' when calling chatUpdateAllMessagesToRead");
      }


      var pathParams = {
        'teammateId': teammateId
      };
      var queryParams = {
        'groupId': groupId,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/UpdateAllMessagesToRead/{teammateId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the chatUpdateGroupImage operation.
     * @callback module:api/ChatApi~chatUpdateGroupImageCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Group Image
     * @param {String} conversationId The conversation id
     * @param {module:model/ProfileImage} groupImage Group Image
     * @param {module:api/ChatApi~chatUpdateGroupImageCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatUpdateGroupImage = function(conversationId, groupImage, callback) {
      var postBody = groupImage;

      // verify the required parameter 'conversationId' is set
      if (conversationId === undefined || conversationId === null) {
        throw new Error("Missing the required parameter 'conversationId' when calling chatUpdateGroupImage");
      }

      // verify the required parameter 'groupImage' is set
      if (groupImage === undefined || groupImage === null) {
        throw new Error("Missing the required parameter 'groupImage' when calling chatUpdateGroupImage");
      }


      var pathParams = {
        'conversationId': conversationId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/GroupImage/{conversationId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the chatUpdateGroupName operation.
     * @callback module:api/ChatApi~chatUpdateGroupNameCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Group Name
     * @param {String} conversationId The conversation id
     * @param {String} groupName Group Name
     * @param {module:api/ChatApi~chatUpdateGroupNameCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.chatUpdateGroupName = function(conversationId, groupName, callback) {
      var postBody = null;

      // verify the required parameter 'conversationId' is set
      if (conversationId === undefined || conversationId === null) {
        throw new Error("Missing the required parameter 'conversationId' when calling chatUpdateGroupName");
      }

      // verify the required parameter 'groupName' is set
      if (groupName === undefined || groupName === null) {
        throw new Error("Missing the required parameter 'groupName' when calling chatUpdateGroupName");
      }


      var pathParams = {
        'conversationId': conversationId
      };
      var queryParams = {
        'groupName': groupName,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Chat/GroupName/{conversationId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
