/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CspFetchMessageRequest', 'model/CspPushToken', 'model/CspSendMessage'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/CspFetchMessageRequest'), require('../model/CspPushToken'), require('../model/CspSendMessage'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.CloudSoftPhoneApi = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.CspFetchMessageRequest, root.PhonespeakApi.CspPushToken, root.PhonespeakApi.CspSendMessage);
  }
}(this, function(ApiClient, CspFetchMessageRequest, CspPushToken, CspSendMessage) {
  'use strict';

  /**
   * CloudSoftPhone service.
   * @module api/CloudSoftPhoneApi
   * @version v2
   */

  /**
   * Constructs a new CloudSoftPhoneApi. 
   * @alias module:api/CloudSoftPhoneApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the cloudSoftPhoneFetchMessage operation.
     * @callback module:api/CloudSoftPhoneApi~cloudSoftPhoneFetchMessageCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List all contacts
     * @param {module:model/CspFetchMessageRequest} request Csp fetch message request
     * @param {module:api/CloudSoftPhoneApi~cloudSoftPhoneFetchMessageCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cloudSoftPhoneFetchMessage = function(request, callback) {
      var postBody = request;

      // verify the required parameter 'request' is set
      if (request === undefined || request === null) {
        throw new Error("Missing the required parameter 'request' when calling cloudSoftPhoneFetchMessage");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/CloudSoftPhone/Message/Fetch', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cloudSoftPhoneListContacts operation.
     * @callback module:api/CloudSoftPhoneApi~cloudSoftPhoneListContactsCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List all contacts
     * @param {String} u username that required to login
     * @param {String} p password
     * @param {module:api/CloudSoftPhoneApi~cloudSoftPhoneListContactsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cloudSoftPhoneListContacts = function(u, p, callback) {
      var postBody = null;

      // verify the required parameter 'u' is set
      if (u === undefined || u === null) {
        throw new Error("Missing the required parameter 'u' when calling cloudSoftPhoneListContacts");
      }

      // verify the required parameter 'p' is set
      if (p === undefined || p === null) {
        throw new Error("Missing the required parameter 'p' when calling cloudSoftPhoneListContacts");
      }


      var pathParams = {
      };
      var queryParams = {
        'u': u,
        'p': p,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/CloudSoftPhone/Contact', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cloudSoftPhoneLogin operation.
     * @callback module:api/CloudSoftPhoneApi~cloudSoftPhoneLoginCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Login
     * @param {String} cloudUsername username that required to login
     * @param {String} cloudPassword password
     * @param {String} cloudId full
     * @param {module:api/CloudSoftPhoneApi~cloudSoftPhoneLoginCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cloudSoftPhoneLogin = function(cloudUsername, cloudPassword, cloudId, callback) {
      var postBody = null;

      // verify the required parameter 'cloudUsername' is set
      if (cloudUsername === undefined || cloudUsername === null) {
        throw new Error("Missing the required parameter 'cloudUsername' when calling cloudSoftPhoneLogin");
      }

      // verify the required parameter 'cloudPassword' is set
      if (cloudPassword === undefined || cloudPassword === null) {
        throw new Error("Missing the required parameter 'cloudPassword' when calling cloudSoftPhoneLogin");
      }

      // verify the required parameter 'cloudId' is set
      if (cloudId === undefined || cloudId === null) {
        throw new Error("Missing the required parameter 'cloudId' when calling cloudSoftPhoneLogin");
      }


      var pathParams = {
      };
      var queryParams = {
        'cloud_username': cloudUsername,
        'cloud_password': cloudPassword,
        'cloud_id': cloudId,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/CloudSoftPhone/Prov', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cloudSoftPhonePushTokenReporter operation.
     * @callback module:api/CloudSoftPhoneApi~cloudSoftPhonePushTokenReporterCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List all contacts
     * @param {module:model/CspPushToken} cspPushToken Push token object
     * @param {module:api/CloudSoftPhoneApi~cloudSoftPhonePushTokenReporterCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cloudSoftPhonePushTokenReporter = function(cspPushToken, callback) {
      var postBody = cspPushToken;

      // verify the required parameter 'cspPushToken' is set
      if (cspPushToken === undefined || cspPushToken === null) {
        throw new Error("Missing the required parameter 'cspPushToken' when calling cloudSoftPhonePushTokenReporter");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/CloudSoftPhone/PushToken', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the cloudSoftPhoneSendMessage operation.
     * @callback module:api/CloudSoftPhoneApi~cloudSoftPhoneSendMessageCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List all contacts
     * @param {module:model/CspSendMessage} message Send message object
     * @param {module:api/CloudSoftPhoneApi~cloudSoftPhoneSendMessageCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.cloudSoftPhoneSendMessage = function(message, callback) {
      var postBody = message;

      // verify the required parameter 'message' is set
      if (message === undefined || message === null) {
        throw new Error("Missing the required parameter 'message' when calling cloudSoftPhoneSendMessage");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/CloudSoftPhone/Message', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
