/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AddCompanyNumberInfo', 'model/CompanyNumber', 'model/IvrKey', 'model/IvrTimeOut', 'model/PhoneNumber', 'model/SMSHandling', 'model/TextToSpeechInfo'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/AddCompanyNumberInfo'), require('../model/CompanyNumber'), require('../model/IvrKey'), require('../model/IvrTimeOut'), require('../model/PhoneNumber'), require('../model/SMSHandling'), require('../model/TextToSpeechInfo'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.CompanyNumberApi = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.AddCompanyNumberInfo, root.PhonespeakApi.CompanyNumber, root.PhonespeakApi.IvrKey, root.PhonespeakApi.IvrTimeOut, root.PhonespeakApi.PhoneNumber, root.PhonespeakApi.SMSHandling, root.PhonespeakApi.TextToSpeechInfo);
  }
}(this, function(ApiClient, AddCompanyNumberInfo, CompanyNumber, IvrKey, IvrTimeOut, PhoneNumber, SMSHandling, TextToSpeechInfo) {
  'use strict';

  /**
   * CompanyNumber service.
   * @module api/CompanyNumberApi
   * @version v2
   */

  /**
   * Constructs a new CompanyNumberApi. 
   * @alias module:api/CompanyNumberApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the companyNumberAddPhoneNumber operation.
     * @callback module:api/CompanyNumberApi~companyNumberAddPhoneNumberCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add Phone Number for Company Number
     * @param {String} id Company Number id to update
     * @param {module:model/PhoneNumber} phoneNumber The phone number object for company number
     * @param {module:api/CompanyNumberApi~companyNumberAddPhoneNumberCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberAddPhoneNumber = function(id, phoneNumber, callback) {
      var postBody = phoneNumber;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberAddPhoneNumber");
      }

      // verify the required parameter 'phoneNumber' is set
      if (phoneNumber === undefined || phoneNumber === null) {
        throw new Error("Missing the required parameter 'phoneNumber' when calling companyNumberAddPhoneNumber");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/PhoneNumber', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberCreate operation.
     * @callback module:api/CompanyNumberApi~companyNumberCreateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a single Company Number
     * @param {module:model/AddCompanyNumberInfo} companyNumberInfo The Company Number object to create
     * @param {module:api/CompanyNumberApi~companyNumberCreateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberCreate = function(companyNumberInfo, callback) {
      var postBody = companyNumberInfo;

      // verify the required parameter 'companyNumberInfo' is set
      if (companyNumberInfo === undefined || companyNumberInfo === null) {
        throw new Error("Missing the required parameter 'companyNumberInfo' when calling companyNumberCreate");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberCreateIvr operation.
     * @callback module:api/CompanyNumberApi~companyNumberCreateIvrCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create Company Number&#39;s ivr
     * @param {String} id The team object to update
     * @param {module:api/CompanyNumberApi~companyNumberCreateIvrCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberCreateIvr = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberCreateIvr");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/Ivr', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberDelete operation.
     * @callback module:api/CompanyNumberApi~companyNumberDeleteCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete a single Company Number
     * @param {String} id Company number id to delete
     * @param {module:api/CompanyNumberApi~companyNumberDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberDelete = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberDelete");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberDeleteIvr operation.
     * @callback module:api/CompanyNumberApi~companyNumberDeleteIvrCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete Company Number&#39;s ivr
     * @param {String} id The team object to update
     * @param {String} ivrNumber The ivr to add
     * @param {module:api/CompanyNumberApi~companyNumberDeleteIvrCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberDeleteIvr = function(id, ivrNumber, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberDeleteIvr");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling companyNumberDeleteIvr");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/Ivr/{ivrNumber}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberDeleteIvrGreeting operation.
     * @callback module:api/CompanyNumberApi~companyNumberDeleteIvrGreetingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete Ivr Greeting File
     * @param {String} id Team Id
     * @param {String} ivrNumber Ivr Id
     * @param {String} greetingId Ivr Greeting Id to delete
     * @param {module:api/CompanyNumberApi~companyNumberDeleteIvrGreetingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberDeleteIvrGreeting = function(id, ivrNumber, greetingId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberDeleteIvrGreeting");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling companyNumberDeleteIvrGreeting");
      }

      // verify the required parameter 'greetingId' is set
      if (greetingId === undefined || greetingId === null) {
        throw new Error("Missing the required parameter 'greetingId' when calling companyNumberDeleteIvrGreeting");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber,
        'greetingId': greetingId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/Ivr/{ivrNumber}/Greeting/{greetingId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberDeletePhoneNumber operation.
     * @callback module:api/CompanyNumberApi~companyNumberDeletePhoneNumberCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete Phone Number for Company Number
     * @param {String} id Company Number id to update
     * @param {String} phoneNumberId Phone number id
     * @param {module:api/CompanyNumberApi~companyNumberDeletePhoneNumberCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberDeletePhoneNumber = function(id, phoneNumberId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberDeletePhoneNumber");
      }

      // verify the required parameter 'phoneNumberId' is set
      if (phoneNumberId === undefined || phoneNumberId === null) {
        throw new Error("Missing the required parameter 'phoneNumberId' when calling companyNumberDeletePhoneNumber");
      }


      var pathParams = {
        'id': id,
        'phoneNumberId': phoneNumberId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/PhoneNumber/{phoneNumberId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberGet operation.
     * @callback module:api/CompanyNumberApi~companyNumberGetCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve a single Company Number by id
     * @param {String} id The Company Number id to retrieve
     * @param {module:api/CompanyNumberApi~companyNumberGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberGet = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberGet");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberIvrConvertTextToSpeech operation.
     * @callback module:api/CompanyNumberApi~companyNumberIvrConvertTextToSpeechCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Ivr Convert text to speech
     * @param {String} id team id
     * @param {String} ivrNumber ivr number
     * @param {module:model/TextToSpeechInfo} textToSpeechInfo Text-to-Speech Info
     * @param {File} textToSpeech Type to convert Text to Speech
     * @param {module:api/CompanyNumberApi~companyNumberIvrConvertTextToSpeechCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberIvrConvertTextToSpeech = function(id, ivrNumber, textToSpeechInfo, textToSpeech, callback) {
      var postBody = textToSpeechInfo;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberIvrConvertTextToSpeech");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling companyNumberIvrConvertTextToSpeech");
      }

      // verify the required parameter 'textToSpeechInfo' is set
      if (textToSpeechInfo === undefined || textToSpeechInfo === null) {
        throw new Error("Missing the required parameter 'textToSpeechInfo' when calling companyNumberIvrConvertTextToSpeech");
      }

      // verify the required parameter 'textToSpeech' is set
      if (textToSpeech === undefined || textToSpeech === null) {
        throw new Error("Missing the required parameter 'textToSpeech' when calling companyNumberIvrConvertTextToSpeech");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'TextToSpeech': textToSpeech
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml', 'multipart/form-data'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/Ivr/{ivrNumber}/Greeting/SpeechGreeting', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberList operation.
     * @callback module:api/CompanyNumberApi~companyNumberListCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List all Company Numbers by account
     * @param {Object} opts Optional parameters
     * @param {String} opts.search Search text
     * @param {String} opts.orderBy Sort by column
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {module:api/CompanyNumberApi~companyNumberListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberList = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'search': opts['search'],
        'orderBy': opts['orderBy'],
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberListAvailableTeammates operation.
     * @callback module:api/CompanyNumberApi~companyNumberListAvailableTeammatesCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Teammate list for company number
     * @param {String} id 
     * @param {module:api/CompanyNumberApi~companyNumberListAvailableTeammatesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberListAvailableTeammates = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberListAvailableTeammates");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/ListAvailableTeammates', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberListIvrGreetings operation.
     * @callback module:api/CompanyNumberApi~companyNumberListIvrGreetingsCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Ivr Greetings for a team
     * @param {String} id Team Id
     * @param {String} ivrNumber Team Ivr Id
     * @param {module:api/CompanyNumberApi~companyNumberListIvrGreetingsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberListIvrGreetings = function(id, ivrNumber, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberListIvrGreetings");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling companyNumberListIvrGreetings");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/Ivr/{ivrNumber}/Greeting', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberUpdate operation.
     * @callback module:api/CompanyNumberApi~companyNumberUpdateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update a single Company Number by id
     * @param {String} id Company Number id to update
     * @param {module:model/CompanyNumber} companyNumber The Company Number object to update
     * @param {module:api/CompanyNumberApi~companyNumberUpdateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberUpdate = function(id, companyNumber, callback) {
      var postBody = companyNumber;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberUpdate");
      }

      // verify the required parameter 'companyNumber' is set
      if (companyNumber === undefined || companyNumber === null) {
        throw new Error("Missing the required parameter 'companyNumber' when calling companyNumberUpdate");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberUpdateBusinessHour operation.
     * @callback module:api/CompanyNumberApi~companyNumberUpdateBusinessHourCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Company Number Business Hour by id
     * @param {String} id Company Number id to update
     * @param {module:model/CompanyNumber} companyNumber The Company Number object to update
     * @param {module:api/CompanyNumberApi~companyNumberUpdateBusinessHourCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberUpdateBusinessHour = function(id, companyNumber, callback) {
      var postBody = companyNumber;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberUpdateBusinessHour");
      }

      // verify the required parameter 'companyNumber' is set
      if (companyNumber === undefined || companyNumber === null) {
        throw new Error("Missing the required parameter 'companyNumber' when calling companyNumberUpdateBusinessHour");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/BusinessHour', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberUpdateCallerIdPermission operation.
     * @callback module:api/CompanyNumberApi~companyNumberUpdateCallerIdPermissionCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add teammate for Company Number
     * @param {String} id Company Number id to update
     * @param {module:model/CompanyNumber} teammateId caller id permission teammate id list
     * @param {module:api/CompanyNumberApi~companyNumberUpdateCallerIdPermissionCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberUpdateCallerIdPermission = function(id, teammateId, callback) {
      var postBody = teammateId;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberUpdateCallerIdPermission");
      }

      // verify the required parameter 'teammateId' is set
      if (teammateId === undefined || teammateId === null) {
        throw new Error("Missing the required parameter 'teammateId' when calling companyNumberUpdateCallerIdPermission");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/CallerIdPermission', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberUpdateClosedHourHandling operation.
     * @callback module:api/CompanyNumberApi~companyNumberUpdateClosedHourHandlingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Company Number Closed Hour Handling
     * @param {String} id Company Number id to update
     * @param {module:model/CompanyNumber} companyNumber The Company Number object to update
     * @param {module:api/CompanyNumberApi~companyNumberUpdateClosedHourHandlingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberUpdateClosedHourHandling = function(id, companyNumber, callback) {
      var postBody = companyNumber;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberUpdateClosedHourHandling");
      }

      // verify the required parameter 'companyNumber' is set
      if (companyNumber === undefined || companyNumber === null) {
        throw new Error("Missing the required parameter 'companyNumber' when calling companyNumberUpdateClosedHourHandling");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/ClosedHourHandling', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberUpdateIvrKey operation.
     * @callback module:api/CompanyNumberApi~companyNumberUpdateIvrKeyCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Ivr Key
     * @param {String} id company number id
     * @param {String} ivrNumber ivr number
     * @param {Number} keyNumber key number
     * @param {module:model/IvrKey} ivrKey ivr key object
     * @param {module:api/CompanyNumberApi~companyNumberUpdateIvrKeyCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberUpdateIvrKey = function(id, ivrNumber, keyNumber, ivrKey, callback) {
      var postBody = ivrKey;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberUpdateIvrKey");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling companyNumberUpdateIvrKey");
      }

      // verify the required parameter 'keyNumber' is set
      if (keyNumber === undefined || keyNumber === null) {
        throw new Error("Missing the required parameter 'keyNumber' when calling companyNumberUpdateIvrKey");
      }

      // verify the required parameter 'ivrKey' is set
      if (ivrKey === undefined || ivrKey === null) {
        throw new Error("Missing the required parameter 'ivrKey' when calling companyNumberUpdateIvrKey");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber,
        'keyNumber': keyNumber
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/Ivr/{ivrNumber}/IvrKey/{keyNumber}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberUpdateIvrName operation.
     * @callback module:api/CompanyNumberApi~companyNumberUpdateIvrNameCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Company Number&#39;s ivr
     * @param {String} id The team object to update
     * @param {String} ivrNumber ivr number
     * @param {String} ivrName ivr name
     * @param {module:api/CompanyNumberApi~companyNumberUpdateIvrNameCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberUpdateIvrName = function(id, ivrNumber, ivrName, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberUpdateIvrName");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling companyNumberUpdateIvrName");
      }

      // verify the required parameter 'ivrName' is set
      if (ivrName === undefined || ivrName === null) {
        throw new Error("Missing the required parameter 'ivrName' when calling companyNumberUpdateIvrName");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber,
        'ivrName': ivrName
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/Ivr/{ivrNumber}/Name/{ivrName}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberUpdateIvrTimeout operation.
     * @callback module:api/CompanyNumberApi~companyNumberUpdateIvrTimeoutCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Ivr Timeout
     * @param {String} id company number id
     * @param {String} ivrNumber ivr number
     * @param {module:model/IvrTimeOut} timeOut timeout action
     * @param {module:api/CompanyNumberApi~companyNumberUpdateIvrTimeoutCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberUpdateIvrTimeout = function(id, ivrNumber, timeOut, callback) {
      var postBody = timeOut;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberUpdateIvrTimeout");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling companyNumberUpdateIvrTimeout");
      }

      // verify the required parameter 'timeOut' is set
      if (timeOut === undefined || timeOut === null) {
        throw new Error("Missing the required parameter 'timeOut' when calling companyNumberUpdateIvrTimeout");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/Ivr/{ivrNumber}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberUpdateOpenHourHandling operation.
     * @callback module:api/CompanyNumberApi~companyNumberUpdateOpenHourHandlingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Company Number Open Hour Handling
     * @param {String} id Company Number id to update
     * @param {module:model/CompanyNumber} companyNumber The Company Number object to update
     * @param {module:api/CompanyNumberApi~companyNumberUpdateOpenHourHandlingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberUpdateOpenHourHandling = function(id, companyNumber, callback) {
      var postBody = companyNumber;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberUpdateOpenHourHandling");
      }

      // verify the required parameter 'companyNumber' is set
      if (companyNumber === undefined || companyNumber === null) {
        throw new Error("Missing the required parameter 'companyNumber' when calling companyNumberUpdateOpenHourHandling");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/OpenHourHandling', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberUpdatePhoneNumber operation.
     * @callback module:api/CompanyNumberApi~companyNumberUpdatePhoneNumberCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add Phone Number
     * @param {String} id Company Number id
     * @param {String} phoneNumberId Phone number Id
     * @param {module:model/PhoneNumber} phoneNumber Phone number details
     * @param {module:api/CompanyNumberApi~companyNumberUpdatePhoneNumberCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberUpdatePhoneNumber = function(id, phoneNumberId, phoneNumber, callback) {
      var postBody = phoneNumber;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberUpdatePhoneNumber");
      }

      // verify the required parameter 'phoneNumberId' is set
      if (phoneNumberId === undefined || phoneNumberId === null) {
        throw new Error("Missing the required parameter 'phoneNumberId' when calling companyNumberUpdatePhoneNumber");
      }

      // verify the required parameter 'phoneNumber' is set
      if (phoneNumber === undefined || phoneNumber === null) {
        throw new Error("Missing the required parameter 'phoneNumber' when calling companyNumberUpdatePhoneNumber");
      }


      var pathParams = {
        'id': id,
        'phoneNumberId': phoneNumberId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/PhoneNumber/{phoneNumberId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberUpdateSMSHandling operation.
     * @callback module:api/CompanyNumberApi~companyNumberUpdateSMSHandlingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update SMS Handling for Company Number
     * @param {String} id Company Number Id
     * @param {module:model/SMSHandling} info SMS handling info
     * @param {module:api/CompanyNumberApi~companyNumberUpdateSMSHandlingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberUpdateSMSHandling = function(id, info, callback) {
      var postBody = info;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberUpdateSMSHandling");
      }

      // verify the required parameter 'info' is set
      if (info === undefined || info === null) {
        throw new Error("Missing the required parameter 'info' when calling companyNumberUpdateSMSHandling");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/Sms/SMSHandling', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberUpdateSelectedIvrGreeting operation.
     * @callback module:api/CompanyNumberApi~companyNumberUpdateSelectedIvrGreetingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update/Set a Company Number&#39;s default Voicemail Greeting
     * @param {String} id Team Id
     * @param {String} ivrNumber Ivr Id
     * @param {String} greetingId Greeting Id to set as default
     * @param {module:api/CompanyNumberApi~companyNumberUpdateSelectedIvrGreetingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberUpdateSelectedIvrGreeting = function(id, ivrNumber, greetingId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberUpdateSelectedIvrGreeting");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling companyNumberUpdateSelectedIvrGreeting");
      }

      // verify the required parameter 'greetingId' is set
      if (greetingId === undefined || greetingId === null) {
        throw new Error("Missing the required parameter 'greetingId' when calling companyNumberUpdateSelectedIvrGreeting");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber,
        'greetingId': greetingId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/Ivr/{ivrNumber}/Greeting/{greetingId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the companyNumberUploadIvrGreeting operation.
     * @callback module:api/CompanyNumberApi~companyNumberUploadIvrGreetingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upload Ivr Greeting File
     * @param {String} id Team Id
     * @param {String} ivrNumber Ivr Id
     * @param {File} uploadIvrGreeting Upload voicemail greeting file
     * @param {module:api/CompanyNumberApi~companyNumberUploadIvrGreetingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.companyNumberUploadIvrGreeting = function(id, ivrNumber, uploadIvrGreeting, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling companyNumberUploadIvrGreeting");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling companyNumberUploadIvrGreeting");
      }

      // verify the required parameter 'uploadIvrGreeting' is set
      if (uploadIvrGreeting === undefined || uploadIvrGreeting === null) {
        throw new Error("Missing the required parameter 'uploadIvrGreeting' when calling companyNumberUploadIvrGreeting");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'UploadIvrGreeting': uploadIvrGreeting
      };

      var authNames = ['Authorization'];
      var contentTypes = ['multipart/form-data'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/CompanyNumber/{id}/Ivr/{ivrNumber}/Greeting', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
