/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AccountSetting', 'model/Address', 'model/Authentication', 'model/BandwidthPortin', 'model/BandwidthPortinSearch', 'model/CsrAccount', 'model/CsrUser', 'model/DeskphoneMacAddress', 'model/Product', 'model/ProfileImage', 'model/SignupInfo', 'model/TrackingRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/AccountSetting'), require('../model/Address'), require('../model/Authentication'), require('../model/BandwidthPortin'), require('../model/BandwidthPortinSearch'), require('../model/CsrAccount'), require('../model/CsrUser'), require('../model/DeskphoneMacAddress'), require('../model/Product'), require('../model/ProfileImage'), require('../model/SignupInfo'), require('../model/TrackingRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.CsrApi = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.AccountSetting, root.PhonespeakApi.Address, root.PhonespeakApi.Authentication, root.PhonespeakApi.BandwidthPortin, root.PhonespeakApi.BandwidthPortinSearch, root.PhonespeakApi.CsrAccount, root.PhonespeakApi.CsrUser, root.PhonespeakApi.DeskphoneMacAddress, root.PhonespeakApi.Product, root.PhonespeakApi.ProfileImage, root.PhonespeakApi.SignupInfo, root.PhonespeakApi.TrackingRequest);
  }
}(this, function(ApiClient, AccountSetting, Address, Authentication, BandwidthPortin, BandwidthPortinSearch, CsrAccount, CsrUser, DeskphoneMacAddress, Product, ProfileImage, SignupInfo, TrackingRequest) {
  'use strict';

  /**
   * Csr service.
   * @module api/CsrApi
   * @version v2
   */

  /**
   * Constructs a new CsrApi. 
   * @alias module:api/CsrApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the csrAddNumber operation.
     * @callback module:api/CsrApi~csrAddNumberCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add Phone Number
     * @param {String} id Account Id
     * @param {String} phoneNumber Phone Numbers
     * @param {module:api/CsrApi~csrAddNumberCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrAddNumber = function(id, phoneNumber, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrAddNumber");
      }

      // verify the required parameter 'phoneNumber' is set
      if (phoneNumber === undefined || phoneNumber === null) {
        throw new Error("Missing the required parameter 'phoneNumber' when calling csrAddNumber");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'phoneNumber': phoneNumber,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Number/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrApplyInvoiceCoupon operation.
     * @callback module:api/CsrApi~csrApplyInvoiceCouponCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Apply Invoice Coupon
     * @param {String} id Account id
     * @param {String} couponId Coupon Id
     * @param {module:api/CsrApi~csrApplyInvoiceCouponCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrApplyInvoiceCoupon = function(id, couponId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrApplyInvoiceCoupon");
      }

      // verify the required parameter 'couponId' is set
      if (couponId === undefined || couponId === null) {
        throw new Error("Missing the required parameter 'couponId' when calling csrApplyInvoiceCoupon");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'couponId': couponId,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}/InvoiceCoupon', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrApplySubscriptionCoupon operation.
     * @callback module:api/CsrApi~csrApplySubscriptionCouponCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Apply Subscription Coupon
     * @param {String} id Account Id
     * @param {String} couponId Coupon Id
     * @param {module:api/CsrApi~csrApplySubscriptionCouponCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrApplySubscriptionCoupon = function(id, couponId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrApplySubscriptionCoupon");
      }

      // verify the required parameter 'couponId' is set
      if (couponId === undefined || couponId === null) {
        throw new Error("Missing the required parameter 'couponId' when calling csrApplySubscriptionCoupon");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'couponId': couponId,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}/SubscriptionCoupon', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrCallLogExport operation.
     * @callback module:api/CsrApi~csrCallLogExportCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Export Call Log
     * @param {Date} fromDate From date
     * @param {Date} toDate To date
     * @param {Object} opts Optional parameters
     * @param {String} opts.companyName Company Name (optional)
     * @param {module:api/CsrApi~csrCallLogExportCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrCallLogExport = function(fromDate, toDate, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'fromDate' is set
      if (fromDate === undefined || fromDate === null) {
        throw new Error("Missing the required parameter 'fromDate' when calling csrCallLogExport");
      }

      // verify the required parameter 'toDate' is set
      if (toDate === undefined || toDate === null) {
        throw new Error("Missing the required parameter 'toDate' when calling csrCallLogExport");
      }


      var pathParams = {
      };
      var queryParams = {
        'fromDate': fromDate,
        'toDate': toDate,
        'companyName': opts['companyName'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/CallLog/Export', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrCheckLnp operation.
     * @callback module:api/CsrApi~csrCheckLnpCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Check Lnp
     * @param {Array.<module:model/String>} numbers Number List
     * @param {module:api/CsrApi~csrCheckLnpCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrCheckLnp = function(numbers, callback) {
      var postBody = numbers;

      // verify the required parameter 'numbers' is set
      if (numbers === undefined || numbers === null) {
        throw new Error("Missing the required parameter 'numbers' when calling csrCheckLnp");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/Portin/CheckLnp', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrCompleteOrder operation.
     * @callback module:api/CsrApi~csrCompleteOrderCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Complete Order
     * @param {String} orderId The order id
     * @param {module:api/CsrApi~csrCompleteOrderCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrCompleteOrder = function(orderId, callback) {
      var postBody = null;

      // verify the required parameter 'orderId' is set
      if (orderId === undefined || orderId === null) {
        throw new Error("Missing the required parameter 'orderId' when calling csrCompleteOrder");
      }


      var pathParams = {
        'orderId': orderId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Order/{orderId}/Complete', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrCreate operation.
     * @callback module:api/CsrApi~csrCreateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a single Csr user
     * @param {module:model/CsrUser} csrUser The Csr user object to create
     * @param {module:api/CsrApi~csrCreateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrCreate = function(csrUser, callback) {
      var postBody = csrUser;

      // verify the required parameter 'csrUser' is set
      if (csrUser === undefined || csrUser === null) {
        throw new Error("Missing the required parameter 'csrUser' when calling csrCreate");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Representative', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrCreateAccount operation.
     * @callback module:api/CsrApi~csrCreateAccountCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a single account
     * @param {module:model/SignupInfo} signUpInfo Account Sign Up info
     * @param {module:api/CsrApi~csrCreateAccountCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrCreateAccount = function(signUpInfo, callback) {
      var postBody = signUpInfo;

      // verify the required parameter 'signUpInfo' is set
      if (signUpInfo === undefined || signUpInfo === null) {
        throw new Error("Missing the required parameter 'signUpInfo' when calling csrCreateAccount");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrCreateLnp operation.
     * @callback module:api/CsrApi~csrCreateLnpCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create Lnp
     * @param {module:model/BandwidthPortin} bandwidthPortin Bandwidth Portin Object
     * @param {String} accountId Account Id
     * @param {module:api/CsrApi~csrCreateLnpCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrCreateLnp = function(bandwidthPortin, accountId, callback) {
      var postBody = bandwidthPortin;

      // verify the required parameter 'bandwidthPortin' is set
      if (bandwidthPortin === undefined || bandwidthPortin === null) {
        throw new Error("Missing the required parameter 'bandwidthPortin' when calling csrCreateLnp");
      }

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling csrCreateLnp");
      }


      var pathParams = {
        'accountId': accountId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{accountId}/Portin', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrCreateProduct operation.
     * @callback module:api/CsrApi~csrCreateProductCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create Product
     * @param {module:model/Product} product The Product Detail
     * @param {module:api/CsrApi~csrCreateProductCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrCreateProduct = function(product, callback) {
      var postBody = product;

      // verify the required parameter 'product' is set
      if (product === undefined || product === null) {
        throw new Error("Missing the required parameter 'product' when calling csrCreateProduct");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Product', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrDelete operation.
     * @callback module:api/CsrApi~csrDeleteCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete a single Csr user
     * @param {String} id The Csr user id to delete
     * @param {module:api/CsrApi~csrDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrDelete = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrDelete");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Representative/{id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrDeleteLnp operation.
     * @callback module:api/CsrApi~csrDeleteLnpCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete Lnp
     * @param {String} orderId Order Id
     * @param {String} accountId 
     * @param {module:api/CsrApi~csrDeleteLnpCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrDeleteLnp = function(orderId, accountId, callback) {
      var postBody = null;

      // verify the required parameter 'orderId' is set
      if (orderId === undefined || orderId === null) {
        throw new Error("Missing the required parameter 'orderId' when calling csrDeleteLnp");
      }

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling csrDeleteLnp");
      }


      var pathParams = {
        'orderId': orderId,
        'accountId': accountId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{accountId}/Portin/{orderId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrDeleteTeammate operation.
     * @callback module:api/CsrApi~csrDeleteTeammateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete a single teammate
     * @param {String} id Account id
     * @param {String} teammateId Teammate id
     * @param {module:api/CsrApi~csrDeleteTeammateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrDeleteTeammate = function(id, teammateId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrDeleteTeammate");
      }

      // verify the required parameter 'teammateId' is set
      if (teammateId === undefined || teammateId === null) {
        throw new Error("Missing the required parameter 'teammateId' when calling csrDeleteTeammate");
      }


      var pathParams = {
        'id': id,
        'teammateId': teammateId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}/Teammate/{teammateId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrForgotPassword operation.
     * @callback module:api/CsrApi~csrForgotPasswordCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Csr Forgot password
     * @param {String} email Email
     * @param {module:api/CsrApi~csrForgotPasswordCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrForgotPassword = function(email, callback) {
      var postBody = null;

      // verify the required parameter 'email' is set
      if (email === undefined || email === null) {
        throw new Error("Missing the required parameter 'email' when calling csrForgotPassword");
      }


      var pathParams = {
      };
      var queryParams = {
        'email': email,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/ForgotPassword', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrGet operation.
     * @callback module:api/CsrApi~csrGetCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve a single Csr user
     * @param {String} id The Csr user id to retrieve
     * @param {module:api/CsrApi~csrGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrGet = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrGet");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Representative/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrGetAccount operation.
     * @callback module:api/CsrApi~csrGetAccountCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve a single account
     * @param {String} id Account id
     * @param {module:api/CsrApi~csrGetAccountCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrGetAccount = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrGetAccount");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrGetCallLog operation.
     * @callback module:api/CsrApi~csrGetCallLogCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List all call log
     * @param {String} id unique cdr id
     * @param {module:api/CsrApi~csrGetCallLogCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrGetCallLog = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrGetCallLog");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/CallLog/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrGetLnp operation.
     * @callback module:api/CsrApi~csrGetLnpCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Lnp
     * @param {String} orderId Order Id
     * @param {String} accountId 
     * @param {module:api/CsrApi~csrGetLnpCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrGetLnp = function(orderId, accountId, callback) {
      var postBody = null;

      // verify the required parameter 'orderId' is set
      if (orderId === undefined || orderId === null) {
        throw new Error("Missing the required parameter 'orderId' when calling csrGetLnp");
      }

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling csrGetLnp");
      }


      var pathParams = {
        'orderId': orderId,
        'accountId': accountId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{accountId}/Portin/{orderId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrGetOrder operation.
     * @callback module:api/CsrApi~csrGetOrderCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Order
     * @param {String} orderId The order id
     * @param {module:api/CsrApi~csrGetOrderCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrGetOrder = function(orderId, callback) {
      var postBody = null;

      // verify the required parameter 'orderId' is set
      if (orderId === undefined || orderId === null) {
        throw new Error("Missing the required parameter 'orderId' when calling csrGetOrder");
      }


      var pathParams = {
        'orderId': orderId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Order/{orderId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrGetUncoveredRate operation.
     * @callback module:api/CsrApi~csrGetUncoveredRateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get current Uncovered Rate
     * @param {module:api/CsrApi~csrGetUncoveredRateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrGetUncoveredRate = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/RateDeck/UncoveredRate', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrGiveCredit operation.
     * @callback module:api/CsrApi~csrGiveCreditCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Give Credit
     * @param {String} id Account id
     * @param {Number} amount Amount given
     * @param {module:api/CsrApi~csrGiveCreditCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrGiveCredit = function(id, amount, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrGiveCredit");
      }

      // verify the required parameter 'amount' is set
      if (amount === undefined || amount === null) {
        throw new Error("Missing the required parameter 'amount' when calling csrGiveCredit");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'amount': amount,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}/Credit', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrImportRateDeck operation.
     * @callback module:api/CsrApi~csrImportRateDeckCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Import Rate Deck
     * @param {File} importRateDeck Import rate deck file
     * @param {module:api/CsrApi~csrImportRateDeckCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrImportRateDeck = function(importRateDeck, callback) {
      var postBody = null;

      // verify the required parameter 'importRateDeck' is set
      if (importRateDeck === undefined || importRateDeck === null) {
        throw new Error("Missing the required parameter 'importRateDeck' when calling csrImportRateDeck");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'ImportRateDeck': importRateDeck
      };

      var authNames = ['Authorization'];
      var contentTypes = ['multipart/form-data'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/RateDeck/Import', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrList operation.
     * @callback module:api/CsrApi~csrListCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve list of Csr users
     * @param {Object} opts Optional parameters
     * @param {String} opts.search Search text (optional)
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {module:api/CsrApi~csrListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrList = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'search': opts['search'],
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Representative', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrListAccountCompanyNumber operation.
     * @callback module:api/CsrApi~csrListAccountCompanyNumberCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List all Company Numbers by account
     * @param {String} id Account Id
     * @param {module:api/CsrApi~csrListAccountCompanyNumberCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrListAccountCompanyNumber = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrListAccountCompanyNumber");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}/CompanyNumber', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrListAccountPhoneNumber operation.
     * @callback module:api/CsrApi~csrListAccountPhoneNumberCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Phone Number
     * @param {String} id Account id
     * @param {module:api/CsrApi~csrListAccountPhoneNumberCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrListAccountPhoneNumber = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrListAccountPhoneNumber");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}/PhoneNumber', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrListAccountTeammate operation.
     * @callback module:api/CsrApi~csrListAccountTeammateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all teammates by account
     * @param {String} id Account Id
     * @param {module:api/CsrApi~csrListAccountTeammateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrListAccountTeammate = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrListAccountTeammate");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}/Teammate', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrListAccounts operation.
     * @callback module:api/CsrApi~csrListAccountsCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve list of all accounts
     * @param {Object} opts Optional parameters
     * @param {Number} opts.status Account status
     * @param {String} opts.search Search text
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {module:api/CsrApi~csrListAccountsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrListAccounts = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'status': opts['status'],
        'search': opts['search'],
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrListCallLog operation.
     * @callback module:api/CsrApi~csrListCallLogCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List all call log
     * @param {Date} fromDate From date
     * @param {Date} toDate To date
     * @param {Object} opts Optional parameters
     * @param {String} opts.companyName Company Name (optional)
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {module:api/CsrApi~csrListCallLogCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrListCallLog = function(fromDate, toDate, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'fromDate' is set
      if (fromDate === undefined || fromDate === null) {
        throw new Error("Missing the required parameter 'fromDate' when calling csrListCallLog");
      }

      // verify the required parameter 'toDate' is set
      if (toDate === undefined || toDate === null) {
        throw new Error("Missing the required parameter 'toDate' when calling csrListCallLog");
      }


      var pathParams = {
      };
      var queryParams = {
        'fromDate': fromDate,
        'toDate': toDate,
        'companyName': opts['companyName'],
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/CallLog', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrListCharge operation.
     * @callback module:api/CsrApi~csrListChargeCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Charge
     * @param {String} id Account id
     * @param {module:api/CsrApi~csrListChargeCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrListCharge = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrListCharge");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}/Charge', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrListLnp operation.
     * @callback module:api/CsrApi~csrListLnpCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Lnp
     * @param {module:model/BandwidthPortinSearch} bandwidthPortinSearch Bandwidth Search Object
     * @param {module:api/CsrApi~csrListLnpCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrListLnp = function(bandwidthPortinSearch, callback) {
      var postBody = bandwidthPortinSearch;

      // verify the required parameter 'bandwidthPortinSearch' is set
      if (bandwidthPortinSearch === undefined || bandwidthPortinSearch === null) {
        throw new Error("Missing the required parameter 'bandwidthPortinSearch' when calling csrListLnp");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/Portin/ListLnp', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrListOrder operation.
     * @callback module:api/CsrApi~csrListOrderCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Order
     * @param {Object} opts Optional parameters
     * @param {Number} opts.status Order Status (Value : 2-5)(Optional)
     * @param {String} opts.orderId Order Id (Optional)
     * @param {String} opts.referenceId Reference Id (Optional)
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {module:api/CsrApi~csrListOrderCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrListOrder = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'status': opts['status'],
        'orderId': opts['orderId'],
        'referenceId': opts['referenceId'],
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Order/List', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrListPhysicalPhoneByOrderId operation.
     * @callback module:api/CsrApi~csrListPhysicalPhoneByOrderIdCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Physical Phone by orderId
     * @param {String} id Account id
     * @param {String} orderId The order id/ reference id
     * @param {module:api/CsrApi~csrListPhysicalPhoneByOrderIdCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrListPhysicalPhoneByOrderId = function(id, orderId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrListPhysicalPhoneByOrderId");
      }

      // verify the required parameter 'orderId' is set
      if (orderId === undefined || orderId === null) {
        throw new Error("Missing the required parameter 'orderId' when calling csrListPhysicalPhoneByOrderId");
      }


      var pathParams = {
        'id': id,
        'orderId': orderId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}/PhysicalPhone/{orderId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrLogin operation.
     * @callback module:api/CsrApi~csrLoginCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Login
     * @param {module:model/Authentication} authentication Authentication details
     * @param {module:api/CsrApi~csrLoginCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrLogin = function(authentication, callback) {
      var postBody = authentication;

      // verify the required parameter 'authentication' is set
      if (authentication === undefined || authentication === null) {
        throw new Error("Missing the required parameter 'authentication' when calling csrLogin");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Login', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrManualCharge operation.
     * @callback module:api/CsrApi~csrManualChargeCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Manual Charge
     * @param {String} id Account id
     * @param {Number} amount Charge amount
     * @param {module:api/CsrApi~csrManualChargeCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrManualCharge = function(id, amount, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrManualCharge");
      }

      // verify the required parameter 'amount' is set
      if (amount === undefined || amount === null) {
        throw new Error("Missing the required parameter 'amount' when calling csrManualCharge");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'amount': amount,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}/Charge', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrMoveNumber operation.
     * @callback module:api/CsrApi~csrMoveNumberCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Move Number
     * @param {String} id Account Id
     * @param {String} phoneNumberId Phone Number Id
     * @param {String} assignTo Assign to &#39;s owner Id (Un-assign &#x3D; \&quot;\&quot;)
     * @param {module:api/CsrApi~csrMoveNumberCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrMoveNumber = function(id, phoneNumberId, assignTo, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrMoveNumber");
      }

      // verify the required parameter 'phoneNumberId' is set
      if (phoneNumberId === undefined || phoneNumberId === null) {
        throw new Error("Missing the required parameter 'phoneNumberId' when calling csrMoveNumber");
      }

      // verify the required parameter 'assignTo' is set
      if (assignTo === undefined || assignTo === null) {
        throw new Error("Missing the required parameter 'assignTo' when calling csrMoveNumber");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'phoneNumberId': phoneNumberId,
        'assignTo': assignTo,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Number/{id}/Move', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrRefund operation.
     * @callback module:api/CsrApi~csrRefundCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create Refund
     * @param {String} accountId Account Id
     * @param {String} chargeId Charge Id
     * @param {Number} amount Refund Amount
     * @param {module:api/CsrApi~csrRefundCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrRefund = function(accountId, chargeId, amount, callback) {
      var postBody = null;

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling csrRefund");
      }

      // verify the required parameter 'chargeId' is set
      if (chargeId === undefined || chargeId === null) {
        throw new Error("Missing the required parameter 'chargeId' when calling csrRefund");
      }

      // verify the required parameter 'amount' is set
      if (amount === undefined || amount === null) {
        throw new Error("Missing the required parameter 'amount' when calling csrRefund");
      }


      var pathParams = {
        'accountId': accountId,
        'chargeId': chargeId
      };
      var queryParams = {
        'amount': amount,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{accountId}/Refund/{chargeId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrUpdate operation.
     * @callback module:api/CsrApi~csrUpdateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update a single Csr user
     * @param {String} id The  Csr user id to update
     * @param {module:model/CsrUser} csrUser The Csr user object to update
     * @param {module:api/CsrApi~csrUpdateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrUpdate = function(id, csrUser, callback) {
      var postBody = csrUser;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrUpdate");
      }

      // verify the required parameter 'csrUser' is set
      if (csrUser === undefined || csrUser === null) {
        throw new Error("Missing the required parameter 'csrUser' when calling csrUpdate");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Representative/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrUpdateAccountDetails operation.
     * @callback module:api/CsrApi~csrUpdateAccountDetailsCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update account
     * @param {String} id Account id
     * @param {module:model/CsrAccount} csrAccount New account details
     * @param {module:api/CsrApi~csrUpdateAccountDetailsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrUpdateAccountDetails = function(id, csrAccount, callback) {
      var postBody = csrAccount;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrUpdateAccountDetails");
      }

      // verify the required parameter 'csrAccount' is set
      if (csrAccount === undefined || csrAccount === null) {
        throw new Error("Missing the required parameter 'csrAccount' when calling csrUpdateAccountDetails");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrUpdateAccountPackage operation.
     * @callback module:api/CsrApi~csrUpdateAccountPackageCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update account package
     * @param {String} id Account Id
     * @param {String} packageId Package Id
     * @param {module:api/CsrApi~csrUpdateAccountPackageCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrUpdateAccountPackage = function(id, packageId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrUpdateAccountPackage");
      }

      // verify the required parameter 'packageId' is set
      if (packageId === undefined || packageId === null) {
        throw new Error("Missing the required parameter 'packageId' when calling csrUpdateAccountPackage");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'packageId': packageId,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}/Package', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrUpdateAccountSetting operation.
     * @callback module:api/CsrApi~csrUpdateAccountSettingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Setting
     * @param {String} id Account id
     * @param {module:model/AccountSetting} setting Setting
     * @param {module:api/CsrApi~csrUpdateAccountSettingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrUpdateAccountSetting = function(id, setting, callback) {
      var postBody = setting;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrUpdateAccountSetting");
      }

      // verify the required parameter 'setting' is set
      if (setting === undefined || setting === null) {
        throw new Error("Missing the required parameter 'setting' when calling csrUpdateAccountSetting");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}/Setting', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrUpdateAccountStatus operation.
     * @callback module:api/CsrApi~csrUpdateAccountStatusCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Account Status
     * @param {String} id 
     * @param {Number} status 
     * @param {module:api/CsrApi~csrUpdateAccountStatusCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrUpdateAccountStatus = function(id, status, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrUpdateAccountStatus");
      }

      // verify the required parameter 'status' is set
      if (status === undefined || status === null) {
        throw new Error("Missing the required parameter 'status' when calling csrUpdateAccountStatus");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'status': status,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}/Status', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrUpdateCsrPassword operation.
     * @callback module:api/CsrApi~csrUpdateCsrPasswordCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update a single Csr User Password
     * @param {String} id The  Csr user id to update
     * @param {String} password New password
     * @param {module:api/CsrApi~csrUpdateCsrPasswordCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrUpdateCsrPassword = function(id, password, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrUpdateCsrPassword");
      }

      // verify the required parameter 'password' is set
      if (password === undefined || password === null) {
        throw new Error("Missing the required parameter 'password' when calling csrUpdateCsrPassword");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'password': password,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Representative/{id}/Password', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrUpdateMacAddress operation.
     * @callback module:api/CsrApi~csrUpdateMacAddressCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Physical Phone Mac Address
     * @param {String} id Account id
     * @param {Array.<module:model/DeskphoneMacAddress>} deskphoneMacAddress List of desk phone
     * @param {module:api/CsrApi~csrUpdateMacAddressCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrUpdateMacAddress = function(id, deskphoneMacAddress, callback) {
      var postBody = deskphoneMacAddress;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrUpdateMacAddress");
      }

      // verify the required parameter 'deskphoneMacAddress' is set
      if (deskphoneMacAddress === undefined || deskphoneMacAddress === null) {
        throw new Error("Missing the required parameter 'deskphoneMacAddress' when calling csrUpdateMacAddress");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}/PhysicalPhone', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrUpdateReferenceId operation.
     * @callback module:api/CsrApi~csrUpdateReferenceIdCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Reference Id
     * @param {String} orderId The order id
     * @param {String} referenceId The reference id
     * @param {module:api/CsrApi~csrUpdateReferenceIdCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrUpdateReferenceId = function(orderId, referenceId, callback) {
      var postBody = null;

      // verify the required parameter 'orderId' is set
      if (orderId === undefined || orderId === null) {
        throw new Error("Missing the required parameter 'orderId' when calling csrUpdateReferenceId");
      }

      // verify the required parameter 'referenceId' is set
      if (referenceId === undefined || referenceId === null) {
        throw new Error("Missing the required parameter 'referenceId' when calling csrUpdateReferenceId");
      }


      var pathParams = {
        'orderId': orderId,
        'referenceId': referenceId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Order/{orderId}/Reference/{referenceId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrUpdateShippingAddress operation.
     * @callback module:api/CsrApi~csrUpdateShippingAddressCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Shipping Address
     * @param {String} orderId The order id
     * @param {module:model/Address} address Shipping Address
     * @param {module:api/CsrApi~csrUpdateShippingAddressCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrUpdateShippingAddress = function(orderId, address, callback) {
      var postBody = address;

      // verify the required parameter 'orderId' is set
      if (orderId === undefined || orderId === null) {
        throw new Error("Missing the required parameter 'orderId' when calling csrUpdateShippingAddress");
      }

      // verify the required parameter 'address' is set
      if (address === undefined || address === null) {
        throw new Error("Missing the required parameter 'address' when calling csrUpdateShippingAddress");
      }


      var pathParams = {
        'orderId': orderId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Order/{orderId}/Address', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrUpdateTollFreeRateDeck operation.
     * @callback module:api/CsrApi~csrUpdateTollFreeRateDeckCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update TollFree RateDeck
     * @param {Number} rate New rate
     * @param {module:api/CsrApi~csrUpdateTollFreeRateDeckCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrUpdateTollFreeRateDeck = function(rate, callback) {
      var postBody = null;

      // verify the required parameter 'rate' is set
      if (rate === undefined || rate === null) {
        throw new Error("Missing the required parameter 'rate' when calling csrUpdateTollFreeRateDeck");
      }


      var pathParams = {
      };
      var queryParams = {
        'rate': rate,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/RateDeck/TollFree', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrUpdateTrackingLink operation.
     * @callback module:api/CsrApi~csrUpdateTrackingLinkCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Tracking Link
     * @param {String} orderId The order id
     * @param {module:model/TrackingRequest} info The tracking info
     * @param {module:api/CsrApi~csrUpdateTrackingLinkCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrUpdateTrackingLink = function(orderId, info, callback) {
      var postBody = info;

      // verify the required parameter 'orderId' is set
      if (orderId === undefined || orderId === null) {
        throw new Error("Missing the required parameter 'orderId' when calling csrUpdateTrackingLink");
      }

      // verify the required parameter 'info' is set
      if (info === undefined || info === null) {
        throw new Error("Missing the required parameter 'info' when calling csrUpdateTrackingLink");
      }


      var pathParams = {
        'orderId': orderId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Order/{orderId}/Tracking', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrUpdateUncoveredRateDeck operation.
     * @callback module:api/CsrApi~csrUpdateUncoveredRateDeckCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Uncovered RateDeck
     * @param {Number} rate New rate
     * @param {module:api/CsrApi~csrUpdateUncoveredRateDeckCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrUpdateUncoveredRateDeck = function(rate, callback) {
      var postBody = null;

      // verify the required parameter 'rate' is set
      if (rate === undefined || rate === null) {
        throw new Error("Missing the required parameter 'rate' when calling csrUpdateUncoveredRateDeck");
      }


      var pathParams = {
      };
      var queryParams = {
        'rate': rate,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/RateDeck/UncoveredRate', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrUploadLoas operation.
     * @callback module:api/CsrApi~csrUploadLoasCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upoad Loas
     * @param {String} id Account id
     * @param {String} orderId Order Id
     * @param {module:api/CsrApi~csrUploadLoasCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrUploadLoas = function(id, orderId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrUploadLoas");
      }

      // verify the required parameter 'orderId' is set
      if (orderId === undefined || orderId === null) {
        throw new Error("Missing the required parameter 'orderId' when calling csrUploadLoas");
      }


      var pathParams = {
        'id': id,
        'orderId': orderId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Account/{id}/Portin/{orderId}/UploadLoas', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the csrUploadProfileImage operation.
     * @callback module:api/CsrApi~csrUploadProfileImageCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upload profile image (format-accepted: .gif |.jpg |.jpeg |.png)
     * @param {String} id Csr user id
     * @param {module:model/ProfileImage} profileImage Profile image(base64)
     * @param {module:api/CsrApi~csrUploadProfileImageCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.csrUploadProfileImage = function(id, profileImage, callback) {
      var postBody = profileImage;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling csrUploadProfileImage");
      }

      // verify the required parameter 'profileImage' is set
      if (profileImage === undefined || profileImage === null) {
        throw new Error("Missing the required parameter 'profileImage' when calling csrUploadProfileImage");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Csr/Representative/{id}/ProfileImage', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
