/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/E911Address', 'model/GetNumber', 'model/ReserveNumber'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/E911Address'), require('../model/GetNumber'), require('../model/ReserveNumber'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.NumberApi = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.E911Address, root.PhonespeakApi.GetNumber, root.PhonespeakApi.ReserveNumber);
  }
}(this, function(ApiClient, E911Address, GetNumber, ReserveNumber) {
  'use strict';

  /**
   * Number service.
   * @module api/NumberApi
   * @version v2
   */

  /**
   * Constructs a new NumberApi. 
   * @alias module:api/NumberApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the numberGet operation.
     * @callback module:api/NumberApi~numberGetCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get List of Numbers
     * @param {module:model/GetNumber} getModel Get Number model
     * @param {module:api/NumberApi~numberGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.numberGet = function(getModel, callback) {
      var postBody = getModel;

      // verify the required parameter 'getModel' is set
      if (getModel === undefined || getModel === null) {
        throw new Error("Missing the required parameter 'getModel' when calling numberGet");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Number/Get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the numberGetAreaCode operation.
     * @callback module:api/NumberApi~numberGetAreaCodeCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Area Codes
     * @param {String} stateCode State Code
     * @param {Boolean} isTollFree Toll Free
     * @param {module:api/NumberApi~numberGetAreaCodeCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.numberGetAreaCode = function(stateCode, isTollFree, callback) {
      var postBody = null;

      // verify the required parameter 'stateCode' is set
      if (stateCode === undefined || stateCode === null) {
        throw new Error("Missing the required parameter 'stateCode' when calling numberGetAreaCode");
      }

      // verify the required parameter 'isTollFree' is set
      if (isTollFree === undefined || isTollFree === null) {
        throw new Error("Missing the required parameter 'isTollFree' when calling numberGetAreaCode");
      }


      var pathParams = {
      };
      var queryParams = {
        'stateCode': stateCode,
        'isTollFree': isTollFree,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Number/GetAreaCodes', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the numberGetPhoneNumDetails operation.
     * @callback module:api/NumberApi~numberGetPhoneNumDetailsCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Phone Number Detail
     * @param {String} _number Number
     * @param {module:api/NumberApi~numberGetPhoneNumDetailsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.numberGetPhoneNumDetails = function(_number, callback) {
      var postBody = null;

      // verify the required parameter '_number' is set
      if (_number === undefined || _number === null) {
        throw new Error("Missing the required parameter '_number' when calling numberGetPhoneNumDetails");
      }


      var pathParams = {
      };
      var queryParams = {
        'number': _number,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Number/GetPhoneNumDetails', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the numberGetStates operation.
     * @callback module:api/NumberApi~numberGetStatesCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get available states
     * @param {Object} opts Optional parameters
     * @param {String} opts.country 
     * @param {module:api/NumberApi~numberGetStatesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.numberGetStates = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'country': opts['country'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Number/GetStates', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the numberGetUserState operation.
     * @callback module:api/NumberApi~numberGetUserStateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {module:api/NumberApi~numberGetUserStateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.numberGetUserState = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Number/UserState', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the numberMoveNumber operation.
     * @callback module:api/NumberApi~numberMoveNumberCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Move Number
     * @param {String} id Phone Number Id
     * @param {String} accountId Account Id
     * @param {String} assignTo Assign to &#39;s owner Id (Un-assign &#x3D; \&quot;\&quot;)
     * @param {module:api/NumberApi~numberMoveNumberCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.numberMoveNumber = function(id, accountId, assignTo, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling numberMoveNumber");
      }

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling numberMoveNumber");
      }

      // verify the required parameter 'assignTo' is set
      if (assignTo === undefined || assignTo === null) {
        throw new Error("Missing the required parameter 'assignTo' when calling numberMoveNumber");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'accountId': accountId,
        'assignTo': assignTo,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Number/{id}/Move', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the numberReserve operation.
     * @callback module:api/NumberApi~numberReserveCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Reserve Number
     * @param {module:model/ReserveNumber} reserveModel Reserve model
     * @param {module:api/NumberApi~numberReserveCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.numberReserve = function(reserveModel, callback) {
      var postBody = reserveModel;

      // verify the required parameter 'reserveModel' is set
      if (reserveModel === undefined || reserveModel === null) {
        throw new Error("Missing the required parameter 'reserveModel' when calling numberReserve");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Number/Reserve', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the numberValidateE911Address operation.
     * @callback module:api/NumberApi~numberValidateE911AddressCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Validate the E911 address
     * @param {module:model/E911Address} address E911 model
     * @param {module:api/NumberApi~numberValidateE911AddressCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.numberValidateE911Address = function(address, callback) {
      var postBody = address;

      // verify the required parameter 'address' is set
      if (address === undefined || address === null) {
        throw new Error("Missing the required parameter 'address' when calling numberValidateE911Address");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Number/E911Address', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
