/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/IncomingMessage', 'model/InteliquentSMSInbound', 'model/SmsInbound'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/IncomingMessage'), require('../model/InteliquentSMSInbound'), require('../model/SmsInbound'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.SmsApi = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.IncomingMessage, root.PhonespeakApi.InteliquentSMSInbound, root.PhonespeakApi.SmsInbound);
  }
}(this, function(ApiClient, IncomingMessage, InteliquentSMSInbound, SmsInbound) {
  'use strict';

  /**
   * Sms service.
   * @module api/SmsApi
   * @version v2
   */

  /**
   * Constructs a new SmsApi. 
   * @alias module:api/SmsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the smsCreateBandwidthSmsInbound operation.
     * @callback module:api/SmsApi~smsCreateBandwidthSmsInboundCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Receive SMS from Bandwidth
     * @param {module:model/SmsInbound} smsInbound sms inbound from Bandwidth
     * @param {module:api/SmsApi~smsCreateBandwidthSmsInboundCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.smsCreateBandwidthSmsInbound = function(smsInbound, callback) {
      var postBody = smsInbound;

      // verify the required parameter 'smsInbound' is set
      if (smsInbound === undefined || smsInbound === null) {
        throw new Error("Missing the required parameter 'smsInbound' when calling smsCreateBandwidthSmsInbound");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Sms/Bandwidth', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the smsCreateBandwidthSmsInboundV2 operation.
     * @callback module:api/SmsApi~smsCreateBandwidthSmsInboundV2Callback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Receive SMS from Bandwidth
     * @param {Array.<module:model/IncomingMessage>} incomingMessages sms inbound from Bandwidth
     * @param {module:api/SmsApi~smsCreateBandwidthSmsInboundV2Callback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.smsCreateBandwidthSmsInboundV2 = function(incomingMessages, callback) {
      var postBody = incomingMessages;

      // verify the required parameter 'incomingMessages' is set
      if (incomingMessages === undefined || incomingMessages === null) {
        throw new Error("Missing the required parameter 'incomingMessages' when calling smsCreateBandwidthSmsInboundV2");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Sms/Bandwidth/v2', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the smsCreateIntelliquentSmsInbound operation.
     * @callback module:api/SmsApi~smsCreateIntelliquentSmsInboundCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Receive SMS from Inteliquent
     * @param {module:model/InteliquentSMSInbound} inteliquentSmsInbound sms inbound from Inteliquent
     * @param {module:api/SmsApi~smsCreateIntelliquentSmsInboundCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.smsCreateIntelliquentSmsInbound = function(inteliquentSmsInbound, callback) {
      var postBody = inteliquentSmsInbound;

      // verify the required parameter 'inteliquentSmsInbound' is set
      if (inteliquentSmsInbound === undefined || inteliquentSmsInbound === null) {
        throw new Error("Missing the required parameter 'inteliquentSmsInbound' when calling smsCreateIntelliquentSmsInbound");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Sms/Inteliquent', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
