/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/IvrKey', 'model/IvrTimeOut', 'model/Team', 'model/TextToSpeechInfo'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/IvrKey'), require('../model/IvrTimeOut'), require('../model/Team'), require('../model/TextToSpeechInfo'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.TeamApi = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.IvrKey, root.PhonespeakApi.IvrTimeOut, root.PhonespeakApi.Team, root.PhonespeakApi.TextToSpeechInfo);
  }
}(this, function(ApiClient, IvrKey, IvrTimeOut, Team, TextToSpeechInfo) {
  'use strict';

  /**
   * Team service.
   * @module api/TeamApi
   * @version v2
   */

  /**
   * Constructs a new TeamApi. 
   * @alias module:api/TeamApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the teamConvertTextToSpeech operation.
     * @callback module:api/TeamApi~teamConvertTextToSpeechCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Convert text to speech
     * @param {String} id 
     * @param {module:model/TextToSpeechInfo} textToSpeechInfo Text-to-Speech Info
     * @param {File} textToSpeech Type to convert Text to Speech
     * @param {module:api/TeamApi~teamConvertTextToSpeechCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamConvertTextToSpeech = function(id, textToSpeechInfo, textToSpeech, callback) {
      var postBody = textToSpeechInfo;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamConvertTextToSpeech");
      }

      // verify the required parameter 'textToSpeechInfo' is set
      if (textToSpeechInfo === undefined || textToSpeechInfo === null) {
        throw new Error("Missing the required parameter 'textToSpeechInfo' when calling teamConvertTextToSpeech");
      }

      // verify the required parameter 'textToSpeech' is set
      if (textToSpeech === undefined || textToSpeech === null) {
        throw new Error("Missing the required parameter 'textToSpeech' when calling teamConvertTextToSpeech");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'TextToSpeech': textToSpeech
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml', 'multipart/form-data'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/VoicemailGreeting/SpeechGreeting', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamCreate operation.
     * @callback module:api/TeamApi~teamCreateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a single team
     * @param {module:model/Team} team The team object to create
     * @param {module:api/TeamApi~teamCreateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamCreate = function(team, callback) {
      var postBody = team;

      // verify the required parameter 'team' is set
      if (team === undefined || team === null) {
        throw new Error("Missing the required parameter 'team' when calling teamCreate");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamCreateIvr operation.
     * @callback module:api/TeamApi~teamCreateIvrCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create team&#39;s ivr
     * @param {String} id The team object to update
     * @param {module:api/TeamApi~teamCreateIvrCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamCreateIvr = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamCreateIvr");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/Ivr', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamDelete operation.
     * @callback module:api/TeamApi~teamDeleteCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete a single team
     * @param {String} id The team id to delete
     * @param {module:api/TeamApi~teamDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamDelete = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamDelete");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamDeleteIvr operation.
     * @callback module:api/TeamApi~teamDeleteIvrCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete team&#39;s ivr
     * @param {String} id The team object to update
     * @param {String} ivrNumber The ivr to add
     * @param {module:api/TeamApi~teamDeleteIvrCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamDeleteIvr = function(id, ivrNumber, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamDeleteIvr");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling teamDeleteIvr");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/Ivr/{ivrNumber}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamDeleteIvrGreeting operation.
     * @callback module:api/TeamApi~teamDeleteIvrGreetingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete Ivr Greeting File
     * @param {String} id Team Id
     * @param {String} ivrNumber Ivr Id
     * @param {String} greetingId Ivr Greeting Id to delete
     * @param {module:api/TeamApi~teamDeleteIvrGreetingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamDeleteIvrGreeting = function(id, ivrNumber, greetingId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamDeleteIvrGreeting");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling teamDeleteIvrGreeting");
      }

      // verify the required parameter 'greetingId' is set
      if (greetingId === undefined || greetingId === null) {
        throw new Error("Missing the required parameter 'greetingId' when calling teamDeleteIvrGreeting");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber,
        'greetingId': greetingId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/Ivr/{ivrNumber}/Greeting/{greetingId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamDeleteMusicOnHold operation.
     * @callback module:api/TeamApi~teamDeleteMusicOnHoldCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete MusicOnHold file
     * @param {String} id Team Id
     * @param {String} mohId MusicOnHold Id to delete
     * @param {module:api/TeamApi~teamDeleteMusicOnHoldCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamDeleteMusicOnHold = function(id, mohId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamDeleteMusicOnHold");
      }

      // verify the required parameter 'mohId' is set
      if (mohId === undefined || mohId === null) {
        throw new Error("Missing the required parameter 'mohId' when calling teamDeleteMusicOnHold");
      }


      var pathParams = {
        'id': id,
        'mohId': mohId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/MusicOnHold/{mohId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamDeleteVoicemailGreeting operation.
     * @callback module:api/TeamApi~teamDeleteVoicemailGreetingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete Voicemail Greeting File
     * @param {String} id Team Id
     * @param {String} voicemailId Voicemail Greeting Id to delete
     * @param {module:api/TeamApi~teamDeleteVoicemailGreetingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamDeleteVoicemailGreeting = function(id, voicemailId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamDeleteVoicemailGreeting");
      }

      // verify the required parameter 'voicemailId' is set
      if (voicemailId === undefined || voicemailId === null) {
        throw new Error("Missing the required parameter 'voicemailId' when calling teamDeleteVoicemailGreeting");
      }


      var pathParams = {
        'id': id,
        'voicemailId': voicemailId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/VoicemailGreeting/{voicemailId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamGet operation.
     * @callback module:api/TeamApi~teamGetCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve a single team by id
     * @param {String} id The team id to retrieve
     * @param {module:api/TeamApi~teamGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamGet = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamGet");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamIvrConvertTextToSpeech operation.
     * @callback module:api/TeamApi~teamIvrConvertTextToSpeechCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Ivr Convert text to speech
     * @param {String} id team id
     * @param {String} ivrNumber ivr number
     * @param {module:model/TextToSpeechInfo} textToSpeechInfo Text-to-Speech Info
     * @param {File} textToSpeech Type to convert Text to Speech
     * @param {module:api/TeamApi~teamIvrConvertTextToSpeechCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamIvrConvertTextToSpeech = function(id, ivrNumber, textToSpeechInfo, textToSpeech, callback) {
      var postBody = textToSpeechInfo;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamIvrConvertTextToSpeech");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling teamIvrConvertTextToSpeech");
      }

      // verify the required parameter 'textToSpeechInfo' is set
      if (textToSpeechInfo === undefined || textToSpeechInfo === null) {
        throw new Error("Missing the required parameter 'textToSpeechInfo' when calling teamIvrConvertTextToSpeech");
      }

      // verify the required parameter 'textToSpeech' is set
      if (textToSpeech === undefined || textToSpeech === null) {
        throw new Error("Missing the required parameter 'textToSpeech' when calling teamIvrConvertTextToSpeech");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'TextToSpeech': textToSpeech
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml', 'multipart/form-data'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/Ivr/{ivrNumber}/Greeting/SpeechGreeting', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamList operation.
     * @callback module:api/TeamApi~teamListCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List all teams by account
     * @param {Object} opts Optional parameters
     * @param {String} opts.orderBy Sort the listing by column.
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {module:api/TeamApi~teamListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamList = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'orderBy': opts['orderBy'],
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamListAvailableNumber operation.
     * @callback module:api/TeamApi~teamListAvailableNumberCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Caller Id
     * @param {String} id Teammate id
     * @param {module:api/TeamApi~teamListAvailableNumberCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamListAvailableNumber = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamListAvailableNumber");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/AvailableNumber', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamListAvailableTeammates operation.
     * @callback module:api/TeamApi~teamListAvailableTeammatesCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Teammate list for team
     * @param {String} id 
     * @param {module:api/TeamApi~teamListAvailableTeammatesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamListAvailableTeammates = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamListAvailableTeammates");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/ListAvailableTeammates', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamListIvrGreetings operation.
     * @callback module:api/TeamApi~teamListIvrGreetingsCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Ivr Greetings for a team
     * @param {String} id Team Id
     * @param {String} ivrNumber Team Ivr Id
     * @param {module:api/TeamApi~teamListIvrGreetingsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamListIvrGreetings = function(id, ivrNumber, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamListIvrGreetings");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling teamListIvrGreetings");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/Ivr/{ivrNumber}/Greeting', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamListMusicOnHold operation.
     * @callback module:api/TeamApi~teamListMusicOnHoldCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List MusicOnHolds for team
     * @param {String} id Team Id
     * @param {module:api/TeamApi~teamListMusicOnHoldCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamListMusicOnHold = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamListMusicOnHold");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/MusicOnHold', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamListTeamsByTeammate operation.
     * @callback module:api/TeamApi~teamListTeamsByTeammateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List all teams by teammate
     * @param {Object} opts Optional parameters
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {module:api/TeamApi~teamListTeamsByTeammateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamListTeamsByTeammate = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/Teammate', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamListVoicemailGreetings operation.
     * @callback module:api/TeamApi~teamListVoicemailGreetingsCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Voicemail Greetings for a team
     * @param {String} id Team Id
     * @param {module:api/TeamApi~teamListVoicemailGreetingsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamListVoicemailGreetings = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamListVoicemailGreetings");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/VoicemailGreeting', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamTeamSummary operation.
     * @callback module:api/TeamApi~teamTeamSummaryCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Team Summary
     * @param {String} teamId Account Id
     * @param {Date} startDate Start date
     * @param {Date} endDate End date
     * @param {module:api/TeamApi~teamTeamSummaryCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamTeamSummary = function(teamId, startDate, endDate, callback) {
      var postBody = null;

      // verify the required parameter 'teamId' is set
      if (teamId === undefined || teamId === null) {
        throw new Error("Missing the required parameter 'teamId' when calling teamTeamSummary");
      }

      // verify the required parameter 'startDate' is set
      if (startDate === undefined || startDate === null) {
        throw new Error("Missing the required parameter 'startDate' when calling teamTeamSummary");
      }

      // verify the required parameter 'endDate' is set
      if (endDate === undefined || endDate === null) {
        throw new Error("Missing the required parameter 'endDate' when calling teamTeamSummary");
      }


      var pathParams = {
        'teamId': teamId
      };
      var queryParams = {
        'startDate': startDate,
        'endDate': endDate,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{teamId}/TeamSummary', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUpdate operation.
     * @callback module:api/TeamApi~teamUpdateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update a single team
     * @param {String} id The team id to update
     * @param {module:model/Team} team The team object to update
     * @param {module:api/TeamApi~teamUpdateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUpdate = function(id, team, callback) {
      var postBody = team;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUpdate");
      }

      // verify the required parameter 'team' is set
      if (team === undefined || team === null) {
        throw new Error("Missing the required parameter 'team' when calling teamUpdate");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUpdateBusinessHour operation.
     * @callback module:api/TeamApi~teamUpdateBusinessHourCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update team business hour
     * @param {String} id The team id to update
     * @param {module:model/Team} team The team object to update
     * @param {module:api/TeamApi~teamUpdateBusinessHourCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUpdateBusinessHour = function(id, team, callback) {
      var postBody = team;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUpdateBusinessHour");
      }

      // verify the required parameter 'team' is set
      if (team === undefined || team === null) {
        throw new Error("Missing the required parameter 'team' when calling teamUpdateBusinessHour");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/BusinessHour', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUpdateCallQueue operation.
     * @callback module:api/TeamApi~teamUpdateCallQueueCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update team&#39;s call queue
     * @param {String} id The team id to update
     * @param {module:model/Team} team The team object to update
     * @param {module:api/TeamApi~teamUpdateCallQueueCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUpdateCallQueue = function(id, team, callback) {
      var postBody = team;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUpdateCallQueue");
      }

      // verify the required parameter 'team' is set
      if (team === undefined || team === null) {
        throw new Error("Missing the required parameter 'team' when calling teamUpdateCallQueue");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/CallQueue', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUpdateCallRouting operation.
     * @callback module:api/TeamApi~teamUpdateCallRoutingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update team call routing
     * @param {String} id The team id to update
     * @param {module:model/Team} team The team object to update
     * @param {module:api/TeamApi~teamUpdateCallRoutingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUpdateCallRouting = function(id, team, callback) {
      var postBody = team;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUpdateCallRouting");
      }

      // verify the required parameter 'team' is set
      if (team === undefined || team === null) {
        throw new Error("Missing the required parameter 'team' when calling teamUpdateCallRouting");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/CallRouting', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUpdateClosedHourHandling operation.
     * @callback module:api/TeamApi~teamUpdateClosedHourHandlingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update team close hour call handling
     * @param {String} id The team id to update
     * @param {module:model/Team} team The team object to update
     * @param {module:api/TeamApi~teamUpdateClosedHourHandlingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUpdateClosedHourHandling = function(id, team, callback) {
      var postBody = team;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUpdateClosedHourHandling");
      }

      // verify the required parameter 'team' is set
      if (team === undefined || team === null) {
        throw new Error("Missing the required parameter 'team' when calling teamUpdateClosedHourHandling");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/ClosedHourHandling', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUpdateIvrKey operation.
     * @callback module:api/TeamApi~teamUpdateIvrKeyCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Ivr Key
     * @param {String} id team id
     * @param {String} ivrNumber ivr number
     * @param {Number} keyNumber key number
     * @param {module:model/IvrKey} ivrKey ivr key object
     * @param {module:api/TeamApi~teamUpdateIvrKeyCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUpdateIvrKey = function(id, ivrNumber, keyNumber, ivrKey, callback) {
      var postBody = ivrKey;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUpdateIvrKey");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling teamUpdateIvrKey");
      }

      // verify the required parameter 'keyNumber' is set
      if (keyNumber === undefined || keyNumber === null) {
        throw new Error("Missing the required parameter 'keyNumber' when calling teamUpdateIvrKey");
      }

      // verify the required parameter 'ivrKey' is set
      if (ivrKey === undefined || ivrKey === null) {
        throw new Error("Missing the required parameter 'ivrKey' when calling teamUpdateIvrKey");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber,
        'keyNumber': keyNumber
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/Ivr/{ivrNumber}/IvrKey/{keyNumber}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUpdateIvrName operation.
     * @callback module:api/TeamApi~teamUpdateIvrNameCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update team&#39;s ivr
     * @param {String} id The team object to update
     * @param {String} ivrNumber ivr number
     * @param {String} ivrName ivr name
     * @param {module:api/TeamApi~teamUpdateIvrNameCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUpdateIvrName = function(id, ivrNumber, ivrName, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUpdateIvrName");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling teamUpdateIvrName");
      }

      // verify the required parameter 'ivrName' is set
      if (ivrName === undefined || ivrName === null) {
        throw new Error("Missing the required parameter 'ivrName' when calling teamUpdateIvrName");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber,
        'ivrName': ivrName
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/Ivr/{ivrNumber}/Name/{ivrName}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUpdateIvrTimeout operation.
     * @callback module:api/TeamApi~teamUpdateIvrTimeoutCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Ivr Timeout
     * @param {String} id team id
     * @param {String} ivrNumber ivr number
     * @param {module:model/IvrTimeOut} timeOut timeout action
     * @param {module:api/TeamApi~teamUpdateIvrTimeoutCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUpdateIvrTimeout = function(id, ivrNumber, timeOut, callback) {
      var postBody = timeOut;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUpdateIvrTimeout");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling teamUpdateIvrTimeout");
      }

      // verify the required parameter 'timeOut' is set
      if (timeOut === undefined || timeOut === null) {
        throw new Error("Missing the required parameter 'timeOut' when calling teamUpdateIvrTimeout");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/Ivr/{ivrNumber}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUpdateMissedCallHandling operation.
     * @callback module:api/TeamApi~teamUpdateMissedCallHandlingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update team miss call handling
     * @param {String} id The team id to update
     * @param {module:model/Team} team The team object to update
     * @param {module:api/TeamApi~teamUpdateMissedCallHandlingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUpdateMissedCallHandling = function(id, team, callback) {
      var postBody = team;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUpdateMissedCallHandling");
      }

      // verify the required parameter 'team' is set
      if (team === undefined || team === null) {
        throw new Error("Missing the required parameter 'team' when calling teamUpdateMissedCallHandling");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/MissedCallHandling', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUpdateOpenHourHandling operation.
     * @callback module:api/TeamApi~teamUpdateOpenHourHandlingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update team open hour call handling
     * @param {String} id The team id to update
     * @param {module:model/Team} team The team object to update
     * @param {module:api/TeamApi~teamUpdateOpenHourHandlingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUpdateOpenHourHandling = function(id, team, callback) {
      var postBody = team;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUpdateOpenHourHandling");
      }

      // verify the required parameter 'team' is set
      if (team === undefined || team === null) {
        throw new Error("Missing the required parameter 'team' when calling teamUpdateOpenHourHandling");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/OpenHourHandling', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUpdateRingGroup operation.
     * @callback module:api/TeamApi~teamUpdateRingGroupCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update team&#39;s ring group
     * @param {String} id The team id to update
     * @param {module:model/Team} team The team object to update
     * @param {module:api/TeamApi~teamUpdateRingGroupCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUpdateRingGroup = function(id, team, callback) {
      var postBody = team;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUpdateRingGroup");
      }

      // verify the required parameter 'team' is set
      if (team === undefined || team === null) {
        throw new Error("Missing the required parameter 'team' when calling teamUpdateRingGroup");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/RingGroup', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUpdateSelectedIvrGreeting operation.
     * @callback module:api/TeamApi~teamUpdateSelectedIvrGreetingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update/Set a Team&#39;s default Voicemail Greeting
     * @param {String} id Team Id
     * @param {String} ivrNumber Ivr Id
     * @param {String} greetingId Greeting Id to set as default
     * @param {module:api/TeamApi~teamUpdateSelectedIvrGreetingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUpdateSelectedIvrGreeting = function(id, ivrNumber, greetingId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUpdateSelectedIvrGreeting");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling teamUpdateSelectedIvrGreeting");
      }

      // verify the required parameter 'greetingId' is set
      if (greetingId === undefined || greetingId === null) {
        throw new Error("Missing the required parameter 'greetingId' when calling teamUpdateSelectedIvrGreeting");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber,
        'greetingId': greetingId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/Ivr/{ivrNumber}/Greeting/{greetingId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUpdateSelectedMusicOnHold operation.
     * @callback module:api/TeamApi~teamUpdateSelectedMusicOnHoldCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update/Set team&#39;s default MusicOnHold
     * @param {String} id Team Id
     * @param {String} mohId MusicOnHold Id to set as default
     * @param {module:api/TeamApi~teamUpdateSelectedMusicOnHoldCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUpdateSelectedMusicOnHold = function(id, mohId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUpdateSelectedMusicOnHold");
      }

      // verify the required parameter 'mohId' is set
      if (mohId === undefined || mohId === null) {
        throw new Error("Missing the required parameter 'mohId' when calling teamUpdateSelectedMusicOnHold");
      }


      var pathParams = {
        'id': id,
        'mohId': mohId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/MusicOnHold/{mohId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUpdateSelectedVoicemailGreeting operation.
     * @callback module:api/TeamApi~teamUpdateSelectedVoicemailGreetingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update/Set a Team&#39;s default Voicemail Greeting
     * @param {String} id Team Id
     * @param {String} voicemailId Voicemail Greeting Id to set as default
     * @param {module:api/TeamApi~teamUpdateSelectedVoicemailGreetingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUpdateSelectedVoicemailGreeting = function(id, voicemailId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUpdateSelectedVoicemailGreeting");
      }

      // verify the required parameter 'voicemailId' is set
      if (voicemailId === undefined || voicemailId === null) {
        throw new Error("Missing the required parameter 'voicemailId' when calling teamUpdateSelectedVoicemailGreeting");
      }


      var pathParams = {
        'id': id,
        'voicemailId': voicemailId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/VoicemailGreeting/{voicemailId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUpdateTeammate operation.
     * @callback module:api/TeamApi~teamUpdateTeammateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update team&#39;s teammate list
     * @param {String} id The team id to update
     * @param {Array.<module:model/String>} teammateId The team object to update
     * @param {module:api/TeamApi~teamUpdateTeammateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUpdateTeammate = function(id, teammateId, callback) {
      var postBody = teammateId;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUpdateTeammate");
      }

      // verify the required parameter 'teammateId' is set
      if (teammateId === undefined || teammateId === null) {
        throw new Error("Missing the required parameter 'teammateId' when calling teamUpdateTeammate");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/Teammate', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUploadIvrGreeting operation.
     * @callback module:api/TeamApi~teamUploadIvrGreetingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upload Ivr Greeting File
     * @param {String} id Team Id
     * @param {String} ivrNumber Ivr Id
     * @param {File} uploadIvrGreeting Upload voicemail greeting file
     * @param {module:api/TeamApi~teamUploadIvrGreetingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUploadIvrGreeting = function(id, ivrNumber, uploadIvrGreeting, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUploadIvrGreeting");
      }

      // verify the required parameter 'ivrNumber' is set
      if (ivrNumber === undefined || ivrNumber === null) {
        throw new Error("Missing the required parameter 'ivrNumber' when calling teamUploadIvrGreeting");
      }

      // verify the required parameter 'uploadIvrGreeting' is set
      if (uploadIvrGreeting === undefined || uploadIvrGreeting === null) {
        throw new Error("Missing the required parameter 'uploadIvrGreeting' when calling teamUploadIvrGreeting");
      }


      var pathParams = {
        'id': id,
        'ivrNumber': ivrNumber
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'UploadIvrGreeting': uploadIvrGreeting
      };

      var authNames = ['Authorization'];
      var contentTypes = ['multipart/form-data'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/Ivr/{ivrNumber}/Greeting', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUploadMusicOnHold operation.
     * @callback module:api/TeamApi~teamUploadMusicOnHoldCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upload MusicOnHold File
     * @param {String} id Team Id
     * @param {File} uploadMusicOnHold Upload music on hold file
     * @param {module:api/TeamApi~teamUploadMusicOnHoldCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUploadMusicOnHold = function(id, uploadMusicOnHold, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUploadMusicOnHold");
      }

      // verify the required parameter 'uploadMusicOnHold' is set
      if (uploadMusicOnHold === undefined || uploadMusicOnHold === null) {
        throw new Error("Missing the required parameter 'uploadMusicOnHold' when calling teamUploadMusicOnHold");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'UploadMusicOnHold': uploadMusicOnHold
      };

      var authNames = ['Authorization'];
      var contentTypes = ['multipart/form-data'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/MusicOnHold', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teamUploadVoicemailGreeting operation.
     * @callback module:api/TeamApi~teamUploadVoicemailGreetingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upload Voicemail Greeting File
     * @param {String} id Team Id
     * @param {File} uploadVoicemailGreeting Upload voicemail greeting file
     * @param {module:api/TeamApi~teamUploadVoicemailGreetingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teamUploadVoicemailGreeting = function(id, uploadVoicemailGreeting, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teamUploadVoicemailGreeting");
      }

      // verify the required parameter 'uploadVoicemailGreeting' is set
      if (uploadVoicemailGreeting === undefined || uploadVoicemailGreeting === null) {
        throw new Error("Missing the required parameter 'uploadVoicemailGreeting' when calling teamUploadVoicemailGreeting");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'UploadVoicemailGreeting': uploadVoicemailGreeting
      };

      var authNames = ['Authorization'];
      var contentTypes = ['multipart/form-data'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Team/{id}/VoicemailGreeting', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
