/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AddTeammateInfo', 'model/Authentication', 'model/BusinessHour', 'model/E911', 'model/MissedCallHandling', 'model/PhoneNumber', 'model/ProfileImage', 'model/ResetPasswordOption', 'model/Teammate', 'model/TextToSpeechInfo'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/AddTeammateInfo'), require('../model/Authentication'), require('../model/BusinessHour'), require('../model/E911'), require('../model/MissedCallHandling'), require('../model/PhoneNumber'), require('../model/ProfileImage'), require('../model/ResetPasswordOption'), require('../model/Teammate'), require('../model/TextToSpeechInfo'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.TeammateApi = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.AddTeammateInfo, root.PhonespeakApi.Authentication, root.PhonespeakApi.BusinessHour, root.PhonespeakApi.E911, root.PhonespeakApi.MissedCallHandling, root.PhonespeakApi.PhoneNumber, root.PhonespeakApi.ProfileImage, root.PhonespeakApi.ResetPasswordOption, root.PhonespeakApi.Teammate, root.PhonespeakApi.TextToSpeechInfo);
  }
}(this, function(ApiClient, AddTeammateInfo, Authentication, BusinessHour, E911, MissedCallHandling, PhoneNumber, ProfileImage, ResetPasswordOption, Teammate, TextToSpeechInfo) {
  'use strict';

  /**
   * Teammate service.
   * @module api/TeammateApi
   * @version v2
   */

  /**
   * Constructs a new TeammateApi. 
   * @alias module:api/TeammateApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the teammateAddDnd operation.
     * @callback module:api/TeammateApi~teammateAddDndCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add Dnd Team
     * @param {String} id team id
     * @param {module:api/TeammateApi~teammateAddDndCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateAddDnd = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateAddDnd");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/Dnd', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateAddPhoneNumber operation.
     * @callback module:api/TeammateApi~teammateAddPhoneNumberCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add Phone Number
     * @param {String} id Teammate id
     * @param {module:model/PhoneNumber} phoneNumber Phone number details
     * @param {module:api/TeammateApi~teammateAddPhoneNumberCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateAddPhoneNumber = function(id, phoneNumber, callback) {
      var postBody = phoneNumber;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateAddPhoneNumber");
      }

      // verify the required parameter 'phoneNumber' is set
      if (phoneNumber === undefined || phoneNumber === null) {
        throw new Error("Missing the required parameter 'phoneNumber' when calling teammateAddPhoneNumber");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/PhoneNumber', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateAuthenticate operation.
     * @callback module:api/TeammateApi~teammateAuthenticateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {String} id 
     * @param {String} accountId 
     * @param {module:model/String} authenticationType 
     * @param {module:api/TeammateApi~teammateAuthenticateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateAuthenticate = function(id, accountId, authenticationType, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateAuthenticate");
      }

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling teammateAuthenticate");
      }

      // verify the required parameter 'authenticationType' is set
      if (authenticationType === undefined || authenticationType === null) {
        throw new Error("Missing the required parameter 'authenticationType' when calling teammateAuthenticate");
      }


      var pathParams = {
        'id': id,
        'accountId': accountId
      };
      var queryParams = {
        'authenticationType': authenticationType,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{accountId}/Authenticate/{id}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateAvailableContactList operation.
     * @callback module:api/TeammateApi~teammateAvailableContactListCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all available number of teammate
     * @param {String} id Teammate id
     * @param {module:api/TeammateApi~teammateAvailableContactListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateAvailableContactList = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateAvailableContactList");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/AvailableContactList', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateConvertTextToSpeech operation.
     * @callback module:api/TeammateApi~teammateConvertTextToSpeechCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Convert text to speech(voicemail greeting)
     * @param {String} id Teammate id
     * @param {module:model/TextToSpeechInfo} textToSpeechInfo Text-to-Speech details
     * @param {File} textToSpeech Convert text to speech(voicemail)
     * @param {module:api/TeammateApi~teammateConvertTextToSpeechCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateConvertTextToSpeech = function(id, textToSpeechInfo, textToSpeech, callback) {
      var postBody = textToSpeechInfo;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateConvertTextToSpeech");
      }

      // verify the required parameter 'textToSpeechInfo' is set
      if (textToSpeechInfo === undefined || textToSpeechInfo === null) {
        throw new Error("Missing the required parameter 'textToSpeechInfo' when calling teammateConvertTextToSpeech");
      }

      // verify the required parameter 'textToSpeech' is set
      if (textToSpeech === undefined || textToSpeech === null) {
        throw new Error("Missing the required parameter 'textToSpeech' when calling teammateConvertTextToSpeech");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'TextToSpeech': textToSpeech
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml', 'multipart/form-data'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/VoicemailGreeting/SpeechGreeting', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateCreate operation.
     * @callback module:api/TeammateApi~teammateCreateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a single teammate (PreCond : Get and reserve the number to create the teammate)
     * @param {module:model/AddTeammateInfo} teammate Teammate details
     * @param {module:api/TeammateApi~teammateCreateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateCreate = function(teammate, callback) {
      var postBody = teammate;

      // verify the required parameter 'teammate' is set
      if (teammate === undefined || teammate === null) {
        throw new Error("Missing the required parameter 'teammate' when calling teammateCreate");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateDelete operation.
     * @callback module:api/TeammateApi~teammateDeleteCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete a single teammate
     * @param {String} id Teammate id
     * @param {module:api/TeammateApi~teammateDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateDelete = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateDelete");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateDeletePhoneNumber operation.
     * @callback module:api/TeammateApi~teammateDeletePhoneNumberCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete Phone Number
     * @param {String} id Teammate id
     * @param {String} phoneNumberId Phone number id
     * @param {module:api/TeammateApi~teammateDeletePhoneNumberCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateDeletePhoneNumber = function(id, phoneNumberId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateDeletePhoneNumber");
      }

      // verify the required parameter 'phoneNumberId' is set
      if (phoneNumberId === undefined || phoneNumberId === null) {
        throw new Error("Missing the required parameter 'phoneNumberId' when calling teammateDeletePhoneNumber");
      }


      var pathParams = {
        'id': id,
        'phoneNumberId': phoneNumberId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/PhoneNumber/{phoneNumberId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateDeleteVoicemailGreeting operation.
     * @callback module:api/TeammateApi~teammateDeleteVoicemailGreetingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete voicemail greeting
     * @param {String} id Teammate id
     * @param {String} voicemailId Voicemail greeting id
     * @param {module:api/TeammateApi~teammateDeleteVoicemailGreetingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateDeleteVoicemailGreeting = function(id, voicemailId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateDeleteVoicemailGreeting");
      }

      // verify the required parameter 'voicemailId' is set
      if (voicemailId === undefined || voicemailId === null) {
        throw new Error("Missing the required parameter 'voicemailId' when calling teammateDeleteVoicemailGreeting");
      }


      var pathParams = {
        'id': id,
        'voicemailId': voicemailId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/VoicemailGreeting/{voicemailId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateDummyEndpointAvailableContactList operation.
     * @callback module:api/TeammateApi~teammateDummyEndpointAvailableContactListCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all available number of teammate (Dummy Endpoint)
     * @param {String} id Teammate id
     * @param {Object} opts Optional parameters
     * @param {String} opts.availableNumberId Id
     * @param {String} opts.availableNumberOwnerId Owner Id
     * @param {String} opts.availableNumberName Name
     * @param {String} opts.availableNumberNumber Number
     * @param {String} opts.availableNumberProfileImage Profile Image
     * @param {String} opts.availableNumberExtension Extension
     * @param {String} opts.availableNumberEmail Email
     * @param {String} opts.availableNumberLabel Label
     * @param {Boolean} opts.availableNumberIsTeammate Is Teammate
     * @param {Number} opts.availableNumberOnlineStatus Online Status
     * @param {module:api/TeammateApi~teammateDummyEndpointAvailableContactListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateDummyEndpointAvailableContactList = function(id, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateDummyEndpointAvailableContactList");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'availableNumber.id': opts['availableNumberId'],
        'availableNumber.ownerId': opts['availableNumberOwnerId'],
        'availableNumber.name': opts['availableNumberName'],
        'availableNumber.number': opts['availableNumberNumber'],
        'availableNumber.profileImage': opts['availableNumberProfileImage'],
        'availableNumber.extension': opts['availableNumberExtension'],
        'availableNumber.email': opts['availableNumberEmail'],
        'availableNumber.label': opts['availableNumberLabel'],
        'availableNumber.isTeammate': opts['availableNumberIsTeammate'],
        'availableNumber.onlineStatus': opts['availableNumberOnlineStatus'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/AvailableContactList/DummyEndpoint', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateGet operation.
     * @callback module:api/TeammateApi~teammateGetCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve a single teammate
     * @param {String} id Teammate id
     * @param {module:api/TeammateApi~teammateGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateGet = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateGet");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateGetTeammateEmail operation.
     * @callback module:api/TeammateApi~teammateGetTeammateEmailCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Check email is exist
     * @param {String} email Email
     * @param {module:api/TeammateApi~teammateGetTeammateEmailCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateGetTeammateEmail = function(email, callback) {
      var postBody = null;

      // verify the required parameter 'email' is set
      if (email === undefined || email === null) {
        throw new Error("Missing the required parameter 'email' when calling teammateGetTeammateEmail");
      }


      var pathParams = {
      };
      var queryParams = {
        'email': email,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/GetTeammateEmail', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateList operation.
     * @callback module:api/TeammateApi~teammateListCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all teammates
     * @param {Number} role The role of the teammate list (0 &#x3D; All, 1 &#x3D; Admin, 2 &#x3D; Standard)
     * @param {Object} opts Optional parameters
     * @param {Number} opts.status Teammate status (optional)
     * @param {String} opts.search Search text (optional)
     * @param {String} opts.orderBy Sort the listing by column (optional)
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {module:api/TeammateApi~teammateListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateList = function(role, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling teammateList");
      }


      var pathParams = {
      };
      var queryParams = {
        'role': role,
        'status': opts['status'],
        'search': opts['search'],
        'orderBy': opts['orderBy'],
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateListAvailableUseNumber operation.
     * @callback module:api/TeammateApi~teammateListAvailableUseNumberCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Caller Id
     * @param {String} id Teammate id
     * @param {module:api/TeammateApi~teammateListAvailableUseNumberCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateListAvailableUseNumber = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateListAvailableUseNumber");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/AvailableUseNumber', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateListVoicemailGreetings operation.
     * @callback module:api/TeammateApi~teammateListVoicemailGreetingsCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get list  of voicemail greetings
     * @param {String} id Teammate id
     * @param {module:api/TeammateApi~teammateListVoicemailGreetingsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateListVoicemailGreetings = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateListVoicemailGreetings");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/VoicemailGreeting', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateLogin operation.
     * @callback module:api/TeammateApi~teammateLoginCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Login
     * @param {module:model/Authentication} authentication Authentication details
     * @param {module:api/TeammateApi~teammateLoginCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateLogin = function(authentication, callback) {
      var postBody = authentication;

      // verify the required parameter 'authentication' is set
      if (authentication === undefined || authentication === null) {
        throw new Error("Missing the required parameter 'authentication' when calling teammateLogin");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/Login', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateLoginImpersonate operation.
     * @callback module:api/TeammateApi~teammateLoginImpersonateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Impersonate login
     * @param {String} id Teammate id
     * @param {String} accountId Account id
     * @param {module:api/TeammateApi~teammateLoginImpersonateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateLoginImpersonate = function(id, accountId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateLoginImpersonate");
      }

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling teammateLoginImpersonate");
      }


      var pathParams = {
        'id': id,
        'accountId': accountId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{accountId}/Impersonate/{id}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateNewPassword operation.
     * @callback module:api/TeammateApi~teammateNewPasswordCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Login and change password.
     * @param {String} id Teammate id
     * @param {String} newPassword New password
     * @param {module:api/TeammateApi~teammateNewPasswordCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateNewPassword = function(id, newPassword, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateNewPassword");
      }

      // verify the required parameter 'newPassword' is set
      if (newPassword === undefined || newPassword === null) {
        throw new Error("Missing the required parameter 'newPassword' when calling teammateNewPassword");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'newPassword': newPassword,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/NewPassword', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateProcessOnBoarding operation.
     * @callback module:api/TeammateApi~teammateProcessOnBoardingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * On boarding for first time teammate (included create extension)
     * @param {String} id Teammate id
     * @param {module:model/PhoneNumber} phoneNumber Phone number details
     * @param {module:api/TeammateApi~teammateProcessOnBoardingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateProcessOnBoarding = function(id, phoneNumber, callback) {
      var postBody = phoneNumber;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateProcessOnBoarding");
      }

      // verify the required parameter 'phoneNumber' is set
      if (phoneNumber === undefined || phoneNumber === null) {
        throw new Error("Missing the required parameter 'phoneNumber' when calling teammateProcessOnBoarding");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/ProcessOnBoarding', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateRemoveDnd operation.
     * @callback module:api/TeammateApi~teammateRemoveDndCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Remove Dnd Team
     * @param {String} id team id
     * @param {module:api/TeammateApi~teammateRemoveDndCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateRemoveDnd = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateRemoveDnd");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/Dnd', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateResendActivation operation.
     * @callback module:api/TeammateApi~teammateResendActivationCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Resend activation email
     * @param {String} id Teammate id
     * @param {module:api/TeammateApi~teammateResendActivationCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateResendActivation = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateResendActivation");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/Activation', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateResetPassword operation.
     * @callback module:api/TeammateApi~teammateResetPasswordCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Forgot password
     * @param {String} email Email
     * @param {module:api/TeammateApi~teammateResetPasswordCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateResetPassword = function(email, callback) {
      var postBody = null;

      // verify the required parameter 'email' is set
      if (email === undefined || email === null) {
        throw new Error("Missing the required parameter 'email' when calling teammateResetPassword");
      }


      var pathParams = {
      };
      var queryParams = {
        'email': email,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/ResetPassword', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateResetPassword_0 operation.
     * @callback module:api/TeammateApi~teammateResetPassword_0Callback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Admin reset teammate&#39;s password
     * @param {String} id Teammate id
     * @param {module:model/ResetPasswordOption} resetPasswordOption Reset password details
     * @param {module:api/TeammateApi~teammateResetPassword_0Callback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateResetPassword_0 = function(id, resetPasswordOption, callback) {
      var postBody = resetPasswordOption;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateResetPassword_0");
      }

      // verify the required parameter 'resetPasswordOption' is set
      if (resetPasswordOption === undefined || resetPasswordOption === null) {
        throw new Error("Missing the required parameter 'resetPasswordOption' when calling teammateResetPassword_0");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/ResetPassword', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateSearchContact operation.
     * @callback module:api/TeammateApi~teammateSearchContactCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List contact by teammate
     * @param {String} teammateId Teammate Id
     * @param {String} text Search&#39;s text
     * @param {Object} opts Optional parameters
     * @param {Number} opts.size Size (optional)
     * @param {Number} opts.pageNum Page number (optional)
     * @param {module:api/TeammateApi~teammateSearchContactCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateSearchContact = function(teammateId, text, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'teammateId' is set
      if (teammateId === undefined || teammateId === null) {
        throw new Error("Missing the required parameter 'teammateId' when calling teammateSearchContact");
      }

      // verify the required parameter 'text' is set
      if (text === undefined || text === null) {
        throw new Error("Missing the required parameter 'text' when calling teammateSearchContact");
      }


      var pathParams = {
        'teammateId': teammateId
      };
      var queryParams = {
        'text': text,
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{teammateId}/SearchContact', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateSearchMessage operation.
     * @callback module:api/TeammateApi~teammateSearchMessageCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List message by teammate
     * @param {String} teammateId Teammate Id
     * @param {String} text Search&#39;s text
     * @param {Object} opts Optional parameters
     * @param {Number} opts.size Size (optional)
     * @param {Number} opts.pageNum Page number (optional)
     * @param {module:api/TeammateApi~teammateSearchMessageCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateSearchMessage = function(teammateId, text, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'teammateId' is set
      if (teammateId === undefined || teammateId === null) {
        throw new Error("Missing the required parameter 'teammateId' when calling teammateSearchMessage");
      }

      // verify the required parameter 'text' is set
      if (text === undefined || text === null) {
        throw new Error("Missing the required parameter 'text' when calling teammateSearchMessage");
      }


      var pathParams = {
        'teammateId': teammateId
      };
      var queryParams = {
        'text': text,
        'size': opts['size'],
        'pageNum': opts['pageNum'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{teammateId}/SearchMessage', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUnreadCount operation.
     * @callback module:api/TeammateApi~teammateUnreadCountCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Total Unread
     * @param {String} id owner id
     * @param {module:api/TeammateApi~teammateUnreadCountCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUnreadCount = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUnreadCount");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/UnreadCount', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdate operation.
     * @callback module:api/TeammateApi~teammateUpdateCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update details
     * @param {String} id Teammate id
     * @param {module:model/Teammate} teammate New teammate details
     * @param {module:api/TeammateApi~teammateUpdateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdate = function(id, teammate, callback) {
      var postBody = teammate;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdate");
      }

      // verify the required parameter 'teammate' is set
      if (teammate === undefined || teammate === null) {
        throw new Error("Missing the required parameter 'teammate' when calling teammateUpdate");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdateBusinessHour operation.
     * @callback module:api/TeammateApi~teammateUpdateBusinessHourCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update business hour
     * @param {String} id Teammate id
     * @param {module:model/BusinessHour} businessHour New business hour
     * @param {module:api/TeammateApi~teammateUpdateBusinessHourCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdateBusinessHour = function(id, businessHour, callback) {
      var postBody = businessHour;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdateBusinessHour");
      }

      // verify the required parameter 'businessHour' is set
      if (businessHour === undefined || businessHour === null) {
        throw new Error("Missing the required parameter 'businessHour' when calling teammateUpdateBusinessHour");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/BusinessHour', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdateCallRecording operation.
     * @callback module:api/TeammateApi~teammateUpdateCallRecordingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update voicemail pin
     * @param {String} id Teammate id
     * @param {module:model/String} callRecordingSetting New voicemail pin
     * @param {module:api/TeammateApi~teammateUpdateCallRecordingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdateCallRecording = function(id, callRecordingSetting, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdateCallRecording");
      }

      // verify the required parameter 'callRecordingSetting' is set
      if (callRecordingSetting === undefined || callRecordingSetting === null) {
        throw new Error("Missing the required parameter 'callRecordingSetting' when calling teammateUpdateCallRecording");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'callRecordingSetting': callRecordingSetting,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/CallRecording', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdateCallWaiting operation.
     * @callback module:api/TeammateApi~teammateUpdateCallWaitingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update call waiting setting
     * @param {String} id Teammate id
     * @param {Boolean} isEnable Enable the call waiting setting. True is enable, false is disable
     * @param {module:api/TeammateApi~teammateUpdateCallWaitingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdateCallWaiting = function(id, isEnable, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdateCallWaiting");
      }

      // verify the required parameter 'isEnable' is set
      if (isEnable === undefined || isEnable === null) {
        throw new Error("Missing the required parameter 'isEnable' when calling teammateUpdateCallWaiting");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'isEnable': isEnable,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/CallWaiting', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdateChangePasswordStatus operation.
     * @callback module:api/TeammateApi~teammateUpdateChangePasswordStatusCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update change password status (required to change the password after login.)
     * @param {String} id Teammate id
     * @param {Boolean} status Status (true &#x3D; required, false &#x3D; not required)
     * @param {module:api/TeammateApi~teammateUpdateChangePasswordStatusCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdateChangePasswordStatus = function(id, status, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdateChangePasswordStatus");
      }

      // verify the required parameter 'status' is set
      if (status === undefined || status === null) {
        throw new Error("Missing the required parameter 'status' when calling teammateUpdateChangePasswordStatus");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'status': status,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/ChangePasswordStatus', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdateDefaultCallerId operation.
     * @callback module:api/TeammateApi~teammateUpdateDefaultCallerIdCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update default Caller Id
     * @param {String} id Teammate id
     * @param {String} phoneNumberId phone number id
     * @param {module:api/TeammateApi~teammateUpdateDefaultCallerIdCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdateDefaultCallerId = function(id, phoneNumberId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdateDefaultCallerId");
      }

      // verify the required parameter 'phoneNumberId' is set
      if (phoneNumberId === undefined || phoneNumberId === null) {
        throw new Error("Missing the required parameter 'phoneNumberId' when calling teammateUpdateDefaultCallerId");
      }


      var pathParams = {
        'id': id,
        'phoneNumberId': phoneNumberId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/CallerId/{phoneNumberId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdateE911Address operation.
     * @callback module:api/TeammateApi~teammateUpdateE911AddressCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update E911 address
     * @param {String} id Teammate id
     * @param {module:model/E911} e911 New E911 info
     * @param {module:api/TeammateApi~teammateUpdateE911AddressCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdateE911Address = function(id, e911, callback) {
      var postBody = e911;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdateE911Address");
      }

      // verify the required parameter 'e911' is set
      if (e911 === undefined || e911 === null) {
        throw new Error("Missing the required parameter 'e911' when calling teammateUpdateE911Address");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/E911Address', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdateE911AddressList operation.
     * @callback module:api/TeammateApi~teammateUpdateE911AddressListCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update E911 address List
     * @param {String} id Teammate id
     * @param {Array.<module:model/E911>} e911List New E911 info
     * @param {module:api/TeammateApi~teammateUpdateE911AddressListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdateE911AddressList = function(id, e911List, callback) {
      var postBody = e911List;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdateE911AddressList");
      }

      // verify the required parameter 'e911List' is set
      if (e911List === undefined || e911List === null) {
        throw new Error("Missing the required parameter 'e911List' when calling teammateUpdateE911AddressList");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/E911AddressList', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdateEmail operation.
     * @callback module:api/TeammateApi~teammateUpdateEmailCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update email
     * @param {String} id Teammate id
     * @param {String} newEmail New email
     * @param {String} password Teammate password
     * @param {module:api/TeammateApi~teammateUpdateEmailCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdateEmail = function(id, newEmail, password, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdateEmail");
      }

      // verify the required parameter 'newEmail' is set
      if (newEmail === undefined || newEmail === null) {
        throw new Error("Missing the required parameter 'newEmail' when calling teammateUpdateEmail");
      }

      // verify the required parameter 'password' is set
      if (password === undefined || password === null) {
        throw new Error("Missing the required parameter 'password' when calling teammateUpdateEmail");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'newEmail': newEmail,
        'password': password,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/Email', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdateMissedCallHandling operation.
     * @callback module:api/TeammateApi~teammateUpdateMissedCallHandlingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update miss call handling
     * @param {String} id Teammate id
     * @param {module:model/MissedCallHandling} missedCallHandling New miss call handling detail
     * @param {module:api/TeammateApi~teammateUpdateMissedCallHandlingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdateMissedCallHandling = function(id, missedCallHandling, callback) {
      var postBody = missedCallHandling;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdateMissedCallHandling");
      }

      // verify the required parameter 'missedCallHandling' is set
      if (missedCallHandling === undefined || missedCallHandling === null) {
        throw new Error("Missing the required parameter 'missedCallHandling' when calling teammateUpdateMissedCallHandling");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/MissedCallHandling', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdateOnboardingStatus operation.
     * @callback module:api/TeammateApi~teammateUpdateOnboardingStatusCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update onboarding status (required to go through on boarding process after login)
     * @param {String} id Teammate id
     * @param {Boolean} status Status (true &#x3D; required, false &#x3D; not required)
     * @param {module:api/TeammateApi~teammateUpdateOnboardingStatusCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdateOnboardingStatus = function(id, status, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdateOnboardingStatus");
      }

      // verify the required parameter 'status' is set
      if (status === undefined || status === null) {
        throw new Error("Missing the required parameter 'status' when calling teammateUpdateOnboardingStatus");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'status': status,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/OnboardingStatus', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdateOnlineStatus operation.
     * @callback module:api/TeammateApi~teammateUpdateOnlineStatusCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update online status
     * @param {String} id Teammate id
     * @param {Number} onlineStatus Online Status (1 &#x3D; Online, 2 &#x3D; Offline, 3 &#x3D; Do not disturb and 4 &#x3D; Away)
     * @param {module:api/TeammateApi~teammateUpdateOnlineStatusCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdateOnlineStatus = function(id, onlineStatus, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdateOnlineStatus");
      }

      // verify the required parameter 'onlineStatus' is set
      if (onlineStatus === undefined || onlineStatus === null) {
        throw new Error("Missing the required parameter 'onlineStatus' when calling teammateUpdateOnlineStatus");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'onlineStatus': onlineStatus,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/OnlineStatus', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdatePassword operation.
     * @callback module:api/TeammateApi~teammateUpdatePasswordCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Teammate update self password
     * @param {String} id Teammate id
     * @param {String} password Teammate password
     * @param {String} newPassword New password
     * @param {module:api/TeammateApi~teammateUpdatePasswordCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdatePassword = function(id, password, newPassword, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdatePassword");
      }

      // verify the required parameter 'password' is set
      if (password === undefined || password === null) {
        throw new Error("Missing the required parameter 'password' when calling teammateUpdatePassword");
      }

      // verify the required parameter 'newPassword' is set
      if (newPassword === undefined || newPassword === null) {
        throw new Error("Missing the required parameter 'newPassword' when calling teammateUpdatePassword");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'password': password,
        'newPassword': newPassword,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/UpdatePassword', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdatePbxOnlineStatus operation.
     * @callback module:api/TeammateApi~teammateUpdatePbxOnlineStatusCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Pbx online status
     * @param {String} id Teammate id
     * @param {module:api/TeammateApi~teammateUpdatePbxOnlineStatusCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdatePbxOnlineStatus = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdatePbxOnlineStatus");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/PbxOnlineStatus', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdatePhoneNumber operation.
     * @callback module:api/TeammateApi~teammateUpdatePhoneNumberCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Phone Number
     * @param {String} id Teammate id
     * @param {String} phoneNumberId Phone number Id
     * @param {module:model/PhoneNumber} phoneNumber Phone number details
     * @param {module:api/TeammateApi~teammateUpdatePhoneNumberCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdatePhoneNumber = function(id, phoneNumberId, phoneNumber, callback) {
      var postBody = phoneNumber;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdatePhoneNumber");
      }

      // verify the required parameter 'phoneNumberId' is set
      if (phoneNumberId === undefined || phoneNumberId === null) {
        throw new Error("Missing the required parameter 'phoneNumberId' when calling teammateUpdatePhoneNumber");
      }

      // verify the required parameter 'phoneNumber' is set
      if (phoneNumber === undefined || phoneNumber === null) {
        throw new Error("Missing the required parameter 'phoneNumber' when calling teammateUpdatePhoneNumber");
      }


      var pathParams = {
        'id': id,
        'phoneNumberId': phoneNumberId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/PhoneNumber/{phoneNumberId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdateSelectedVoicemailGreeting operation.
     * @callback module:api/TeammateApi~teammateUpdateSelectedVoicemailGreetingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Set voicemail greeting
     * @param {String} id Teammate id
     * @param {String} voicemailId Voicemail greeting id
     * @param {module:api/TeammateApi~teammateUpdateSelectedVoicemailGreetingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdateSelectedVoicemailGreeting = function(id, voicemailId, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdateSelectedVoicemailGreeting");
      }

      // verify the required parameter 'voicemailId' is set
      if (voicemailId === undefined || voicemailId === null) {
        throw new Error("Missing the required parameter 'voicemailId' when calling teammateUpdateSelectedVoicemailGreeting");
      }


      var pathParams = {
        'id': id,
        'voicemailId': voicemailId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/VoicemailGreeting/{voicemailId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdateStatus operation.
     * @callback module:api/TeammateApi~teammateUpdateStatusCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update status
     * @param {String} id Teammate id
     * @param {Number} status Status (1 &#x3D; Active, 2 &#x3D; Suspend, 3 &#x3D; Pending)
     * @param {module:api/TeammateApi~teammateUpdateStatusCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdateStatus = function(id, status, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdateStatus");
      }

      // verify the required parameter 'status' is set
      if (status === undefined || status === null) {
        throw new Error("Missing the required parameter 'status' when calling teammateUpdateStatus");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'status': status,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/Status', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUpdateVoicemailPin operation.
     * @callback module:api/TeammateApi~teammateUpdateVoicemailPinCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update voicemail pin
     * @param {String} id Teammate id
     * @param {String} voicemailPin New voicemail pin
     * @param {module:api/TeammateApi~teammateUpdateVoicemailPinCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUpdateVoicemailPin = function(id, voicemailPin, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUpdateVoicemailPin");
      }

      // verify the required parameter 'voicemailPin' is set
      if (voicemailPin === undefined || voicemailPin === null) {
        throw new Error("Missing the required parameter 'voicemailPin' when calling teammateUpdateVoicemailPin");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'voicemailPin': voicemailPin,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/VoicemailPin', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUploadProfileImage operation.
     * @callback module:api/TeammateApi~teammateUploadProfileImageCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upload profile image (format-accepted: .gif |.jpg |.jpeg |.png)
     * @param {String} id Teammate id
     * @param {module:model/ProfileImage} profileImage Profile image(base64)
     * @param {module:api/TeammateApi~teammateUploadProfileImageCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUploadProfileImage = function(id, profileImage, callback) {
      var postBody = profileImage;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUploadProfileImage");
      }

      // verify the required parameter 'profileImage' is set
      if (profileImage === undefined || profileImage === null) {
        throw new Error("Missing the required parameter 'profileImage' when calling teammateUploadProfileImage");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/ProfileImage', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the teammateUploadVoicemailGreeting operation.
     * @callback module:api/TeammateApi~teammateUploadVoicemailGreetingCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upload voicemail greeting
     * @param {String} id Teammate id
     * @param {File} uploadVoicemailGreeting Upload voicemail greeting
     * @param {module:api/TeammateApi~teammateUploadVoicemailGreetingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.teammateUploadVoicemailGreeting = function(id, uploadVoicemailGreeting, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling teammateUploadVoicemailGreeting");
      }

      // verify the required parameter 'uploadVoicemailGreeting' is set
      if (uploadVoicemailGreeting === undefined || uploadVoicemailGreeting === null) {
        throw new Error("Missing the required parameter 'uploadVoicemailGreeting' when calling teammateUploadVoicemailGreeting");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'UploadVoicemailGreeting': uploadVoicemailGreeting
      };

      var authNames = ['Authorization'];
      var contentTypes = ['multipart/form-data'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Teammate/{id}/VoicemailGreeting', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
