/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.VoicemailApi = factory(root.PhonespeakApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * Voicemail service.
   * @module api/VoicemailApi
   * @version v2
   */

  /**
   * Constructs a new VoicemailApi. 
   * @alias module:api/VoicemailApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the voicemailDelete operation.
     * @callback module:api/VoicemailApi~voicemailDeleteCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete a single voicemail
     * @param {String} id The voicemail id to delete
     * @param {module:api/VoicemailApi~voicemailDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.voicemailDelete = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling voicemailDelete");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Voicemail/{id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the voicemailList operation.
     * @callback module:api/VoicemailApi~voicemailListCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List all voicemails by owner id
     * @param {String} ownerId 
     * @param {Object} opts Optional parameters
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {Date} opts.fromDate Get all record greater than this date (optional)
     * @param {module:api/VoicemailApi~voicemailListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.voicemailList = function(ownerId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'ownerId' is set
      if (ownerId === undefined || ownerId === null) {
        throw new Error("Missing the required parameter 'ownerId' when calling voicemailList");
      }


      var pathParams = {
        'ownerId': ownerId
      };
      var queryParams = {
        'size': opts['size'],
        'pageNum': opts['pageNum'],
        'fromDate': opts['fromDate'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Voicemail/{ownerId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the voicemailListDummyEndPoint operation.
     * @callback module:api/VoicemailApi~voicemailListDummyEndPointCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List all voicemails by owner id
     * @param {String} ownerId 
     * @param {Object} opts Optional parameters
     * @param {Number} opts.size Number of records to retrieve (optional)
     * @param {Number} opts.pageNum Page number to retrieve (optional)
     * @param {String} opts.voicemailId Voicemail Id
     * @param {String} opts.voicemailCdrId Cdr Id
     * @param {String} opts.voicemailProfileImage Caller Profile Image. no profile image if empty
     * @param {String} opts.voicemailTranscribe Transcript of the audio file
     * @param {String} opts.voicemailAccountId Account Id
     * @param {Number} opts.voicemailParticipantType ParticipantT Type
     * @param {String} opts.voicemailParticipantId Participant Id
     * @param {String} opts.voicemailParticipantName Name
     * @param {String} opts.voicemailFrom Voicemail created from phone number
     * @param {String} opts.voicemailCallerOwnerId Voicemail caller owner id
     * @param {String} opts.voicemailUrl Voicemail recording location (amazon AWS S3 uri)
     * @param {Number} opts.voicemailDuration Voicemail duration
     * @param {String} opts.voicemailReferenceId Reference Id from portsip
     * @param {String} opts.voicemailOwnerId Voicemail ownerId
     * @param {Boolean} opts.voicemailIsRead Voicemail is read?
     * @param {Array.<String>} opts.voicemailRead Voicemail read list
     * @param {Date} opts.voicemailCreatedDate Voicemail created date
     * @param {Boolean} opts.voicemailIsExtensionCall Is Extension Call
     * @param {module:api/VoicemailApi~voicemailListDummyEndPointCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.voicemailListDummyEndPoint = function(ownerId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'ownerId' is set
      if (ownerId === undefined || ownerId === null) {
        throw new Error("Missing the required parameter 'ownerId' when calling voicemailListDummyEndPoint");
      }


      var pathParams = {
        'ownerId': ownerId
      };
      var queryParams = {
        'size': opts['size'],
        'pageNum': opts['pageNum'],
        'voicemail.id': opts['voicemailId'],
        'voicemail.cdrId': opts['voicemailCdrId'],
        'voicemail.profileImage': opts['voicemailProfileImage'],
        'voicemail.transcribe': opts['voicemailTranscribe'],
        'voicemail.accountId': opts['voicemailAccountId'],
        'voicemail.participantType': opts['voicemailParticipantType'],
        'voicemail.participantId': opts['voicemailParticipantId'],
        'voicemail.participantName': opts['voicemailParticipantName'],
        'voicemail.from': opts['voicemailFrom'],
        'voicemail.callerOwnerId': opts['voicemailCallerOwnerId'],
        'voicemail.url': opts['voicemailUrl'],
        'voicemail.duration': opts['voicemailDuration'],
        'voicemail.referenceId': opts['voicemailReferenceId'],
        'voicemail.ownerId': opts['voicemailOwnerId'],
        'voicemail.isRead': opts['voicemailIsRead'],
        'voicemail.createdDate': opts['voicemailCreatedDate'],
        'voicemail.isExtensionCall': opts['voicemailIsExtensionCall'],
      };
      var collectionQueryParams = {
        'voicemail.read': {
          value: opts['voicemailRead'],
          collectionFormat: 'multi'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Voicemail/{ownerId}/dummyendpoint', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the voicemailUnreadVoicemailCount operation.
     * @callback module:api/VoicemailApi~voicemailUnreadVoicemailCountCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Total Unread Voicemail
     * @param {String} id Owner id
     * @param {module:api/VoicemailApi~voicemailUnreadVoicemailCountCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.voicemailUnreadVoicemailCount = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling voicemailUnreadVoicemailCount");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Voicemail/{id}/UnreadCount', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the voicemailUpdateAllVoicemailReadStatus operation.
     * @callback module:api/VoicemailApi~voicemailUpdateAllVoicemailReadStatusCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update all voicemail read status
     * @param {String} ownerId The voicemail id to delete
     * @param {module:api/VoicemailApi~voicemailUpdateAllVoicemailReadStatusCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.voicemailUpdateAllVoicemailReadStatus = function(ownerId, callback) {
      var postBody = null;

      // verify the required parameter 'ownerId' is set
      if (ownerId === undefined || ownerId === null) {
        throw new Error("Missing the required parameter 'ownerId' when calling voicemailUpdateAllVoicemailReadStatus");
      }


      var pathParams = {
        'ownerId': ownerId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Voicemail/{ownerId}/Read', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the voicemailUpdateVoicemailReadStatus operation.
     * @callback module:api/VoicemailApi~voicemailUpdateVoicemailReadStatusCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update voicemail read status
     * @param {String} ownerId The ownerId of the voicemails
     * @param {String} id The voicemail id to update the read status
     * @param {module:api/VoicemailApi~voicemailUpdateVoicemailReadStatusCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.voicemailUpdateVoicemailReadStatus = function(ownerId, id, callback) {
      var postBody = null;

      // verify the required parameter 'ownerId' is set
      if (ownerId === undefined || ownerId === null) {
        throw new Error("Missing the required parameter 'ownerId' when calling voicemailUpdateVoicemailReadStatus");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling voicemailUpdateVoicemailReadStatus");
      }


      var pathParams = {
        'ownerId': ownerId,
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Voicemail/{ownerId}/Read/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the voicemailUpdateVoicemailUnreadStatus operation.
     * @callback module:api/VoicemailApi~voicemailUpdateVoicemailUnreadStatusCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update voicemail unread status
     * @param {String} ownerId The ownerId of the voicemails
     * @param {String} id The voicemail id to update the read status
     * @param {module:api/VoicemailApi~voicemailUpdateVoicemailUnreadStatusCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.voicemailUpdateVoicemailUnreadStatus = function(ownerId, id, callback) {
      var postBody = null;

      // verify the required parameter 'ownerId' is set
      if (ownerId === undefined || ownerId === null) {
        throw new Error("Missing the required parameter 'ownerId' when calling voicemailUpdateVoicemailUnreadStatus");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling voicemailUpdateVoicemailUnreadStatus");
      }


      var pathParams = {
        'ownerId': ownerId,
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['Authorization'];
      var contentTypes = [];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/client/Voicemail/{ownerId}/Unread/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
