/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AccountCurrentExtension', 'model/AccountSetting', 'model/Address', 'model/BillingAddress', 'model/BillingContact', 'model/Country', 'model/E911Address', 'model/MusicOnHold', 'model/RateDeck', 'model/StripeCharge', 'model/StripeInfo'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./AccountCurrentExtension'), require('./AccountSetting'), require('./Address'), require('./BillingAddress'), require('./BillingContact'), require('./Country'), require('./E911Address'), require('./MusicOnHold'), require('./RateDeck'), require('./StripeCharge'), require('./StripeInfo'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.Account = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.AccountCurrentExtension, root.PhonespeakApi.AccountSetting, root.PhonespeakApi.Address, root.PhonespeakApi.BillingAddress, root.PhonespeakApi.BillingContact, root.PhonespeakApi.Country, root.PhonespeakApi.E911Address, root.PhonespeakApi.MusicOnHold, root.PhonespeakApi.RateDeck, root.PhonespeakApi.StripeCharge, root.PhonespeakApi.StripeInfo);
  }
}(this, function(ApiClient, AccountCurrentExtension, AccountSetting, Address, BillingAddress, BillingContact, Country, E911Address, MusicOnHold, RateDeck, StripeCharge, StripeInfo) {
  'use strict';




  /**
   * The Account model module.
   * @module model/Account
   * @version v2
   */

  /**
   * Constructs a new <code>Account</code>.
   * The \&quot;Account\&quot; object
   * @alias module:model/Account
   * @class
   */
  var exports = function() {
    var _this = this;













































  };

  /**
   * Constructs a <code>Account</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Account} obj Optional instance to populate.
   * @return {module:model/Account} The populated <code>Account</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('companyName')) {
        obj['companyName'] = ApiClient.convertToType(data['companyName'], 'String');
      }
      if (data.hasOwnProperty('tenantId')) {
        obj['tenantId'] = ApiClient.convertToType(data['tenantId'], 'String');
      }
      if (data.hasOwnProperty('tenantPassword')) {
        obj['tenantPassword'] = ApiClient.convertToType(data['tenantPassword'], 'String');
      }
      if (data.hasOwnProperty('mainConferenceNo')) {
        obj['mainConferenceNo'] = ApiClient.convertToType(data['mainConferenceNo'], 'String');
      }
      if (data.hasOwnProperty('callCredit')) {
        obj['callCredit'] = ApiClient.convertToType(data['callCredit'], 'Number');
      }
      if (data.hasOwnProperty('isAutoTopupCredit')) {
        obj['isAutoTopupCredit'] = ApiClient.convertToType(data['isAutoTopupCredit'], 'Boolean');
      }
      if (data.hasOwnProperty('topupCredit')) {
        obj['topupCredit'] = ApiClient.convertToType(data['topupCredit'], 'Number');
      }
      if (data.hasOwnProperty('lastTopupDate')) {
        obj['lastTopupDate'] = ApiClient.convertToType(data['lastTopupDate'], 'Date');
      }
      if (data.hasOwnProperty('weeklyTopUpLimit')) {
        obj['weeklyTopUpLimit'] = ApiClient.convertToType(data['weeklyTopUpLimit'], 'Number');
      }
      if (data.hasOwnProperty('isCompanySetup')) {
        obj['isCompanySetup'] = ApiClient.convertToType(data['isCompanySetup'], 'Boolean');
      }
      if (data.hasOwnProperty('isEnableCallerId')) {
        obj['isEnableCallerId'] = ApiClient.convertToType(data['isEnableCallerId'], 'Boolean');
      }
      if (data.hasOwnProperty('timeZone')) {
        obj['timeZone'] = ApiClient.convertToType(data['timeZone'], 'String');
      }
      if (data.hasOwnProperty('sipRealm')) {
        obj['sipRealm'] = ApiClient.convertToType(data['sipRealm'], 'String');
      }
      if (data.hasOwnProperty('srvId')) {
        obj['srvId'] = ApiClient.convertToType(data['srvId'], 'String');
      }
      if (data.hasOwnProperty('hostAId')) {
        obj['hostAId'] = ApiClient.convertToType(data['hostAId'], 'String');
      }
      if (data.hasOwnProperty('callerId')) {
        obj['callerId'] = ApiClient.convertToType(data['callerId'], 'String');
      }
      if (data.hasOwnProperty('resellerId')) {
        obj['resellerId'] = ApiClient.convertToType(data['resellerId'], 'String');
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'Number');
      }
      if (data.hasOwnProperty('isEnableCallRecording')) {
        obj['isEnableCallRecording'] = ApiClient.convertToType(data['isEnableCallRecording'], 'Boolean');
      }
      if (data.hasOwnProperty('isEnableInternationalCall')) {
        obj['isEnableInternationalCall'] = ApiClient.convertToType(data['isEnableInternationalCall'], 'Boolean');
      }
      if (data.hasOwnProperty('isCsrEnableInternationalCall')) {
        obj['isCsrEnableInternationalCall'] = ApiClient.convertToType(data['isCsrEnableInternationalCall'], 'Boolean');
      }
      if (data.hasOwnProperty('isVerifiedInternationalCall')) {
        obj['isVerifiedInternationalCall'] = ApiClient.convertToType(data['isVerifiedInternationalCall'], 'Boolean');
      }
      if (data.hasOwnProperty('cancelJobId')) {
        obj['cancelJobId'] = ApiClient.convertToType(data['cancelJobId'], 'String');
      }
      if (data.hasOwnProperty('stripeInfo')) {
        obj['stripeInfo'] = StripeInfo.constructFromObject(data['stripeInfo']);
      }
      if (data.hasOwnProperty('stripeCharges')) {
        obj['stripeCharges'] = ApiClient.convertToType(data['stripeCharges'], [StripeCharge]);
      }
      if (data.hasOwnProperty('billingContacts')) {
        obj['billingContacts'] = ApiClient.convertToType(data['billingContacts'], [BillingContact]);
      }
      if (data.hasOwnProperty('accountCurrentExtension')) {
        obj['accountCurrentExtension'] = AccountCurrentExtension.constructFromObject(data['accountCurrentExtension']);
      }
      if (data.hasOwnProperty('companyAddress')) {
        obj['companyAddress'] = Address.constructFromObject(data['companyAddress']);
      }
      if (data.hasOwnProperty('e911Address')) {
        obj['e911Address'] = E911Address.constructFromObject(data['e911Address']);
      }
      if (data.hasOwnProperty('accountSetting')) {
        obj['accountSetting'] = AccountSetting.constructFromObject(data['accountSetting']);
      }
      if (data.hasOwnProperty('musicOnHolds')) {
        obj['musicOnHolds'] = ApiClient.convertToType(data['musicOnHolds'], [MusicOnHold]);
      }
      if (data.hasOwnProperty('rateDecks')) {
        obj['rateDecks'] = ApiClient.convertToType(data['rateDecks'], [RateDeck]);
      }
      if (data.hasOwnProperty('tollFreeRateDeck')) {
        obj['tollFreeRateDeck'] = RateDeck.constructFromObject(data['tollFreeRateDeck']);
      }
      if (data.hasOwnProperty('country')) {
        obj['country'] = ApiClient.convertToType(data['country'], 'String');
      }
      if (data.hasOwnProperty('countryDetail')) {
        obj['countryDetail'] = Country.constructFromObject(data['countryDetail']);
      }
      if (data.hasOwnProperty('billingAddress')) {
        obj['billingAddress'] = BillingAddress.constructFromObject(data['billingAddress']);
      }
      if (data.hasOwnProperty('createdDate')) {
        obj['createdDate'] = ApiClient.convertToType(data['createdDate'], 'Date');
      }
      if (data.hasOwnProperty('createdBy')) {
        obj['createdBy'] = ApiClient.convertToType(data['createdBy'], 'String');
      }
      if (data.hasOwnProperty('updatedDate')) {
        obj['updatedDate'] = ApiClient.convertToType(data['updatedDate'], 'Date');
      }
      if (data.hasOwnProperty('updatedBy')) {
        obj['updatedBy'] = ApiClient.convertToType(data['updatedBy'], 'String');
      }
      if (data.hasOwnProperty('cancelledDate')) {
        obj['cancelledDate'] = ApiClient.convertToType(data['cancelledDate'], 'Date');
      }
      if (data.hasOwnProperty('suspendedDate')) {
        obj['suspendedDate'] = ApiClient.convertToType(data['suspendedDate'], 'Date');
      }
      if (data.hasOwnProperty('lastUpdatedContactDate')) {
        obj['lastUpdatedContactDate'] = ApiClient.convertToType(data['lastUpdatedContactDate'], 'Date');
      }
    }
    return obj;
  }

  /**
   * The unique identifier of account
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Company name
   * @member {String} companyName
   */
  exports.prototype['companyName'] = undefined;
  /**
   * Portsip tenant's id
   * @member {String} tenantId
   */
  exports.prototype['tenantId'] = undefined;
  /**
   * Portsip tenant's password
   * @member {String} tenantPassword
   */
  exports.prototype['tenantPassword'] = undefined;
  /**
   * Main confernce number
   * @member {String} mainConferenceNo
   */
  exports.prototype['mainConferenceNo'] = undefined;
  /**
   * Credit for international calling
   * @member {Number} callCredit
   */
  exports.prototype['callCredit'] = undefined;
  /**
   * The flag of top up call credit automatically
   * @member {Boolean} isAutoTopupCredit
   */
  exports.prototype['isAutoTopupCredit'] = undefined;
  /**
   * The amount of auto topup credit
   * @member {Number} topupCredit
   */
  exports.prototype['topupCredit'] = undefined;
  /**
   * The last top up date
   * @member {Date} lastTopupDate
   */
  exports.prototype['lastTopupDate'] = undefined;
  /**
   * Weekly Top Up Limit
   * @member {Number} weeklyTopUpLimit
   */
  exports.prototype['weeklyTopUpLimit'] = undefined;
  /**
   * The flag of company is setup or not
   * @member {Boolean} isCompanySetup
   */
  exports.prototype['isCompanySetup'] = undefined;
  /**
   * The flag of enable the caller Id name
   * @member {Boolean} isEnableCallerId
   */
  exports.prototype['isEnableCallerId'] = undefined;
  /**
   * Company timezone setting
   * @member {String} timeZone
   */
  exports.prototype['timeZone'] = undefined;
  /**
   * SipRealm
   * @member {String} sipRealm
   */
  exports.prototype['sipRealm'] = undefined;
  /**
   * Srv Id in CloudFlare
   * @member {String} srvId
   */
  exports.prototype['srvId'] = undefined;
  /**
   * HostA Id in CloudFlare
   * @member {String} hostAId
   */
  exports.prototype['hostAId'] = undefined;
  /**
   * Company caller Id
   * @member {String} callerId
   */
  exports.prototype['callerId'] = undefined;
  /**
   * Reseller Id
   * @member {String} resellerId
   */
  exports.prototype['resellerId'] = undefined;
  /**
   * Account Status
   * @member {Number} status
   */
  exports.prototype['status'] = undefined;
  /**
   * Flag indicate the account is enable the call recording.
   * @member {Boolean} isEnableCallRecording
   */
  exports.prototype['isEnableCallRecording'] = undefined;
  /**
   * Flag indicate the account is valid for do international call.
   * @member {Boolean} isEnableInternationalCall
   */
  exports.prototype['isEnableInternationalCall'] = undefined;
  /**
   * Flag indicate the account is valid for do international call by Csr.
   * @member {Boolean} isCsrEnableInternationalCall
   */
  exports.prototype['isCsrEnableInternationalCall'] = undefined;
  /**
   * Flag indicate the account is verified for do international call.
   * @member {Boolean} isVerifiedInternationalCall
   */
  exports.prototype['isVerifiedInternationalCall'] = undefined;
  /**
   * Cancellation job id
   * @member {String} cancelJobId
   */
  exports.prototype['cancelJobId'] = undefined;
  /**
   * Stripe Info
   * @member {module:model/StripeInfo} stripeInfo
   */
  exports.prototype['stripeInfo'] = undefined;
  /**
   * Account stripe charges.
   * @member {Array.<module:model/StripeCharge>} stripeCharges
   */
  exports.prototype['stripeCharges'] = undefined;
  /**
   * List of Billing Contact
   * @member {Array.<module:model/BillingContact>} billingContacts
   */
  exports.prototype['billingContacts'] = undefined;
  /**
   * Current Extension
   * @member {module:model/AccountCurrentExtension} accountCurrentExtension
   */
  exports.prototype['accountCurrentExtension'] = undefined;
  /**
   * Company address
   * @member {module:model/Address} companyAddress
   */
  exports.prototype['companyAddress'] = undefined;
  /**
   * Company E911 address
   * @member {module:model/E911Address} e911Address
   */
  exports.prototype['e911Address'] = undefined;
  /**
   * Account setting
   * @member {module:model/AccountSetting} accountSetting
   */
  exports.prototype['accountSetting'] = undefined;
  /**
   * List of music on hold
   * @member {Array.<module:model/MusicOnHold>} musicOnHolds
   */
  exports.prototype['musicOnHolds'] = undefined;
  /**
   * RateDecks
   * @member {Array.<module:model/RateDeck>} rateDecks
   */
  exports.prototype['rateDecks'] = undefined;
  /**
   * Toll Free RateDeck
   * @member {module:model/RateDeck} tollFreeRateDeck
   */
  exports.prototype['tollFreeRateDeck'] = undefined;
  /**
   * Account's country
   * @member {String} country
   */
  exports.prototype['country'] = undefined;
  /**
   * Account's country's object
   * @member {module:model/Country} countryDetail
   */
  exports.prototype['countryDetail'] = undefined;
  /**
   * Billing address object
   * @member {module:model/BillingAddress} billingAddress
   */
  exports.prototype['billingAddress'] = undefined;
  /**
   * Account's creation date
   * @member {Date} createdDate
   */
  exports.prototype['createdDate'] = undefined;
  /**
   * Account's created by
   * @member {String} createdBy
   */
  exports.prototype['createdBy'] = undefined;
  /**
   * Account's updated date
   * @member {Date} updatedDate
   */
  exports.prototype['updatedDate'] = undefined;
  /**
   * Account's updated by
   * @member {String} updatedBy
   */
  exports.prototype['updatedBy'] = undefined;
  /**
   * Account cancelled date
   * @member {Date} cancelledDate
   */
  exports.prototype['cancelledDate'] = undefined;
  /**
   * Account suspended date
   * @member {Date} suspendedDate
   */
  exports.prototype['suspendedDate'] = undefined;
  /**
   * This property use for CloudSoftPhone contact purpose
   * @member {Date} lastUpdatedContactDate
   */
  exports.prototype['lastUpdatedContactDate'] = undefined;



  return exports;
}));


