/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/E911Address'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./E911Address'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.BandwidthPortin = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.E911Address);
  }
}(this, function(ApiClient, E911Address) {
  'use strict';




  /**
   * The BandwidthPortin model module.
   * @module model/BandwidthPortin
   * @version v2
   */

  /**
   * Constructs a new <code>BandwidthPortin</code>.
   * Bandwidth Portin
   * @alias module:model/BandwidthPortin
   * @class
   */
  var exports = function() {
    var _this = this;















  };

  /**
   * Constructs a <code>BandwidthPortin</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/BandwidthPortin} obj Optional instance to populate.
   * @return {module:model/BandwidthPortin} The populated <code>BandwidthPortin</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('orderId')) {
        obj['orderId'] = ApiClient.convertToType(data['orderId'], 'String');
      }
      if (data.hasOwnProperty('processingStatus')) {
        obj['processingStatus'] = ApiClient.convertToType(data['processingStatus'], 'String');
      }
      if (data.hasOwnProperty('partial')) {
        obj['partial'] = ApiClient.convertToType(data['partial'], 'Boolean');
      }
      if (data.hasOwnProperty('billingTelephoneNumber')) {
        obj['billingTelephoneNumber'] = ApiClient.convertToType(data['billingTelephoneNumber'], 'String');
      }
      if (data.hasOwnProperty('newBillingTelephoneNumber')) {
        obj['newBillingTelephoneNumber'] = ApiClient.convertToType(data['newBillingTelephoneNumber'], 'String');
      }
      if (data.hasOwnProperty('subscriberType')) {
        obj['subscriberType'] = ApiClient.convertToType(data['subscriberType'], 'Number');
      }
      if (data.hasOwnProperty('firstName')) {
        obj['firstName'] = ApiClient.convertToType(data['firstName'], 'String');
      }
      if (data.hasOwnProperty('lastName')) {
        obj['lastName'] = ApiClient.convertToType(data['lastName'], 'String');
      }
      if (data.hasOwnProperty('address')) {
        obj['address'] = E911Address.constructFromObject(data['address']);
      }
      if (data.hasOwnProperty('loaAuthorizingPerson')) {
        obj['loaAuthorizingPerson'] = ApiClient.convertToType(data['loaAuthorizingPerson'], 'String');
      }
      if (data.hasOwnProperty('accountNumber')) {
        obj['accountNumber'] = ApiClient.convertToType(data['accountNumber'], 'String');
      }
      if (data.hasOwnProperty('pinNumber')) {
        obj['pinNumber'] = ApiClient.convertToType(data['pinNumber'], 'String');
      }
      if (data.hasOwnProperty('numbers')) {
        obj['numbers'] = ApiClient.convertToType(data['numbers'], ['String']);
      }
      if (data.hasOwnProperty('requestedFocDate')) {
        obj['requestedFocDate'] = ApiClient.convertToType(data['requestedFocDate'], 'Date');
      }
    }
    return obj;
  }

  /**
   * Order Id
   * @member {String} orderId
   */
  exports.prototype['orderId'] = undefined;
  /**
   * Processing Status
   * @member {String} processingStatus
   */
  exports.prototype['processingStatus'] = undefined;
  /**
   * Partial
   * @member {Boolean} partial
   */
  exports.prototype['partial'] = undefined;
  /**
   * Billing Telephone Number
   * @member {String} billingTelephoneNumber
   */
  exports.prototype['billingTelephoneNumber'] = undefined;
  /**
   * New Billing Telephone Number
   * @member {String} newBillingTelephoneNumber
   */
  exports.prototype['newBillingTelephoneNumber'] = undefined;
  /**
   * Subscriber Type
   * @member {Number} subscriberType
   */
  exports.prototype['subscriberType'] = undefined;
  /**
   * FirstName
   * @member {String} firstName
   */
  exports.prototype['firstName'] = undefined;
  /**
   * LastName
   * @member {String} lastName
   */
  exports.prototype['lastName'] = undefined;
  /**
   * Name
   * @member {module:model/E911Address} address
   */
  exports.prototype['address'] = undefined;
  /**
   * Loa Authorizing Person
   * @member {String} loaAuthorizingPerson
   */
  exports.prototype['loaAuthorizingPerson'] = undefined;
  /**
   * AccountNumber
   * @member {String} accountNumber
   */
  exports.prototype['accountNumber'] = undefined;
  /**
   * PinNumber
   * @member {String} pinNumber
   */
  exports.prototype['pinNumber'] = undefined;
  /**
   * Numbers
   * @member {Array.<String>} numbers
   */
  exports.prototype['numbers'] = undefined;
  /**
   * Requested Foc Date
   * @member {Date} requestedFocDate
   */
  exports.prototype['requestedFocDate'] = undefined;



  return exports;
}));


