/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.BusinessHour = factory(root.PhonespeakApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The BusinessHour model module.
   * @module model/BusinessHour
   * @version v2
   */

  /**
   * Constructs a new <code>BusinessHour</code>.
   * Business hour object
   * @alias module:model/BusinessHour
   * @class
   * @param officeHoursMode {String} Office Hour Mode Option
   */
  var exports = function(officeHoursMode) {
    var _this = this;

    _this['office_hours_mode'] = officeHoursMode;














  };

  /**
   * Constructs a <code>BusinessHour</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/BusinessHour} obj Optional instance to populate.
   * @return {module:model/BusinessHour} The populated <code>BusinessHour</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('office_hours_mode')) {
        obj['office_hours_mode'] = ApiClient.convertToType(data['office_hours_mode'], 'String');
      }
      if (data.hasOwnProperty('monday_from')) {
        obj['monday_from'] = ApiClient.convertToType(data['monday_from'], 'String');
      }
      if (data.hasOwnProperty('monday_to')) {
        obj['monday_to'] = ApiClient.convertToType(data['monday_to'], 'String');
      }
      if (data.hasOwnProperty('tuesday_from')) {
        obj['tuesday_from'] = ApiClient.convertToType(data['tuesday_from'], 'String');
      }
      if (data.hasOwnProperty('tuesday_to')) {
        obj['tuesday_to'] = ApiClient.convertToType(data['tuesday_to'], 'String');
      }
      if (data.hasOwnProperty('wednesday_from')) {
        obj['wednesday_from'] = ApiClient.convertToType(data['wednesday_from'], 'String');
      }
      if (data.hasOwnProperty('wednesday_to')) {
        obj['wednesday_to'] = ApiClient.convertToType(data['wednesday_to'], 'String');
      }
      if (data.hasOwnProperty('thursday_from')) {
        obj['thursday_from'] = ApiClient.convertToType(data['thursday_from'], 'String');
      }
      if (data.hasOwnProperty('thursday_to')) {
        obj['thursday_to'] = ApiClient.convertToType(data['thursday_to'], 'String');
      }
      if (data.hasOwnProperty('friday_from')) {
        obj['friday_from'] = ApiClient.convertToType(data['friday_from'], 'String');
      }
      if (data.hasOwnProperty('friday_to')) {
        obj['friday_to'] = ApiClient.convertToType(data['friday_to'], 'String');
      }
      if (data.hasOwnProperty('saturday_from')) {
        obj['saturday_from'] = ApiClient.convertToType(data['saturday_from'], 'String');
      }
      if (data.hasOwnProperty('saturday_to')) {
        obj['saturday_to'] = ApiClient.convertToType(data['saturday_to'], 'String');
      }
      if (data.hasOwnProperty('sunday_from')) {
        obj['sunday_from'] = ApiClient.convertToType(data['sunday_from'], 'String');
      }
      if (data.hasOwnProperty('sunday_to')) {
        obj['sunday_to'] = ApiClient.convertToType(data['sunday_to'], 'String');
      }
    }
    return obj;
  }

  /**
   * Office Hour Mode Option
   * @member {String} office_hours_mode
   */
  exports.prototype['office_hours_mode'] = undefined;
  /**
   * Monday Start Time
   * @member {String} monday_from
   */
  exports.prototype['monday_from'] = undefined;
  /**
   * Monday End Time
   * @member {String} monday_to
   */
  exports.prototype['monday_to'] = undefined;
  /**
   * Tuesday Start Time
   * @member {String} tuesday_from
   */
  exports.prototype['tuesday_from'] = undefined;
  /**
   * Tuesday End Time
   * @member {String} tuesday_to
   */
  exports.prototype['tuesday_to'] = undefined;
  /**
   * Wednesday Start Time
   * @member {String} wednesday_from
   */
  exports.prototype['wednesday_from'] = undefined;
  /**
   * Wednesday End Time
   * @member {String} wednesday_to
   */
  exports.prototype['wednesday_to'] = undefined;
  /**
   * Thursday Start Time
   * @member {String} thursday_from
   */
  exports.prototype['thursday_from'] = undefined;
  /**
   * Thursday ENd Time
   * @member {String} thursday_to
   */
  exports.prototype['thursday_to'] = undefined;
  /**
   * Friday Start Time
   * @member {String} friday_from
   */
  exports.prototype['friday_from'] = undefined;
  /**
   * Friday End Time
   * @member {String} friday_to
   */
  exports.prototype['friday_to'] = undefined;
  /**
   * Saturday Start Time
   * @member {String} saturday_from
   */
  exports.prototype['saturday_from'] = undefined;
  /**
   * Saturday End Time
   * @member {String} saturday_to
   */
  exports.prototype['saturday_to'] = undefined;
  /**
   * Sunday Start Time
   * @member {String} sunday_from
   */
  exports.prototype['sunday_from'] = undefined;
  /**
   * Sunday End Time
   * @member {String} sunday_to
   */
  exports.prototype['sunday_to'] = undefined;



  return exports;
}));


