/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.CallLog = factory(root.PhonespeakApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The CallLog model module.
   * @module model/CallLog
   * @version v2
   */

  /**
   * Constructs a new <code>CallLog</code>.
   * The call credit usage object
   * @alias module:model/CallLog
   * @class
   */
  var exports = function() {
    var _this = this;






















  };

  /**
   * Constructs a <code>CallLog</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CallLog} obj Optional instance to populate.
   * @return {module:model/CallLog} The populated <code>CallLog</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('participantType')) {
        obj['participantType'] = ApiClient.convertToType(data['participantType'], 'Number');
      }
      if (data.hasOwnProperty('participantId')) {
        obj['participantId'] = ApiClient.convertToType(data['participantId'], 'String');
      }
      if (data.hasOwnProperty('ownerId')) {
        obj['ownerId'] = ApiClient.convertToType(data['ownerId'], 'String');
      }
      if (data.hasOwnProperty('date')) {
        obj['date'] = ApiClient.convertToType(data['date'], 'Date');
      }
      if (data.hasOwnProperty('cost')) {
        obj['cost'] = ApiClient.convertToType(data['cost'], 'Number');
      }
      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('duration')) {
        obj['duration'] = ApiClient.convertToType(data['duration'], 'Number');
      }
      if (data.hasOwnProperty('number')) {
        obj['number'] = ApiClient.convertToType(data['number'], 'String');
      }
      if (data.hasOwnProperty('participantName')) {
        obj['participantName'] = ApiClient.convertToType(data['participantName'], 'String');
      }
      if (data.hasOwnProperty('ownerName')) {
        obj['ownerName'] = ApiClient.convertToType(data['ownerName'], 'String');
      }
      if (data.hasOwnProperty('profileImage')) {
        obj['profileImage'] = ApiClient.convertToType(data['profileImage'], 'String');
      }
      if (data.hasOwnProperty('isMissedCall')) {
        obj['isMissedCall'] = ApiClient.convertToType(data['isMissedCall'], 'Boolean');
      }
      if (data.hasOwnProperty('isRead')) {
        obj['isRead'] = ApiClient.convertToType(data['isRead'], 'Boolean');
      }
      if (data.hasOwnProperty('callDirection')) {
        obj['callDirection'] = ApiClient.convertToType(data['callDirection'], 'String');
      }
      if (data.hasOwnProperty('isExtensionCall')) {
        obj['isExtensionCall'] = ApiClient.convertToType(data['isExtensionCall'], 'Boolean');
      }
      if (data.hasOwnProperty('isOwnerDeleted')) {
        obj['isOwnerDeleted'] = ApiClient.convertToType(data['isOwnerDeleted'], 'Boolean');
      }
      if (data.hasOwnProperty('isParticipantDeleted')) {
        obj['isParticipantDeleted'] = ApiClient.convertToType(data['isParticipantDeleted'], 'Boolean');
      }
      if (data.hasOwnProperty('callRecording')) {
        obj['callRecording'] = ApiClient.convertToType(data['callRecording'], 'String');
      }
      if (data.hasOwnProperty('callRecordingTranscribe')) {
        obj['callRecordingTranscribe'] = ApiClient.convertToType(data['callRecordingTranscribe'], 'String');
      }
      if (data.hasOwnProperty('teamId')) {
        obj['teamId'] = ApiClient.convertToType(data['teamId'], 'String');
      }
    }
    return obj;
  }

  /**
   * Id
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * ParticipantT Type
   * @member {Number} participantType
   */
  exports.prototype['participantType'] = undefined;
  /**
   * Participant Id
   * @member {String} participantId
   */
  exports.prototype['participantId'] = undefined;
  /**
   * Id
   * @member {String} ownerId
   */
  exports.prototype['ownerId'] = undefined;
  /**
   * Call Date
   * @member {Date} date
   */
  exports.prototype['date'] = undefined;
  /**
   * Call Cost
   * @member {Number} cost
   */
  exports.prototype['cost'] = undefined;
  /**
   * Call Type Outbound/Inbound
   * @member {String} type
   */
  exports.prototype['type'] = undefined;
  /**
   * Call Duration
   * @member {Number} duration
   */
  exports.prototype['duration'] = undefined;
  /**
   * Number
   * @member {String} number
   */
  exports.prototype['number'] = undefined;
  /**
   * Name
   * @member {String} participantName
   */
  exports.prototype['participantName'] = undefined;
  /**
   * Teammate
   * @member {String} ownerName
   */
  exports.prototype['ownerName'] = undefined;
  /**
   * The profile picture url
   * @member {String} profileImage
   */
  exports.prototype['profileImage'] = undefined;
  /**
   * Is Missed Call
   * @member {Boolean} isMissedCall
   */
  exports.prototype['isMissedCall'] = undefined;
  /**
   * Is Read
   * @member {Boolean} isRead
   */
  exports.prototype['isRead'] = undefined;
  /**
   * Call Direction
   * @member {String} callDirection
   */
  exports.prototype['callDirection'] = undefined;
  /**
   * Is Extension Call
   * @member {Boolean} isExtensionCall
   */
  exports.prototype['isExtensionCall'] = undefined;
  /**
   * Is Owner Deleted
   * @member {Boolean} isOwnerDeleted
   */
  exports.prototype['isOwnerDeleted'] = undefined;
  /**
   * Is Participant Deleted
   * @member {Boolean} isParticipantDeleted
   */
  exports.prototype['isParticipantDeleted'] = undefined;
  /**
   * Call Recording url
   * @member {String} callRecording
   */
  exports.prototype['callRecording'] = undefined;
  /**
   * Call Recording Transcribe
   * @member {String} callRecordingTranscribe
   */
  exports.prototype['callRecordingTranscribe'] = undefined;
  /**
   * Team Id
   * @member {String} teamId
   */
  exports.prototype['teamId'] = undefined;



  return exports;
}));


