/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/MusicOnHold'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./MusicOnHold'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.CallQueue = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.MusicOnHold);
  }
}(this, function(ApiClient, MusicOnHold) {
  'use strict';




  /**
   * The CallQueue model module.
   * @module model/CallQueue
   * @version v2
   */

  /**
   * Constructs a new <code>CallQueue</code>.
   * Call queue object
   * @alias module:model/CallQueue
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>CallQueue</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CallQueue} obj Optional instance to populate.
   * @return {module:model/CallQueue} The populated <code>CallQueue</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('queue_number')) {
        obj['queue_number'] = ApiClient.convertToType(data['queue_number'], 'String');
      }
      if (data.hasOwnProperty('polling_strategy')) {
        obj['polling_strategy'] = ApiClient.convertToType(data['polling_strategy'], 'Number');
      }
      if (data.hasOwnProperty('ring_time')) {
        obj['ring_time'] = ApiClient.convertToType(data['ring_time'], 'Number');
      }
      if (data.hasOwnProperty('music_on_hold')) {
        obj['music_on_hold'] = ApiClient.convertToType(data['music_on_hold'], [MusicOnHold]);
      }
      if (data.hasOwnProperty('enable_announce_caller_position')) {
        obj['enable_announce_caller_position'] = ApiClient.convertToType(data['enable_announce_caller_position'], 'Boolean');
      }
      if (data.hasOwnProperty('max_callers')) {
        obj['max_callers'] = ApiClient.convertToType(data['max_callers'], 'Number');
      }
      if (data.hasOwnProperty('max_wait_time')) {
        obj['max_wait_time'] = ApiClient.convertToType(data['max_wait_time'], 'Number');
      }
    }
    return obj;
  }

  /**
   * @member {String} queue_number
   */
  exports.prototype['queue_number'] = undefined;
  /**
   * @member {Number} polling_strategy
   */
  exports.prototype['polling_strategy'] = undefined;
  /**
   * @member {Number} ring_time
   */
  exports.prototype['ring_time'] = undefined;
  /**
   * @member {Array.<module:model/MusicOnHold>} music_on_hold
   */
  exports.prototype['music_on_hold'] = undefined;
  /**
   * @member {Boolean} enable_announce_caller_position
   */
  exports.prototype['enable_announce_caller_position'] = undefined;
  /**
   * @member {Number} max_callers
   */
  exports.prototype['max_callers'] = undefined;
  /**
   * @member {Number} max_wait_time
   */
  exports.prototype['max_wait_time'] = undefined;



  return exports;
}));


