/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.CallTarget = factory(root.PhonespeakApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The CallTarget model module.
   * @module model/CallTarget
   * @version v2
   */

  /**
   * Constructs a new <code>CallTarget</code>.
   * Call Target Object
   * @alias module:model/CallTarget
   * @class
   */
  var exports = function() {
    var _this = this;














  };

  /**
   * Constructs a <code>CallTarget</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CallTarget} obj Optional instance to populate.
   * @return {module:model/CallTarget} The populated <code>CallTarget</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('target_add_time')) {
        obj['target_add_time'] = ApiClient.convertToType(data['target_add_time'], 'Number');
      }
      if (data.hasOwnProperty('target_add_date_time')) {
        obj['target_add_date_time'] = ApiClient.convertToType(data['target_add_date_time'], 'Date');
      }
      if (data.hasOwnProperty('target_answered_time')) {
        obj['target_answered_time'] = ApiClient.convertToType(data['target_answered_time'], 'Number');
      }
      if (data.hasOwnProperty('target_answered_date_time')) {
        obj['target_answered_date_time'] = ApiClient.convertToType(data['target_answered_date_time'], 'Date');
      }
      if (data.hasOwnProperty('target_domain')) {
        obj['target_domain'] = ApiClient.convertToType(data['target_domain'], 'String');
      }
      if (data.hasOwnProperty('target_end_reason')) {
        obj['target_end_reason'] = ApiClient.convertToType(data['target_end_reason'], 'String');
      }
      if (data.hasOwnProperty('target_ended_time')) {
        obj['target_ended_time'] = ApiClient.convertToType(data['target_ended_time'], 'Number');
      }
      if (data.hasOwnProperty('target_ended_date_time')) {
        obj['target_ended_date_time'] = ApiClient.convertToType(data['target_ended_date_time'], 'Date');
      }
      if (data.hasOwnProperty('target_fail_code')) {
        obj['target_fail_code'] = ApiClient.convertToType(data['target_fail_code'], 'Number');
      }
      if (data.hasOwnProperty('target_number')) {
        obj['target_number'] = ApiClient.convertToType(data['target_number'], 'String');
      }
      if (data.hasOwnProperty('target_ring_duration')) {
        obj['target_ring_duration'] = ApiClient.convertToType(data['target_ring_duration'], 'Number');
      }
      if (data.hasOwnProperty('target_status')) {
        obj['target_status'] = ApiClient.convertToType(data['target_status'], 'String');
      }
      if (data.hasOwnProperty('target_talk_time')) {
        obj['target_talk_time'] = ApiClient.convertToType(data['target_talk_time'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Target add time
   * @member {Number} target_add_time
   */
  exports.prototype['target_add_time'] = undefined;
  /**
   * Target add date time
   * @member {Date} target_add_date_time
   */
  exports.prototype['target_add_date_time'] = undefined;
  /**
   * Target answered time
   * @member {Number} target_answered_time
   */
  exports.prototype['target_answered_time'] = undefined;
  /**
   * Target answered date time
   * @member {Date} target_answered_date_time
   */
  exports.prototype['target_answered_date_time'] = undefined;
  /**
   * Target domain
   * @member {String} target_domain
   */
  exports.prototype['target_domain'] = undefined;
  /**
   * Target end reason
   * @member {String} target_end_reason
   */
  exports.prototype['target_end_reason'] = undefined;
  /**
   * Target ended time
   * @member {Number} target_ended_time
   */
  exports.prototype['target_ended_time'] = undefined;
  /**
   * Target ended date time
   * @member {Date} target_ended_date_time
   */
  exports.prototype['target_ended_date_time'] = undefined;
  /**
   * Target fail code
   * @member {Number} target_fail_code
   */
  exports.prototype['target_fail_code'] = undefined;
  /**
   * Target number
   * @member {String} target_number
   */
  exports.prototype['target_number'] = undefined;
  /**
   * Target ring duration
   * @member {Number} target_ring_duration
   */
  exports.prototype['target_ring_duration'] = undefined;
  /**
   * Target status
   * @member {String} target_status
   */
  exports.prototype['target_status'] = undefined;
  /**
   * Target talk time
   * @member {Number} target_talk_time
   */
  exports.prototype['target_talk_time'] = undefined;



  return exports;
}));


