/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CallTarget'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CallTarget'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.Cdr = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.CallTarget);
  }
}(this, function(ApiClient, CallTarget) {
  'use strict';




  /**
   * The Cdr model module.
   * @module model/Cdr
   * @version v2
   */

  /**
   * Constructs a new <code>Cdr</code>.
   * The \&quot;Call Detail Record (CDR)\&quot; object
   * @alias module:model/Cdr
   * @class
   */
  var exports = function() {
    var _this = this;


















































  };

  /**
   * Constructs a <code>Cdr</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Cdr} obj Optional instance to populate.
   * @return {module:model/Cdr} The populated <code>Cdr</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('caller_owner_id')) {
        obj['caller_owner_id'] = ApiClient.convertToType(data['caller_owner_id'], 'String');
      }
      if (data.hasOwnProperty('callee_owner_id')) {
        obj['callee_owner_id'] = ApiClient.convertToType(data['callee_owner_id'], 'String');
      }
      if (data.hasOwnProperty('account_id')) {
        obj['account_id'] = ApiClient.convertToType(data['account_id'], 'String');
      }
      if (data.hasOwnProperty('call_answered_time')) {
        obj['call_answered_time'] = ApiClient.convertToType(data['call_answered_time'], 'Number');
      }
      if (data.hasOwnProperty('call_answered_date_time')) {
        obj['call_answered_date_time'] = ApiClient.convertToType(data['call_answered_date_time'], 'Date');
      }
      if (data.hasOwnProperty('call_cost')) {
        obj['call_cost'] = ApiClient.convertToType(data['call_cost'], 'Number');
      }
      if (data.hasOwnProperty('callCharges')) {
        obj['callCharges'] = ApiClient.convertToType(data['callCharges'], 'Number');
      }
      if (data.hasOwnProperty('call_direction')) {
        obj['call_direction'] = ApiClient.convertToType(data['call_direction'], 'String');
      }
      if (data.hasOwnProperty('call_ended_reason')) {
        obj['call_ended_reason'] = ApiClient.convertToType(data['call_ended_reason'], 'String');
      }
      if (data.hasOwnProperty('callDuration')) {
        obj['callDuration'] = ApiClient.convertToType(data['callDuration'], 'Number');
      }
      if (data.hasOwnProperty('call_ended_time')) {
        obj['call_ended_time'] = ApiClient.convertToType(data['call_ended_time'], 'Number');
      }
      if (data.hasOwnProperty('call_ended_date_time')) {
        obj['call_ended_date_time'] = ApiClient.convertToType(data['call_ended_date_time'], 'Date');
      }
      if (data.hasOwnProperty('call_fail_code')) {
        obj['call_fail_code'] = ApiClient.convertToType(data['call_fail_code'], 'Number');
      }
      if (data.hasOwnProperty('call_final_destination_domain')) {
        obj['call_final_destination_domain'] = ApiClient.convertToType(data['call_final_destination_domain'], 'String');
      }
      if (data.hasOwnProperty('call_final_destination_number')) {
        obj['call_final_destination_number'] = ApiClient.convertToType(data['call_final_destination_number'], 'String');
      }
      if (data.hasOwnProperty('call_final_destination_ownerId')) {
        obj['call_final_destination_ownerId'] = ApiClient.convertToType(data['call_final_destination_ownerId'], 'String');
      }
      if (data.hasOwnProperty('call_id')) {
        obj['call_id'] = ApiClient.convertToType(data['call_id'], 'String');
      }
      if (data.hasOwnProperty('call_prefix')) {
        obj['call_prefix'] = ApiClient.convertToType(data['call_prefix'], 'String');
      }
      if (data.hasOwnProperty('call_rate')) {
        obj['call_rate'] = ApiClient.convertToType(data['call_rate'], 'Number');
      }
      if (data.hasOwnProperty('call_ring_duration')) {
        obj['call_ring_duration'] = ApiClient.convertToType(data['call_ring_duration'], 'Number');
      }
      if (data.hasOwnProperty('call_start_time')) {
        obj['call_start_time'] = ApiClient.convertToType(data['call_start_time'], 'Number');
      }
      if (data.hasOwnProperty('call_start_date_time')) {
        obj['call_start_date_time'] = ApiClient.convertToType(data['call_start_date_time'], 'Date');
      }
      if (data.hasOwnProperty('call_status')) {
        obj['call_status'] = ApiClient.convertToType(data['call_status'], 'String');
      }
      if (data.hasOwnProperty('call_talk_time')) {
        obj['call_talk_time'] = ApiClient.convertToType(data['call_talk_time'], 'Number');
      }
      if (data.hasOwnProperty('call_targets')) {
        obj['call_targets'] = ApiClient.convertToType(data['call_targets'], [CallTarget]);
      }
      if (data.hasOwnProperty('call_trunk_name')) {
        obj['call_trunk_name'] = ApiClient.convertToType(data['call_trunk_name'], 'String');
      }
      if (data.hasOwnProperty('callee_domain')) {
        obj['callee_domain'] = ApiClient.convertToType(data['callee_domain'], 'String');
      }
      if (data.hasOwnProperty('callee_number')) {
        obj['callee_number'] = ApiClient.convertToType(data['callee_number'], 'String');
      }
      if (data.hasOwnProperty('callee_phonenumber')) {
        obj['callee_phonenumber'] = ApiClient.convertToType(data['callee_phonenumber'], 'String');
      }
      if (data.hasOwnProperty('calleeName')) {
        obj['calleeName'] = ApiClient.convertToType(data['calleeName'], 'String');
      }
      if (data.hasOwnProperty('calleeIsTollFree')) {
        obj['calleeIsTollFree'] = ApiClient.convertToType(data['calleeIsTollFree'], 'Boolean');
      }
      if (data.hasOwnProperty('caller_display_name')) {
        obj['caller_display_name'] = ApiClient.convertToType(data['caller_display_name'], 'String');
      }
      if (data.hasOwnProperty('caller_domain')) {
        obj['caller_domain'] = ApiClient.convertToType(data['caller_domain'], 'String');
      }
      if (data.hasOwnProperty('caller_number')) {
        obj['caller_number'] = ApiClient.convertToType(data['caller_number'], 'String');
      }
      if (data.hasOwnProperty('caller_phonenumber')) {
        obj['caller_phonenumber'] = ApiClient.convertToType(data['caller_phonenumber'], 'String');
      }
      if (data.hasOwnProperty('callerName')) {
        obj['callerName'] = ApiClient.convertToType(data['callerName'], 'String');
      }
      if (data.hasOwnProperty('callerIsTollFree')) {
        obj['callerIsTollFree'] = ApiClient.convertToType(data['callerIsTollFree'], 'Boolean');
      }
      if (data.hasOwnProperty('caller_duration_unit')) {
        obj['caller_duration_unit'] = ApiClient.convertToType(data['caller_duration_unit'], 'Number');
      }
      if (data.hasOwnProperty('extension')) {
        obj['extension'] = ApiClient.convertToType(data['extension'], 'String');
      }
      if (data.hasOwnProperty('recording_file_name')) {
        obj['recording_file_name'] = ApiClient.convertToType(data['recording_file_name'], 'String');
      }
      if (data.hasOwnProperty('tenant_domain')) {
        obj['tenant_domain'] = ApiClient.convertToType(data['tenant_domain'], 'String');
      }
      if (data.hasOwnProperty('tenant_id')) {
        obj['tenant_id'] = ApiClient.convertToType(data['tenant_id'], 'String');
      }
      if (data.hasOwnProperty('recording_location')) {
        obj['recording_location'] = ApiClient.convertToType(data['recording_location'], 'String');
      }
      if (data.hasOwnProperty('timezone')) {
        obj['timezone'] = ApiClient.convertToType(data['timezone'], 'Number');
      }
      if (data.hasOwnProperty('isRead')) {
        obj['isRead'] = ApiClient.convertToType(data['isRead'], 'Boolean');
      }
      if (data.hasOwnProperty('isCallerRead')) {
        obj['isCallerRead'] = ApiClient.convertToType(data['isCallerRead'], 'Boolean');
      }
      if (data.hasOwnProperty('isCalleeRead')) {
        obj['isCalleeRead'] = ApiClient.convertToType(data['isCalleeRead'], 'Boolean');
      }
      if (data.hasOwnProperty('read')) {
        obj['read'] = ApiClient.convertToType(data['read'], ['String']);
      }
    }
    return obj;
  }

  /**
   * Cdr Id
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Call recording location
   * @member {String} caller_owner_id
   */
  exports.prototype['caller_owner_id'] = undefined;
  /**
   * Call recording location
   * @member {String} callee_owner_id
   */
  exports.prototype['callee_owner_id'] = undefined;
  /**
   * Call recording location
   * @member {String} account_id
   */
  exports.prototype['account_id'] = undefined;
  /**
   * Date/time the call was answered
   * @member {Number} call_answered_time
   */
  exports.prototype['call_answered_time'] = undefined;
  /**
   * Converted Date/time the call was answered
   * @member {Date} call_answered_date_time
   */
  exports.prototype['call_answered_date_time'] = undefined;
  /**
   * Cost of the call
   * @member {Number} call_cost
   */
  exports.prototype['call_cost'] = undefined;
  /**
   * Call Charges
   * @member {Number} callCharges
   */
  exports.prototype['callCharges'] = undefined;
  /**
   * Call direction
   * @member {String} call_direction
   */
  exports.prototype['call_direction'] = undefined;
  /**
   * Call ended reason (hangup code)
   * @member {String} call_ended_reason
   */
  exports.prototype['call_ended_reason'] = undefined;
  /**
   * Call Duration
   * @member {Number} callDuration
   */
  exports.prototype['callDuration'] = undefined;
  /**
   * Date/time the call ended
   * @member {Number} call_ended_time
   */
  exports.prototype['call_ended_time'] = undefined;
  /**
   * Converted Date/time the call was ended
   * @member {Date} call_ended_date_time
   */
  exports.prototype['call_ended_date_time'] = undefined;
  /**
   * Call failure code/reason
   * @member {Number} call_fail_code
   */
  exports.prototype['call_fail_code'] = undefined;
  /**
   * Call final destination sip domain
   * @member {String} call_final_destination_domain
   */
  exports.prototype['call_final_destination_domain'] = undefined;
  /**
   * Call final destination phone number/extension
   * @member {String} call_final_destination_number
   */
  exports.prototype['call_final_destination_number'] = undefined;
  /**
   * Call final destination owner
   * @member {String} call_final_destination_ownerId
   */
  exports.prototype['call_final_destination_ownerId'] = undefined;
  /**
   * Unique sip call id
   * @member {String} call_id
   */
  exports.prototype['call_id'] = undefined;
  /**
   * Call prefix
   * @member {String} call_prefix
   */
  exports.prototype['call_prefix'] = undefined;
  /**
   * Rate for this call
   * @member {Number} call_rate
   */
  exports.prototype['call_rate'] = undefined;
  /**
   * Total ring duration
   * @member {Number} call_ring_duration
   */
  exports.prototype['call_ring_duration'] = undefined;
  /**
   * Date/time the call started
   * @member {Number} call_start_time
   */
  exports.prototype['call_start_time'] = undefined;
  /**
   * Date/time the call started
   * @member {Date} call_start_date_time
   */
  exports.prototype['call_start_date_time'] = undefined;
  /**
   * Call status
   * @member {String} call_status
   */
  exports.prototype['call_status'] = undefined;
  /**
   * Duration of the call in seconds
   * @member {Number} call_talk_time
   */
  exports.prototype['call_talk_time'] = undefined;
  /**
   * Call targets
   * @member {Array.<module:model/CallTarget>} call_targets
   */
  exports.prototype['call_targets'] = undefined;
  /**
   * Name of the trunk/provider the call was sent/received
   * @member {String} call_trunk_name
   */
  exports.prototype['call_trunk_name'] = undefined;
  /**
   * Callee's sip domain
   * @member {String} callee_domain
   */
  exports.prototype['callee_domain'] = undefined;
  /**
   * Callee's phone number/extension
   * @member {String} callee_number
   */
  exports.prototype['callee_number'] = undefined;
  /**
   * Callee's phone number
   * @member {String} callee_phonenumber
   */
  exports.prototype['callee_phonenumber'] = undefined;
  /**
   * Callee's name
   * @member {String} calleeName
   */
  exports.prototype['calleeName'] = undefined;
  /**
   * Callee Is Toll Free
   * @member {Boolean} calleeIsTollFree
   */
  exports.prototype['calleeIsTollFree'] = undefined;
  /**
   * Caller's display name
   * @member {String} caller_display_name
   */
  exports.prototype['caller_display_name'] = undefined;
  /**
   * Caller's sip domain
   * @member {String} caller_domain
   */
  exports.prototype['caller_domain'] = undefined;
  /**
   * Caller's phone number/extension
   * @member {String} caller_number
   */
  exports.prototype['caller_number'] = undefined;
  /**
   * Caller's phone number
   * @member {String} caller_phonenumber
   */
  exports.prototype['caller_phonenumber'] = undefined;
  /**
   * Caller's name
   * @member {String} callerName
   */
  exports.prototype['callerName'] = undefined;
  /**
   * Caller Is Toll Free
   * @member {Boolean} callerIsTollFree
   */
  exports.prototype['callerIsTollFree'] = undefined;
  /**
   * Cost duration unit
   * @member {Number} caller_duration_unit
   */
  exports.prototype['caller_duration_unit'] = undefined;
  /**
   * Cost duration unit
   * @member {String} extension
   */
  exports.prototype['extension'] = undefined;
  /**
   * Call recording file name
   * @member {String} recording_file_name
   */
  exports.prototype['recording_file_name'] = undefined;
  /**
   * PBX Tenant ID
   * @member {String} tenant_domain
   */
  exports.prototype['tenant_domain'] = undefined;
  /**
   * PBX Tenant ID
   * @member {String} tenant_id
   */
  exports.prototype['tenant_id'] = undefined;
  /**
   * Call recording location
   * @member {String} recording_location
   */
  exports.prototype['recording_location'] = undefined;
  /**
   * Call recording location
   * @member {Number} timezone
   */
  exports.prototype['timezone'] = undefined;
  /**
   * Call detail record is read?
   * @member {Boolean} isRead
   */
  exports.prototype['isRead'] = undefined;
  /**
   * Caller is read?
   * @member {Boolean} isCallerRead
   */
  exports.prototype['isCallerRead'] = undefined;
  /**
   * Callee is read?
   * @member {Boolean} isCalleeRead
   */
  exports.prototype['isCalleeRead'] = undefined;
  /**
   * Teammate Read Status
   * @member {Array.<String>} read
   */
  exports.prototype['read'] = undefined;



  return exports;
}));


