/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BusinessHour', 'model/CallHandlingClosedHour', 'model/CallHandlingOpenHour', 'model/Ivr', 'model/PhoneNumber', 'model/SMSHandling'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./BusinessHour'), require('./CallHandlingClosedHour'), require('./CallHandlingOpenHour'), require('./Ivr'), require('./PhoneNumber'), require('./SMSHandling'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.CompanyNumber = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.BusinessHour, root.PhonespeakApi.CallHandlingClosedHour, root.PhonespeakApi.CallHandlingOpenHour, root.PhonespeakApi.Ivr, root.PhonespeakApi.PhoneNumber, root.PhonespeakApi.SMSHandling);
  }
}(this, function(ApiClient, BusinessHour, CallHandlingClosedHour, CallHandlingOpenHour, Ivr, PhoneNumber, SMSHandling) {
  'use strict';




  /**
   * The CompanyNumber model module.
   * @module model/CompanyNumber
   * @version v2
   */

  /**
   * Constructs a new <code>CompanyNumber</code>.
   * The \&quot;CompanyNumber\&quot; object
   * @alias module:model/CompanyNumber
   * @class
   * @param name {String} Company Number Name
   */
  var exports = function(name) {
    var _this = this;



    _this['name'] = name;


















  };

  /**
   * Constructs a <code>CompanyNumber</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CompanyNumber} obj Optional instance to populate.
   * @return {module:model/CompanyNumber} The populated <code>CompanyNumber</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('accountId')) {
        obj['accountId'] = ApiClient.convertToType(data['accountId'], 'String');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('number')) {
        obj['number'] = ApiClient.convertToType(data['number'], 'String');
      }
      if (data.hasOwnProperty('phoneNumbers')) {
        obj['phoneNumbers'] = ApiClient.convertToType(data['phoneNumbers'], [PhoneNumber]);
      }
      if (data.hasOwnProperty('callerIDPermission')) {
        obj['callerIDPermission'] = ApiClient.convertToType(data['callerIDPermission'], ['String']);
      }
      if (data.hasOwnProperty('extension')) {
        obj['extension'] = ApiClient.convertToType(data['extension'], 'String');
      }
      if (data.hasOwnProperty('businessHour')) {
        obj['businessHour'] = BusinessHour.constructFromObject(data['businessHour']);
      }
      if (data.hasOwnProperty('callHandlingOpenHour')) {
        obj['callHandlingOpenHour'] = CallHandlingOpenHour.constructFromObject(data['callHandlingOpenHour']);
      }
      if (data.hasOwnProperty('callHandlingClosedHour')) {
        obj['callHandlingClosedHour'] = CallHandlingClosedHour.constructFromObject(data['callHandlingClosedHour']);
      }
      if (data.hasOwnProperty('smsHandling')) {
        obj['smsHandling'] = SMSHandling.constructFromObject(data['smsHandling']);
      }
      if (data.hasOwnProperty('callerId')) {
        obj['callerId'] = ApiClient.convertToType(data['callerId'], 'String');
      }
      if (data.hasOwnProperty('callRecordingSetting')) {
        obj['callRecordingSetting'] = ApiClient.convertToType(data['callRecordingSetting'], 'Number');
      }
      if (data.hasOwnProperty('isDeleted')) {
        obj['isDeleted'] = ApiClient.convertToType(data['isDeleted'], 'Boolean');
      }
      if (data.hasOwnProperty('ivr')) {
        obj['ivr'] = ApiClient.convertToType(data['ivr'], [Ivr]);
      }
      if (data.hasOwnProperty('createdDate')) {
        obj['createdDate'] = ApiClient.convertToType(data['createdDate'], 'Date');
      }
      if (data.hasOwnProperty('createdBy')) {
        obj['createdBy'] = ApiClient.convertToType(data['createdBy'], 'String');
      }
      if (data.hasOwnProperty('updatedDate')) {
        obj['updatedDate'] = ApiClient.convertToType(data['updatedDate'], 'Date');
      }
      if (data.hasOwnProperty('updatedBy')) {
        obj['updatedBy'] = ApiClient.convertToType(data['updatedBy'], 'String');
      }
      if (data.hasOwnProperty('isDefault')) {
        obj['isDefault'] = ApiClient.convertToType(data['isDefault'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * CompanyNumber Id
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Account Id
   * @member {String} accountId
   */
  exports.prototype['accountId'] = undefined;
  /**
   * Company Number Name
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Company Number Description
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * Company Number's default phone number
   * @member {String} number
   */
  exports.prototype['number'] = undefined;
  /**
   * Company Numbers
   * @member {Array.<module:model/PhoneNumber>} phoneNumbers
   */
  exports.prototype['phoneNumbers'] = undefined;
  /**
   * Company Number permission for number usage
   * @member {Array.<String>} callerIDPermission
   */
  exports.prototype['callerIDPermission'] = undefined;
  /**
   * Company Number Extension
   * @member {String} extension
   */
  exports.prototype['extension'] = undefined;
  /**
   * Company Business Hour
   * @member {module:model/BusinessHour} businessHour
   */
  exports.prototype['businessHour'] = undefined;
  /**
   * Company Call Handling Open Hour
   * @member {module:model/CallHandlingOpenHour} callHandlingOpenHour
   */
  exports.prototype['callHandlingOpenHour'] = undefined;
  /**
   * Company Call Handling Closed Hour
   * @member {module:model/CallHandlingClosedHour} callHandlingClosedHour
   */
  exports.prototype['callHandlingClosedHour'] = undefined;
  /**
   * SMS Handling
   * @member {module:model/SMSHandling} smsHandling
   */
  exports.prototype['smsHandling'] = undefined;
  /**
   * Company Number Caller Id
   * @member {String} callerId
   */
  exports.prototype['callerId'] = undefined;
  /**
   * Company Call Recording Setting
   * @member {Number} callRecordingSetting
   */
  exports.prototype['callRecordingSetting'] = undefined;
  /**
   * Is deleted?
   * @member {Boolean} isDeleted
   */
  exports.prototype['isDeleted'] = undefined;
  /**
   * Company Number's Ivr Number
   * @member {Array.<module:model/Ivr>} ivr
   */
  exports.prototype['ivr'] = undefined;
  /**
   * Created Date
   * @member {Date} createdDate
   */
  exports.prototype['createdDate'] = undefined;
  /**
   * Created By
   * @member {String} createdBy
   */
  exports.prototype['createdBy'] = undefined;
  /**
   * Updated Date
   * @member {Date} updatedDate
   */
  exports.prototype['updatedDate'] = undefined;
  /**
   * Updated By
   * @member {String} updatedBy
   */
  exports.prototype['updatedBy'] = undefined;
  /**
   * Is Default
   * @member {Boolean} isDefault
   */
  exports.prototype['isDefault'] = undefined;



  return exports;
}));


