/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Address', 'model/PhoneNumber', 'model/ProfileImage'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Address'), require('./PhoneNumber'), require('./ProfileImage'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.Contact = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.Address, root.PhonespeakApi.PhoneNumber, root.PhonespeakApi.ProfileImage);
  }
}(this, function(ApiClient, Address, PhoneNumber, ProfileImage) {
  'use strict';




  /**
   * The Contact model module.
   * @module model/Contact
   * @version v2
   */

  /**
   * Constructs a new <code>Contact</code>.
   * The \&quot;Contact\&quot; object
   * @alias module:model/Contact
   * @class
   */
  var exports = function() {
    var _this = this;





















  };

  /**
   * Constructs a <code>Contact</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Contact} obj Optional instance to populate.
   * @return {module:model/Contact} The populated <code>Contact</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('ownerId')) {
        obj['ownerId'] = ApiClient.convertToType(data['ownerId'], 'String');
      }
      if (data.hasOwnProperty('accountId')) {
        obj['accountId'] = ApiClient.convertToType(data['accountId'], 'String');
      }
      if (data.hasOwnProperty('firstName')) {
        obj['firstName'] = ApiClient.convertToType(data['firstName'], 'String');
      }
      if (data.hasOwnProperty('lastName')) {
        obj['lastName'] = ApiClient.convertToType(data['lastName'], 'String');
      }
      if (data.hasOwnProperty('fullName')) {
        obj['fullName'] = ApiClient.convertToType(data['fullName'], 'String');
      }
      if (data.hasOwnProperty('company')) {
        obj['company'] = ApiClient.convertToType(data['company'], 'String');
      }
      if (data.hasOwnProperty('companyTitle')) {
        obj['companyTitle'] = ApiClient.convertToType(data['companyTitle'], 'String');
      }
      if (data.hasOwnProperty('email')) {
        obj['email'] = ApiClient.convertToType(data['email'], 'String');
      }
      if (data.hasOwnProperty('profileImage')) {
        obj['profileImage'] = ApiClient.convertToType(data['profileImage'], 'String');
      }
      if (data.hasOwnProperty('defaultNumber')) {
        obj['defaultNumber'] = ApiClient.convertToType(data['defaultNumber'], 'String');
      }
      if (data.hasOwnProperty('contactNumbers')) {
        obj['contactNumbers'] = ApiClient.convertToType(data['contactNumbers'], [PhoneNumber]);
      }
      if (data.hasOwnProperty('address')) {
        obj['address'] = Address.constructFromObject(data['address']);
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('isFavourite')) {
        obj['isFavourite'] = ApiClient.convertToType(data['isFavourite'], 'Boolean');
      }
      if (data.hasOwnProperty('folderId')) {
        obj['folderId'] = ApiClient.convertToType(data['folderId'], 'String');
      }
      if (data.hasOwnProperty('isDeleted')) {
        obj['isDeleted'] = ApiClient.convertToType(data['isDeleted'], 'Boolean');
      }
      if (data.hasOwnProperty('createdDate')) {
        obj['createdDate'] = ApiClient.convertToType(data['createdDate'], 'Date');
      }
      if (data.hasOwnProperty('isBlock')) {
        obj['isBlock'] = ApiClient.convertToType(data['isBlock'], 'Boolean');
      }
      if (data.hasOwnProperty('contactImage')) {
        obj['contactImage'] = ProfileImage.constructFromObject(data['contactImage']);
      }
    }
    return obj;
  }

  /**
   * Contact Id
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Teammate's Id
   * @member {String} ownerId
   */
  exports.prototype['ownerId'] = undefined;
  /**
   * Teammate's Account Id
   * @member {String} accountId
   */
  exports.prototype['accountId'] = undefined;
  /**
   * Contact's first name
   * @member {String} firstName
   */
  exports.prototype['firstName'] = undefined;
  /**
   * Contact's last name
   * @member {String} lastName
   */
  exports.prototype['lastName'] = undefined;
  /**
   * Contact's full name
   * @member {String} fullName
   */
  exports.prototype['fullName'] = undefined;
  /**
   * Contact's company name
   * @member {String} company
   */
  exports.prototype['company'] = undefined;
  /**
   * Contact's Company title
   * @member {String} companyTitle
   */
  exports.prototype['companyTitle'] = undefined;
  /**
   * Contact's email address
   * @member {String} email
   */
  exports.prototype['email'] = undefined;
  /**
   * The Contact's profile picture url
   * @member {String} profileImage
   */
  exports.prototype['profileImage'] = undefined;
  /**
   * Default phone number
   * @member {String} defaultNumber
   */
  exports.prototype['defaultNumber'] = undefined;
  /**
   * List of Contact Number
   * @member {Array.<module:model/PhoneNumber>} contactNumbers
   */
  exports.prototype['contactNumbers'] = undefined;
  /**
   * Contact's address
   * @member {module:model/Address} address
   */
  exports.prototype['address'] = undefined;
  /**
   * Contact's description
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * Is contact a favourite?
   * @member {Boolean} isFavourite
   */
  exports.prototype['isFavourite'] = undefined;
  /**
   * Contact's FolderId
   * @member {String} folderId
   */
  exports.prototype['folderId'] = undefined;
  /**
   * Is contact deleted?
   * @member {Boolean} isDeleted
   */
  exports.prototype['isDeleted'] = undefined;
  /**
   * Contact created date
   * @member {Date} createdDate
   */
  exports.prototype['createdDate'] = undefined;
  /**
   * Is block
   * @member {Boolean} isBlock
   */
  exports.prototype['isBlock'] = undefined;
  /**
   * List of Contact Number
   * @member {module:model/ProfileImage} contactImage
   */
  exports.prototype['contactImage'] = undefined;



  return exports;
}));


