/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Message'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Message'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.Conversation = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.Message);
  }
}(this, function(ApiClient, Message) {
  'use strict';




  /**
   * The Conversation model module.
   * @module model/Conversation
   * @version v2
   */

  /**
   * Constructs a new <code>Conversation</code>.
   * Conversation object
   * @alias module:model/Conversation
   * @class
   */
  var exports = function() {
    var _this = this;

















  };

  /**
   * Constructs a <code>Conversation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Conversation} obj Optional instance to populate.
   * @return {module:model/Conversation} The populated <code>Conversation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('conversationImage')) {
        obj['conversationImage'] = ApiClient.convertToType(data['conversationImage'], 'String');
      }
      if (data.hasOwnProperty('fromNumber')) {
        obj['fromNumber'] = ApiClient.convertToType(data['fromNumber'], 'String');
      }
      if (data.hasOwnProperty('ownerId')) {
        obj['ownerId'] = ApiClient.convertToType(data['ownerId'], 'String');
      }
      if (data.hasOwnProperty('accountId')) {
        obj['accountId'] = ApiClient.convertToType(data['accountId'], 'String');
      }
      if (data.hasOwnProperty('number')) {
        obj['number'] = ApiClient.convertToType(data['number'], 'String');
      }
      if (data.hasOwnProperty('isDeleted')) {
        obj['isDeleted'] = ApiClient.convertToType(data['isDeleted'], 'Boolean');
      }
      if (data.hasOwnProperty('isTeammateDeleted')) {
        obj['isTeammateDeleted'] = ApiClient.convertToType(data['isTeammateDeleted'], 'Boolean');
      }
      if (data.hasOwnProperty('pinnedDate')) {
        obj['pinnedDate'] = ApiClient.convertToType(data['pinnedDate'], 'Date');
      }
      if (data.hasOwnProperty('isArchived')) {
        obj['isArchived'] = ApiClient.convertToType(data['isArchived'], 'Boolean');
      }
      if (data.hasOwnProperty('createdDate')) {
        obj['createdDate'] = ApiClient.convertToType(data['createdDate'], 'Date');
      }
      if (data.hasOwnProperty('groupId')) {
        obj['groupId'] = ApiClient.convertToType(data['groupId'], 'String');
      }
      if (data.hasOwnProperty('messages')) {
        obj['messages'] = ApiClient.convertToType(data['messages'], [Message]);
      }
      if (data.hasOwnProperty('cspMessage')) {
        obj['cspMessage'] = Message.constructFromObject(data['cspMessage']);
      }
      if (data.hasOwnProperty('participants')) {
        obj['participants'] = ApiClient.convertToType(data['participants'], ['String']);
      }
    }
    return obj;
  }

  /**
   * Conversation Id
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Receiver Name
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Conversation Image
   * @member {String} conversationImage
   */
  exports.prototype['conversationImage'] = undefined;
  /**
   * From Name
   * @member {String} fromNumber
   */
  exports.prototype['fromNumber'] = undefined;
  /**
   * Owner Id
   * @member {String} ownerId
   */
  exports.prototype['ownerId'] = undefined;
  /**
   * Owner's Account Id
   * @member {String} accountId
   */
  exports.prototype['accountId'] = undefined;
  /**
   * Number used to receive or send
   * @member {String} number
   */
  exports.prototype['number'] = undefined;
  /**
   * Is Deleted
   * @member {Boolean} isDeleted
   */
  exports.prototype['isDeleted'] = undefined;
  /**
   * Is Teammate Deleted
   * @member {Boolean} isTeammateDeleted
   */
  exports.prototype['isTeammateDeleted'] = undefined;
  /**
   * Pinned Date
   * @member {Date} pinnedDate
   */
  exports.prototype['pinnedDate'] = undefined;
  /**
   * Is Archived
   * @member {Boolean} isArchived
   */
  exports.prototype['isArchived'] = undefined;
  /**
   * Conversation created date
   * @member {Date} createdDate
   */
  exports.prototype['createdDate'] = undefined;
  /**
   * Group Id
   * @member {String} groupId
   */
  exports.prototype['groupId'] = undefined;
  /**
   * Conversation messages
   * @member {Array.<module:model/Message>} messages
   */
  exports.prototype['messages'] = undefined;
  /**
   * For CloudSoftPhone message
   * @member {module:model/Message} cspMessage
   */
  exports.prototype['cspMessage'] = undefined;
  /**
   * Participants
   * @member {Array.<String>} participants
   */
  exports.prototype['participants'] = undefined;



  return exports;
}));


