/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ChatFile', 'model/Conversation'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ChatFile'), require('./Conversation'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.CreateConversation = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.ChatFile, root.PhonespeakApi.Conversation);
  }
}(this, function(ApiClient, ChatFile, Conversation) {
  'use strict';




  /**
   * The CreateConversation model module.
   * @module model/CreateConversation
   * @version v2
   */

  /**
   * Constructs a new <code>CreateConversation</code>.
   * The \&quot;CreateConversation\&quot; object
   * @alias module:model/CreateConversation
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>CreateConversation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CreateConversation} obj Optional instance to populate.
   * @return {module:model/CreateConversation} The populated <code>CreateConversation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('sender')) {
        obj['sender'] = Conversation.constructFromObject(data['sender']);
      }
      if (data.hasOwnProperty('receivers')) {
        obj['receivers'] = ApiClient.convertToType(data['receivers'], [Conversation]);
      }
      if (data.hasOwnProperty('message')) {
        obj['message'] = ApiClient.convertToType(data['message'], 'String');
      }
      if (data.hasOwnProperty('medias')) {
        obj['medias'] = ApiClient.convertToType(data['medias'], [ChatFile]);
      }
    }
    return obj;
  }

  /**
   * Sender Object
   * @member {module:model/Conversation} sender
   */
  exports.prototype['sender'] = undefined;
  /**
   * Receivers Object
   * @member {Array.<module:model/Conversation>} receivers
   */
  exports.prototype['receivers'] = undefined;
  /**
   * Conversation's Message
   * @member {String} message
   */
  exports.prototype['message'] = undefined;
  /**
   * Conversation's Medias
   * @member {Array.<module:model/ChatFile>} medias
   */
  exports.prototype['medias'] = undefined;



  return exports;
}));


