/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BillingAddress'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./BillingAddress'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.CreditCard = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.BillingAddress);
  }
}(this, function(ApiClient, BillingAddress) {
  'use strict';




  /**
   * The CreditCard model module.
   * @module model/CreditCard
   * @version v2
   */

  /**
   * Constructs a new <code>CreditCard</code>.
   * Credit card information
   * @alias module:model/CreditCard
   * @class
   */
  var exports = function() {
    var _this = this;











  };

  /**
   * Constructs a <code>CreditCard</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CreditCard} obj Optional instance to populate.
   * @return {module:model/CreditCard} The populated <code>CreditCard</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('creditCardId')) {
        obj['creditCardId'] = ApiClient.convertToType(data['creditCardId'], 'String');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('number')) {
        obj['number'] = ApiClient.convertToType(data['number'], 'String');
      }
      if (data.hasOwnProperty('last4Digits')) {
        obj['last4Digits'] = ApiClient.convertToType(data['last4Digits'], 'String');
      }
      if (data.hasOwnProperty('cvc')) {
        obj['cvc'] = ApiClient.convertToType(data['cvc'], 'String');
      }
      if (data.hasOwnProperty('expirationMonth')) {
        obj['expirationMonth'] = ApiClient.convertToType(data['expirationMonth'], 'Number');
      }
      if (data.hasOwnProperty('expirationYear')) {
        obj['expirationYear'] = ApiClient.convertToType(data['expirationYear'], 'Number');
      }
      if (data.hasOwnProperty('addressZip')) {
        obj['addressZip'] = ApiClient.convertToType(data['addressZip'], 'String');
      }
      if (data.hasOwnProperty('isDefault')) {
        obj['isDefault'] = ApiClient.convertToType(data['isDefault'], 'Boolean');
      }
      if (data.hasOwnProperty('billingAddress')) {
        obj['billingAddress'] = BillingAddress.constructFromObject(data['billingAddress']);
      }
    }
    return obj;
  }

  /**
   * Credit Card Id
   * @member {String} creditCardId
   */
  exports.prototype['creditCardId'] = undefined;
  /**
   * Credit Card Name
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Credit Card Number
   * @member {String} number
   */
  exports.prototype['number'] = undefined;
  /**
   * Credit Card last 4 digits
   * @member {String} last4Digits
   */
  exports.prototype['last4Digits'] = undefined;
  /**
   * Credit Card Cvc
   * @member {String} cvc
   */
  exports.prototype['cvc'] = undefined;
  /**
   * Credit Card Expired Month
   * @member {Number} expirationMonth
   */
  exports.prototype['expirationMonth'] = undefined;
  /**
   * Credit Card Expired Year
   * @member {Number} expirationYear
   */
  exports.prototype['expirationYear'] = undefined;
  /**
   * Credit Card's address zip
   * @member {String} addressZip
   */
  exports.prototype['addressZip'] = undefined;
  /**
   * Default credit card
   * @member {Boolean} isDefault
   */
  exports.prototype['isDefault'] = undefined;
  /**
   * Billing address of credit card
   * @member {module:model/BillingAddress} billingAddress
   */
  exports.prototype['billingAddress'] = undefined;



  return exports;
}));


