/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AccountSetting'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./AccountSetting'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.CsrAccount = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.AccountSetting);
  }
}(this, function(ApiClient, AccountSetting) {
  'use strict';




  /**
   * The CsrAccount model module.
   * @module model/CsrAccount
   * @version v2
   */

  /**
   * Constructs a new <code>CsrAccount</code>.
   * The \&quot;CsrAccount\&quot; object
   * @alias module:model/CsrAccount
   * @class
   */
  var exports = function() {
    var _this = this;





















  };

  /**
   * Constructs a <code>CsrAccount</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CsrAccount} obj Optional instance to populate.
   * @return {module:model/CsrAccount} The populated <code>CsrAccount</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('companyName')) {
        obj['companyName'] = ApiClient.convertToType(data['companyName'], 'String');
      }
      if (data.hasOwnProperty('createdDate')) {
        obj['createdDate'] = ApiClient.convertToType(data['createdDate'], 'Date');
      }
      if (data.hasOwnProperty('reseller')) {
        obj['reseller'] = ApiClient.convertToType(data['reseller'], 'String');
      }
      if (data.hasOwnProperty('packageId')) {
        obj['packageId'] = ApiClient.convertToType(data['packageId'], 'String');
      }
      if (data.hasOwnProperty('planId')) {
        obj['planId'] = ApiClient.convertToType(data['planId'], 'String');
      }
      if (data.hasOwnProperty('planPrice')) {
        obj['planPrice'] = ApiClient.convertToType(data['planPrice'], 'Number');
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'Number');
      }
      if (data.hasOwnProperty('csrInternationalCall')) {
        obj['csrInternationalCall'] = ApiClient.convertToType(data['csrInternationalCall'], 'Boolean');
      }
      if (data.hasOwnProperty('callUsage')) {
        obj['callUsage'] = ApiClient.convertToType(data['callUsage'], 'Number');
      }
      if (data.hasOwnProperty('smsUsage')) {
        obj['smsUsage'] = ApiClient.convertToType(data['smsUsage'], 'Number');
      }
      if (data.hasOwnProperty('weeklyTopUpLimit')) {
        obj['weeklyTopUpLimit'] = ApiClient.convertToType(data['weeklyTopUpLimit'], 'Number');
      }
      if (data.hasOwnProperty('adminId')) {
        obj['adminId'] = ApiClient.convertToType(data['adminId'], 'String');
      }
      if (data.hasOwnProperty('country')) {
        obj['country'] = ApiClient.convertToType(data['country'], 'String');
      }
      if (data.hasOwnProperty('totalPhoneNumber')) {
        obj['totalPhoneNumber'] = ApiClient.convertToType(data['totalPhoneNumber'], 'Number');
      }
      if (data.hasOwnProperty('totalTeammate')) {
        obj['totalTeammate'] = ApiClient.convertToType(data['totalTeammate'], 'Number');
      }
      if (data.hasOwnProperty('setting')) {
        obj['setting'] = AccountSetting.constructFromObject(data['setting']);
      }
      if (data.hasOwnProperty('callCredit')) {
        obj['callCredit'] = ApiClient.convertToType(data['callCredit'], 'Number');
      }
      if (data.hasOwnProperty('desktopLastLogin')) {
        obj['desktopLastLogin'] = ApiClient.convertToType(data['desktopLastLogin'], 'Date');
      }
      if (data.hasOwnProperty('mobileLastLogin')) {
        obj['mobileLastLogin'] = ApiClient.convertToType(data['mobileLastLogin'], 'Date');
      }
    }
    return obj;
  }

  /**
   * The unique identifier of account
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Company name
   * @member {String} companyName
   */
  exports.prototype['companyName'] = undefined;
  /**
   * Account's creation date
   * @member {Date} createdDate
   */
  exports.prototype['createdDate'] = undefined;
  /**
   * Reseller
   * @member {String} reseller
   */
  exports.prototype['reseller'] = undefined;
  /**
   * PackageId
   * @member {String} packageId
   */
  exports.prototype['packageId'] = undefined;
  /**
   * PlanId
   * @member {String} planId
   */
  exports.prototype['planId'] = undefined;
  /**
   * Plan Price
   * @member {Number} planPrice
   */
  exports.prototype['planPrice'] = undefined;
  /**
   * Account Status
   * @member {Number} status
   */
  exports.prototype['status'] = undefined;
  /**
   * Flag indicate the account is valid for do international call.
   * @member {Boolean} csrInternationalCall
   */
  exports.prototype['csrInternationalCall'] = undefined;
  /**
   * Maximum teammate's call usage
   * @member {Number} callUsage
   */
  exports.prototype['callUsage'] = undefined;
  /**
   * Maximum teammate's sms usage
   * @member {Number} smsUsage
   */
  exports.prototype['smsUsage'] = undefined;
  /**
   * Weekly top up limit
   * @member {Number} weeklyTopUpLimit
   */
  exports.prototype['weeklyTopUpLimit'] = undefined;
  /**
   * Admin Teammate Id
   * @member {String} adminId
   */
  exports.prototype['adminId'] = undefined;
  /**
   * Admin Country
   * @member {String} country
   */
  exports.prototype['country'] = undefined;
  /**
   * Total PhoneNumber
   * @member {Number} totalPhoneNumber
   */
  exports.prototype['totalPhoneNumber'] = undefined;
  /**
   * Total Teammate
   * @member {Number} totalTeammate
   */
  exports.prototype['totalTeammate'] = undefined;
  /**
   * Account Setting
   * @member {module:model/AccountSetting} setting
   */
  exports.prototype['setting'] = undefined;
  /**
   * Call Credit
   * @member {Number} callCredit
   */
  exports.prototype['callCredit'] = undefined;
  /**
   * Desktop LastLogin
   * @member {Date} desktopLastLogin
   */
  exports.prototype['desktopLastLogin'] = undefined;
  /**
   * Mobile LastLogin
   * @member {Date} mobileLastLogin
   */
  exports.prototype['mobileLastLogin'] = undefined;



  return exports;
}));


