/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ProfileImage'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ProfileImage'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.CsrUser = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.ProfileImage);
  }
}(this, function(ApiClient, ProfileImage) {
  'use strict';




  /**
   * The CsrUser model module.
   * @module model/CsrUser
   * @version v2
   */

  /**
   * Constructs a new <code>CsrUser</code>.
   * The \&quot;CsrUser\&quot; Object
   * @alias module:model/CsrUser
   * @class
   */
  var exports = function() {
    var _this = this;
















  };

  /**
   * Constructs a <code>CsrUser</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CsrUser} obj Optional instance to populate.
   * @return {module:model/CsrUser} The populated <code>CsrUser</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('profileImage')) {
        obj['profileImage'] = ApiClient.convertToType(data['profileImage'], 'String');
      }
      if (data.hasOwnProperty('password')) {
        obj['password'] = ApiClient.convertToType(data['password'], 'String');
      }
      if (data.hasOwnProperty('firstName')) {
        obj['firstName'] = ApiClient.convertToType(data['firstName'], 'String');
      }
      if (data.hasOwnProperty('lastName')) {
        obj['lastName'] = ApiClient.convertToType(data['lastName'], 'String');
      }
      if (data.hasOwnProperty('fullName')) {
        obj['fullName'] = ApiClient.convertToType(data['fullName'], 'String');
      }
      if (data.hasOwnProperty('email')) {
        obj['email'] = ApiClient.convertToType(data['email'], 'String');
      }
      if (data.hasOwnProperty('createdDate')) {
        obj['createdDate'] = ApiClient.convertToType(data['createdDate'], 'Date');
      }
      if (data.hasOwnProperty('createdBy')) {
        obj['createdBy'] = ApiClient.convertToType(data['createdBy'], 'String');
      }
      if (data.hasOwnProperty('updatedDate')) {
        obj['updatedDate'] = ApiClient.convertToType(data['updatedDate'], 'Date');
      }
      if (data.hasOwnProperty('updatedBy')) {
        obj['updatedBy'] = ApiClient.convertToType(data['updatedBy'], 'String');
      }
      if (data.hasOwnProperty('csrImage')) {
        obj['csrImage'] = ProfileImage.constructFromObject(data['csrImage']);
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'Number');
      }
      if (data.hasOwnProperty('note')) {
        obj['note'] = ApiClient.convertToType(data['note'], 'String');
      }
      if (data.hasOwnProperty('lastLogin')) {
        obj['lastLogin'] = ApiClient.convertToType(data['lastLogin'], 'Date');
      }
    }
    return obj;
  }

  /**
   * Csr user id
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Profile picture url
   * @member {String} profileImage
   */
  exports.prototype['profileImage'] = undefined;
  /**
   * Csr user's password
   * @member {String} password
   */
  exports.prototype['password'] = undefined;
  /**
   * Csr user first name
   * @member {String} firstName
   */
  exports.prototype['firstName'] = undefined;
  /**
   * Csr user last name
   * @member {String} lastName
   */
  exports.prototype['lastName'] = undefined;
  /**
   * Csr user full name
   * @member {String} fullName
   */
  exports.prototype['fullName'] = undefined;
  /**
   * Csr user email
   * @member {String} email
   */
  exports.prototype['email'] = undefined;
  /**
   * Csr user created date
   * @member {Date} createdDate
   */
  exports.prototype['createdDate'] = undefined;
  /**
   * Csr user created id
   * @member {String} createdBy
   */
  exports.prototype['createdBy'] = undefined;
  /**
   * Csr user Updated date
   * @member {Date} updatedDate
   */
  exports.prototype['updatedDate'] = undefined;
  /**
   * Csr user Updated by
   * @member {String} updatedBy
   */
  exports.prototype['updatedBy'] = undefined;
  /**
   * Csr Profile Image
   * @member {module:model/ProfileImage} csrImage
   */
  exports.prototype['csrImage'] = undefined;
  /**
   * Csr User Status
   * @member {Number} status
   */
  exports.prototype['status'] = undefined;
  /**
   * Csr User Note
   * @member {String} note
   */
  exports.prototype['note'] = undefined;
  /**
   * Last Login
   * @member {Date} lastLogin
   */
  exports.prototype['lastLogin'] = undefined;



  return exports;
}));


