/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.EmailTemplate = factory(root.PhonespeakApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The EmailTemplate model module.
   * @module model/EmailTemplate
   * @version v2
   */

  /**
   * Constructs a new <code>EmailTemplate</code>.
   * The Email Template Object
   * @alias module:model/EmailTemplate
   * @class
   */
  var exports = function() {
    var _this = this;











  };

  /**
   * Constructs a <code>EmailTemplate</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/EmailTemplate} obj Optional instance to populate.
   * @return {module:model/EmailTemplate} The populated <code>EmailTemplate</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('event')) {
        obj['event'] = ApiClient.convertToType(data['event'], 'String');
      }
      if (data.hasOwnProperty('emailSubject')) {
        obj['emailSubject'] = ApiClient.convertToType(data['emailSubject'], 'String');
      }
      if (data.hasOwnProperty('fromEmail')) {
        obj['fromEmail'] = ApiClient.convertToType(data['fromEmail'], 'String');
      }
      if (data.hasOwnProperty('ccEmails')) {
        obj['ccEmails'] = ApiClient.convertToType(data['ccEmails'], 'String');
      }
      if (data.hasOwnProperty('bccEmails')) {
        obj['bccEmails'] = ApiClient.convertToType(data['bccEmails'], 'String');
      }
      if (data.hasOwnProperty('bodyContents')) {
        obj['bodyContents'] = ApiClient.convertToType(data['bodyContents'], 'String');
      }
      if (data.hasOwnProperty('isDefault')) {
        obj['isDefault'] = ApiClient.convertToType(data['isDefault'], 'Boolean');
      }
      if (data.hasOwnProperty('resellerId')) {
        obj['resellerId'] = ApiClient.convertToType(data['resellerId'], 'String');
      }
      if (data.hasOwnProperty('createdDate')) {
        obj['createdDate'] = ApiClient.convertToType(data['createdDate'], 'Date');
      }
    }
    return obj;
  }

  /**
   * Email template id
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Event of the email for specific content
   * @member {String} event
   */
  exports.prototype['event'] = undefined;
  /**
   * Subect of email
   * @member {String} emailSubject
   */
  exports.prototype['emailSubject'] = undefined;
  /**
   * From email address
   * @member {String} fromEmail
   */
  exports.prototype['fromEmail'] = undefined;
  /**
   * CC email addresses
   * @member {String} ccEmails
   */
  exports.prototype['ccEmails'] = undefined;
  /**
   * BCC email addresses
   * @member {String} bccEmails
   */
  exports.prototype['bccEmails'] = undefined;
  /**
   * Email body contents
   * @member {String} bodyContents
   */
  exports.prototype['bodyContents'] = undefined;
  /**
   * Is Default?
   * @member {Boolean} isDefault
   */
  exports.prototype['isDefault'] = undefined;
  /**
   * Reseller Id
   * @member {String} resellerId
   */
  exports.prototype['resellerId'] = undefined;
  /**
   * Created Date
   * @member {Date} createdDate
   */
  exports.prototype['createdDate'] = undefined;



  return exports;
}));


