/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/MessageDetail'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./MessageDetail'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.IncomingMessage = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.MessageDetail);
  }
}(this, function(ApiClient, MessageDetail) {
  'use strict';




  /**
   * The IncomingMessage model module.
   * @module model/IncomingMessage
   * @version v2
   */

  /**
   * Constructs a new <code>IncomingMessage</code>.
   * @alias module:model/IncomingMessage
   * @class
   */
  var exports = function() {
    var _this = this;










  };

  /**
   * Constructs a <code>IncomingMessage</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/IncomingMessage} obj Optional instance to populate.
   * @return {module:model/IncomingMessage} The populated <code>IncomingMessage</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('time')) {
        obj['time'] = ApiClient.convertToType(data['time'], 'Date');
      }
      if (data.hasOwnProperty('senderOwnerId')) {
        obj['senderOwnerId'] = ApiClient.convertToType(data['senderOwnerId'], 'String');
      }
      if (data.hasOwnProperty('senderAccountId')) {
        obj['senderAccountId'] = ApiClient.convertToType(data['senderAccountId'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('receiverOwnerId')) {
        obj['receiverOwnerId'] = ApiClient.convertToType(data['receiverOwnerId'], 'String');
      }
      if (data.hasOwnProperty('receiverAccountId')) {
        obj['receiverAccountId'] = ApiClient.convertToType(data['receiverAccountId'], 'String');
      }
      if (data.hasOwnProperty('message')) {
        obj['message'] = MessageDetail.constructFromObject(data['message']);
      }
    }
    return obj;
  }

  /**
   * 
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * The Event type
   * @member {String} type
   */
  exports.prototype['type'] = undefined;
  /**
   * The time of the event described in the receipt
   * @member {Date} time
   */
  exports.prototype['time'] = undefined;
  /**
   * Sender ownerId
   * @member {String} senderOwnerId
   */
  exports.prototype['senderOwnerId'] = undefined;
  /**
   * Sender account id
   * @member {String} senderAccountId
   */
  exports.prototype['senderAccountId'] = undefined;
  /**
   * A detailed description of the event described by the receipt
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * Receiver Owner Id
   * @member {String} receiverOwnerId
   */
  exports.prototype['receiverOwnerId'] = undefined;
  /**
   * Receiver Account Id
   * @member {String} receiverAccountId
   */
  exports.prototype['receiverAccountId'] = undefined;
  /**
   * Any string, it will be included in the callback events of the message.
   * @member {module:model/MessageDetail} message
   */
  exports.prototype['message'] = undefined;



  return exports;
}));


