/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/InvoiceItem'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./InvoiceItem'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.Invoice = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.InvoiceItem);
  }
}(this, function(ApiClient, InvoiceItem) {
  'use strict';




  /**
   * The Invoice model module.
   * @module model/Invoice
   * @version v2
   */

  /**
   * Constructs a new <code>Invoice</code>.
   * Invoice object
   * @alias module:model/Invoice
   * @class
   */
  var exports = function() {
    var _this = this;






























  };

  /**
   * Constructs a <code>Invoice</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Invoice} obj Optional instance to populate.
   * @return {module:model/Invoice} The populated <code>Invoice</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('accountId')) {
        obj['accountId'] = ApiClient.convertToType(data['accountId'], 'String');
      }
      if (data.hasOwnProperty('stripeInvoiceId')) {
        obj['stripeInvoiceId'] = ApiClient.convertToType(data['stripeInvoiceId'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('statementDescription')) {
        obj['statementDescription'] = ApiClient.convertToType(data['statementDescription'], 'String');
      }
      if (data.hasOwnProperty('amountDue')) {
        obj['amountDue'] = ApiClient.convertToType(data['amountDue'], 'Number');
      }
      if (data.hasOwnProperty('amountPaid')) {
        obj['amountPaid'] = ApiClient.convertToType(data['amountPaid'], 'Number');
      }
      if (data.hasOwnProperty('amountRemaining')) {
        obj['amountRemaining'] = ApiClient.convertToType(data['amountRemaining'], 'Number');
      }
      if (data.hasOwnProperty('applicationFee')) {
        obj['applicationFee'] = ApiClient.convertToType(data['applicationFee'], 'Number');
      }
      if (data.hasOwnProperty('subtotal')) {
        obj['subtotal'] = ApiClient.convertToType(data['subtotal'], 'Number');
      }
      if (data.hasOwnProperty('tax')) {
        obj['tax'] = ApiClient.convertToType(data['tax'], 'Number');
      }
      if (data.hasOwnProperty('taxPercent')) {
        obj['taxPercent'] = ApiClient.convertToType(data['taxPercent'], 'Number');
      }
      if (data.hasOwnProperty('total')) {
        obj['total'] = ApiClient.convertToType(data['total'], 'Number');
      }
      if (data.hasOwnProperty('totalInDecimal')) {
        obj['totalInDecimal'] = ApiClient.convertToType(data['totalInDecimal'], 'Number');
      }
      if (data.hasOwnProperty('billingReason')) {
        obj['billingReason'] = ApiClient.convertToType(data['billingReason'], 'String');
      }
      if (data.hasOwnProperty('chargeId')) {
        obj['chargeId'] = ApiClient.convertToType(data['chargeId'], 'String');
      }
      if (data.hasOwnProperty('currency')) {
        obj['currency'] = ApiClient.convertToType(data['currency'], 'String');
      }
      if (data.hasOwnProperty('attemptCount')) {
        obj['attemptCount'] = ApiClient.convertToType(data['attemptCount'], 'Number');
      }
      if (data.hasOwnProperty('isAttempted')) {
        obj['isAttempted'] = ApiClient.convertToType(data['isAttempted'], 'Boolean');
      }
      if (data.hasOwnProperty('isPaid')) {
        obj['isPaid'] = ApiClient.convertToType(data['isPaid'], 'Boolean');
      }
      if (data.hasOwnProperty('isDeleted')) {
        obj['isDeleted'] = ApiClient.convertToType(data['isDeleted'], 'Boolean');
      }
      if (data.hasOwnProperty('invoicePdf')) {
        obj['invoicePdf'] = ApiClient.convertToType(data['invoicePdf'], 'String');
      }
      if (data.hasOwnProperty('dueDate')) {
        obj['dueDate'] = ApiClient.convertToType(data['dueDate'], 'Date');
      }
      if (data.hasOwnProperty('periodEnd')) {
        obj['periodEnd'] = ApiClient.convertToType(data['periodEnd'], 'Date');
      }
      if (data.hasOwnProperty('periodStart')) {
        obj['periodStart'] = ApiClient.convertToType(data['periodStart'], 'Date');
      }
      if (data.hasOwnProperty('invoiceDate')) {
        obj['invoiceDate'] = ApiClient.convertToType(data['invoiceDate'], 'Date');
      }
      if (data.hasOwnProperty('invoiceItem')) {
        obj['invoiceItem'] = ApiClient.convertToType(data['invoiceItem'], [InvoiceItem]);
      }
      if (data.hasOwnProperty('createdDate')) {
        obj['createdDate'] = ApiClient.convertToType(data['createdDate'], 'Date');
      }
      if (data.hasOwnProperty('updatedDate')) {
        obj['updatedDate'] = ApiClient.convertToType(data['updatedDate'], 'Date');
      }
    }
    return obj;
  }

  /**
   * Invoice Id
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Account Id
   * @member {String} accountId
   */
  exports.prototype['accountId'] = undefined;
  /**
   * Stripe Invoice Id
   * @member {String} stripeInvoiceId
   */
  exports.prototype['stripeInvoiceId'] = undefined;
  /**
   * Invoice description
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * Extra information about a charge for the customer’s credit card statement.  It must contain at least one letter. If not specified and this invoice is part of a subscription
   * @member {String} statementDescription
   */
  exports.prototype['statementDescription'] = undefined;
  /**
   * Invoice amount due
   * @member {Number} amountDue
   */
  exports.prototype['amountDue'] = undefined;
  /**
   * Invoice amount paid
   * @member {Number} amountPaid
   */
  exports.prototype['amountPaid'] = undefined;
  /**
   * Invoice amount remaining
   * @member {Number} amountRemaining
   */
  exports.prototype['amountRemaining'] = undefined;
  /**
   * Invoice application fee
   * @member {Number} applicationFee
   */
  exports.prototype['applicationFee'] = undefined;
  /**
   * Invoice subtotal
   * @member {Number} subtotal
   */
  exports.prototype['subtotal'] = undefined;
  /**
   * Invoice tax
   * @member {Number} tax
   */
  exports.prototype['tax'] = undefined;
  /**
   * Invoice tax percent
   * @member {Number} taxPercent
   */
  exports.prototype['taxPercent'] = undefined;
  /**
   * Invoice total
   * @member {Number} total
   */
  exports.prototype['total'] = undefined;
  /**
   * Invoice total in decimal
   * @member {Number} totalInDecimal
   */
  exports.prototype['totalInDecimal'] = undefined;
  /**
   * Invoice billing reason
   * @member {String} billingReason
   */
  exports.prototype['billingReason'] = undefined;
  /**
   * Invoice charge id
   * @member {String} chargeId
   */
  exports.prototype['chargeId'] = undefined;
  /**
   * Invoice currency
   * @member {String} currency
   */
  exports.prototype['currency'] = undefined;
  /**
   * Invoice attempt paid count
   * @member {Number} attemptCount
   */
  exports.prototype['attemptCount'] = undefined;
  /**
   * Invoice attempted
   * @member {Boolean} isAttempted
   */
  exports.prototype['isAttempted'] = undefined;
  /**
   * Invoice is paid
   * @member {Boolean} isPaid
   */
  exports.prototype['isPaid'] = undefined;
  /**
   * Invoice is delete
   * @member {Boolean} isDeleted
   */
  exports.prototype['isDeleted'] = undefined;
  /**
   * Invoice pdf url
   * @member {String} invoicePdf
   */
  exports.prototype['invoicePdf'] = undefined;
  /**
   * Invoice due date
   * @member {Date} dueDate
   */
  exports.prototype['dueDate'] = undefined;
  /**
   * Invoice period end
   * @member {Date} periodEnd
   */
  exports.prototype['periodEnd'] = undefined;
  /**
   * Invoice period start
   * @member {Date} periodStart
   */
  exports.prototype['periodStart'] = undefined;
  /**
   * Invoice created date
   * @member {Date} invoiceDate
   */
  exports.prototype['invoiceDate'] = undefined;
  /**
   * Invoice plan
   * @member {Array.<module:model/InvoiceItem>} invoiceItem
   */
  exports.prototype['invoiceItem'] = undefined;
  /**
   * Invoice created date
   * @member {Date} createdDate
   */
  exports.prototype['createdDate'] = undefined;
  /**
   * Invoice created date
   * @member {Date} updatedDate
   */
  exports.prototype['updatedDate'] = undefined;



  return exports;
}));


