/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ChatFile', 'model/Conversation'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ChatFile'), require('./Conversation'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.Message = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.ChatFile, root.PhonespeakApi.Conversation);
  }
}(this, function(ApiClient, ChatFile, Conversation) {
  'use strict';




  /**
   * The Message model module.
   * @module model/Message
   * @version v2
   */

  /**
   * Constructs a new <code>Message</code>.
   * Conversation Message object
   * @alias module:model/Message
   * @class
   */
  var exports = function() {
    var _this = this;
















  };

  /**
   * Constructs a <code>Message</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Message} obj Optional instance to populate.
   * @return {module:model/Message} The populated <code>Message</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('sender')) {
        obj['sender'] = ApiClient.convertToType(data['sender'], 'String');
      }
      if (data.hasOwnProperty('senderId')) {
        obj['senderId'] = ApiClient.convertToType(data['senderId'], 'String');
      }
      if (data.hasOwnProperty('senderImage')) {
        obj['senderImage'] = ApiClient.convertToType(data['senderImage'], 'String');
      }
      if (data.hasOwnProperty('isOwner')) {
        obj['isOwner'] = ApiClient.convertToType(data['isOwner'], 'Boolean');
      }
      if (data.hasOwnProperty('isSenderDeleted')) {
        obj['isSenderDeleted'] = ApiClient.convertToType(data['isSenderDeleted'], 'Boolean');
      }
      if (data.hasOwnProperty('content')) {
        obj['content'] = ApiClient.convertToType(data['content'], 'String');
      }
      if (data.hasOwnProperty('medias')) {
        obj['medias'] = ApiClient.convertToType(data['medias'], [ChatFile]);
      }
      if (data.hasOwnProperty('groupId')) {
        obj['groupId'] = ApiClient.convertToType(data['groupId'], 'String');
      }
      if (data.hasOwnProperty('contentType')) {
        obj['contentType'] = ApiClient.convertToType(data['contentType'], 'String');
      }
      if (data.hasOwnProperty('dispositionNotification')) {
        obj['dispositionNotification'] = ApiClient.convertToType(data['dispositionNotification'], 'String');
      }
      if (data.hasOwnProperty('conversations')) {
        obj['conversations'] = ApiClient.convertToType(data['conversations'], [Conversation]);
      }
      if (data.hasOwnProperty('deleted')) {
        obj['deleted'] = ApiClient.convertToType(data['deleted'], 'Boolean');
      }
      if (data.hasOwnProperty('read')) {
        obj['read'] = ApiClient.convertToType(data['read'], ['String']);
      }
      if (data.hasOwnProperty('createdDate')) {
        obj['createdDate'] = ApiClient.convertToType(data['createdDate'], 'Date');
      }
    }
    return obj;
  }

  /**
   * Message Id
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * The sender of the message
   * @member {String} sender
   */
  exports.prototype['sender'] = undefined;
  /**
   * The Sender Id of the message
   * @member {String} senderId
   */
  exports.prototype['senderId'] = undefined;
  /**
   * Sender Image
   * @member {String} senderImage
   */
  exports.prototype['senderImage'] = undefined;
  /**
   * Is Owner
   * @member {Boolean} isOwner
   */
  exports.prototype['isOwner'] = undefined;
  /**
   * Is Sender Deleted
   * @member {Boolean} isSenderDeleted
   */
  exports.prototype['isSenderDeleted'] = undefined;
  /**
   * Message content
   * @member {String} content
   */
  exports.prototype['content'] = undefined;
  /**
   * Media's content
   * @member {Array.<module:model/ChatFile>} medias
   */
  exports.prototype['medias'] = undefined;
  /**
   * Group Id
   * @member {String} groupId
   */
  exports.prototype['groupId'] = undefined;
  /**
   * Content type for cloudSoftPhone
   * @member {String} contentType
   */
  exports.prototype['contentType'] = undefined;
  /**
   * Disposition notification for cloudSoftPhone
   * @member {String} dispositionNotification
   */
  exports.prototype['dispositionNotification'] = undefined;
  /**
   * List of related conversations
   * @member {Array.<module:model/Conversation>} conversations
   */
  exports.prototype['conversations'] = undefined;
  /**
   * Is Deleted List
   * @member {Boolean} deleted
   */
  exports.prototype['deleted'] = undefined;
  /**
   * Is Read List
   * @member {Array.<String>} read
   */
  exports.prototype['read'] = undefined;
  /**
   * Conversation created date
   * @member {Date} createdDate
   */
  exports.prototype['createdDate'] = undefined;



  return exports;
}));


