/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.MessageDetail = factory(root.PhonespeakApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The MessageDetail model module.
   * @module model/MessageDetail
   * @version v2
   */

  /**
   * Constructs a new <code>MessageDetail</code>.
   * @alias module:model/MessageDetail
   * @class
   */
  var exports = function() {
    var _this = this;











  };

  /**
   * Constructs a <code>MessageDetail</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/MessageDetail} obj Optional instance to populate.
   * @return {module:model/MessageDetail} The populated <code>MessageDetail</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('time')) {
        obj['time'] = ApiClient.convertToType(data['time'], 'Date');
      }
      if (data.hasOwnProperty('to')) {
        obj['to'] = ApiClient.convertToType(data['to'], ['String']);
      }
      if (data.hasOwnProperty('from')) {
        obj['from'] = ApiClient.convertToType(data['from'], 'String');
      }
      if (data.hasOwnProperty('text')) {
        obj['text'] = ApiClient.convertToType(data['text'], 'String');
      }
      if (data.hasOwnProperty('applicationId')) {
        obj['applicationId'] = ApiClient.convertToType(data['applicationId'], 'String');
      }
      if (data.hasOwnProperty('media')) {
        obj['media'] = ApiClient.convertToType(data['media'], ['String']);
      }
      if (data.hasOwnProperty('owner')) {
        obj['owner'] = ApiClient.convertToType(data['owner'], 'String');
      }
      if (data.hasOwnProperty('direction')) {
        obj['direction'] = ApiClient.convertToType(data['direction'], 'String');
      }
      if (data.hasOwnProperty('segmentCount')) {
        obj['segmentCount'] = ApiClient.convertToType(data['segmentCount'], 'Number');
      }
    }
    return obj;
  }

  /**
   * The unique ID of this message
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * The time stamp of when message was created
   * @member {Date} time
   */
  exports.prototype['time'] = undefined;
  /**
   * The phone number (or numbers) the message the message is sent to. On a POST, this can be a String, or an array of one or more numbers. In all other places, this will be an array.
   * @member {Array.<String>} to
   */
  exports.prototype['to'] = undefined;
  /**
   * The phone number the message was sent from
   * @member {String} from
   */
  exports.prototype['from'] = undefined;
  /**
   * The text content of the message
   * @member {String} text
   */
  exports.prototype['text'] = undefined;
  /**
   * The ID of the Application your from number is associated with in the Bandwidth Phone Number Dashboard.
   * @member {String} applicationId
   */
  exports.prototype['applicationId'] = undefined;
  /**
   * A list of URLs to include as media attachments as part of the message.
   * @member {Array.<String>} media
   */
  exports.prototype['media'] = undefined;
  /**
   *  The phone number this particular message is associated with.   For an outbound message, this is always the from number.   For an inbound message, this will be (one of) the to number(s).  For instance, if this is an inbound group message, the owner field will be set to the to number that this particular copy of the group message belongs to.
   * @member {String} owner
   */
  exports.prototype['owner'] = undefined;
  /**
   * Whether the message was sent from Bandwidth, or received by a Bandwidth number
   * @member {String} direction
   */
  exports.prototype['direction'] = undefined;
  /**
   *  This indicates the number of segments the original message from the user is broken into before sending over to carrier networks. Segmentation of messages depends on the size and encoding. Bandwidth will segment the message if the character count is over the below limits:  - 160 for GSM-7  - 70 for UCS-2  For MMS messages the segment count will always be set to 1
   * @member {Number} segmentCount
   */
  exports.prototype['segmentCount'] = undefined;



  return exports;
}));


