/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Charges', 'model/Item', 'model/OrderPaymentInfo', 'model/ShippingInfo'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Charges'), require('./Item'), require('./OrderPaymentInfo'), require('./ShippingInfo'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.Order = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.Charges, root.PhonespeakApi.Item, root.PhonespeakApi.OrderPaymentInfo, root.PhonespeakApi.ShippingInfo);
  }
}(this, function(ApiClient, Charges, Item, OrderPaymentInfo, ShippingInfo) {
  'use strict';




  /**
   * The Order model module.
   * @module model/Order
   * @version v2
   */

  /**
   * Constructs a new <code>Order</code>.
   * Order objects
   * @alias module:model/Order
   * @class
   */
  var exports = function() {
    var _this = this;


















  };

  /**
   * Constructs a <code>Order</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Order} obj Optional instance to populate.
   * @return {module:model/Order} The populated <code>Order</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('trackingLink')) {
        obj['trackingLink'] = ApiClient.convertToType(data['trackingLink'], 'String');
      }
      if (data.hasOwnProperty('referenceId')) {
        obj['referenceId'] = ApiClient.convertToType(data['referenceId'], 'String');
      }
      if (data.hasOwnProperty('accountId')) {
        obj['accountId'] = ApiClient.convertToType(data['accountId'], 'String');
      }
      if (data.hasOwnProperty('orderBy')) {
        obj['orderBy'] = ApiClient.convertToType(data['orderBy'], 'String');
      }
      if (data.hasOwnProperty('ordererName')) {
        obj['ordererName'] = ApiClient.convertToType(data['ordererName'], 'String');
      }
      if (data.hasOwnProperty('ordererContactNumber')) {
        obj['ordererContactNumber'] = ApiClient.convertToType(data['ordererContactNumber'], 'String');
      }
      if (data.hasOwnProperty('ordererEmail')) {
        obj['ordererEmail'] = ApiClient.convertToType(data['ordererEmail'], 'String');
      }
      if (data.hasOwnProperty('createdDate')) {
        obj['createdDate'] = ApiClient.convertToType(data['createdDate'], 'Date');
      }
      if (data.hasOwnProperty('expectedDeliveredDate')) {
        obj['expectedDeliveredDate'] = ApiClient.convertToType(data['expectedDeliveredDate'], 'Date');
      }
      if (data.hasOwnProperty('items')) {
        obj['items'] = ApiClient.convertToType(data['items'], [Item]);
      }
      if (data.hasOwnProperty('payment')) {
        obj['payment'] = OrderPaymentInfo.constructFromObject(data['payment']);
      }
      if (data.hasOwnProperty('charges')) {
        obj['charges'] = Charges.constructFromObject(data['charges']);
      }
      if (data.hasOwnProperty('shipping')) {
        obj['shipping'] = ShippingInfo.constructFromObject(data['shipping']);
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'String');
      }
      if (data.hasOwnProperty('updatedDate')) {
        obj['updatedDate'] = ApiClient.convertToType(data['updatedDate'], 'Date');
      }
      if (data.hasOwnProperty('updatedBy')) {
        obj['updatedBy'] = ApiClient.convertToType(data['updatedBy'], 'String');
      }
    }
    return obj;
  }

  /**
   * Order's Id
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Shipment Tracking Link
   * @member {String} trackingLink
   */
  exports.prototype['trackingLink'] = undefined;
  /**
   * Reference Id
   * @member {String} referenceId
   */
  exports.prototype['referenceId'] = undefined;
  /**
   * Account Id
   * @member {String} accountId
   */
  exports.prototype['accountId'] = undefined;
  /**
   * Order By (Owner)
   * @member {String} orderBy
   */
  exports.prototype['orderBy'] = undefined;
  /**
   * Orderer Name
   * @member {String} ordererName
   */
  exports.prototype['ordererName'] = undefined;
  /**
   * Orderer Contact Number
   * @member {String} ordererContactNumber
   */
  exports.prototype['ordererContactNumber'] = undefined;
  /**
   * Orderer Email
   * @member {String} ordererEmail
   */
  exports.prototype['ordererEmail'] = undefined;
  /**
   * Created Date (Order's Date)
   * @member {Date} createdDate
   */
  exports.prototype['createdDate'] = undefined;
  /**
   * Expected Delivered Date
   * @member {Date} expectedDeliveredDate
   */
  exports.prototype['expectedDeliveredDate'] = undefined;
  /**
   * Item list
   * @member {Array.<module:model/Item>} items
   */
  exports.prototype['items'] = undefined;
  /**
   * Payment Info
   * @member {module:model/OrderPaymentInfo} payment
   */
  exports.prototype['payment'] = undefined;
  /**
   * Charges
   * @member {module:model/Charges} charges
   */
  exports.prototype['charges'] = undefined;
  /**
   * Shipping Info
   * @member {module:model/ShippingInfo} shipping
   */
  exports.prototype['shipping'] = undefined;
  /**
   * Status
   * @member {module:model/Order.StatusEnum} status
   */
  exports.prototype['status'] = undefined;
  /**
   * Order's updated date
   * @member {Date} updatedDate
   */
  exports.prototype['updatedDate'] = undefined;
  /**
   * Order's updated by
   * @member {String} updatedBy
   */
  exports.prototype['updatedBy'] = undefined;


  /**
   * Allowed values for the <code>status</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StatusEnum = {
    /**
     * value: "Pending"
     * @const
     */
    "Pending": "Pending",
    /**
     * value: "Confirmed"
     * @const
     */
    "Confirmed": "Confirmed",
    /**
     * value: "Processing"
     * @const
     */
    "Processing": "Processing",
    /**
     * value: "Shipping"
     * @const
     */
    "Shipping": "Shipping",
    /**
     * value: "Completed"
     * @const
     */
    "Completed": "Completed"  };


  return exports;
}));


