/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.PhoneNumber = factory(root.PhonespeakApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The PhoneNumber model module.
   * @module model/PhoneNumber
   * @version v2
   */

  /**
   * Constructs a new <code>PhoneNumber</code>.
   * Phone Number object
   * @alias module:model/PhoneNumber
   * @class
   */
  var exports = function() {
    var _this = this;



















  };

  /**
   * Constructs a <code>PhoneNumber</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PhoneNumber} obj Optional instance to populate.
   * @return {module:model/PhoneNumber} The populated <code>PhoneNumber</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('ownerId')) {
        obj['ownerId'] = ApiClient.convertToType(data['ownerId'], 'String');
      }
      if (data.hasOwnProperty('tenantId')) {
        obj['tenantId'] = ApiClient.convertToType(data['tenantId'], 'String');
      }
      if (data.hasOwnProperty('accountId')) {
        obj['accountId'] = ApiClient.convertToType(data['accountId'], 'String');
      }
      if (data.hasOwnProperty('extension')) {
        obj['extension'] = ApiClient.convertToType(data['extension'], 'String');
      }
      if (data.hasOwnProperty('number')) {
        obj['number'] = ApiClient.convertToType(data['number'], 'String');
      }
      if (data.hasOwnProperty('isTollFree')) {
        obj['isTollFree'] = ApiClient.convertToType(data['isTollFree'], 'Boolean');
      }
      if (data.hasOwnProperty('reservationId')) {
        obj['reservationId'] = ApiClient.convertToType(data['reservationId'], 'String');
      }
      if (data.hasOwnProperty('label')) {
        obj['label'] = ApiClient.convertToType(data['label'], 'String');
      }
      if (data.hasOwnProperty('provider')) {
        obj['provider'] = ApiClient.convertToType(data['provider'], 'String');
      }
      if (data.hasOwnProperty('numberId')) {
        obj['numberId'] = ApiClient.convertToType(data['numberId'], 'String');
      }
      if (data.hasOwnProperty('isFree')) {
        obj['isFree'] = ApiClient.convertToType(data['isFree'], 'Boolean');
      }
      if (data.hasOwnProperty('isDefault')) {
        obj['isDefault'] = ApiClient.convertToType(data['isDefault'], 'Boolean');
      }
      if (data.hasOwnProperty('isDeleted')) {
        obj['isDeleted'] = ApiClient.convertToType(data['isDeleted'], 'Boolean');
      }
      if (data.hasOwnProperty('createdDate')) {
        obj['createdDate'] = ApiClient.convertToType(data['createdDate'], 'Date');
      }
      if (data.hasOwnProperty('createdBy')) {
        obj['createdBy'] = ApiClient.convertToType(data['createdBy'], 'String');
      }
      if (data.hasOwnProperty('updatedDate')) {
        obj['updatedDate'] = ApiClient.convertToType(data['updatedDate'], 'Date');
      }
      if (data.hasOwnProperty('updatedBy')) {
        obj['updatedBy'] = ApiClient.convertToType(data['updatedBy'], 'String');
      }
    }
    return obj;
  }

  /**
   * Phone number Id
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Teammate id or Company Number Id
   * @member {String} ownerId
   */
  exports.prototype['ownerId'] = undefined;
  /**
   * Tenant Id
   * @member {String} tenantId
   */
  exports.prototype['tenantId'] = undefined;
  /**
   * Account Id
   * @member {String} accountId
   */
  exports.prototype['accountId'] = undefined;
  /**
   * Owner extension
   * @member {String} extension
   */
  exports.prototype['extension'] = undefined;
  /**
   * Phone number
   * @member {String} number
   */
  exports.prototype['number'] = undefined;
  /**
   * 1 = Local number  2 = Toll free number
   * @member {Boolean} isTollFree
   */
  exports.prototype['isTollFree'] = undefined;
  /**
   * Phone number's reservation Id
   * @member {String} reservationId
   */
  exports.prototype['reservationId'] = undefined;
  /**
   * Phone number's label
   * @member {String} label
   */
  exports.prototype['label'] = undefined;
  /**
   * Phone number's provider
   * @member {String} provider
   */
  exports.prototype['provider'] = undefined;
  /**
   * Number Id for Bandwidth
   * @member {String} numberId
   */
  exports.prototype['numberId'] = undefined;
  /**
   * Whether the phone number is excluded from stripe
   * @member {Boolean} isFree
   */
  exports.prototype['isFree'] = undefined;
  /**
   * Default Phone number
   * @member {Boolean} isDefault
   */
  exports.prototype['isDefault'] = undefined;
  /**
   * Is Deleted?
   * @member {Boolean} isDeleted
   */
  exports.prototype['isDeleted'] = undefined;
  /**
   * Phone number's creation date
   * @member {Date} createdDate
   */
  exports.prototype['createdDate'] = undefined;
  /**
   * Phone number's created by
   * @member {String} createdBy
   */
  exports.prototype['createdBy'] = undefined;
  /**
   * Phone number's updated date
   * @member {Date} updatedDate
   */
  exports.prototype['updatedDate'] = undefined;
  /**
   * Phone number's updated by
   * @member {String} updatedBy
   */
  exports.prototype['updatedBy'] = undefined;



  return exports;
}));


