/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BillingAddress', 'model/CreditCard'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./BillingAddress'), require('./CreditCard'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.SignupInfo = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.BillingAddress, root.PhonespeakApi.CreditCard);
  }
}(this, function(ApiClient, BillingAddress, CreditCard) {
  'use strict';




  /**
   * The SignupInfo model module.
   * @module model/SignupInfo
   * @version v2
   */

  /**
   * Constructs a new <code>SignupInfo</code>.
   * Sign up Info for account and teammate
   * @alias module:model/SignupInfo
   * @class
   */
  var exports = function() {
    var _this = this;

















  };

  /**
   * Constructs a <code>SignupInfo</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SignupInfo} obj Optional instance to populate.
   * @return {module:model/SignupInfo} The populated <code>SignupInfo</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('urlId')) {
        obj['urlId'] = ApiClient.convertToType(data['urlId'], 'String');
      }
      if (data.hasOwnProperty('email')) {
        obj['email'] = ApiClient.convertToType(data['email'], 'String');
      }
      if (data.hasOwnProperty('password')) {
        obj['password'] = ApiClient.convertToType(data['password'], 'String');
      }
      if (data.hasOwnProperty('firstName')) {
        obj['firstName'] = ApiClient.convertToType(data['firstName'], 'String');
      }
      if (data.hasOwnProperty('lastName')) {
        obj['lastName'] = ApiClient.convertToType(data['lastName'], 'String');
      }
      if (data.hasOwnProperty('country')) {
        obj['country'] = ApiClient.convertToType(data['country'], 'String');
      }
      if (data.hasOwnProperty('billingAddress')) {
        obj['billingAddress'] = BillingAddress.constructFromObject(data['billingAddress']);
      }
      if (data.hasOwnProperty('ipAddress')) {
        obj['ipAddress'] = ApiClient.convertToType(data['ipAddress'], 'String');
      }
      if (data.hasOwnProperty('reservationId')) {
        obj['reservationId'] = ApiClient.convertToType(data['reservationId'], 'String');
      }
      if (data.hasOwnProperty('phoneNumber')) {
        obj['phoneNumber'] = ApiClient.convertToType(data['phoneNumber'], 'String');
      }
      if (data.hasOwnProperty('phoneNumberProvider')) {
        obj['phoneNumberProvider'] = ApiClient.convertToType(data['phoneNumberProvider'], 'String');
      }
      if (data.hasOwnProperty('isTollFree')) {
        obj['isTollFree'] = ApiClient.convertToType(data['isTollFree'], 'Boolean');
      }
      if (data.hasOwnProperty('creditCard')) {
        obj['creditCard'] = CreditCard.constructFromObject(data['creditCard']);
      }
      if (data.hasOwnProperty('successUrl')) {
        obj['successUrl'] = ApiClient.convertToType(data['successUrl'], 'String');
      }
      if (data.hasOwnProperty('cancelUrl')) {
        obj['cancelUrl'] = ApiClient.convertToType(data['cancelUrl'], 'String');
      }
      if (data.hasOwnProperty('createdBy')) {
        obj['createdBy'] = ApiClient.convertToType(data['createdBy'], 'String');
      }
    }
    return obj;
  }

  /**
   * Url Id
   * @member {String} urlId
   */
  exports.prototype['urlId'] = undefined;
  /**
   * Teammate email
   * @member {String} email
   */
  exports.prototype['email'] = undefined;
  /**
   * Teammate password
   * @member {String} password
   */
  exports.prototype['password'] = undefined;
  /**
   * Teammate first name
   * @member {String} firstName
   */
  exports.prototype['firstName'] = undefined;
  /**
   * Teammate last name
   * @member {String} lastName
   */
  exports.prototype['lastName'] = undefined;
  /**
   * Country
   * @member {String} country
   */
  exports.prototype['country'] = undefined;
  /**
   * Billing Address
   * @member {module:model/BillingAddress} billingAddress
   */
  exports.prototype['billingAddress'] = undefined;
  /**
   * IP address
   * @member {String} ipAddress
   */
  exports.prototype['ipAddress'] = undefined;
  /**
   * Reservation Id for buy phone number
   * @member {String} reservationId
   */
  exports.prototype['reservationId'] = undefined;
  /**
   * Teammate's phone number
   * @member {String} phoneNumber
   */
  exports.prototype['phoneNumber'] = undefined;
  /**
   * Teammate's phone number provider
   * @member {String} phoneNumberProvider
   */
  exports.prototype['phoneNumberProvider'] = undefined;
  /**
   * Flag indicate is toll free number or not. True is toll free.
   * @member {Boolean} isTollFree
   */
  exports.prototype['isTollFree'] = undefined;
  /**
   * Stripe billing info
   * @member {module:model/CreditCard} creditCard
   */
  exports.prototype['creditCard'] = undefined;
  /**
   * Success url
   * @member {String} successUrl
   */
  exports.prototype['successUrl'] = undefined;
  /**
   * Cancel url
   * @member {String} cancelUrl
   */
  exports.prototype['cancelUrl'] = undefined;
  /**
   * Created By
   * @member {String} createdBy
   */
  exports.prototype['createdBy'] = undefined;



  return exports;
}));


