/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.SmsInbound = factory(root.PhonespeakApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The SmsInbound model module.
   * @module model/SmsInbound
   * @version v2
   */

  /**
   * Constructs a new <code>SmsInbound</code>.
   * Sms Inbound from Bandwidth
   * @alias module:model/SmsInbound
   * @class
   */
  var exports = function() {
    var _this = this;


















  };

  /**
   * Constructs a <code>SmsInbound</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SmsInbound} obj Optional instance to populate.
   * @return {module:model/SmsInbound} The populated <code>SmsInbound</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('eventType')) {
        obj['eventType'] = ApiClient.convertToType(data['eventType'], 'String');
      }
      if (data.hasOwnProperty('direction')) {
        obj['direction'] = ApiClient.convertToType(data['direction'], 'String');
      }
      if (data.hasOwnProperty('messageId')) {
        obj['messageId'] = ApiClient.convertToType(data['messageId'], 'String');
      }
      if (data.hasOwnProperty('messageUri')) {
        obj['messageUri'] = ApiClient.convertToType(data['messageUri'], 'String');
      }
      if (data.hasOwnProperty('from')) {
        obj['from'] = ApiClient.convertToType(data['from'], 'String');
      }
      if (data.hasOwnProperty('senderOwnerId')) {
        obj['senderOwnerId'] = ApiClient.convertToType(data['senderOwnerId'], 'String');
      }
      if (data.hasOwnProperty('senderAccountId')) {
        obj['senderAccountId'] = ApiClient.convertToType(data['senderAccountId'], 'String');
      }
      if (data.hasOwnProperty('to')) {
        obj['to'] = ApiClient.convertToType(data['to'], 'String');
      }
      if (data.hasOwnProperty('receiverOwnerId')) {
        obj['receiverOwnerId'] = ApiClient.convertToType(data['receiverOwnerId'], 'String');
      }
      if (data.hasOwnProperty('receiverAccountId')) {
        obj['receiverAccountId'] = ApiClient.convertToType(data['receiverAccountId'], 'String');
      }
      if (data.hasOwnProperty('text')) {
        obj['text'] = ApiClient.convertToType(data['text'], 'String');
      }
      if (data.hasOwnProperty('applicationId')) {
        obj['applicationId'] = ApiClient.convertToType(data['applicationId'], 'String');
      }
      if (data.hasOwnProperty('time')) {
        obj['time'] = ApiClient.convertToType(data['time'], 'Date');
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'String');
      }
      if (data.hasOwnProperty('media')) {
        obj['media'] = ApiClient.convertToType(data['media'], ['String']);
      }
      if (data.hasOwnProperty('deliveryReceipt')) {
        obj['deliveryReceipt'] = ApiClient.convertToType(data['deliveryReceipt'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * Sms Inbound Id
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Event type
   * @member {String} eventType
   */
  exports.prototype['eventType'] = undefined;
  /**
   * Direction
   * @member {String} direction
   */
  exports.prototype['direction'] = undefined;
  /**
   * Message Id for Bandwidth
   * @member {String} messageId
   */
  exports.prototype['messageId'] = undefined;
  /**
   * Message Uri
   * @member {String} messageUri
   */
  exports.prototype['messageUri'] = undefined;
  /**
   * Sender
   * @member {String} from
   */
  exports.prototype['from'] = undefined;
  /**
   * Sender ownerId
   * @member {String} senderOwnerId
   */
  exports.prototype['senderOwnerId'] = undefined;
  /**
   * Sender account id
   * @member {String} senderAccountId
   */
  exports.prototype['senderAccountId'] = undefined;
  /**
   * Receiver
   * @member {String} to
   */
  exports.prototype['to'] = undefined;
  /**
   * Receiver Owner Id
   * @member {String} receiverOwnerId
   */
  exports.prototype['receiverOwnerId'] = undefined;
  /**
   * Receiver Account Id
   * @member {String} receiverAccountId
   */
  exports.prototype['receiverAccountId'] = undefined;
  /**
   * Content
   * @member {String} text
   */
  exports.prototype['text'] = undefined;
  /**
   * Application Id
   * @member {String} applicationId
   */
  exports.prototype['applicationId'] = undefined;
  /**
   * Date the event trigger
   * @member {Date} time
   */
  exports.prototype['time'] = undefined;
  /**
   * Status of the message
   * @member {String} state
   */
  exports.prototype['state'] = undefined;
  /**
   * MMS Media url
   * @member {Array.<String>} media
   */
  exports.prototype['media'] = undefined;
  /**
   * Delivery Receipt
   * @member {Boolean} deliveryReceipt
   */
  exports.prototype['deliveryReceipt'] = undefined;



  return exports;
}));


