/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CouponDetail'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CouponDetail'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.StripeInfo = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.CouponDetail);
  }
}(this, function(ApiClient, CouponDetail) {
  'use strict';




  /**
   * The StripeInfo model module.
   * @module model/StripeInfo
   * @version v2
   */

  /**
   * Constructs a new <code>StripeInfo</code>.
   * Stripe Info object
   * @alias module:model/StripeInfo
   * @class
   */
  var exports = function() {
    var _this = this;























  };

  /**
   * Constructs a <code>StripeInfo</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/StripeInfo} obj Optional instance to populate.
   * @return {module:model/StripeInfo} The populated <code>StripeInfo</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('stripeId')) {
        obj['stripeId'] = ApiClient.convertToType(data['stripeId'], 'String');
      }
      if (data.hasOwnProperty('stripeEmail')) {
        obj['stripeEmail'] = ApiClient.convertToType(data['stripeEmail'], 'String');
      }
      if (data.hasOwnProperty('isTrial')) {
        obj['isTrial'] = ApiClient.convertToType(data['isTrial'], 'Boolean');
      }
      if (data.hasOwnProperty('stripeSubscriptionId')) {
        obj['stripeSubscriptionId'] = ApiClient.convertToType(data['stripeSubscriptionId'], 'String');
      }
      if (data.hasOwnProperty('urlId')) {
        obj['urlId'] = ApiClient.convertToType(data['urlId'], 'String');
      }
      if (data.hasOwnProperty('billInterval')) {
        obj['billInterval'] = ApiClient.convertToType(data['billInterval'], 'String');
      }
      if (data.hasOwnProperty('userLicensePlanId')) {
        obj['userLicensePlanId'] = ApiClient.convertToType(data['userLicensePlanId'], 'String');
      }
      if (data.hasOwnProperty('e911PlanId')) {
        obj['e911PlanId'] = ApiClient.convertToType(data['e911PlanId'], 'String');
      }
      if (data.hasOwnProperty('companyNumberPlanId')) {
        obj['companyNumberPlanId'] = ApiClient.convertToType(data['companyNumberPlanId'], 'String');
      }
      if (data.hasOwnProperty('deskphonePlanId')) {
        obj['deskphonePlanId'] = ApiClient.convertToType(data['deskphonePlanId'], 'String');
      }
      if (data.hasOwnProperty('teammateDIDPlanId')) {
        obj['teammateDIDPlanId'] = ApiClient.convertToType(data['teammateDIDPlanId'], 'String');
      }
      if (data.hasOwnProperty('regulatoryRecoveryPlanId')) {
        obj['regulatoryRecoveryPlanId'] = ApiClient.convertToType(data['regulatoryRecoveryPlanId'], 'String');
      }
      if (data.hasOwnProperty('packageId')) {
        obj['packageId'] = ApiClient.convertToType(data['packageId'], 'String');
      }
      if (data.hasOwnProperty('callLimit')) {
        obj['callLimit'] = ApiClient.convertToType(data['callLimit'], 'Number');
      }
      if (data.hasOwnProperty('smsLimit')) {
        obj['smsLimit'] = ApiClient.convertToType(data['smsLimit'], 'Number');
      }
      if (data.hasOwnProperty('smsOverageCharge')) {
        obj['smsOverageCharge'] = ApiClient.convertToType(data['smsOverageCharge'], 'Number');
      }
      if (data.hasOwnProperty('callOverageCharge')) {
        obj['callOverageCharge'] = ApiClient.convertToType(data['callOverageCharge'], 'Number');
      }
      if (data.hasOwnProperty('maxUser')) {
        obj['maxUser'] = ApiClient.convertToType(data['maxUser'], 'Number');
      }
      if (data.hasOwnProperty('isTier')) {
        obj['isTier'] = ApiClient.convertToType(data['isTier'], 'Boolean');
      }
      if (data.hasOwnProperty('invoiceCoupon')) {
        obj['invoiceCoupon'] = CouponDetail.constructFromObject(data['invoiceCoupon']);
      }
      if (data.hasOwnProperty('subscriptionCoupon')) {
        obj['subscriptionCoupon'] = CouponDetail.constructFromObject(data['subscriptionCoupon']);
      }
      if (data.hasOwnProperty('nextPackageId')) {
        obj['nextPackageId'] = ApiClient.convertToType(data['nextPackageId'], 'String');
      }
    }
    return obj;
  }

  /**
   * Stripe Id for company billing purpose
   * @member {String} stripeId
   */
  exports.prototype['stripeId'] = undefined;
  /**
   * Stripe email for company billing purpose
   * @member {String} stripeEmail
   */
  exports.prototype['stripeEmail'] = undefined;
  /**
   * This flag is indicate the account is under trial period
   * @member {Boolean} isTrial
   */
  exports.prototype['isTrial'] = undefined;
  /**
   * Stripe subscription id
   * @member {String} stripeSubscriptionId
   */
  exports.prototype['stripeSubscriptionId'] = undefined;
  /**
   * Url Id
   * @member {String} urlId
   */
  exports.prototype['urlId'] = undefined;
  /**
   * Bill Interval
   * @member {String} billInterval
   */
  exports.prototype['billInterval'] = undefined;
  /**
   * User Package plan
   * @member {String} userLicensePlanId
   */
  exports.prototype['userLicensePlanId'] = undefined;
  /**
   * E911 plan
   * @member {String} e911PlanId
   */
  exports.prototype['e911PlanId'] = undefined;
  /**
   * Company Number plan
   * @member {String} companyNumberPlanId
   */
  exports.prototype['companyNumberPlanId'] = undefined;
  /**
   * Deskphone plan
   * @member {String} deskphonePlanId
   */
  exports.prototype['deskphonePlanId'] = undefined;
  /**
   * TeammateDID Plan
   * @member {String} teammateDIDPlanId
   */
  exports.prototype['teammateDIDPlanId'] = undefined;
  /**
   * Regulatory Recovery Plan
   * @member {String} regulatoryRecoveryPlanId
   */
  exports.prototype['regulatoryRecoveryPlanId'] = undefined;
  /**
   * Stripe Product Id
   * @member {String} packageId
   */
  exports.prototype['packageId'] = undefined;
  /**
   * Call Limit
   * @member {Number} callLimit
   */
  exports.prototype['callLimit'] = undefined;
  /**
   * Sms Limit
   * @member {Number} smsLimit
   */
  exports.prototype['smsLimit'] = undefined;
  /**
   * Sms Overage Charge
   * @member {Number} smsOverageCharge
   */
  exports.prototype['smsOverageCharge'] = undefined;
  /**
   * Call Overage Charge
   * @member {Number} callOverageCharge
   */
  exports.prototype['callOverageCharge'] = undefined;
  /**
   * Max User
   * @member {Number} maxUser
   */
  exports.prototype['maxUser'] = undefined;
  /**
   * Tier Type
   * @member {Boolean} isTier
   */
  exports.prototype['isTier'] = undefined;
  /**
   * Invoice Coupon used by current account
   * @member {module:model/CouponDetail} invoiceCoupon
   */
  exports.prototype['invoiceCoupon'] = undefined;
  /**
   * Subscription Coupon used by current account
   * @member {module:model/CouponDetail} subscriptionCoupon
   */
  exports.prototype['subscriptionCoupon'] = undefined;
  /**
   * Next level Stripe product id tier product
   * @member {String} nextPackageId
   */
  exports.prototype['nextPackageId'] = undefined;



  return exports;
}));


