/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BusinessHour', 'model/E911Address', 'model/Greeting', 'model/LastLogin', 'model/MissedCallHandling', 'model/PhoneNumber', 'model/RingGroup'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./BusinessHour'), require('./E911Address'), require('./Greeting'), require('./LastLogin'), require('./MissedCallHandling'), require('./PhoneNumber'), require('./RingGroup'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.Teammate = factory(root.PhonespeakApi.ApiClient, root.PhonespeakApi.BusinessHour, root.PhonespeakApi.E911Address, root.PhonespeakApi.Greeting, root.PhonespeakApi.LastLogin, root.PhonespeakApi.MissedCallHandling, root.PhonespeakApi.PhoneNumber, root.PhonespeakApi.RingGroup);
  }
}(this, function(ApiClient, BusinessHour, E911Address, Greeting, LastLogin, MissedCallHandling, PhoneNumber, RingGroup) {
  'use strict';




  /**
   * The Teammate model module.
   * @module model/Teammate
   * @version v2
   */

  /**
   * Constructs a new <code>Teammate</code>.
   * The \&quot;Teammate\&quot; object
   * @alias module:model/Teammate
   * @class
   */
  var exports = function() {
    var _this = this;















































  };

  /**
   * Constructs a <code>Teammate</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Teammate} obj Optional instance to populate.
   * @return {module:model/Teammate} The populated <code>Teammate</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('accountId')) {
        obj['accountId'] = ApiClient.convertToType(data['accountId'], 'String');
      }
      if (data.hasOwnProperty('email')) {
        obj['email'] = ApiClient.convertToType(data['email'], 'String');
      }
      if (data.hasOwnProperty('password')) {
        obj['password'] = ApiClient.convertToType(data['password'], 'String');
      }
      if (data.hasOwnProperty('sipPassword')) {
        obj['sipPassword'] = ApiClient.convertToType(data['sipPassword'], 'String');
      }
      if (data.hasOwnProperty('conferenceId')) {
        obj['conferenceId'] = ApiClient.convertToType(data['conferenceId'], 'String');
      }
      if (data.hasOwnProperty('firstName')) {
        obj['firstName'] = ApiClient.convertToType(data['firstName'], 'String');
      }
      if (data.hasOwnProperty('lastName')) {
        obj['lastName'] = ApiClient.convertToType(data['lastName'], 'String');
      }
      if (data.hasOwnProperty('fullName')) {
        obj['fullName'] = ApiClient.convertToType(data['fullName'], 'String');
      }
      if (data.hasOwnProperty('title')) {
        obj['title'] = ApiClient.convertToType(data['title'], 'String');
      }
      if (data.hasOwnProperty('role')) {
        obj['role'] = ApiClient.convertToType(data['role'], 'Number');
      }
      if (data.hasOwnProperty('voicemailGreetings')) {
        obj['voicemailGreetings'] = ApiClient.convertToType(data['voicemailGreetings'], [Greeting]);
      }
      if (data.hasOwnProperty('e911Address')) {
        obj['e911Address'] = E911Address.constructFromObject(data['e911Address']);
      }
      if (data.hasOwnProperty('profileImage')) {
        obj['profileImage'] = ApiClient.convertToType(data['profileImage'], 'String');
      }
      if (data.hasOwnProperty('callerId')) {
        obj['callerId'] = ApiClient.convertToType(data['callerId'], 'String');
      }
      if (data.hasOwnProperty('smsUsage')) {
        obj['smsUsage'] = ApiClient.convertToType(data['smsUsage'], 'Number');
      }
      if (data.hasOwnProperty('callUsage')) {
        obj['callUsage'] = ApiClient.convertToType(data['callUsage'], 'Number');
      }
      if (data.hasOwnProperty('isFirstTime')) {
        obj['isFirstTime'] = ApiClient.convertToType(data['isFirstTime'], 'Boolean');
      }
      if (data.hasOwnProperty('isDeleted')) {
        obj['isDeleted'] = ApiClient.convertToType(data['isDeleted'], 'Boolean');
      }
      if (data.hasOwnProperty('isChangePassword')) {
        obj['isChangePassword'] = ApiClient.convertToType(data['isChangePassword'], 'Boolean');
      }
      if (data.hasOwnProperty('isEnableCallWaiting')) {
        obj['isEnableCallWaiting'] = ApiClient.convertToType(data['isEnableCallWaiting'], 'Boolean');
      }
      if (data.hasOwnProperty('number')) {
        obj['number'] = ApiClient.convertToType(data['number'], 'String');
      }
      if (data.hasOwnProperty('defaultCallerId')) {
        obj['defaultCallerId'] = ApiClient.convertToType(data['defaultCallerId'], 'String');
      }
      if (data.hasOwnProperty('phoneNumbers')) {
        obj['phoneNumbers'] = ApiClient.convertToType(data['phoneNumbers'], [PhoneNumber]);
      }
      if (data.hasOwnProperty('extension')) {
        obj['extension'] = ApiClient.convertToType(data['extension'], 'String');
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'Number');
      }
      if (data.hasOwnProperty('onlineStatus')) {
        obj['onlineStatus'] = ApiClient.convertToType(data['onlineStatus'], 'Number');
      }
      if (data.hasOwnProperty('isCompany')) {
        obj['isCompany'] = ApiClient.convertToType(data['isCompany'], 'Boolean');
      }
      if (data.hasOwnProperty('tags')) {
        obj['tags'] = ApiClient.convertToType(data['tags'], ['String']);
      }
      if (data.hasOwnProperty('dndTeam')) {
        obj['dndTeam'] = ApiClient.convertToType(data['dndTeam'], ['String']);
      }
      if (data.hasOwnProperty('ringGroup')) {
        obj['ringGroup'] = RingGroup.constructFromObject(data['ringGroup']);
      }
      if (data.hasOwnProperty('callForwarding')) {
        obj['callForwarding'] = ApiClient.convertToType(data['callForwarding'], 'String');
      }
      if (data.hasOwnProperty('voicemailPin')) {
        obj['voicemailPin'] = ApiClient.convertToType(data['voicemailPin'], 'String');
      }
      if (data.hasOwnProperty('callRecordingSetting')) {
        obj['callRecordingSetting'] = ApiClient.convertToType(data['callRecordingSetting'], 'String');
      }
      if (data.hasOwnProperty('callRecordingMessage')) {
        obj['callRecordingMessage'] = ApiClient.convertToType(data['callRecordingMessage'], 'Boolean');
      }
      if (data.hasOwnProperty('isVoicemailNotification')) {
        obj['isVoicemailNotification'] = ApiClient.convertToType(data['isVoicemailNotification'], 'Boolean');
      }
      if (data.hasOwnProperty('isIncludeVoicemail')) {
        obj['isIncludeVoicemail'] = ApiClient.convertToType(data['isIncludeVoicemail'], 'Boolean');
      }
      if (data.hasOwnProperty('missedCallHandling')) {
        obj['missedCallHandling'] = MissedCallHandling.constructFromObject(data['missedCallHandling']);
      }
      if (data.hasOwnProperty('businessHour')) {
        obj['businessHour'] = BusinessHour.constructFromObject(data['businessHour']);
      }
      if (data.hasOwnProperty('createdDate')) {
        obj['createdDate'] = ApiClient.convertToType(data['createdDate'], 'Date');
      }
      if (data.hasOwnProperty('createdBy')) {
        obj['createdBy'] = ApiClient.convertToType(data['createdBy'], 'String');
      }
      if (data.hasOwnProperty('updatedDate')) {
        obj['updatedDate'] = ApiClient.convertToType(data['updatedDate'], 'Date');
      }
      if (data.hasOwnProperty('updatedBy')) {
        obj['updatedBy'] = ApiClient.convertToType(data['updatedBy'], 'String');
      }
      if (data.hasOwnProperty('answered')) {
        obj['answered'] = ApiClient.convertToType(data['answered'], 'Number');
      }
      if (data.hasOwnProperty('lastUpdatedContactDate')) {
        obj['lastUpdatedContactDate'] = ApiClient.convertToType(data['lastUpdatedContactDate'], 'Date');
      }
      if (data.hasOwnProperty('lastLogins')) {
        obj['lastLogins'] = ApiClient.convertToType(data['lastLogins'], [LastLogin]);
      }
    }
    return obj;
  }

  /**
   * Teammate id
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Teammate's parent account id
   * @member {String} accountId
   */
  exports.prototype['accountId'] = undefined;
  /**
   * The teammate's email
   * @member {String} email
   */
  exports.prototype['email'] = undefined;
  /**
   * The teammate's password
   * @member {String} password
   */
  exports.prototype['password'] = undefined;
  /**
   * The teammate's portsip password
   * @member {String} sipPassword
   */
  exports.prototype['sipPassword'] = undefined;
  /**
   * Conference Id
   * @member {String} conferenceId
   */
  exports.prototype['conferenceId'] = undefined;
  /**
   * The teammate's first name
   * @member {String} firstName
   */
  exports.prototype['firstName'] = undefined;
  /**
   * The teammate's last name
   * @member {String} lastName
   */
  exports.prototype['lastName'] = undefined;
  /**
   * The teammate's full name
   * @member {String} fullName
   */
  exports.prototype['fullName'] = undefined;
  /**
   * The teammate's title
   * @member {String} title
   */
  exports.prototype['title'] = undefined;
  /**
   * The teammate's role  1 = Admin  2 = Standard User
   * @member {Number} role
   */
  exports.prototype['role'] = undefined;
  /**
   * The list of teammate's voicemail greetings
   * @member {Array.<module:model/Greeting>} voicemailGreetings
   */
  exports.prototype['voicemailGreetings'] = undefined;
  /**
   * The teammate's E911Address
   * @member {module:model/E911Address} e911Address
   */
  exports.prototype['e911Address'] = undefined;
  /**
   * The teammate's profile picture url
   * @member {String} profileImage
   */
  exports.prototype['profileImage'] = undefined;
  /**
   * The teammate's caller Id
   * @member {String} callerId
   */
  exports.prototype['callerId'] = undefined;
  /**
   * The teammate's total sms usage within a billing period
   * @member {Number} smsUsage
   */
  exports.prototype['smsUsage'] = undefined;
  /**
   * The teammate's total call usage within a billing period
   * @member {Number} callUsage
   */
  exports.prototype['callUsage'] = undefined;
  /**
   * Check if teammate is first time login to application
   * @member {Boolean} isFirstTime
   */
  exports.prototype['isFirstTime'] = undefined;
  /**
   * Indicate teammate is delete from system
   * @member {Boolean} isDeleted
   */
  exports.prototype['isDeleted'] = undefined;
  /**
   * Check if teammate require to change password when login
   * @member {Boolean} isChangePassword
   */
  exports.prototype['isChangePassword'] = undefined;
  /**
   * Check if teammate enable call waiting setting
   * @member {Boolean} isEnableCallWaiting
   */
  exports.prototype['isEnableCallWaiting'] = undefined;
  /**
   * Teammate's default phone number
   * @member {String} number
   */
  exports.prototype['number'] = undefined;
  /**
   * Teammate's default caller id
   * @member {String} defaultCallerId
   */
  exports.prototype['defaultCallerId'] = undefined;
  /**
   * Teammate's list of phone number
   * @member {Array.<module:model/PhoneNumber>} phoneNumbers
   */
  exports.prototype['phoneNumbers'] = undefined;
  /**
   * Teammate's extension
   * @member {String} extension
   */
  exports.prototype['extension'] = undefined;
  /**
   * Teammate's status  1 = Active  2 = Pending  3 = Suspend
   * @member {Number} status
   */
  exports.prototype['status'] = undefined;
  /**
   * Teammate's online status  1 = Online  2 = Away  3 = Do not disturb  4 = Invisible
   * @member {Number} onlineStatus
   */
  exports.prototype['onlineStatus'] = undefined;
  /**
   * Indicate is company or teammate. True = company.
   * @member {Boolean} isCompany
   */
  exports.prototype['isCompany'] = undefined;
  /**
   * Teammate's tags
   * @member {Array.<String>} tags
   */
  exports.prototype['tags'] = undefined;
  /**
   * Teammate's dnd team
   * @member {Array.<String>} dndTeam
   */
  exports.prototype['dndTeam'] = undefined;
  /**
   * Teammate's ring group
   * @member {module:model/RingGroup} ringGroup
   */
  exports.prototype['ringGroup'] = undefined;
  /**
   * Teammate's call forwarding to which number
   * @member {String} callForwarding
   */
  exports.prototype['callForwarding'] = undefined;
  /**
   * Teammate's voicemail's pin
   * @member {String} voicemailPin
   */
  exports.prototype['voicemailPin'] = undefined;
  /**
   * Teammate's call recording settings
   * @member {module:model/Teammate.CallRecordingSettingEnum} callRecordingSetting
   */
  exports.prototype['callRecordingSetting'] = undefined;
  /**
   * Teammate's call recording settings
   * @member {Boolean} callRecordingMessage
   */
  exports.prototype['callRecordingMessage'] = undefined;
  /**
   * Teammate's receive voicemail email notification
   * @member {Boolean} isVoicemailNotification
   */
  exports.prototype['isVoicemailNotification'] = undefined;
  /**
   * The flag of innclude voicemails in email notification
   * @member {Boolean} isIncludeVoicemail
   */
  exports.prototype['isIncludeVoicemail'] = undefined;
  /**
   * Teammate's miss call routing setting
   * @member {module:model/MissedCallHandling} missedCallHandling
   */
  exports.prototype['missedCallHandling'] = undefined;
  /**
   * Teammate Business Hour
   * @member {module:model/BusinessHour} businessHour
   */
  exports.prototype['businessHour'] = undefined;
  /**
   * Teammate's creation date
   * @member {Date} createdDate
   */
  exports.prototype['createdDate'] = undefined;
  /**
   * Teammate's created by
   * @member {String} createdBy
   */
  exports.prototype['createdBy'] = undefined;
  /**
   * Teammate's updated date
   * @member {Date} updatedDate
   */
  exports.prototype['updatedDate'] = undefined;
  /**
   * Teammate's updated by
   * @member {String} updatedBy
   */
  exports.prototype['updatedBy'] = undefined;
  /**
   * call answered
   * @member {Number} answered
   */
  exports.prototype['answered'] = undefined;
  /**
   * Teammate's Last Updated Contact Date for CloudSoftPhone
   * @member {Date} lastUpdatedContactDate
   */
  exports.prototype['lastUpdatedContactDate'] = undefined;
  /**
   * Teammate Last Login Detail
   * @member {Array.<module:model/LastLogin>} lastLogins
   */
  exports.prototype['lastLogins'] = undefined;


  /**
   * Allowed values for the <code>callRecordingSetting</code> property.
   * @enum {String}
   * @readonly
   */
  exports.CallRecordingSettingEnum = {
    /**
     * value: "None"
     * @const
     */
    "None": "None",
    /**
     * value: "IncomingCalls"
     * @const
     */
    "IncomingCalls": "IncomingCalls",
    /**
     * value: "OutgoingCalls"
     * @const
     */
    "OutgoingCalls": "OutgoingCalls",
    /**
     * value: "AllCalls"
     * @const
     */
    "AllCalls": "AllCalls"  };


  return exports;
}));


