/**
 * phonespeak api
 * PhoneSpeak API v2
 *
 * OpenAPI spec version: v2
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.PhonespeakApi) {
      root.PhonespeakApi = {};
    }
    root.PhonespeakApi.Voicemail = factory(root.PhonespeakApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Voicemail model module.
   * @module model/Voicemail
   * @version v2
   */

  /**
   * Constructs a new <code>Voicemail</code>.
   * The \&quot;Voicemail\&quot; object
   * @alias module:model/Voicemail
   * @class
   */
  var exports = function() {
    var _this = this;



















  };

  /**
   * Constructs a <code>Voicemail</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Voicemail} obj Optional instance to populate.
   * @return {module:model/Voicemail} The populated <code>Voicemail</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('cdrId')) {
        obj['cdrId'] = ApiClient.convertToType(data['cdrId'], 'String');
      }
      if (data.hasOwnProperty('profileImage')) {
        obj['profileImage'] = ApiClient.convertToType(data['profileImage'], 'String');
      }
      if (data.hasOwnProperty('transcribe')) {
        obj['transcribe'] = ApiClient.convertToType(data['transcribe'], 'String');
      }
      if (data.hasOwnProperty('accountId')) {
        obj['accountId'] = ApiClient.convertToType(data['accountId'], 'String');
      }
      if (data.hasOwnProperty('participantType')) {
        obj['participantType'] = ApiClient.convertToType(data['participantType'], 'Number');
      }
      if (data.hasOwnProperty('participantId')) {
        obj['participantId'] = ApiClient.convertToType(data['participantId'], 'String');
      }
      if (data.hasOwnProperty('participantName')) {
        obj['participantName'] = ApiClient.convertToType(data['participantName'], 'String');
      }
      if (data.hasOwnProperty('from')) {
        obj['from'] = ApiClient.convertToType(data['from'], 'String');
      }
      if (data.hasOwnProperty('callerOwnerId')) {
        obj['callerOwnerId'] = ApiClient.convertToType(data['callerOwnerId'], 'String');
      }
      if (data.hasOwnProperty('url')) {
        obj['url'] = ApiClient.convertToType(data['url'], 'String');
      }
      if (data.hasOwnProperty('duration')) {
        obj['duration'] = ApiClient.convertToType(data['duration'], 'Number');
      }
      if (data.hasOwnProperty('referenceId')) {
        obj['referenceId'] = ApiClient.convertToType(data['referenceId'], 'String');
      }
      if (data.hasOwnProperty('ownerId')) {
        obj['ownerId'] = ApiClient.convertToType(data['ownerId'], 'String');
      }
      if (data.hasOwnProperty('isRead')) {
        obj['isRead'] = ApiClient.convertToType(data['isRead'], 'Boolean');
      }
      if (data.hasOwnProperty('read')) {
        obj['read'] = ApiClient.convertToType(data['read'], ['String']);
      }
      if (data.hasOwnProperty('createdDate')) {
        obj['createdDate'] = ApiClient.convertToType(data['createdDate'], 'Date');
      }
      if (data.hasOwnProperty('isExtensionCall')) {
        obj['isExtensionCall'] = ApiClient.convertToType(data['isExtensionCall'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * Voicemail Id
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Cdr Id
   * @member {String} cdrId
   */
  exports.prototype['cdrId'] = undefined;
  /**
   * Caller Profile Image. no profile image if empty
   * @member {String} profileImage
   */
  exports.prototype['profileImage'] = undefined;
  /**
   * Transcript of the audio file
   * @member {String} transcribe
   */
  exports.prototype['transcribe'] = undefined;
  /**
   * Account Id
   * @member {String} accountId
   */
  exports.prototype['accountId'] = undefined;
  /**
   * ParticipantT Type
   * @member {Number} participantType
   */
  exports.prototype['participantType'] = undefined;
  /**
   * Participant Id
   * @member {String} participantId
   */
  exports.prototype['participantId'] = undefined;
  /**
   * Name
   * @member {String} participantName
   */
  exports.prototype['participantName'] = undefined;
  /**
   * Voicemail created from phone number
   * @member {String} from
   */
  exports.prototype['from'] = undefined;
  /**
   * Voicemail caller owner id
   * @member {String} callerOwnerId
   */
  exports.prototype['callerOwnerId'] = undefined;
  /**
   * Voicemail recording location (amazon AWS S3 uri)
   * @member {String} url
   */
  exports.prototype['url'] = undefined;
  /**
   * Voicemail duration
   * @member {Number} duration
   */
  exports.prototype['duration'] = undefined;
  /**
   * Reference Id from portsip
   * @member {String} referenceId
   */
  exports.prototype['referenceId'] = undefined;
  /**
   * Voicemail ownerId
   * @member {String} ownerId
   */
  exports.prototype['ownerId'] = undefined;
  /**
   * Voicemail is read?
   * @member {Boolean} isRead
   */
  exports.prototype['isRead'] = undefined;
  /**
   * Voicemail read list
   * @member {Array.<String>} read
   */
  exports.prototype['read'] = undefined;
  /**
   * Voicemail created date
   * @member {Date} createdDate
   */
  exports.prototype['createdDate'] = undefined;
  /**
   * Is Extension Call
   * @member {Boolean} isExtensionCall
   */
  exports.prototype['isExtensionCall'] = undefined;



  return exports;
}));


